/***************************************************************************
                 articulos.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
	function calculateField(fN:String):String { return this.ctx.interna_calculateField(fN); }
	function validateForm():Boolean {return this.ctx.interna_validateForm();}
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
	var ejercicioActual:String;
	var longSubcuenta:Number;
	var bloqueoSubcuenta:Boolean;
	var posActualPuntoSubcuenta:Number;
	var posActualPuntoSubcuentaIRPF:Number;
	var tbnProvDefecto:Object;

	function oficial( context ) { interna( context ); }
	function generarArticulosTarifas() {
		return this.ctx.oficial_generarArticulosTarifas();
	}
	function calcularStockFisico() {
		return this.ctx.oficial_calcularStockFisico();
	}
	function bufferChanged(fN:String) {
		return this.ctx.oficial_bufferChanged(fN);
	}
	function genCodBar(fN:String) {
		return this.ctx.oficial_genCodBar(fN);
	}
	function eliminarStock():Boolean {
		return this.ctx.oficial_eliminarStock();
	}
	function borrarDatosStock(referencia:String):Boolean {
		return this.ctx.oficial_borrarDatosStock(referencia);
	}
	function marcarProvDefecto() {
		return this.ctx.oficial_marcarProvDefecto();
	}
	function establecerProveedorDefecto(referencia:String, codProveedor:String):Boolean {
		return this.ctx.oficial_establecerProveedorDefecto(referencia, codProveedor);
	}
	function establecerDatosAlta() {
		return this.ctx.oficial_establecerDatosAlta();
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration artObsoletos */
/////////////////////////////////////////////////////////////////
//// ART OBSOLETOS //////////////////////////////////////////////
class artObsoletos extends oficial /** %from: oficial */
{
	function artObsoletos( context ) { oficial ( context ); }
	function calculateField(fN:String) {
		return this.ctx.artObsoletos_calculateField(fN);
	}
	function bufferChanged(fN:String) {
		return this.ctx.artObsoletos_bufferChanged(fN);
	}
	function validateForm():Boolean {
		return this.ctx.artObsoletos_validateForm();
	}
}
//// ART OBSOLETOS //////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration baseSinTarifa */
/////////////////////////////////////////////////////////////////
//// BASESINTARIFA //////////////////////////////////////////////
class baseSinTarifa extends artObsoletos /** %from: oficial */ {
	function baseSinTarifa( context ) { artObsoletos( context ); }
	function init() {
		this.ctx.baseSinTarifa_init();
	}
	function bufferChanged(fN:String) {
		return this.ctx.baseSinTarifa_bufferChanged(fN);
	}
	function generarArticulosTarifas() {
		return this.ctx.baseSinTarifa_generarArticulosTarifas();
	}
}
//// BASESINTARIFA //////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration tarifaUpdate */
/////////////////////////////////////////////////////////////////
//// TARIFA UPDATE///////////////////////////////////////////////
class tarifaUpdate extends baseSinTarifa /** %from: oficial */ {
	var necesarioActualizarTarifa:Boolean = false;
	function tarifaUpdate( context ) { baseSinTarifa ( context ); }
	function validateForm():Boolean {
		return this.ctx.tarifaUpdate_validateForm();
	}
	function bufferChanged(fN:String) {
		return this.ctx.tarifaUpdate_bufferChanged(fN);
	}
	function generarArticulosTarifas() {
		return this.ctx.tarifaUpdate_generarArticulosTarifas();
	}
}
//// TARIFA UPDATE///////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration tarifaViv */
//////////////////////////////////////////////////////////////////
//// TARIFAVIV ///////////////////////////////////////////////////
class tarifaViv extends tarifaUpdate /** %from: oficial */ {
	function tarifaViv( context ) { tarifaUpdate( context ); }
	function generarArticulosTarifas() {
		return this.ctx.tarifaViv_generarArticulosTarifas();
	}
}
//// TARIFAVIV ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration barcodeGs1 */
/////////////////////////////////////////////////////////////////
//// BARCODE_GS1 ////////////////////////////////////////////////
class barcodeGs1 extends tarifaViv /** %from: oficial */ {
    function barcodeGs1( context ) { tarifaViv ( context ); }
    function bufferChanged(fN:String) {
		return this.ctx.barcodeGs1_bufferChanged(fN);
	}
    function calcularGS1(codEmpresa:String, referencia:String):String {
    		return this.ctx.barcodeGs1_calcularGS1(codEmpresa,referencia);
    	}
    function validateForm():Boolean {
    		return this.ctx.barcodeGs1_validateForm();
    	}
}
//// BARCODE_GS1 ////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ivaIncluido */
//////////////////////////////////////////////////////////////////
//// IVAINCLUIDO /////////////////////////////////////////////////////
class ivaIncluido extends barcodeGs1 /** %from: oficial */ {
    function ivaIncluido( context ) { barcodeGs1( context ); }
	function validateForm():Boolean {
		return this.ctx.ivaIncluido_validateForm();
	}
	function establecerDatosAlta() {
		return this.ctx.ivaIncluido_establecerDatosAlta();
	}
}
//// IVAINCLUIDO /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration stockUnificado */
/////////////////////////////////////////////////////////////////
//// STOCK_UNIFICADO ////////////////////////////////////////////
class stockUnificado extends ivaIncluido /** %from: oficial */ {
	function stockUnificado( context ) { ivaIncluido ( context ); }
	function init() { this.ctx.stockUnificado_init(); }
}
//// STOCK_UNIFICADO ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration lasCunas */
/////////////////////////////////////////////////////////////////
//// LASCUNAS /////////////////////////////////////////////////
class lasCunas extends stockUnificado /** %from: stockUnificado */ {
    function lasCunas( context ) { stockUnificado ( context ); }
	function generarArticulosTarifas() {
		return this.ctx.lasCunas_generarArticulosTarifas();
	}
}
//// LASCUNAS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends lasCunas {
    function head( context ) { lasCunas ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
	function pub_establecerProveedorDefecto(referencia:String, codProveedor:String):Boolean {
		return this.establecerProveedorDefecto(referencia, codProveedor);
	}
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C El valor de --stockfis-- se calcula automticamente para cada artculo como la suma de existencias del artculo en todos los almacenes.
\end */
function interna_init()
{
	var util:FLUtil = new FLUtil();
	var cursor:FLSqlCursor = this.cursor();

	this.iface.tbnProvDefecto = this.child("tbnProvDefecto");

	connect (this.iface.tbnProvDefecto, "clicked()", this, "iface.marcarProvDefecto");
	connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
	connect(this.child("pbnGenerarArticulosTarifas"), "clicked()", this, "iface.generarArticulosTarifas");
	if (this.child("tdbStocks"))
		connect(this.child("tdbStocks").cursor(), "cursorUpdated()", this, "iface.calcularStockFisico()");

	switch (cursor.modeAccess()) {
		case cursor.Insert: {
			this.iface.establecerDatosAlta();
			break;
		}
		case cursor.Browse: {
			this.child("pbnGenerarArticulosTarifas").enabled = false;
			break;
		}
		case cursor.Edit: {
			if (cursor.valueBuffer("nostock")) {
				this.child("tbwArticulo").setTabEnabled("stocks", false);
			} else {
				this.child("tbwArticulo").setTabEnabled("stocks", true);
			}
			break;
		}
	}
	this.iface.genCodBar("codbarras");

	this.iface.bufferChanged("secompra");
	this.iface.bufferChanged("sevende");

	if (sys.isLoadedModule("flcontppal")) {
		this.iface.ejercicioActual = flfactppal.iface.pub_ejercicioActual();
		this.iface.longSubcuenta = util.sqlSelect("ejercicios", "longsubcuenta", "codejercicio = '" + this.iface.ejercicioActual + "'");
		this.iface.bloqueoSubcuenta = false;
		this.iface.posActualPuntoSubcuenta = -1;
		this.child("fdbIdSubcuentaCom").setFilter("codejercicio = '" + this.iface.ejercicioActual + "'");
		this.child("fdbIdSubcuentaIrpfCom").setFilter("codejercicio = '" + this.iface.ejercicioActual + "'");
	} else
		this.child("tbwArticulo").setTabEnabled("contabilidad", false);
}

function interna_calculateField(nombreCampo:String):String
{
	var util:FLUtil = new FLUtil();
	/** \D El valor de --stockfis-- se calcula sumando todas las cantidades de esa referencia en la tabla stocks, esto es, las cantidades de todos los almacenes
	\end */
	if (nombreCampo == "stockfis")
		return util.sqlSelect("stocks", "SUM(cantidad)",  "referencia='" + this.cursor().valueBuffer("referencia") + "';");
}

function interna_validateForm():Boolean
{
	return true;
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
/** \D Genera las lneas de tarifas para un determinado artculo mediante el pvp base y los incrementos de cada tarifa. Cada lnea contiene la referencia del artculo, el cdigo de tarifa y el precio calculado para la tarifa.
\end */
function oficial_generarArticulosTarifas()
{
		var cursor:FLSqlCursor = this.cursor();
		var referencia:String = cursor.valueBuffer("referencia");
		var pvp:Number = cursor.valueBuffer("pvp");
		var codTarifa:String;
		var incLineal:Number;
		var incPorcentual:Number;
		var pvpTarifa:Number;

		var curArtTar:FLSqlCursor = this.child("tdbArticulosTarifas").cursor()
		var qryTarifas:FLSqlQuery = new FLSqlQuery();

/** \D Los incrementos lineal y porcentual de la tarifa sobre el precio base pueden acumularse
Las tarifas del artculo son eliminadas y regeneradas despus
\end */
		qryTarifas.setTablesList("tarifas");
		qryTarifas.setSelect("codtarifa,inclineal,incporcentual");
		qryTarifas.setFrom("tarifas");

		qryTarifas.exec();
		while (qryTarifas.next()) {
			codTarifa = qryTarifas.value(0);
			with(curArtTar) {
				select("referencia = '" + referencia + "' AND codtarifa = '" + codTarifa + "'");
				if (first()) {
					setModeAccess(Del);
					refreshBuffer();
					commitBuffer();
				}
			}
		}

		qryTarifas.exec();
		while (qryTarifas.next()) {
			codTarifa = qryTarifas.value(0);
			incLineal = parseFloat(qryTarifas.value(1));
			incPorcentual = parseFloat(qryTarifas.value(2));
			pvpTarifa = ((pvp * (100 + incPorcentual)) / 100) + incLineal;
			with(curArtTar) {
				setModeAccess(Insert);
				refreshBuffer();
				setValueBuffer("referencia", referencia);
				setValueBuffer("codtarifa", codTarifa);
				setValueBuffer("pvp", pvpTarifa);
				commitBuffer();
			}
		}

		this.child("tdbArticulosTarifas").refresh();
}

/** \D Informa el campo --stockfis--
\end */
function oficial_calcularStockFisico()
{
		this.child("fdbStockFisico").setValue(this.iface.calculateField("stockfis"));
}

function oficial_bufferChanged(fN:String)
{
	var cursor:FLSqlCursor = this.cursor();

	switch (fN) {
		case "tipocodbarras":
		case "codbarras": {
			this.iface.genCodBar(fN)
			break;
		}
		case "codsubcuentacom": {
			if (!this.iface.bloqueoSubcuenta) {
				this.iface.bloqueoSubcuenta = true;
				this.iface.posActualPuntoSubcuenta = flcontppal.iface.pub_formatearCodSubcta(this, "fdbCodSubcuentaCom", this.iface.longSubcuenta, this.iface.posActualPuntoSubcuenta);
				this.iface.bloqueoSubcuenta = false;
			}
			break;
		}
		case "codsubcuentairpfcom": {
			if (!this.iface.bloqueoSubcuenta) {
				this.iface.bloqueoSubcuenta = true;
				this.iface.posActualPuntoSubcuentaIRPF = flcontppal.iface.pub_formatearCodSubcta(this, "fdbCodSubcuentaIrpfCom", this.iface.longSubcuenta, this.iface.posActualPuntoSubcuentaIRPF);
				this.iface.bloqueoSubcuenta = false;
			}
			break;
		}
		case "nostock": {
			if (cursor.valueBuffer("nostock")) {
				if (this.iface.eliminarStock()) {
					this.child("tbwArticulo").setTabEnabled("stocks", false);
				} else {
					this.child("fdbNoStock").setValue(false);
				}
			} else {
				this.child("tbwArticulo").setTabEnabled("stocks", true);
			}
			break;
		}
		case "secompra": {
			if(!cursor.valueBuffer("secompra"))
				this.child("tbwArticulo").setTabEnabled("compra", false);
			else
				this.child("tbwArticulo").setTabEnabled("compra", true);
			break;
		}
		case "sevende": {
			if(!cursor.valueBuffer("sevende"))
				this.child("tbwArticulo").setTabEnabled("venta", false);
			else
				this.child("tbwArticulo").setTabEnabled("venta", true);
			break;
		}
	}
}

function oficial_genCodBar(fN:String)
{
	if (fN == "tipocodbarras" || fN == "codbarras") {
		var cursor:FLSqlCursor = this.cursor();
		var type:String = cursor.valueBuffer("tipocodbarras");
		var value:String = cursor.valueBuffer("codbarras");

		var auxCodBar:FLCodBar = new FLCodBar(0);
		var codBar:FLCodBar = new FLCodBar(value, auxCodBar.nameToType(type), 10, 1, 0, 0, true);
		var pixmap:Object = codBar.pixmap();
		if (codBar.validBarcode())
			this.child("pixmapCodBar").setPixmap(pixmap);
		else
			this.child("pixmapCodBar").setPixmap(codBar.pixmapError());
	}
}

function oficial_eliminarStock():Boolean
{
	var util:FLUtil = new FLUtil;
	var cursor:FLSqlCursor = this.cursor();

	var referencia:String = cursor.valueBuffer("referencia");
	if (util.sqlSelect("stocks", "idstock", "referencia = '" + referencia + "'")) {
		var res:Number = MessageBox.warning(util.translate("scripts", "Existen valores de stock para este artculo.\nSi lo que desea hacer es indicar que se permiten ventas sin stock de este material, pulse Cancelar e indquelo en la pestaa de Stocks.\nSi quiere eliminar completamente los datos de stock asociados a este artculo pulse Aceptar. Esta accin no es reversible."), MessageBox.Cancel, MessageBox.Ok);
		if (res != MessageBox.Ok) {
			return false;
		}
	}
	var curTrans:FLSqlCursor = new FLSqlCursor("stocks");
	curTrans.transaction(false);
	try {
		if (this.iface.borrarDatosStock(referencia)) {
			curTrans.commit();
		} else {
			curTrans.rollback();
			return false;
		}
	}
	catch (e) {
		curTrans.rollback();
		MessageBox.critical(util.translate("scripts", "Error al eliminar los datos de stock para el artculo %1").arg(referencia), MessageBox.Ok, MessageBox.NoButton);
		return false;
	}
	return true;
}

function oficial_borrarDatosStock(referencia:String):Boolean
{
	var util:FLUtil = new FLUtil;
	if (!util.sqlDelete("stocks", "referencia = '" + referencia + "'")) {
		return false;
	}

	return true;
}

function oficial_marcarProvDefecto()
{
	var util:FLUtil = new FLUtil;
	var cursor:FLSqlCursor = this.cursor();
	var curProv:FLSqlCursor = this.child("tdbArticulosProv").cursor();
	if (!curProv.valueBuffer("id"))
		return;

	var referencia:String = cursor.valueBuffer("referencia");
	var codProveedor:String = curProv.valueBuffer("codproveedor");
	if (!this.iface.establecerProveedorDefecto(referencia, codProveedor)) {
		return;
	}
	this.child("tdbArticulosProv").refresh();
}

function oficial_establecerProveedorDefecto(referencia:String, codProveedor:String):Boolean
{
	var util:FLUtil = new FLUtil;
	if (!util.sqlUpdate("articulosprov", "pordefecto", false, "referencia = '" + referencia + "'")) {
		return false;
	}

	if (!util.sqlUpdate("articulosprov", "pordefecto", true, "referencia = '" + referencia + "' AND codproveedor = '" + codProveedor + "'")) {
		return false;
	}

	return true;
}

function oficial_establecerDatosAlta()
{
debug("oficial_establecerDatosAlta " + flfactalma.iface.pub_valorDefectoAlmacen("codimpuesto"));
	this.child("fdbImpuesto").setValue(flfactalma.iface.pub_valorDefectoAlmacen("codimpuesto"));
}
//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition artObsoletos */
/////////////////////////////////////////////////////////////////
//// ART OBSOLETOS //////////////////////////////////////////////

function artObsoletos_bufferChanged(fN:String)
{
	var cursor:FLSqlCursor = this.cursor();
	switch(fN) {
		case "obsoleto": {
			var fecha:String = this.iface.calculateField("fechaobsoleto");
			debug("fecha -> " + fecha);
			this.child("fdbFechaObsoleto").setValue(fecha);
			if (fecha == "NAN") {
				cursor.setNull("fechaobsoleto");
			}
			break;
		}
        default: {
            this.iface.__bufferChanged(fN);
        }
	}
}

function artObsoletos_calculateField(fN:String):String
{
	this.iface.__calculateField();

	var util:FLUtil = new FLUtil();
	var cursor:FLSqlCursor = this.cursor();
	var res:String;

	switch (fN) {
		case "fechaobsoleto": {
			if (cursor.valueBuffer("obsoleto")) {
				var hoy:Date = new Date;
				res = hoy.toString();
			} else
				res = "NAN";
			break;
		}
		default: {
			res = this.iface.__calculateField(fN);
			break;
		}
	}
	return res;
}

function artObsoletos_validateForm():Boolean
{
	this.iface.__validateForm();

	var cursor:FLSqlCursor = this.cursor();
	var util:FLUtil = new FLUtil;
	/** \C Si el artculo est obsoleto, la fecha de comienzo de la baja debe estar informada
	\end */
	if (cursor.valueBuffer("obsoleto") && cursor.isNull("fechaobsoleto")) {
		MessageBox.warning(util.translate("scripts", "Si el artculo est obsoleto deb1e introducir la correspondiente fecha de inicio de la baja"), MessageBox.Ok, MessageBox.NoButton)
		return false;
	}

	return true;
}

//// ART OBSOLETOS //////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition baseSinTarifa */
/////////////////////////////////////////////////////////////////
//// BASESINTARIFA //////////////////////////////////////////////
function baseSinTarifa_init()
{
var cursor:FLSqlCursor = this.cursor();

this.iface.__init();

if (!cursor.valueBuffer("solobase"))
				{
		     		this.child("pbnGenerarArticulosTarifas").enabled = true;
		     		this.child("toolButtonEditPTarifa").enabled = true;
		     		this.child("toolButtonDeletePTarifa").enabled = true;
		     		this.child("toolButtonInsertPTarifa").enabled = true;
		     		this.child("toolButtonZoomPTarifa").enabled = true;
				}
			else
		     		{
		     		this.child("pbnGenerarArticulosTarifas").enabled = false;
		     		this.child("toolButtonEditPTarifa").enabled = false;
		     		this.child("toolButtonDeletePTarifa").enabled = false;
		     		this.child("toolButtonInsertPTarifa").enabled = false;
		     		this.child("toolButtonZoomPTarifa").enabled = false;
		    		}
}



function baseSinTarifa_bufferChanged(fN)
{
var cursor:FLSqlCursor = this.cursor();
var util:FLUtil = new FLUtil;


if (fN == "solobase")
	{
	if (!cursor.valueBuffer("solobase"))
				{
		     		this.child("pbnGenerarArticulosTarifas").enabled = true;
		     		this.iface.generarArticulosTarifas();
		     		this.child("toolButtonEditPTarifa").enabled = true;
		     		this.child("toolButtonDeletePTarifa").enabled = true;
		     		this.child("toolButtonInsertPTarifa").enabled = true;
		     		this.child("toolButtonZoomPTarifa").enabled = true;
				}
			else
		     		{
		     		util.sqlDelete("articulostarifas", "referencia = '" + cursor.valueBuffer("referencia") + "'");
		    		this.child("tdbArticulosTarifas").refresh();
		    		this.child("pbnGenerarArticulosTarifas").enabled = false;
		     		this.child("toolButtonEditPTarifa").enabled = false;
		     		this.child("toolButtonDeletePTarifa").enabled = false;
		     		this.child("toolButtonInsertPTarifa").enabled = false;
		     		this.child("toolButtonZoomPTarifa").enabled = false;
		    		}
	}
else
	this.iface.__bufferChanged(fN);

}
function baseSinTarifa_generarArticulosTarifas()
{
		var cursor:FLSqlCursor = this.cursor();

		if (cursor.valueBuffer("solobase"))
			return;

		this.iface.__generarArticulosTarifas();

}

//// BASESINTARIFA //////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition tarifaUpdate */
/////////////////////////////////////////////////////////////////
//// TARIFA UPDATE///////////////////////////////////////////////
/** \D Si el flag necesarioActualizarTarifa es true, actualiza las tarifas automaticamente
\end */
function tarifaUpdate_validateForm():Boolean
{
//	if (this.iface.necesarioActualizarTarifa == true)
//		this.iface.generarArticulosTarifas();

	return this.iface.__validateForm();
}

function tarifaUpdate_bufferChanged(fN:String)
{
	var cursor:FLSqlCursor = this.cursor();

	switch (fN) {
		case "pvp": {
			 this.iface.necesarioActualizarTarifa = true;
			break;
		}
		default: {
			this.iface.__bufferChanged(fN);
			break;
		}

	}
}


function tarifaUpdate_generarArticulosTarifas()
{
 this.iface.necesarioActualizarTarifa = false;
 this.iface.__generarArticulosTarifas();
}
//// TARIFA UPDATE///////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition tarifaViv */
//////////////////////////////////////////////////////////////////
//// TARIFAVIV ///////////////////////////////////////////////////
function tarifaViv_generarArticulosTarifas()
{
		var util:FLUtil = new FLUtil();
		var cursor:FLSqlCursor = this.cursor();
		var referencia:String = cursor.valueBuffer("referencia");
		var pvp:Number = cursor.valueBuffer("pvp");
		var codTarifa:String;
		var incLineal:Number;
		var incPorcentual:Number;
		var pvpTarifa:Number;
		var disponible:Array = [];
		var curArtTar:FLSqlCursor = this.child("tdbArticulosTarifas").cursor()
		var qryTarifas:FLSqlQuery = new FLSqlQuery();

/** \D Los incrementos lineal y porcentual de la tarifa sobre el precio base pueden acumularse
Las tarifas del artculo son eliminadas y regeneradas despus
\end */
		qryTarifas.setTablesList("tarifas");
		qryTarifas.setSelect("codtarifa,inclineal,incporcentual");
		qryTarifas.setFrom("tarifas");

		qryTarifas.exec();
		while (qryTarifas.next()) {
			codTarifa = qryTarifas.value(0);
			disponible[codTarifa] = util.sqlSelect("articulostarifas", "excluir", "referencia = '" + referencia + "' AND codtarifa = '" + codTarifa + "'");

			with(curArtTar) {
				select("referencia = '" + referencia + "' AND codtarifa = '" + codTarifa + "'");
				if (first()) {
					setModeAccess(Del);
					refreshBuffer();
					commitBuffer();
				}
			}
		}

		qryTarifas.exec();
		while (qryTarifas.next()) {
			codTarifa = qryTarifas.value(0);
			incLineal = parseFloat(qryTarifas.value(1));
			incPorcentual = parseFloat(qryTarifas.value(2));
			pvpTarifa = ((pvp * (100 + incPorcentual)) / 100) + incLineal;
			with(curArtTar) {
				setModeAccess(Insert);
				refreshBuffer();
				setValueBuffer("referencia", referencia);
				setValueBuffer("codtarifa", codTarifa);
				setValueBuffer("pvp", pvpTarifa);
				setValueBuffer("excluir", disponible[codTarifa]);
				commitBuffer();
			}
		}

		this.child("tdbArticulosTarifas").refresh();
}
//// TARIFAVIV ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition barcodeGs1 */
/////////////////////////////////////////////////////////////////
//// BARCODE_GS1 ////////////////////////////////////////////////
function barcodeGs1_bufferChanged( fN:String )
{
	var util:FLUtil = new FLUtil;
	var cursor:FLSqlCursor = this.cursor();

	var codEmpresa:String = util.sqlSelect("empresa", "codgs1", "1 = 1");

	switch (fN) {
		case "referencia": {
			valor = this.iface.calcularGS1(codEmpresa,cursor.valueBuffer("referencia"));
			cursor.setValueBuffer("codbarras",valor);
		}
		default: {
			this.iface.__bufferChanged( fN );
		}
	}
}

function barcodeGs1_calcularGS1(codEmpresa:String, referencia:String):String
{
var valor:String ="";

var codigo:String = codEmpresa + referencia;
var codigoN:Number = parseFloat(codigo);
var valorPaso1:Number;
var tope:Number = 0;
var diferencia:Number;

for (var i:Number = 0; i < codigo.length ; i++)
	{
	if (i % 2 == 0)
		{
		//debug( " pos(" + i + ") es par.");
		valorPaso1 += parseFloat(codigo.charAt(i));
		}
	else
		{
		valorPaso1 += 3 * parseFloat(codigo.charAt(i));
		}
	}

//debug("Valor paso1 = " + valorPaso1 );
while (tope < valorPaso1)
	tope = tope + 10;

diferencia = tope - valorPaso1;

//debug("Valor tope = " + tope );

//debug("La diferencia es" + diferencia);
valor = codigo + diferencia;
return valor;
}

function barcodeGs1_validateForm():Boolean
{
	var util:FLUtil = new FLUtil;
	var cursor:FLSqlCursor = this.cursor();
	if (cursor.valueBuffer("referencia").length > 4 || parseFloat(cursor.valueBuffer("referencia")) == NaN)
		{
		if (!cursor.valueBuffer("referencia").lower().startsWith("p")) {
			MessageBox.warning(util.translate("scripts", "Error al generar el cdigo de barras.\nLa referencia tiene que ser de 4 caracteres numricos.\nTampoco es una referencia de produccin."), MessageBox.Ok, MessageBox.NoButton)
			return false;
		}

		}
	return this.iface.__validateForm();
}
//// BARCODE_GS1 ////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition ivaIncluido */
//////////////////////////////////////////////////////////////////
//// IVAINCLUIDO /////////////////////////////////////////////////////

function ivaIncluido_validateForm():Boolean
{
	var cursor:FLSqlCursor = this.cursor();
	var util:FLUtil = new FLUtil();

	if(!this.iface.__validateForm())
		return false;

	if (cursor.valueBuffer("ivaincluido") && !cursor.valueBuffer("codimpuesto")) {
		MessageBox.critical(util.translate("scripts","Si el IVA del artculo est includo se debe especificar el tipo de IVA"),
				MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
		return false;
	}

	return true;
}

function ivaIncluido_establecerDatosAlta()
{
	this.iface.__establecerDatosAlta();
	this.child("fdbIvaIncluido").setValue(flfactalma.iface.pub_valorDefectoAlmacen("ivaincluido"));
}
//// IVAINCLUIDO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition stockUnificado */
/////////////////////////////////////////////////////////////////
//// STOCK_UNIFICADO ////////////////////////////////////////////
function stockUnificado_init()
{

var conn:String = flfactalma.iface.recogeConnUnificada();

if (this.cursor().modeAccess() == this.cursor().Insert && conn != "default")
		{
		var util = new FLUtil;
		MessageBox.critical(util.translate("scripts","Solo se puede crear articulos en la base de datos Maestra"), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
		this.close();
		return;
		 }

this.iface.__init();
if (conn != "default")
	{
	this.child("tdbStocks").cursor().changeConnection(conn);
	this.child("tdbStocks").setReadOnly(true);
	this.child("tdbStocks").refresh();
	this.child("gbxStocks1").hide();
	//this.child("tbwArticulo").setTabEnabled("stocks", false);
	}

debug("*** Fecha modificado" + this.cursor().valueBuffer("fecha_modificado"));
flfactalma.iface.revisar_entradas(this.cursor().valueBuffer("referencia"));
}
//// STOCK_UNIFICADO ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition lasCunas */
//////////////////////////////////////////////////////////////////
//// LASCUNAS ///////////////////////////////////////////////////
function lasCunas_generarArticulosTarifas()
{
		var util:FLUtil = new FLUtil();
		var cursor:FLSqlCursor = this.cursor();
		var referencia:String = cursor.valueBuffer("referencia");
		var pvp:Number = cursor.valueBuffer("pvp");
		var codTarifa:String;
		var incLineal:Number;
		var incPorcentual:Number;
		var pvpTarifa:Number;
		var formula:String;
		var disponible:Array = [];
		var curArtTar:FLSqlCursor = this.child("tdbArticulosTarifas").cursor()
		var qryTarifas:FLSqlQuery = new FLSqlQuery();

/** \D Los incrementos lineal y porcentual de la tarifa sobre el precio base pueden acumularse
Las tarifas del artculo son eliminadas y regeneradas despus
\end */
		qryTarifas.setTablesList("tarifas");
		qryTarifas.setSelect("codtarifa,inclineal,incporcentual,formula");
		qryTarifas.setFrom("tarifas");

		qryTarifas.exec();
		while (qryTarifas.next()) {
			codTarifa = qryTarifas.value(0);
			disponible[codTarifa] = util.sqlSelect("articulostarifas", "excluir", "referencia = '" + referencia + "' AND codtarifa = '" + codTarifa + "'");

			with(curArtTar) {
				select("referencia = '" + referencia + "' AND codtarifa = '" + codTarifa + "'");
				if (first()) {
					setModeAccess(Del);
					refreshBuffer();
					commitBuffer();
				}
			}
		}

		qryTarifas.exec();
		while (qryTarifas.next()) {
			codTarifa = qryTarifas.value(0);
			incLineal = parseFloat(qryTarifas.value(1));
			incPorcentual = parseFloat(qryTarifas.value(2));
			formula = qryTarifas.value(3);
			if (!formula || formula == "") {
				pvpTarifa = ((pvp * (100 + incPorcentual)) / 100) + incLineal;
				} else {
				pvpTarifa = flfactalma.iface.generaPVPFormula(referencia, qryTarifas.value(0), cursor);
				}
			with(curArtTar) {
				setModeAccess(Insert);
				refreshBuffer();
				setValueBuffer("referencia", referencia);
				setValueBuffer("codtarifa", codTarifa);
				setValueBuffer("pvp", util.roundFieldValue(pvpTarifa, "articulostarifas", "pvp"));
				setValueBuffer("excluir", disponible[codTarifa]);
				commitBuffer();
			}
		}

		this.child("tdbArticulosTarifas").refresh();
}
//// LASCUNAS ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

