/***************************************************************************
                 flfactalma.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
	var ctx:Object;
	function interna( context ) { this.ctx = context; }
	function init() { this.ctx.interna_init(); }
	function afterCommit_stocks(curStock:FLSqlCursor):Boolean {
		return this.ctx.interna_afterCommit_stocks(curStock);
	}
	function beforeCommit_stocks(curStock:FLSqlCursor):Boolean {
		return this.ctx.interna_beforeCommit_stocks(curStock);
	}
	function afterCommit_lineastransstock(curLTS:FLSqlCursor):Boolean {
		return this.ctx.interna_afterCommit_lineastransstock(curLTS);
	}
	function afterCommit_lineasregstocks(curLRS:FLSqlCursor):Boolean {
                return this.ctx.interna_afterCommit_lineasregstocks(curLRS);
	}
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
	function oficial( context ) { interna( context ); }
	function cambiarStock(codAlmacen:String, referencia:String, variacion:Number, campo:String):Boolean {
		return this.ctx.oficial_cambiarStock(codAlmacen, referencia, variacion, campo);
	}
	function cambiarCosteMedio(referencia:String):Boolean {
		return this.ctx.oficial_cambiarCosteMedio(referencia);
	}
	function controlStockPedidosCli(curLP:FLSqlCursor):Boolean {
		return this.ctx.oficial_controlStockPedidosCli(curLP);
	}
	function controlStockPedidosProv(curLP:FLSqlCursor):Boolean {
		return this.ctx.oficial_controlStockPedidosProv(curLP);
	}
	function controlStockAlbaranesCli(curLA:FLSqlCursor):Boolean {
		return this.ctx.oficial_controlStockAlbaranesCli(curLA);
	}
	function controlStockAlbaranesProv(curLA:FLSqlCursor):Boolean {
		return this.ctx.oficial_controlStockAlbaranesProv(curLA);
	}
	function controlStockFacturasCli(curLF:FLSqlCursor):Boolean {
		return this.ctx.oficial_controlStockFacturasCli(curLF);
	}
	function controlStockComandasCli(curLV:FLSqlCursor):Boolean {
		return this.ctx.oficial_controlStockComandasCli(curLV);
	}
	function controlStockFacturasProv(curLF:FLSqlCursor):Boolean {
		return this.ctx.oficial_controlStockFacturasProv(curLF);
	}
	function crearStock(codAlmacen:String, referencia:String):Number {
		return this.ctx.oficial_crearStock(codAlmacen, referencia);
	}
	function controlStockLineasTrans(curLTS:FLSqlCursor):Boolean {
		return this.ctx.oficial_controlStockLineasTrans(curLTS);
	}
	function controlStockValesTPV(curLinea:FLSqlCursor):Boolean {
		return this.ctx.oficial_controlStockValesTPV(curLinea);
	}
	function controlStock( curLinea:FLSqlCursor, campo:String, signo:Number, codAlmacen:String ):Boolean {
		return this.ctx.oficial_controlStock( curLinea, campo, signo, codAlmacen );
	}
	function controlStockPteRecibir(curLinea:FLSqlCursor, codAlmacen:String):Boolean {
		return this.ctx.oficial_controlStockPteRecibir(curLinea, codAlmacen);
	}
	function actualizarStockPteRecibir(referencia:String, codAlmacen:String, idPedido:String):Boolean {
		return this.ctx.oficial_actualizarStockPteRecibir(referencia, codAlmacen, idPedido);
	}
	function controlStockReservado(curLinea:FLSqlCursor, codAlmacen:String):Boolean {
		return this.ctx.oficial_controlStockReservado(curLinea, codAlmacen);
	}
	function actualizarStockReservado(referencia:String, codAlmacen:String, idPedido:String):Boolean {
		return this.ctx.oficial_actualizarStockReservado(referencia, codAlmacen, idPedido);
	}
	function comprobarStock(curStock:FLSqlCursor):Boolean {
		return this.ctx.oficial_comprobarStock(curStock);
	}
	function valorDefectoAlmacen(fN:String):String {
		return this.ctx.oficial_valorDefectoAlmacen(fN);
	}
	function controlRegStock(curLRS:FLSqlCursor):Boolean {
		return this.ctx.oficial_controlRegStock(curLRS);
        }
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration tarifaGenerator */
/////////////////////////////////////////////////////////////////
//// TARIFAGENERATOR ////////////////////////////////////////////
class tarifaGenerator extends oficial /** %from: oficial */ {
	function tarifaGenerator( context ) { oficial ( context ); }
	function afterCommit_tarifas(curTarifa:FLSqlCursor):Boolean {
		return this.ctx.tarifaGenerator_afterCommit_tarifas(curTarifa);
	}
}
//// TARIFAGENERATOR ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration keepAlive */
/////////////////////////////////////////////////////////////////
//// KEEP_ALIVE /////////////////////////////////////////////////
class keepAlive extends tarifaGenerator /** %from: oficial */ {
	function keepAlive( context ) { tarifaGenerator ( context ); }
	function init() {
		return this.ctx.keepAlive_init();
	}
}
//// KEEP_ALIVE /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration scabLite */
/////////////////////////////////////////////////////////////////
//// CONTROL STOCK CABECERA /////////////////////////////////////
class scabLite extends keepAlive /** %from: oficial */ {
    function scabLite( context ) { keepAlive ( context ); }
    function arraySocksAfectados(arrayInicial:Array, arrayFinal:Array):Array {
        return this.ctx.scabLite_arraySocksAfectados(arrayInicial, arrayFinal);
    }
    function compararArrayStock(a:Array, b:Array):Number {
        return this.ctx.scabLite_compararArrayStock(a, b);
    }
}
//// CONTROL STOCK CABECERA /////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration almacenLinea */
/////////////////////////////////////////////////////////////////
//// ALMACEN_LINEA //////////////////////////////////////////////
class almacenLinea extends scabLite /** %from: oficial */ {
	function almacenLinea( context ) { scabLite ( context ); }
	function controlStockPedidosCli(curLP:FLSqlCursor):Boolean {
		return this.ctx.almacenLinea_controlStockPedidosCli(curLP);
	}
	function controlStockPedidosProv(curLP:FLSqlCursor):Boolean {
		return this.ctx.almacenLinea_controlStockPedidosProv(curLP);
	}
	function controlStockAlbaranesCli(curLA:FLSqlCursor):Boolean {
		return this.ctx.almacenLinea_controlStockAlbaranesCli(curLA);
	}
	function controlStockAlbaranesProv(curLA:FLSqlCursor):Boolean {
		return this.ctx.almacenLinea_controlStockAlbaranesProv(curLA);
	}
	function controlStockFacturasCli(curLF:FLSqlCursor):Boolean {
		return this.ctx.almacenLinea_controlStockFacturasCli(curLF);
	}
	function controlStockFacturasProv(curLF:FLSqlCursor):Boolean {
		return this.ctx.almacenLinea_controlStockFacturasProv(curLF);
	}
	function controlStock( curLinea:FLSqlCursor, campo:String, signo:Number, codAlmacen:String ):Boolean {
		return this.ctx.almacenLinea_controlStock( curLinea, campo, signo, codAlmacen );
	}
}
//// ALMACEN_LINEA //////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration stockUnificado */
/////////////////////////////////////////////////////////////////
//// STOCK_UNIFICADO ////////////////////////////////////////////
class stockUnificado extends almacenLinea /** %from: oficial */ {
	var conn_unificada;
	function stockUnificado( context ) { almacenLinea ( context ); }
	function recogeConnUnificada() {
		return this.ctx.stockUnificado_recogeConnUnificada();
	}
	function controlRegStock(curLRS:FLSqlCursor):Boolean {
		return this.ctx.stockUnificado_controlRegStock(curLRS);
        }
	function actualizarStockReservado(referencia:String, codAlmacen:String, idPedido:String):Boolean {
		return this.ctx.stockUnificado_actualizarStockReservado(referencia, codAlmacen, idPedido);
	}
	function cambiarStock(codAlmacen:String, referencia:String, variacion:Number, campo:String):Boolean {
		return this.ctx.stockUnificado_cambiarStock(codAlmacen, referencia, variacion, campo);
	}
	function crearStock(codAlmacen:String, referencia:String):Number {
		return this.ctx.stockUnificado_crearStock(codAlmacen, referencia);
	}
	function afterCommit_stocks(curStock:FLSqlCursor):Boolean {
		return this.ctx.stockUnificado_afterCommit_stocks(curStock);
	}
	function revisar_entradas(referencia:String) {
		this.ctx.stockUnificado_revisar_entradas(referencia);
	}
	function init() {
		this.ctx.stockUnificado_init();
	}
	function calcular_entradas(id_stock: Number, fecha:Date): Number {
		return this.ctx.stockUnificado_calcular_entradas(id_stock, fecha);
	}
	function marcar_entradas(id_stock: Number, fecha:Date): Number {
		this.ctx.stockUnificado_marcar_entradas(id_stock, fecha);
	}

	function controlStock( curLinea:FLSqlCursor, campo:String, signo:Number, codAlmacen:String ):Boolean {
		return this.ctx.stockUnificado_controlStock( curLinea, campo, signo, codAlmacen );
	}
	function beforeCommit_articulos(curArt:FLSqlCursor):Boolean {
		return this.ctx.stockUnificado_beforeCommit_articulos(curArt);
	}
	function beforeCommit_vlc_produccion(cursor:FLSqlCursor):Boolean {
		return this.ctx.stockUnificado_beforeCommit_vlc_produccion(cursor);
	}
	function crea_montante(cursor:FLSqlCursor):Boolean {
		return this.ctx.stockUnificado_crea_montante(cursor);
	}

	function borra_montante(cursor:FLSqlCursor):Boolean {
		return this.ctx.stockUnificado_borra_montante(cursor);
	}

}
//// STOCK_UNIFICADO ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration lasCunas */
/////////////////////////////////////////////////////////////////
//// LASCUNAS /////////////////////////////////////////////////
class lasCunas extends stockUnificado /** %from: stockUnificado */ {
	function lasCunas( context ) { stockUnificado ( context ); }
	function generaPVPFormula(referencia:String, codTarifa: String, cursor_articulo: FLSqlCursor):Boolean {
		return this.ctx.lasCunas_generaPVPFormula(referencia, codTarifa, cursor_articulo);
	}
}
//// LASCUNAS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends lasCunas {
	function head( context ) { lasCunas ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
	function ifaceCtx( context ) { head( context ); }
	function pub_cambiarStock(codAlmacen:String, referencia:String, variacion:Number, campo:String, noAvisar:Boolean ):Boolean {
		return this.cambiarStock(codAlmacen, referencia, variacion,campo);
	}
	function pub_crearStock(codAlmacen:String, referencia:String):Number {
		return this.crearStock(codAlmacen, referencia);
	}
	function pub_cambiarCosteMedio(referencia:String):Boolean {
		return this.cambiarCosteMedio(referencia);
	}
	function pub_controlStockPedidosCli(curLP:FLSqlCursor):Boolean {
		return this.controlStockPedidosCli(curLP);
	}
	function pub_controlStockPedidosProv(curLP:FLSqlCursor):Boolean {
		return this.controlStockPedidosProv(curLP);
	}
	function pub_controlStockAlbaranesCli(curLA:FLSqlCursor):Boolean {
		return this.controlStockAlbaranesCli(curLA);
	}
	function pub_controlStockAlbaranesProv(curLA:FLSqlCursor):Boolean {
		return this.controlStockAlbaranesProv(curLA);
	}
	function pub_controlStockFacturasCli(curLF:FLSqlCursor):Boolean {
		return this.controlStockFacturasCli(curLF);
	}
	function pub_controlStockComandasCli(curLV:FLSqlCursor):Boolean {
		return this.controlStockComandasCli(curLV);
	}
	function pub_controlStockFacturasProv(curLF:FLSqlCursor):Boolean {
		return this.controlStockFacturasProv(curLF);
	}
	function pub_controlStockValesTPV(curLinea:FLSqlCursor):Boolean {
		return this.controlStockValesTPV(curLinea);
	}
	function pub_valorDefectoAlmacen(fN:String):String {
		return this.valorDefectoAlmacen(fN);
	}
}

const iface = new pubscabLite( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration pubscabLite */
/////////////////////////////////////////////////////////////////
//// PUB scabLite ///////////////////////////////////////////////////
class pubscabLite extends ifaceCtx /** %from: ifaceCtx */ {
    function pubscabLite ( context ) { ifaceCtx( context ); }
    function pub_arraySocksAfectados(arrayInicial:Array, arrayFinal:Array):Array {
        return this.arraySocksAfectados(arrayInicial, arrayFinal);
    }
    function pub_actualizarStockPteRecibir(referencia:String, codAlmacen:String, idPedido:String):Boolean {
        return this.actualizarStockPteRecibir(referencia, codAlmacen, idPedido);
    }
}
//// PUB scabLite ///////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \D Si no hay ningn almacn en la tabla almacenes se inserta uno por defecto
\end */
function interna_init()
{
	var cursor:FLSqlCursor = new FLSqlCursor("almacenes");
	cursor.select();
	if (!cursor.first()) {
		var util:FLUtil = new FLUtil();
		MessageBox.information(util.translate("scripts",
			"Se insertar un almacn por defecto para empezar a trabajar."),
			MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
		with (cursor) {
			setModeAccess(Insert);
			refreshBuffer();
			setValueBuffer("codalmacen","ALG");
			setValueBuffer("nombre", util.translate("scripts","ALMACEN GENERAL"));
			commitBuffer();
		}
		cursor = new FLSqlCursor("empresa");
		cursor.select();
		if (cursor.first()) {
			with (cursor) {
				setModeAccess(cursor.Edit);
				refreshBuffer();
				if (!valueBuffer("codalmacen")) {
					setValueBuffer("codalmacen","ALG");
					commitBuffer();
				}
			}
		}
	}
/**
	///////////// BORRAR 25/09/08 ///////////////////////////////
	// Es para inicializar los dos campos nuevos Se compra y Se vende a true.
	var util:FLUtil;
	if(!util.sqlSelect("articulos","referencia","secompra OR sevende")) {
		MessageBox.information(util.translate("scripts", "A continuacin se van a actualizar los nuevos campos de los artculos\nEsto puede llevar algunos segundos"),
			MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
		util.sqlUpdate("articulos","secompra",true,"1 = 1");
		util.sqlUpdate("articulos","sevende",true,"1 = 1");
		MessageBox.information(util.translate("scripts", "Proceso finalizado"),
			MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
	}
	///////////// BORRAR 25/09/08 ///////////////////////////////
**/
}

/** \D
Actualiza el stock fsico total en la tabla de artculos
\end */
function interna_afterCommit_stocks(curStock:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil;
	var referencia:String = curStock.valueBuffer("referencia");
	var stockFisico:Number = util.sqlSelect("stocks", "SUM(cantidad)", "referencia = '" + referencia + "'");
	switch (curStock.modeAccess()) {
		case curStock.Edit:
			var refAnterior:String = curStock.valueBufferCopy("referencia");
			if (referencia != refAnterior) {
				if (!util.sqlUpdate("articulos", "stockfis", stockFisico, "referencia = '" + refAnterior + "'"))
					return false;
			}
		case curStock.Insert:
// 			if((curStock.valueBufferCopy("cantidad") != curStock.valueBuffer("cantidad")) || (curStock.valueBufferCopy("reservada") != curStock.valueBuffer("reservada"))) {
// 				curStock.setValueBuffer("disponible",parseFloat(curStock.valueBuffer("cantidad")) - parseFloat(curStock.valueBuffer("reservada")));
// 			}
		case curStock.Del:
			if (!util.sqlUpdate("articulos", "stockfis", stockFisico, "referencia = '" + referencia + "'"))
				return false;
	}
	return true;
}

/** \D
Avisa al usuario en caso de querer borrar un stock con cantidad distinta de 0
\end */
function interna_beforeCommit_stocks(curStock:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil;
	switch (curStock.modeAccess()) {
		case curStock.Del: {
			if (parseFloat(curStock.valueBuffer("cantidad")) != 0) {
				var res:Number = MessageBox.warning(util.translate("scripts", "Va a eliminar un registro de stock con cantidad distinta de 0.\nEst seguro?"), MessageBox.No, MessageBox.Yes);
				if (res != MessageBox.Yes)
					return false;
			}
		}
	}
	return true;
}

function interna_afterCommit_lineastransstock(curLTS:FLSqlCursor):Boolean {
	return this.iface.controlStockLineasTrans(curLTS);
}


function interna_afterCommit_lineasregstocks(curLRS:FLSqlCursor):Boolean
{
debug("interna_afterCommit_lineasregstocks");
    if (!this.iface.controlRegStock(curLRS)) {
        return false;
    }
    return true;
}

//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
/** \D Cambia el valor del stock en un determinado almacn. Se comprueba si el valor de la variacin es negativo y mayor al stock actual, en cuyo caso se avisa al usuario de la falta de existencias

@param codAlmacen Cdigo del almacn
@param referencia Referencia del artculo
@param variacin Variacin en el nmero de existencias del artculo
@param	campo: Nombre del campo a modificar. Si el campo es vaco o es --cantidad-- se llama a la funcin padre
@return True si la modificacin tuvo xito, false en caso contrario
\end */
function oficial_cambiarStock(codAlmacen:String, referencia:String, variacion:Number, campo:String):Boolean
{
	var util:FLUtil = new FLUtil();
	if (referencia == "" || !referencia) {
		return true;
	}

	if (codAlmacen == "" || !codAlmacen) {
		return true;
	}

	if ( !campo || campo == "") {
		return false;
	}

	var idStock:String;
	idStock = util.sqlSelect("stocks", "idstock", "referencia = '" + referencia + "' AND codalmacen = '" + codAlmacen + "'");
	if ( !idStock ) {
		idStock = this.iface.crearStock( codAlmacen, referencia );
		if ( !idStock ) {
			return false;
		}
	}
	var curStock:FLSqlCursor = new FLSqlCursor( "stocks" );
	curStock.select( "idstock = " + idStock );
	if ( !curStock.first() ) {
		return false;
	}

	curStock.setModeAccess( curStock.Edit );
	curStock.refreshBuffer();

	var cantidadPrevia:Number = parseFloat( curStock.valueBuffer( campo ) );
	var nuevaCantidad:Number = cantidadPrevia + parseFloat( variacion );

// 	if (nuevaCantidad < 0 && campo == "cantidad") {
// 		if (!util.sqlSelect("articulos", "controlstock", "referencia = '" + referencia + "'")) {
// 			MessageBox.warning( util.translate("scripts", "El artculo %1 no permite ventas sin stock. Este movimiento dejara el stock de %2 con cantidad %3.\n").arg(referencia).arg(codAlmacen).arg(nuevaCantidad), MessageBox.Ok, MessageBox.NoButton);
// 			return false;
// 		}
// 	}

	curStock.setValueBuffer( campo, nuevaCantidad );
	if (campo == "cantidad" || campo == "reservada") {
		curStock.setValueBuffer("disponible", formRecordregstocks.iface.pub_commonCalculateField("disponible", curStock));
	}

	if (!this.iface.comprobarStock(curStock)) {
		return false;
	}

	if ( !curStock.commitBuffer() ) {
		return false;
	}

	return true;
}

/** \D Comprueba, en el caso de que el artculo no permita ventas sin stock, si el stock que se va a guardar incumple dicha condicin
@param	curStock: Cursor a guardar
@return	True si la comprobacin es correcta, false en caso contrario
\end */
function oficial_comprobarStock(curStock:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil();
	var referencia:String = curStock.valueBuffer("referencia");
	var codAlmacen:String = curStock.valueBuffer("codalmacen");
	if (util.sqlSelect("articulos", "controlstock", "referencia = '" + referencia + "'")) {
		return true;
	}

	var stockPedidos:Boolean = flfactppal.iface.pub_valorDefectoEmpresa("stockpedidos");

	var cantidadControl:Number;
	if (stockPedidos) {
		cantidadControl = curStock.valueBuffer("disponible");
	} else {
		cantidadControl = curStock.valueBuffer("cantidad");
	}
	if (cantidadControl < 0) {
		var nombreCantidad:String;
		if (stockPedidos) {
			nombreCantidad = util.translate("scripts", "cantidad disponible");
		} else {
			nombreCantidad = util.translate("scripts", "cantidad en stock");
		}
		if (!util.sqlSelect("articulos", "controlstock", "referencia = '" + referencia + "'")) {
			MessageBox.warning( util.translate("scripts", "El artculo %1 no permite ventas sin stock. Este movimiento dejara el stock de %2 con %3 %4.\n").arg(referencia).arg(codAlmacen).arg(nombreCantidad).arg(cantidadControl), MessageBox.Ok, MessageBox.NoButton);
			return false;
		}
	}
	return true;
}

/** \D Recalcula el coste medio de compra de un artculo como media del coste en todos los albaranes de proveedor

@param referencia Referencia del artculo
@return True si la modificacin tuvo xito, false en caso contrario
\end */
function oficial_cambiarCosteMedio(referencia:String):Boolean
{
	if (referencia == "")
		return true;

	var util:FLUtil = new FLUtil();
	var sumCant:Number = util.sqlSelect("lineasfacturasprov", "SUM(cantidad)", "referencia = '" + referencia + "'");
	if ( !sumCant )
		return true;
	var cM:Number = util.sqlSelect("lineasfacturasprov", "(SUM(pvptotal) / SUM(cantidad))", "referencia = '" + referencia + "'");
	if (!cM)
		cM = 0;

	var curArticulo:FLSqlCursor = new FLSqlCursor("articulos");
	curArticulo.select("referencia = '" + referencia + "'");
	if (curArticulo.first()) {
		curArticulo.setModeAccess(curArticulo.Edit);
		curArticulo.refreshBuffer();
		curArticulo.setValueBuffer("costemedio", cM);
		curArticulo.commitBuffer();
	}

	return true;
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function oficial_controlStockPedidosCli(curLP:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil;

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLP.valueBuffer("referencia") + "'")) {
		return true;
	}

	var codAlmacen:String;
	var curRel:FLSqlCursor = curLP.cursorRelation();
	if (curRel && curRel.table() == "pedidoscli") {
		codAlmacen = curRel.valueBuffer("codalmacen");
	} else {
		codAlmacen = util.sqlSelect("pedidoscli", "codalmacen", "idpedido = " + curLP.valueBuffer("idpedido"));
	}
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}

	if (!this.iface.controlStockReservado(curLP, codAlmacen)) {
		return false;
	}
	return true;
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
en caso de que no venga de un pedido, o que la opcin general de control
de stocks en pedidos est inhabilitada
\end */
function oficial_controlStockAlbaranesCli(curLA:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil();

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLA.valueBuffer("referencia") + "'")) {
		return true;
	}

	var codAlmacen:String;
	var curRel:FLSqlCursor = curLA.cursorRelation();
	if (curRel && curRel.table() == "albaranescli") {
		codAlmacen = curRel.valueBuffer("codalmacen");
	} else {
		codAlmacen = util.sqlSelect("albaranescli", "codalmacen", "idalbaran = " + curLA.valueBuffer("idalbaran"));
	}
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}


	if (!this.iface.controlStock( curLA, "cantidad", -1, codAlmacen )) {
		return false;
	}

	return true;
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function oficial_controlStockFacturasCli(curLF:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil();

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLF.valueBuffer("referencia") + "'")) {
		return true;
	}
	if (util.sqlSelect("facturascli", "automatica", "idfactura = " + curLF.valueBuffer("idfactura"))) {
		return true;
	}

	var codAlmacen:String;
	var curRel:FLSqlCursor = curLF.cursorRelation();
	if (curRel && curRel.table() == "facturascli") {
		codAlmacen = curRel.valueBuffer("codalmacen");
	} else {
		codAlmacen = util.sqlSelect("facturascli", "codalmacen", "idfactura = " + curLF.valueBuffer("idfactura"));
	}
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}
	if (!this.iface.controlStock(curLF, "cantidad", -1, codAlmacen)) {
		return false;
	}
	return true;
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function oficial_controlStockComandasCli(curLV:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil();

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLV.valueBuffer("referencia") + "'")) {
		return true;
	}

	var codAlmacen = util.sqlSelect("tpv_comandas c INNER JOIN tpv_puntosventa pv ON c.codtpv_puntoventa = pv.codtpv_puntoventa", "pv.codalmacen", "idtpv_comanda = " + curLV.valueBuffer("idtpv_comanda"), "tpv_comandas,tpv_puntosventa");
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}

	if (!this.iface.controlStock(curLV, "cantidad", -1, codAlmacen)) {
		return false;
	}

	return true;
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function oficial_controlStockPedidosProv(curLP:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil;

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLP.valueBuffer("referencia") + "'")) {
		return true;
	}

	var codAlmacen:String;
	var curRel:FLSqlCursor = curLP.cursorRelation();
	if (curRel && curRel.table() == "pedidosprov") {
		codAlmacen = curRel.valueBuffer("codalmacen");
	} else {
		codAlmacen = util.sqlSelect("pedidosprov", "codalmacen", "idpedido = " + curLP.valueBuffer("idpedido"));
	}
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}

	if (!this.iface.controlStockPteRecibir(curLP, codAlmacen)) {
		return false;
	}

	return true;
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function oficial_controlStockAlbaranesProv(curLA:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil();

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLA.valueBuffer("referencia") + "'")) {
		return true;
	}
	var codAlmacen:String;
	var curRel:FLSqlCursor = curLA.cursorRelation();
	if (curRel && curRel.table() == "albaranesprov") {
		codAlmacen = curRel.valueBuffer("codalmacen");
	} else {
		codAlmacen = util.sqlSelect("albaranesprov", "codalmacen", "idalbaran = " + curLA.valueBuffer("idalbaran"));
	}
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}

	if (!this.iface.controlStock(curLA, "cantidad", 1, codAlmacen)) {
		return false;
	}
	return true;
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function oficial_controlStockFacturasProv(curLF:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil;

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLF.valueBuffer("referencia") + "'")) {
		return true;
	}
	if (util.sqlSelect("facturasprov", "automatica", "idfactura = " + curLF.valueBuffer("idfactura"))) {
		return true;
	}
	var codAlmacen:String;
	var curRel:FLSqlCursor = curLF.cursorRelation();
	if (curRel && curRel.table() == "facturasprov") {
		codAlmacen = curRel.valueBuffer("codalmacen");
	} else {
		codAlmacen = util.sqlSelect("facturasprov", "codalmacen", "idfactura = " + curLF.valueBuffer("idfactura"));
	}
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}

	if (!this.iface.controlStock(curLF, "cantidad", 1, codAlmacen)) {
		return false;
	}
	return true;
}

/** \D Crea un registro de stock para el almacn y artculo especificados
@param	codAlmacen: Almacn
@param	referencia: Referencia del artculo
@return	identificador del stock o false si hay error
\end */
function oficial_crearStock(codAlmacen:String, referencia:String):Number
{
	var util:FLUtil = new FLUtil;
	var curStock:FLSqlCursor = new FLSqlCursor("stocks");

	/* fusiodarts: Agregado para compatibilidad
		La referencia puede venir como objeto o string
	*/
	var refArticulo:String;
	try {

		if (referencia.referencia){
			refArticulo = referencia.referencia
		}
	} catch (e) {
		// Si da error el try porque no es un objeto se almacena el string
		refArticulo = referencia;
	}
	/* FIN fusiodarts */

	with(curStock) {
		setModeAccess(Insert);
		refreshBuffer();
		setValueBuffer("codalmacen", codAlmacen);
		//setValueBuffer("referencia", referencia);
		setValueBuffer("referencia", refArticulo); /* fusiodarts: Agregado para compatibilidad */
		setValueBuffer("nombre", util.sqlSelect("almacenes", "nombre", "codalmacen = '" + codAlmacen + "'"));
		setValueBuffer("cantidad", 0);
		if (!commitBuffer())
			return false;
	}
	return curStock.valueBuffer("idstock");
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function oficial_controlStockLineasTrans(curLTS:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil();
	var codAlmacenOrigen:String = util.sqlSelect("transstock", "codalmaorigen", "idtrans = " + curLTS.valueBuffer("idtrans"));
	if (!codAlmacenOrigen || codAlmacenOrigen == "")
		return true;

	var codAlmacenDestino:String = util.sqlSelect("transstock", "codalmadestino", "idtrans = " + curLTS.valueBuffer("idtrans"));
	if (!codAlmacenDestino || codAlmacenDestino == "")
		return true;

	if (!this.iface.controlStock(curLTS, "cantidad", -1, codAlmacenOrigen))
			return false;

	if (!this.iface.controlStock(curLTS, "cantidad", 1, codAlmacenDestino))
			return false;

	return true;
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function oficial_controlStockValesTPV(curLinea:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil();

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLinea.valueBuffer("referencia") + "'"))
		return true;

	var codAlmacen:String = curLinea.valueBuffer("codalmacen");
	if (!codAlmacen || codAlmacen == "")
		return true;

	if (!this.iface.controlStock(curLinea, "cantidad", 1, codAlmacen))
			return false;

	return true;
}

/** \D Incrementa o decrementa el stock en funcin de la variacin experimentada por una lnea de documento de facturacin
@param	curLinea: Cursor posicionado en la lnea de documento de facturacin
@param	campo: Campo a modificar
@param	operacin: Indica si la cantidad debe sumarse o restarse del stock
@param	codAlmacen: Cdigo del almacn asociado al stock a modificar
@return	True si el control se realiza correctamente, false en caso contrario
*/
function oficial_controlStock( curLinea:FLSqlCursor, campo:String, signo:Number, codAlmacen:String ):Boolean
{
	var variacion:Number;
	var cantidad:Number = parseFloat( curLinea.valueBuffer( "cantidad" ) );
	var cantidadPrevia:Number = parseFloat( curLinea.valueBufferCopy( "cantidad" ) );

	if ( curLinea.table() == "lineaspedidoscli" || curLinea.table() == "lineaspedidosprov" ) {
		cantidad -= parseFloat( curLinea.valueBuffer( "totalenalbaran" ) );
		cantidadPrevia -= parseFloat( curLinea.valueBufferCopy( "totalenalbaran" ) );
	}

	switch(curLinea.modeAccess()) {
		case curLinea.Insert: {
			variacion = signo * cantidad;
			if ( !this.iface.cambiarStock( codAlmacen, curLinea.valueBuffer( "referencia" ), variacion, campo ) )
				return false;
			break;
		}
		case curLinea.Del: {
			variacion = signo * -1 * cantidad;
			if ( !this.iface.cambiarStock( codAlmacen, curLinea.valueBuffer( "referencia" ), variacion, campo ) )
				return false;
			break;
		}
		case curLinea.Edit: {
			if (curLinea.valueBuffer( "referencia" ) != curLinea.valueBufferCopy( "referencia" )) {
				variacion = signo * -1 * cantidadPrevia;
				if ( !this.iface.cambiarStock( codAlmacen, curLinea.valueBufferCopy( "referencia" ), variacion, campo ) )
					return false;
				variacion = signo * cantidad;
				if ( !this.iface.cambiarStock( codAlmacen, curLinea.valueBuffer( "referencia" ), variacion, campo, true ) )
					return false;
			}
			else {
				if(cantidad != cantidadPrevia);
				variacion = (cantidad - cantidadPrevia) * signo;
				if (!this.iface.cambiarStock( codAlmacen, curLinea.valueBuffer( "referencia" ), variacion, campo) )
					return false;
			}
			break;
		}
	}

	return true;
}

function oficial_controlStockPteRecibir(curLinea:FLSqlCursor, codAlmacen:String):Boolean
{
	var util:FLUtil = new FLUtil;

	var idPedido:String = curLinea.valueBuffer("idpedido");
	var referencia:String = curLinea.valueBuffer("referencia");
	if (referencia && referencia != "") {
		if (!this.iface.actualizarStockPteRecibir(referencia, codAlmacen, idPedido)) {
			return false;
		}
	}

	var referenciaPrevia:String = curLinea.valueBufferCopy("referencia");
	if (referenciaPrevia && referenciaPrevia != "" && referenciaPrevia != referencia) {
		if (!this.iface.actualizarStockPteRecibir(referenciaPrevia, codAlmacen, idPedido)) {
			return false;
		}
	}

	return true;
}

function oficial_actualizarStockPteRecibir(referencia:String, codAlmacen:String, idPedido:String):Boolean
{
	var util:FLUtil = new FLUtil;

	var idStock:String = util.sqlSelect("stocks", "idstock", "referencia = '" + referencia + "' AND codalmacen = '" + codAlmacen + "'");
	if ( !idStock ) {
		idStock = this.iface.crearStock( codAlmacen, referencia );
		if ( !idStock ) {
			return false;
		}
	}
	var pteRecibir:Number = util.sqlSelect("lineaspedidosprov lp INNER JOIN pedidosprov p ON lp.idpedido = p.idpedido", "sum(lp.cantidad - lp.totalenalbaran)", "p.codalmacen = '" + codAlmacen + "' AND (p.servido IN ('No', 'Parcial') OR p.idpedido = " + idPedido + ") AND lp.referencia = '" + referencia + "' AND (lp.cerrada IS NULL OR lp.cerrada = false)", "lineaspedidosprov,pedidosprov");

	if (isNaN(pteRecibir)) {
		pteRecibir = 0;
	}

	var curStock:FLSqlCursor = new FLSqlCursor("stocks");
	curStock.select("idstock = " + idStock);
	if (!curStock.first()) {
		return false;
	}
	curStock.setModeAccess(curStock.Edit);
	curStock.refreshBuffer();
	curStock.setValueBuffer("pterecibir", pteRecibir);
	if (!curStock.commitBuffer()) {
		return false;
	}
	return true;
}

function oficial_controlStockReservado(curLinea:FLSqlCursor, codAlmacen:String):Boolean
{
	var util:FLUtil = new FLUtil;

	var idPedido:String = curLinea.valueBuffer("idpedido");
	var referencia:String = curLinea.valueBuffer("referencia");
	if (referencia && referencia != "") {
		if (!this.iface.actualizarStockReservado(referencia, codAlmacen, idPedido)) {
			return false;
		}
	}

	var referenciaPrevia:String = curLinea.valueBufferCopy("referencia");
	if (referenciaPrevia && referenciaPrevia != "" && referenciaPrevia != referencia) {
		if (!this.iface.actualizarStockReservado(referenciaPrevia, codAlmacen, idPedido)) {
			return false;
		}
	}

	return true;
}

function oficial_actualizarStockReservado(referencia:String, codAlmacen:String, idPedido:String):Boolean
{
	var util:FLUtil = new FLUtil;

	var idStock:String = util.sqlSelect("stocks", "idstock", "referencia = '" + referencia + "' AND codalmacen = '" + codAlmacen + "'");
	if ( !idStock ) {
		idStock = this.iface.crearStock( codAlmacen, referencia );
		if ( !idStock ) {
			return false;
		}
	}

	var reservada:Number = util.sqlSelect("lineaspedidoscli lp INNER JOIN pedidoscli p ON lp.idpedido = p.idpedido", "sum(lp.cantidad - lp.totalenalbaran)", "p.codalmacen = '" + codAlmacen + "' AND (p.servido IN ('No', 'Parcial') OR p.idpedido = " + idPedido + ") AND lp.referencia = '" + referencia + "' AND (lp.cerrada IS NULL OR lp.cerrada = false)", "lineaspedidoscli,pedidoscli");
	if (isNaN(reservada)) {
		reservada = 0;
	}

	var curStock:FLSqlCursor = new FLSqlCursor("stocks");
	curStock.select("idstock = " + idStock);
	if (!curStock.first()) {
		return false;
	}
	curStock.setModeAccess(curStock.Edit);
	curStock.refreshBuffer();
	curStock.setValueBuffer("reservada", reservada);
	curStock.setValueBuffer("disponible", formRecordregstocks.iface.pub_commonCalculateField("disponible", curStock));
	if (!this.iface.comprobarStock(curStock)) {
		return false;
	}
	if (!curStock.commitBuffer()) {
		return false;
	}
	return true;
}

function oficial_valorDefectoAlmacen(fN:String):String
{
	var query:FLSqlQuery = new FLSqlQuery();

	query.setTablesList( "factalma_general" );
	query.setForwardOnly( true );
	query.setSelect( fN );
	query.setFrom( "factalma_general" );
	if ( query.exec() ) {
		if ( query.next() ) {
			return query.value( 0 );
		}
	}

	return "";
}


function oficial_controlRegStock(curLRS):Boolean
{
debug("oficial_controlRegStock");
        var curRel = curLRS.cursorRelation();
        if (curRel && curRel.table() == "stocks") {
            return true;
        }
        var curStock = new FLSqlCursor("stocks");
        curStock.select("idstock = " + curLRS.valueBuffer("idstock"));
        if (!curStock.first()) {
debug("idstock = " + curLRS.valueBuffer("idstock"));
            return false;
        }
        curStock.setModeAccess(curStock.Edit);
        curStock.refreshBuffer();

        var fechaUltReg:String = formRecordregstocks.iface.commonCalculateField("fechaultreg", curStock);
        if (fechaUltReg) {
                curStock.setValueBuffer("fechaultreg", fechaUltReg);
                curStock.setValueBuffer("horaultreg", formRecordregstocks.iface.commonCalculateField("horaultreg", curStock));
                curStock.setValueBuffer("cantidadultreg", formRecordregstocks.iface.commonCalculateField("cantidadultreg", curStock));
        } else {
                curStock.setNull("fechaultreg");
                curStock.setNull("horaultreg");
                curStock.setValueBuffer("cantidadultreg", 0);
        }
        curStock.setValueBuffer("cantidad", formRecordregstocks.iface.commonCalculateField("cantidad", curStock));
        curStock.setValueBuffer("disponible", formRecordregstocks.iface.commonCalculateField("disponible", curStock));
        if (!curStock.commitBuffer()) {
                debug("!curStock.commitBuffer");
                return false;
        }
        return true;
}

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition tarifaGenerator */
/////////////////////////////////////////////////////////////////
function tarifaGenerator_afterCommit_tarifas(curTarifa)
{
	var util:FLUtil = new FLUtil;
	switch (curTarifa.modeAccess()) {
		case curTarifa.Insert:
			{
	var curArticulos = new FLSqlCursor("articulos");
	    curArticulos.select("NOT solobase");
	    if (curArticulos.first()) {
	    				var curArtTarifas = new FLSqlCursor("articulostarifas");
        		    		do
        		    			{
        		    			curArtTarifas.setModeAccess(curArtTarifas.Insert);
        		    			curArtTarifas.refreshBuffer();
        		    			curArtTarifas.setValueBuffer("codtarifa",curTarifa.valueBuffer("codtarifa"));
        		    			curArtTarifas.setValueBuffer("referencia",curArticulos.valueBuffer("referencia"));
        		    			if(!curArtTarifas.commitBuffer())
        		    				debug("No se ha creado articulostarifa para referencia " + curArticulos.valueBuffer("referencia"));
        		    			} while (curArticulos.next());
	    				}
			}

	}


}
//// TARIFAGENERATOR ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition keepAlive */
/////////////////////////////////////////////////////////////////
//// KEEP_ALIVE /////////////////////////////////////////////////
function keepAlive_init()
{

  this.iface.__init();

  var util:FLUtil = new FLUtil;
  //var funcion:String = util.readSettingEntry("application/callFunction");
  //if (funcion != "flfactppal.globalInit") {
//	util.writeSettingEntry("application/callFunction", "flfactppal.globalInit");
//	}
}
//// KEEP_ALIVE /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition scabLite */
/////////////////////////////////////////////////////////////////
//// CONTROL STOCKS CABECERA ////////////////////////////////////
/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */

function scabLite_arraySocksAfectados(arrayInicial:Array, arrayFinal:Array):Array
{
    var arrayAfectados:Array = [];
    var iAA:Number = 0;
    var iAI:Number = 0;
    var iAF:Number = 0;
    var longAI:Number = arrayInicial.length;
    var longAF:Number = arrayFinal.length;


    arrayInicial.sort(this.iface.compararArrayStock);
    arrayFinal.sort(this.iface.compararArrayStock);

    var comparacion:Number;
    while (iAI < longAI || iAF < longAF) {
        if (iAI < longAI && iAF < longAF) {
	    //debug("Compara linea");
            comparacion = this.iface.compararArrayStock(arrayInicial[iAI], arrayFinal[iAF]);
        } else if (iAF < longAF) {
	    //debug("Nueva linea");
            comparacion = 1;
        } else if (iAI < longAI) {
	     //debug("Falta linea");
            comparacion = -1;
        }
        switch (comparacion) {
            case 1: {
                arrayAfectados[iAA] = [];
                arrayAfectados[iAA]["idarticulo"] = arrayFinal[iAF]["idarticulo"];
                arrayAfectados[iAA]["codalmacen"] = arrayFinal[iAF]["codalmacen"];
                arrayAfectados[iAA]["cantidad"] = arrayFinal[iAF]["cantidad"];
                iAF++;
                iAA++;
                break;
            }
            case -1: {
                arrayAfectados[iAA] = [];
                arrayAfectados[iAA]["idarticulo"] = arrayInicial[iAI]["idarticulo"];
                arrayAfectados[iAA]["codalmacen"] = arrayInicial[iAI]["codalmacen"];
                arrayAfectados[iAA]["cantidad"] =  arrayInicial[iAI]["cantidad"] * -1;
                iAI++;
                iAA++;
                break;
            }
            case 0: {
                if (arrayInicial[iAI]["cantidad"] != arrayFinal[iAF]["cantidad"]) {
                    arrayAfectados[iAA] = [];
                    arrayAfectados[iAA]["idarticulo"] = arrayFinal[iAI]["idarticulo"];
                    arrayAfectados[iAA]["codalmacen"] = arrayFinal[iAI]["codalmacen"];
                    arrayAfectados[iAA]["cantidad"] = arrayFinal[iAF]["cantidad"] - arrayInicial[iAI]["cantidad"];
                    iAA++;
                }
                iAI++;
                iAF++;
                break;
            }
        }
        //debug("REFERENCIA = " + arrayAfectados[iAA - 1]["idarticulo"]);
        //debug("CANTIDAD = " + arrayAfectados[iAA - 1 ]["cantidad"]);

    }
    return arrayAfectados;
}

function scabLite_compararArrayStock(a:Array, b:Array):Number
{
    var resultado:Number = 0;
    if (a["codalmacen"] > b["codalmacen"]) {
        resultado = 1;
    } else if (a["codalmacen"] < b["codalmacen"]) {
        resultado = -1;
    } else if (a["codalmacen"] == b["codalmacen"]) {
        if (a["idarticulo"] > b["idarticulo"])  {
            resultado = 1;
        } else if (a["idarticulo"] < b["idarticulo"])  {
            resultado = -1;
        }
    }
    return resultado;
}

//// CONTROL STOCKS CABECERA ////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition almacenLinea */
/////////////////////////////////////////////////////////////////
//// ALMACEN_LINEA //////////////////////////////////////////////
/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function almacenLinea_controlStockPedidosCli(curLP:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil;

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLP.valueBuffer("referencia") + "'")) {
		return true;
	}

	var codAlmacen:String = curLP.valueBuffer("codalmacen");
	if (!codAlmacen || codAlmacen == "") {
		var curRel:FLSqlCursor = curLP.cursorRelation();
		if (curRel && curRel.table() == "pedidoscli") {
			codAlmacen = curRel.valueBuffer("codalmacen");
		} else {
			codAlmacen = util.sqlSelect("pedidoscli", "codalmacen", "idpedido = " + curLP.valueBuffer("idpedido"));
		}
	}
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}

	if (!this.iface.controlStockReservado(curLP, codAlmacen)) {
		return false;
	}

	var stockPedidos:Boolean = flfactppal.iface.pub_valorDefectoEmpresa("stockpedidos");
	if (stockPedidos)
		{
		if (!this.iface.controlStock( curLP, "cantidad", -1, codAlmacen )) {
			return false;
			}
		}
	return true;
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
en caso de que no venga de un pedido, o que la opcin general de control
de stocks en pedidos est inhabilitada
\end */
function almacenLinea_controlStockAlbaranesCli(curLA:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil();

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLA.valueBuffer("referencia") + "'")) {
		return true;
	}


	var codAlmacen:String = curLA.valueBuffer("codalmacen");
	if (!codAlmacen || codAlmacen == "") {
		var curRel:FLSqlCursor = curLA.cursorRelation();
		if (curRel && curRel.table() == "albaranescli") {
			codAlmacen = curRel.valueBuffer("codalmacen");
		} else {
			codAlmacen = util.sqlSelect("albaranescli", "codalmacen", "idalbaran = " + curLA.valueBuffer("idalbaran"));
		}
	}
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}

	if (!this.iface.controlStock( curLA, "cantidad", -1, codAlmacen )) {
		return false;
	}

	return true;
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function almacenLinea_controlStockFacturasCli(curLF:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil();
	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLF.valueBuffer("referencia") + "'")) {
		return true;
	}
	if (util.sqlSelect("facturascli", "automatica", "idfactura = " + curLF.valueBuffer("idfactura"))) {
		return true;
	}

	var codAlmacen:String = curLF.valueBuffer("codalmacen");
	if (!codAlmacen || codAlmacen == "") {
		var curRel:FLSqlCursor = curLF.cursorRelation();
		if (curRel && curRel.table() == "facturascli") {
			codAlmacen = curRel.valueBuffer("codalmacen");
		} else {
			codAlmacen = util.sqlSelect("facturascli", "codalmacen", "idfactura = " + curLF.valueBuffer("idfactura"));
		}
	}
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}

	if (!this.iface.controlStock(curLF, "cantidad", -1, codAlmacen)) {
		return false;
	}

	return true;
}


/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function almacenLinea_controlStockPedidosProv(curLP:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil;

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLP.valueBuffer("referencia") + "'")) {
		return true;
	}

	var codAlmacen:String = curLP.valueBuffer("codalmacen");
	if (!codAlmacen || codAlmacen == "") {
		var curRel:FLSqlCursor = curLP.cursorRelation();
		if (curRel && curRel.table() == "pedidosprov") {
			codAlmacen = curRel.valueBuffer("codalmacen");
		} else {
			codAlmacen = util.sqlSelect("pedidosprov", "codalmacen", "idpedido = " + curLP.valueBuffer("idpedido"));
		}
	}
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}

	if (!this.iface.controlStockPteRecibir(curLP, codAlmacen)) {
		return false;
	}

	return true;
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function almacenLinea_controlStockAlbaranesProv(curLA:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil();

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLA.valueBuffer("referencia") + "'")) {
		return true;
	}
	var codAlmacen:String = curLA.valueBuffer("codalmacen");
	if (!codAlmacen || codAlmacen == "") {
		var curRel:FLSqlCursor = curLA.cursorRelation();
		if (curRel && curRel.table() == "albanesprov") {
			codAlmacen = curRel.valueBuffer("codalmacen");
		} else {
			codAlmacen = util.sqlSelect("albaranesprov", "codalmacen", "idalbaran = " + curLA.valueBuffer("idalbaran"));
		}
	}
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}

	if (!this.iface.controlStock(curLA, "cantidad", 1, codAlmacen)) {
		return false;
	}
	return true;
}

/** \C
Actualiza el stock correspondiente al artculo seleccionado en la lnea
\end */
function almacenLinea_controlStockFacturasProv(curLF:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil;

	if (util.sqlSelect("articulos", "nostock", "referencia = '" + curLF.valueBuffer("referencia") + "'")) {
		return true;
	}
	if (util.sqlSelect("facturasprov", "automatica", "idfactura = " + curLF.valueBuffer("idfactura"))) {
		return true;
	}
	var codAlmacen:String = curLF.valueBuffer("codalmacen");
	if (!codAlmacen || codAlmacen == "") {
		var curRel:FLSqlCursor = curLF.cursorRelation();
		if (curRel && curRel.table() == "facturasprov") {
			codAlmacen = curRel.valueBuffer("codalmacen");
		} else {
			codAlmacen = util.sqlSelect("facturasprov", "codalmacen", "idfactura = " + curLF.valueBuffer("idfactura"));
		}
	}
	if (!codAlmacen || codAlmacen == "") {
		return true;
	}

	if (!this.iface.controlStock(curLF, "cantidad", 1, codAlmacen)) {
		return false;
	}
	return true;
}

/** \D Incrementa o decrementa el stock en funcin de la variacin experimentada por una lnea de documento de facturacin
@param	curLinea: Cursor posicionado en la lnea de documento de facturacin
@param	campo: Campo a modificar
@param	operacin: Indica si la cantidad debe sumarse o restarse del stock
@param	codAlmacen: Cdigo del almacn asociado al stock a modificar
@return	True si el control se realiza correctamente, false en caso contrario
*/
function almacenLinea_controlStock( curLinea:FLSqlCursor, campo:String, signo:Number, codAlmacen:String ):Boolean
{
	var variacion:Number;
	var cantidad:Number = parseFloat( curLinea.valueBuffer( "cantidad" ) );
	var cantidadPrevia:Number = parseFloat( curLinea.valueBufferCopy( "cantidad" ) );
	var cod_almacen_viejo_linea:String = "";
	var cod_almacen_viejo_cabecera:String = "";


	if ( curLinea.table() == "lineaspedidoscli" || curLinea.table() == "lineaspedidosprov" ) {
		cantidad -= parseFloat( curLinea.valueBuffer( "totalenalbaran" ) );
		cantidadPrevia -= parseFloat( curLinea.valueBufferCopy( "totalenalbaran" ) );
	}

	switch(curLinea.modeAccess()) {
		case curLinea.Insert: {
			variacion = signo * cantidad;
			if ( !this.iface.cambiarStock( codAlmacen, curLinea.valueBuffer( "referencia" ), variacion, campo ) )
				return false;
			break;
		}
		case curLinea.Del: {
			variacion = signo * -1 * cantidad;
			if ( !this.iface.cambiarStock( codAlmacen, curLinea.valueBuffer( "referencia" ), variacion, campo ) )
				return false;
			break;
		}
		case curLinea.Edit: {
			cod_almacen_viejo_linea = curLinea.valueBufferCopy( "codalmacen" );
			if (cod_almacen_viejo_linea == "")
					{
					var curRel:FLSqlCursor = curLinea.cursorRelation();
					if (curRel)
						{
						cod_almacen_viejo_linea = curRel.valueBufferCopy("codalmacen");
						}
					}
			//if (!cod_almacen_viejo_linea)
			//	codAlmacenViejo = codAlmacen;





			if ((curLinea.valueBuffer( "referencia" ) != curLinea.valueBufferCopy( "referencia" )) || codAlmacen != cod_almacen_viejo_linea ) {
				variacion = signo * -1 * cantidadPrevia;
				if ( !this.iface.cambiarStock( cod_almacen_viejo_linea, curLinea.valueBufferCopy( "referencia" ), variacion, campo ) )
					return false;
				variacion = signo * cantidad;
				if ( !this.iface.cambiarStock( codAlmacen, curLinea.valueBuffer( "referencia" ), variacion, campo, true ) )
					return false;
			}
			else {
				if(cantidad != cantidadPrevia);
				variacion = (cantidad - cantidadPrevia) * signo;
				if (!this.iface.cambiarStock( codAlmacen, curLinea.valueBuffer( "referencia" ), variacion, campo) )
					return false;
			}
			break;
		}
	}

	return true;
}
//// ALMACEN_LINEA //////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition stockUnificado */
/////////////////////////////////////////////////////////////////
//// STOCK_UNIFICADO ////////////////////////////////////////////
function stockUnificado_init()
{
this.iface.__init();
//this.iface.revisar_entradas("");
}







function stockUnificado_controlStock( curLinea:FLSqlCursor, campo:String, signo:Number, codAlmacen:String ):Boolean
{
var util:FLUtil = new FLUtil;
var conn:String = this.iface.recogeConnUnificada();
debug("CONTROL STOCK! " + curLinea.table());
if ( curLinea.table() == "lineaspedidoscli")
		{
		if (!curLinea.isNull("fecha_reserva") || curLinea.valueBuffer("fecha_reserva") < new Date())
			{
			debug("Esta linea es reserva y su fecha es superior a hoy!. No se controla su stock!");
			return true;
			}
		}

if (curLinea.table() == "lineaspedidosprov" || curLinea.table() == "lineasalbaranesprov" || curLinea.table() == "lineasfacturasprov")
		{
		var referencia : String = curLinea.valueBuffer("referencia");
		if (util.sqlSelect("articulos", "stock_indirecto", "referencia = '" + referencia + "'","",conn))
			{
			debug("** Stock indirecto activado para " + referencia + ". no se cambiara el stock segun linea");
			if (curLinea.table() == "lineasfacturasprov" && !curLinea.isNull("fecha_disponible")) //Solo se controla stock en facturasprov y con fecha disponible.
				{
				if (curLinea.modeAccess() == curLinea.Del || curLinea.modeAccess() == curLinea.Edit)
					{
					//Si cambia referencia, cantidad o almacen , elimino montante previo.
					if (curLinea.valueBuffer("referencia") != curLinea.valueBufferCopy("referencia") || curLinea.valueBuffer("codalmacen") != curLinea.valueBufferCopy("codalmacen") || curLinea.valueBuffer("cantidad") != curLinea.valueBufferCopy("cantidad") || curLinea.valueBuffer("fecha_disponible") != curLinea.valueBufferCopy("fecha_disponible"))
						{
						//Elimina entrada existente.
						this.iface.borra_montante(curLinea);
						}
					}
				if (curLinea.modeAccess() == curLinea.Edit || curLinea.modeAccess() == curLinea.Insert)
					{
					this.iface.crea_montante(curLinea);
					}

				}
			return true;
			}
		}

return this.iface.__controlStock( curLinea, campo, signo, codAlmacen);

}


function stockUnificado_recogeConnUnificada()
{
//Recogemos conexin a usar en los cursores.
	if (!this.iface.conn_unificada)
		{
		debug("Creando conn unificada");
		if (!this.iface.valorDefectoAlmacen("es_unificado") || (this.iface.valorDefectoAlmacen("es_unificado") && this.iface.valorDefectoAlmacen("tipo_servidor") == "Local"))
			{
			this.iface.conn_unificada = "default";
			}
		else
			{
			//Creamos conexin remota.
			this.iface.conn_unificada = "default";

			var util:FLUtil = new FLUtil();
			//var cursor:FLSqlCursor = this.cursor();

			var driver:String = this.iface.valorDefectoAlmacen("driver_remoto");
			var nombreBD:String = this.iface.valorDefectoAlmacen("db_remota");
			var usuario:String = this.iface.valorDefectoAlmacen("usuario_remoto");
			var host:String = this.iface.valorDefectoAlmacen("host_remoto");
			var puerto:String = this.iface.valorDefectoAlmacen("puerto_remoto");
			var password:String = this.iface.valorDefectoAlmacen("password_remoto");


			if (!driver || !nombreBD || !usuario || !host) {
				debug("PELIGRO: Los datos de conexin estn incompletos!!");
				}

			else {
				this.iface.conn_unificada = "remota_stock";
				if (!sys.addDatabase(driver, nombreBD, usuario, password, host, puerto, this.iface.conn_unificada)) {
					debug("No se ha establecido la conexin");
					}
				else {
					debug("Conexin remota establecida satisfactoriamente");
					}


				}
			}
		}
		//debug("Usando conn " + this.iface.conn_unificada + " para gestin stocks");
		return this.iface.conn_unificada;
}


function stockUnificado_controlRegStock(curLRS:FLSqlCursor):Boolean
{
debug("stockUnificado_controlRegStock");
	debug("--> Ini " + curLRS.valueBuffer("cantidadini"));
	debug("--> Fin " + curLRS.valueBuffer("cantidadfin"));
	debug("--> IDStock " + curLRS.valueBuffer("idstock"));
        var curRel = curLRS.cursorRelation();
        if (curRel && curRel.table() == "stocks") {
		debug("Chao!");
            return true;
        }

	var conn:String = this.iface.recogeConnUnificada();
        var curStock = new FLSqlCursor("stocks", conn);

        curStock.select("idstock = " + curLRS.valueBuffer("idstock"));
        if (!curStock.first()) {
debug("idstock = " + curLRS.valueBuffer("idstock"));
            return false;
        }
        curStock.setModeAccess(curStock.Edit);
        curStock.refreshBuffer();

        var fechaUltReg:String = formRecordregstocks.iface.commonCalculateField("fechaultreg", curStock);
        if (fechaUltReg) {
		//debug("**fecha" + fechaUltReg +" <- " + formRecordregstocks.iface.commonCalculateField("cantidadultreg", curStock));
                curStock.setValueBuffer("fechaultreg", fechaUltReg);
                curStock.setValueBuffer("horaultreg", formRecordregstocks.iface.commonCalculateField("horaultreg", curStock));
                curStock.setValueBuffer("cantidadultreg", formRecordregstocks.iface.commonCalculateField("cantidadultreg", curStock));
        } else {
                curStock.setNull("fechaultreg");
                curStock.setNull("horaultreg");
                curStock.setValueBuffer("cantidadultreg", 0);
        }
	debug("Cantidad para stocks" + formRecordregstocks.iface.commonCalculateField("cantidad", curStock));
	debug("Disponible para stocks" + formRecordregstocks.iface.commonCalculateField("disponible", curStock));

        //curStock.setValueBuffer("cantidad", formRecordregstocks.iface.commonCalculateField("cantidad", curStock));
	curStock.setValueBuffer("cantidad", formRecordregstocks.iface.commonCalculateField("cantidadultreg", curStock));
        curStock.setValueBuffer("disponible", formRecordregstocks.iface.commonCalculateField("disponible", curStock));
        if (!curStock.commitBuffer()) {
                debug("!curStock.commitBuffer");
                return false;
        }
	curStock.refreshBuffer();
	debug("Nueva cantidad" + curStock.valueBuffer("cantidad"));
	debug("Nueva disponible" + curStock.valueBuffer("disponible"));
        return true;
}

function stockUnificado_actualizarStockReservado(referencia:String, codAlmacen:String, idPedido:String):Boolean
{
	var util:FLUtil = new FLUtil;
	debug("stockUnificado_actualizarStockReservado");
	var conn:String = this.iface.recogeConnUnificada();
	var idStock:String = util.sqlSelect("stocks", "idstock", "referencia = '" + referencia + "' AND codalmacen = '" + codAlmacen + "'", "", conn);
	if ( !idStock ) {
		idStock = this.iface.crearStock( codAlmacen, referencia );
		if ( !idStock ) {
			return false;
		}
	}

	var reservada:Number = util.sqlSelect("lineaspedidoscli lp INNER JOIN pedidoscli p ON lp.idpedido = p.idpedido", "sum(lp.cantidad - lp.totalenalbaran)", "p.codalmacen = '" + codAlmacen + "' AND (p.servido IN ('No', 'Parcial') OR p.idpedido = " + idPedido + ") AND lp.referencia = '" + referencia + "' AND (lp.cerrada IS NULL OR lp.cerrada = false)", "lineaspedidoscli,pedidoscli", conn);
	if (isNaN(reservada)) {
		reservada = 0;
	}

	var stockPedidos:Boolean = flfactppal.iface.pub_valorDefectoEmpresa("stockpedidos");
	if (stockPedidos)
		{
		reservada = 0;
		}


        var curStock:FLSqlCursor  = new FLSqlCursor("stocks", conn);
	curStock.select("idstock = " + idStock);
	if (!curStock.first()) {
		return false;
	}
	curStock.setModeAccess(curStock.Edit);
	curStock.refreshBuffer();
	curStock.setValueBuffer("reservada", reservada);
	curStock.setValueBuffer("disponible", formRecordregstocks.iface.pub_commonCalculateField("disponible", curStock));
	if (!this.iface.comprobarStock(curStock)) {
		return false;
	}
	if (!curStock.commitBuffer()) {
		return false;
	}
	return true;
}

function stockUnificado_crearStock(codAlmacen:String, referencia:String):Number
{
	var util:FLUtil = new FLUtil;
	debug("stockUnificado_crearStock");
	var conn:String = this.iface.recogeConnUnificada();
        var curStock:FLSqlCursor  = new FLSqlCursor("stocks", conn);

	/* fusiodarts: Agregado para compatibilidad
		La referencia puede venir como objeto o string
	*/
	var refArticulo:String;
	try {

		if (referencia.referencia){
			refArticulo = referencia.referencia
		}
	} catch (e) {
		// Si da error el try porque no es un objeto se almacena el string
		refArticulo = referencia;
	}
	/* FIN fusiodarts */

	with(curStock) {
		setModeAccess(Insert);
		refreshBuffer();
		setValueBuffer("codalmacen", codAlmacen);
		//setValueBuffer("referencia", referencia);
		setValueBuffer("referencia", refArticulo); /* fusiodarts: Agregado para compatibilidad */
		setValueBuffer("nombre", util.sqlSelect("almacenes", "nombre", "codalmacen = '" + codAlmacen + "'"));
		setValueBuffer("cantidad", 0);
		if (!commitBuffer())
			return false;
	}
	return curStock.valueBuffer("idstock");
}

function stockUnificado_cambiarStock(codAlmacen:String, referencia:String, variacion:Number, campo:String, noAvisar:Boolean ):Boolean
{
	debug("stockUnificado_cambiarStock");
	var util:FLUtil = new FLUtil();
	if (referencia == "" || !referencia) {
		return true;
	}

	if (codAlmacen == "" || !codAlmacen) {
		return true;
	}



	if ( !campo || campo == "") {
		return false;
	}

	var idStock:String;
	var conn:String = this.iface.recogeConnUnificada();
	idStock = util.sqlSelect("stocks", "idstock", "referencia = '" + referencia + "' AND codalmacen = '" + codAlmacen + "'","",conn);
	if ( !idStock ) {
		idStock = this.iface.crearStock( codAlmacen, referencia );
		if ( !idStock ) {
			return false;
		}
	}
	var curStock:FLSqlCursor = new FLSqlCursor( "stocks", conn);
	curStock.select( "idstock = " + idStock );
	if ( !curStock.first() ) {
		return false;
	}

	curStock.setModeAccess( curStock.Edit );
	curStock.refreshBuffer();

	var cantidadPrevia:Number = parseFloat( curStock.valueBuffer( campo ) );
	var nuevaCantidad:Number = cantidadPrevia + parseFloat( variacion );

// 	if (nuevaCantidad < 0 && campo == "cantidad") {
// 		if (!util.sqlSelect("articulos", "controlstock", "referencia = '" + referencia + "'")) {
// 			MessageBox.warning( util.translate("scripts", "El artculo %1 no permite ventas sin stock. Este movimiento dejar el stock de %2 con cantidad %3.\n").arg(referencia).arg(codAlmacen).arg(nuevaCantidad), MessageBox.Ok, MessageBox.NoButton);
// 			return false;
// 		}
// 	}

	curStock.setValueBuffer( campo, nuevaCantidad );
	if (campo == "cantidad" || campo == "reservada") {
		curStock.setValueBuffer("disponible", formRecordregstocks.iface.pub_commonCalculateField("disponible", curStock));
	}

	if (!this.iface.comprobarStock(curStock)) {
		return false;
	}

	if ( !curStock.commitBuffer() ) {
		return false;
	}

	if (conn != "default")
		{
		debug("Forzando aftercommit stocks");
		curStock.setModeAccess(curStock.Edit);
		this.iface.afterCommit_stocks(curStock);
		}

	return true;
}

/** \D
Actualiza el stock fsico total en la tabla de artculos
\end */
function stockUnificado_afterCommit_stocks(curStock:FLSqlCursor):Boolean
{
	debug("stockUnificado_afterCommit_stocks");
	var util:FLUtil = new FLUtil;
	var conn:String = this.iface.recogeConnUnificada();
	var referencia:String = curStock.valueBuffer("referencia");
	var stockFisico:Number = util.sqlSelect("stocks", "SUM(cantidad)", "referencia = '" + referencia + "'", "", conn);
	switch (curStock.modeAccess()) {
		case curStock.Edit:
			var refAnterior:String = curStock.valueBufferCopy("referencia");
			if (referencia != refAnterior) {
				if (!util.sqlUpdate("articulos", "stockfis", stockFisico, "referencia = '" + refAnterior + "'", conn))
					{
					return false;
					debug("ok");
					}
			}
		case curStock.Insert:
// 			if((curStock.valueBufferCopy("cantidad") != curStock.valueBuffer("cantidad")) || (curStock.valueBufferCopy("reservada") != curStock.valueBuffer("reservada"))) {
// 				curStock.setValueBuffer("disponible",parseFloat(curStock.valueBuffer("cantidad")) - parseFloat(curStock.valueBuffer("reservada")));
// 			}
		case curStock.Del:
			if (!util.sqlUpdate("articulos", "stockfis", stockFisico, "referencia = '" + referencia + "'", conn))
				return false;
	}
	return true;
}

function stockUnificado_revisar_entradas(referencia:String)
{
debug("Revisando entrada de " + referencia);
var util:FLUtil = new FLUtil;


var filtro:String;
if (referencia == "")
	{
	//filtro = "1 = 1";
	return;
	}
else
	{
	filtro = "referencia ='" + referencia + "'";
	}

var conn:String = this.iface.recogeConnUnificada();
//Creamos lista de referencias.
var qry_referencias: FLSqlQuery = new FLSqlQuery("", conn);
qry_referencias.setTablesList("articulos");
qry_referencias.setSelect("referencia");
qry_referencias.setFrom("articulos");
qry_referencias.setWhere(filtro);
qry_referencias.setOrderBy( "referencia asc" );
debug("Entrada qry referencias " + qry_referencias.sql());
if (!qry_referencias.exec())
	{
	MessageBox.critical(util.translate("scripts","Problema al actualizar las entradas de planta (1 - " + qry_referencias.value("referencia") +" ). Avise al tcnico."), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
	return;
	}

while (qry_referencias.next()) //Selecciono referencia
	{
	var qry_almacenes: FLSqlQuery = new FLSqlQuery("", conn);
	qry_almacenes.setTablesList("almacenes");
	qry_almacenes.setSelect("codalmacen");
	qry_almacenes.setFrom("almacenes");
	qry_almacenes.setWhere("1 = 1");
	debug("Entrada qry almacenes " + qry_almacenes.sql());
	if (!qry_almacenes.exec())
		{
		MessageBox.critical(util.translate("scripts","Problema al actualizar las entradas de planta (2 - " + qry_referencias.value("referencia") + " ). Avise al tcnico."), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
		return;
		}
	while (qry_almacenes.next()) //Selecciono almacen
		{
		var cur_stocks: FLSqlCursor = new FLSqlCursor("stocks", conn);
		//cur_stocks.select();
		//cur_stocks.setModeAccess(cur_stocks.Edit);
		//cur_stocks.refreshBuffer();

		if (!util.sqlSelect("stocks","referencia","referencia ='" + qry_referencias.value("referencia") + "' AND codalmacen ='" + qry_almacenes.value("codalmacen") + "'", "stocks", conn))
			{
			debug("Crenado id_stock");
			//Nuevo registro en stocks.
			cur_stocks.setModeAccess(cur_stocks.Insert);
			cur_stocks.refreshBuffer();
			cur_stocks.setValueBuffer("codalmacen", qry_almacenes.value("codalmacen"));
			cur_stocks.setValueBuffer("nombre", util.sqlSelect("articulos","descripcion","referencia = '" + qry_referencias.value("referencia") + "'"));
			cur_stocks.setValueBuffer("referencia", qry_referencias.value("referencia"));

			if (!cur_stocks.commitBuffer())
				{
				MessageBox.critical(util.translate("scripts","Problema al actualizar las entradas de planta (3 - " + qry_referencias.value("referencia") + " " + qry_almacenes.value("codalmacen") + " ). Avise al tcnico."), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
				return;
				}
			}

		//cur_stocks.refreshBuffer(); // Refrescamos ???
		//Sacamos el id_stock
		var id_stock = util.sqlSelect("stocks","idstock","referencia = '" + qry_referencias.value("referencia") + "' AND codalmacen ='" + qry_almacenes.value("codalmacen") +"'", "stocks", conn);
		var cantidad_previa:Number = util.sqlSelect("stocks","cantidad","referencia = '" + qry_referencias.value("referencia") + "' AND codalmacen ='" + qry_almacenes.value("codalmacen") +"'", "stocks", conn);
		var hoy: Date = new Date();
		var cantidad_entradas: Number = this.iface.calcular_entradas(id_stock, hoy);

		if (cantidad_entradas == 0)
			{
			continue;
			}

		var cantidad_nueva:Number = cantidad_entradas + cantidad_previa;
		var desc:String = "Disponibilidad produccin FINCA: " +  qry_almacenes.value("codalmacen") + " REFERENCIA : " + qry_referencias.value("referencia") ;
		var cur_reg_stock: FLSqlCursor = new FLSqlCursor("lineasregstocks", conn);
		cur_reg_stock.select();
		cur_reg_stock.setModeAccess(cur_reg_stock.Insert);
		cur_reg_stock.refreshBuffer();
		cur_reg_stock.setValueBuffer("idstock",id_stock);
		cur_reg_stock.setValueBuffer("fecha", hoy);
		cur_reg_stock.setValueBuffer("hora", hoy.toString().right(8));
		cur_reg_stock.setValueBuffer("cantidadini", cantidad_previa);
		cur_reg_stock.setValueBuffer("cantidadfin", cantidad_nueva);
		cur_reg_stock.setValueBuffer("codalmacendest", qry_almacenes.value("codalmacen"));
		cur_reg_stock.setValueBuffer("motivo", desc);
		if (!cur_reg_stock.commitBuffer())
				{
				MessageBox.critical(util.translate("scripts","Problema al actualizar las entradas de planta (4 - " + qry_referencias.value("referencia") + " " + qry_almacenes.value("codalmacen") + " ). Avise al tcnico."), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
				return;
				}
		if (conn != "default")
				{
				debug("Forzando controlRegStock");
				this.iface.controlRegStock(cur_reg_stock);
				}

		this.iface.marcar_entradas(id_stock, hoy);



		}
	}


}

function stockUnificado_calcular_entradas(id_stock: Number, fecha:Date): Number
{
var conn:String = this.iface.recogeConnUnificada();
var util:FLUtil = new FLUtil;
var retorno: Number;
retorno = util.sqlSelect("vlc_produccion", "SUM (cantidad)", " pendiente = true AND idstock = " + id_stock + " AND fecha_disponible <= '" + fecha.toString() +"'" , "vlc_produccion", conn);
if (!retorno)
	{
	retorno = 0;
	}
debug("stock nuevo de id_stock "+ id_stock +" = " + retorno);
return parseFloat(retorno);
}

function stockUnificado_marcar_entradas(id_stock: Number, fecha:Date): Number
{
debug("marcando entradas para id_stock " + id_stock);
var conn:String = this.iface.recogeConnUnificada();
var util:FLUtil = new FLUtil;
var retorno: Number;
if (!util.sqlUpdate("vlc_produccion", "pendiente",false, " pendiente = true AND idstock = " + id_stock + " AND fecha_disponible <= '" + fecha.toString() +"'", conn))
	{
	MessageBox.critical(util.translate("scripts","Problema al marcar las entradas de planta (" +id_stock +") . Avise al tcnico."), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
	}
}

function stockUnificado_beforeCommit_articulos(curArt:FLSqlCursor):Boolean {

var value: Boolean = true;
try {
	value = this.iface.__beforeCommit_articulos(curArt);
	} catch (e) {
		value = true;
	}

if (value)
	{
	if (this.iface.valorDefectoAlmacen("tipo_servidor") == "Local")
		{
		var fecha: Date = new Date();
		curArt.setValueBuffer("fecha_modificado", fecha);
		debug("Seteada fecha" + fecha + " para el articulo " + curArt.valueBuffer("referencia"));
		}
	}

return value;
}

function stockUnificado_beforeCommit_vlc_produccion(cursor:FLSqlCursor):Boolean {
var value: Boolean = true;
var conn:String = this.iface.recogeConnUnificada();

	var util:FLUtil = new FLUtil;
	//Crea reagularizacion eliminando

	if (cursor.isNull("idstock"))
		{
		if (cursor.isNull("referencia") || cursor.isNull("codalmacen"))
			{
			MessageBox.warning( util.translate("scripts", "Es necesario especificar almacn y referencia"), MessageBox.Ok, MessageBox.NoButton);
			return false;
			}
		else
			{

			//resolvemos idstock
			if (!util.sqlSelect("stocks","referencia","referencia ='" + cursor.valueBuffer("referencia") + "' AND codalmacen ='" + cursor.valueBuffer("codalmacen") + "'", "stocks", conn))
				{
				debug("Creando id_stock");
				//Nuevo registro en stocks.
				var cur_stocks: FLSqlCursor = new FLSqlCursor("stocks", conn);
				cur_stocks.setModeAccess(cur_stocks.Insert);
				cur_stocks.refreshBuffer();
				cur_stocks.setValueBuffer("codalmacen", cursor.valueBuffer("codalmacen"));
				cur_stocks.setValueBuffer("nombre", util.sqlSelect("articulos","descripcion","referencia = '" + cursor.valueBuffer("referencia")  + "'"));
				cur_stocks.setValueBuffer("referencia", cursor.valueBuffer("referencia") );

				if (!cur_stocks.commitBuffer())
					{
					MessageBox.critical(util.translate("scripts","Problema al crear idstock (vlc_produccion) " + cursor.valueBuffer("referencia") + " " + cursor.valueBuffer("codalmacen") + " ). Avise al tcnico."), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
					return false;
					}
				}

			cursor.setValueBuffer("idstock", util.sqlSelect("stocks","referencia","referencia ='" + cursor.valueBuffer("referencia") + "' AND codalmacen ='" + cursor.valueBuffer("codalmacen") + "'", "stocks", conn));

			}
		}


	var hoy: Date = new Date();
	var cantidad_previa:Number = util.sqlSelect("stocks","cantidad","idstock=" + cursor.valueBuffer("idstock"), "stocks", conn);
	var referencia: String = util.sqlSelect("stocks","referencia","idstock=" + cursor.valueBuffer("idstock"), "stocks", conn);
	var codalmacen: String = util.sqlSelect("stocks","codalmacen","idstock=" + cursor.valueBuffer("idstock"), "stocks", conn);

	if (cursor.modeAccess() == cursor.Insert)
		{
		if (cursor.isNull("referencia"))
			{
		//	debug(1);
			cursor.setValueBuffer("referencia", referencia);
			}
		if (cursor.isNull("codalmacen"))
			{
		//	debug(2);
			cursor.setValueBuffer("codalmacen", codalmacen);
			}
		//debug("REF " + cursor.valueBuffer("referencia"));
		//debug("ALM " + cursor.valueBuffer("codalmacen"));





		}

		if (!cursor.isNull("id_padre"))
			{
			var id_stock_padre = util.sqlSelect("vlc_produccion","idstock","id = " + cursor.valueBuffer("id_padre"), "vlc_produccion", conn);
			var codalmacen_padre = util.sqlSelect("vlc_produccion","codalmacen","id = " + cursor.valueBuffer("id_padre"), "vlc_produccion", conn);
			var cantidad_previa_padre = util.sqlSelect("stocks","cantidad","idstock=" + id_stock_padre, "stocks", conn);
			if (cursor.modeAccess() == cursor.Insert)
				{
				//eliminamos de padre la cantidad creada.


				var cantidad_nueva_padre:Number = cantidad_previa_padre - cursor.valueBuffer("cantidad");
				var desc:String = "CREADO RECUBITAJE produccin FINCA: " +  codalmacen + " REFERENCIA : " + referencia ;
				var cur_reg_stock_padre: FLSqlCursor = new FLSqlCursor("lineasregstocks", conn);
				cur_reg_stock_padre.select();
				cur_reg_stock_padre.setModeAccess(cur_reg_stock_padre.Insert);
				cur_reg_stock_padre.refreshBuffer();
				cur_reg_stock_padre.setValueBuffer("idstock",id_stock_padre);
				cur_reg_stock_padre.setValueBuffer("fecha", hoy);
				cur_reg_stock_padre.setValueBuffer("hora", hoy.toString().right(8));
				cur_reg_stock_padre.setValueBuffer("cantidadini", cantidad_previa_padre);
				cur_reg_stock_padre.setValueBuffer("cantidadfin", cantidad_nueva_padre);
				cur_reg_stock_padre.setValueBuffer("codalmacendest", codalmacen_padre);
				cur_reg_stock_padre.setValueBuffer("motivo", desc);
				if (!cur_reg_stock_padre.commitBuffer())
					{
					MessageBox.critical(util.translate("scripts","Problema al actualizar al padre por CREADO RECUBITAJE. Avise al tcnico."), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
					return false;
					}
				if (conn != "default")
					{
					this.iface.controlRegStock(cur_reg_stock_padre);
					}
				}


			else if (cursor.modeAccess() == cursor.Del)
				{
				//devolvemos a padre la cantidad.


				var cantidad_nueva_padre:Number = cantidad_previa_padre + cursor.valueBuffer("cantidad");
				var desc:String = "CANCELADO RECUBITAJE produccin FINCA: " +  codalmacen + " REFERENCIA : " + referencia ;
				var cur_reg_stock_padre: FLSqlCursor = new FLSqlCursor("lineasregstocks", conn);
				cur_reg_stock_padre.select();
				cur_reg_stock_padre.setModeAccess(cur_reg_stock_padre.Insert);
				cur_reg_stock_padre.refreshBuffer();
				cur_reg_stock_padre.setValueBuffer("idstock",id_stock_padre);
				cur_reg_stock_padre.setValueBuffer("fecha", hoy);
				cur_reg_stock_padre.setValueBuffer("hora", hoy.toString().right(8));
				cur_reg_stock_padre.setValueBuffer("cantidadini", cantidad_previa_padre);
				cur_reg_stock_padre.setValueBuffer("cantidadfin", cantidad_nueva_padre);
				cur_reg_stock_padre.setValueBuffer("codalmacendest", codalmacen_padre);
				cur_reg_stock_padre.setValueBuffer("motivo", desc);
				if (!cur_reg_stock_padre.commitBuffer())
					{
					MessageBox.critical(util.translate("scripts","Problema al actualizar al padre por CANCELADO RECUBITAJE. Avise al tcnico."), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
					return false;
					}
				if (conn != "default")
					{
					this.iface.controlRegStock(cur_reg_stock_padre);
					}
				}
			}



if (cursor.modeAccess() == cursor.Del && !cursor.valueBuffer("pendiente"))
	{
	var cantidad_nueva:Number = cantidad_previa - cursor.valueBuffer("cantidad");
	var desc:String = "Eliminada produccin FINCA: " +  codalmacen + " REFERENCIA : " + referencia ;
	var cur_reg_stock: FLSqlCursor = new FLSqlCursor("lineasregstocks", conn);
	cur_reg_stock.select();
	cur_reg_stock.setModeAccess(cur_reg_stock.Insert);
	cur_reg_stock.refreshBuffer();
	cur_reg_stock.setValueBuffer("idstock",cursor.valueBuffer("idstock"));
	cur_reg_stock.setValueBuffer("fecha", hoy);
	cur_reg_stock.setValueBuffer("hora", hoy.toString().right(8));
	cur_reg_stock.setValueBuffer("cantidadini", cantidad_previa);
	cur_reg_stock.setValueBuffer("cantidadfin", cantidad_nueva);
	cur_reg_stock.setValueBuffer("codalmacendest", codalmacen);
	cur_reg_stock.setValueBuffer("motivo", desc);
		if (!cur_reg_stock.commitBuffer())
				{
				MessageBox.critical(util.translate("scripts","Problema al actualizar las borrado de planta (" + referencia + " " + codalmacen + " ). Avise al tcnico."), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
				value = false;
				}
		if (conn != "default")
				{
				this.iface.controlRegStock(cur_reg_stock);
				}
	}


return value;
}


function stockUnificado_crea_montante(cursor:FLSqlCursor):Boolean
{
var util:FLUtil = new FLUtil;
var conn:String = this.iface.recogeConnUnificada();
var id_linea: Number = cursor.valueBuffer("idlinea");
var database: String = aqApp.db().database();

var referencia: String = cursor.valueBuffer("referencia");
var codalmacen: String = cursor.valueBuffer("codalmacen");
if (!codalmacen || codalmacen == "")
	{
	codalmacen = cursor.cursorRelation().valueBuffer("codalmacen");
	}

//Borramos si existe previo....
var id_existente = util.sqlSelect("vlc_produccion","id", "database='" + database +"' AND id_linea ="+ id_linea, "vlc_produccion", conn);

if (id_existente ) {
	debug("El montante ya existe");
   //if (referencia == cursor.valueBufferCopy("referencia") && codalmacen == cursor.valueBufferCopy("codalmacen") && cursor.valueBuffer("cantidad") == cursor.valueBufferCopy("cantidad") && cursor.valueBuffer("fecha_disponible") == cursor.valueBufferCopy("fecha_disponible") ) {
   	//debug("No se hace nada.");
   	//return true;
   //}

   MessageBox.critical(util.translate("scripts","La produccion , a la que hace referencia esta linea, ya existe. Modificala/Borral en la ficha de articulo para aplicar estos cambios"), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
		return false;
}


//resolvemos idstock
if (!util.sqlSelect("stocks","referencia","referencia ='" + referencia + "' AND codalmacen ='" + codalmacen + "'", "stocks", conn))
	{
	debug("Creando id_stock");
	//Nuevo registro en stocks.
	var cur_stocks: FLSqlCursor = new FLSqlCursor("stocks", conn);
	cur_stocks.setModeAccess(cur_stocks.Insert);
	cur_stocks.refreshBuffer();
	cur_stocks.setValueBuffer("codalmacen", codalmacen);
	cur_stocks.setValueBuffer("nombre", util.sqlSelect("articulos","descripcion","referencia = '" + referencia + "'"));
	cur_stocks.setValueBuffer("referencia", referencia);

	if (!cur_stocks.commitBuffer())
		{
		MessageBox.critical(util.translate("scripts","Problema al crear montante ( 1 - " + referencia + " " + codalmacen + " ). Avise al tcnico."), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
		return false;
		}
	}

		//cur_stocks.refreshBuffer(); // Refrescamos ???
		//Sacamos el id_stock
var id_stock = util.sqlSelect("stocks","idstock","referencia = '" + referencia + "' AND codalmacen ='" + codalmacen +"'", "stocks", conn);
var codpais = util.sqlSelect("dirproveedores","codpais","codproveedor='" + cursor.cursorRelation().valueBuffer("codproveedor") + "' AND direccionppal", "dirproveedores", conn);
var iso_pais = util.sqlSelect("paises","codiso","codpais = '" + codpais + "'", "paises", conn);
var hoy: Date = cursor.cursorRelation().valueBuffer("fecha");

var cur_montante = new FLSqlCursor("vlc_produccion", conn);
cur_montante.setModeAccess(cur_montante.Insert);
cur_montante.refreshBuffer();
cur_montante.setValueBuffer("idstock", id_stock);
cur_montante.setValueBuffer("fecha_creacion", hoy);
cur_montante.setValueBuffer("fecha_disponible", cursor.valueBuffer("fecha_disponible"));
cur_montante.setValueBuffer("pendiente", true);
cur_montante.setValueBuffer("cantidad", cursor.valueBuffer("cantidad"));
cur_montante.setValueBuffer("observaciones", "Generado desde " + database + "." + cursor.table() + " id " + cursor.valueBuffer("idlinea") + "(Documento " +  cursor.cursorRelation().valueBuffer("codigo") +")");
cur_montante.setValueBuffer("database", database);
cur_montante.setValueBuffer("id_linea", cursor.valueBuffer("idlinea"));
cur_montante.setValueBuffer("fecha_factura", cursor.cursorRelation().valueBuffer("fecha"));
cur_montante.setValueBuffer("codproveedor", cursor.cursorRelation().valueBuffer("codproveedor"));
cur_montante.setValueBuffer("codpais", iso_pais);
if (!cur_montante.commitBuffer())
	{
	MessageBox.critical(util.translate("scripts","Problema al crear montante ( 2 - " + referencia + " " + codalmacen + " ). Avise al tcnico."), MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
		return false;
	}

this.iface.revisar_entradas(referencia);
return true;
}

function stockUnificado_borra_montante(cursor:FLSqlCursor):Boolean
{
var util:FLUtil = new FLUtil;
var conn:String = this.iface.recogeConnUnificada();
var id_linea: Number = cursor.valueBuffer("idlinea");
var database: String = aqApp.db().database();
debug("BORRANDO " + id_linea + " DB " + database);
util.sqlDelete("vlc_produccion","id_linea =" + id_linea + " AND database='" + database + "'", conn);

return true;
}
//// STOCK_UNIFICADO ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition lasCunas */
/////////////////////////////////////////////////////////////////
//// LASCUNAS /////////////////////////////////////////////////
function lasCunas_generaPVPFormula(referencia:String, codTarifa:String, cursor_articulo: FLSqlCursor ) : Number
{
	//debug("Formula FRANCA! referencia: " + referencia + ", tarifa: " + codTarifa);
    var util = new FLUtil;
    var resultado:Number = 0;
    var V1: String = ""; //precio base.
    var V2: String = util.sqlSelect("factalma_general","rfa","1=1"); //rfa
    var V3: String = ""; // unidades por piso box.
    var V4: String = ""; // Cantidad pisos.
    var formula: String = util.sqlSelect("tarifas","formula","codtarifa='" + codTarifa + "'");

	V1 = cursor_articulo.valueBuffer("pvp");
	V3 = cursor_articulo.valueBuffer("udsbox");
	if (!V1) {
		V1 = 0;
	}
	if (!V2) {
		V2 = 0;
	}
	if (!V3) {
		V3 = 1;
	}
	V4 = parseInt((V3 / cursor_articulo.valueBuffer("udspisobox")));
	if (!V4) {
		V4 = 1;
	}
	var formula_procesada = "";
	var tmp = formula;
	while (formula_procesada != tmp) {
		formula_procesada = tmp;
		tmp = tmp.replace("v", "V");
		tmp = tmp.replace("V1", V1);
		tmp = tmp.replace("V2", V2);
		tmp = tmp.replace("V3", V3);
		tmp = tmp.replace("V4", V4);
		tmp = tmp.replace(",", ".");
	}

	formula_procesada = tmp;
	resultado = eval("(" +  formula_procesada + ")");
	if (isNaN(resultado) || !resultado) {
		resultado = 0;
	}
	debug(resultado + " = " + formula_procesada + " , original : " + formula );



return resultado;
}
//// LASCUNAS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

