/**************************************************************************
                 imprimiretiquetas.qs  -  description
                             -------------------
    begin                : jue nov 25 2010
    copyright            : (C) 2010 by Silix
    email                : contacto@silix.com.ar
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
	var COL_REFERENCIA:Number;
	var COL_DESCRIPCION:Number;
	var COL_CANTIDAD:Number;
	var COL_PVP:Number;
	var COL_CODBARRAS:Number;

	var tdbArticulos:FLTableDB;
	var tblArticulos:QTable;
	var currentRow:Number;
	var currentCol:Number;

	var tbnAceptar:Object;
	var tbnCancelar:Object;

    function oficial( context ) { interna( context ); }
	function generarTabla() {
		return this.ctx.oficial_generarTabla();
	}
	function tblArticulos_currentChanged(row:Number, col:Number) {
		return this.ctx.oficial_tblArticulos_currentChanged(row, col);
	}
	function pbnAdd_clicked() {
		return this.ctx.oficial_pbnAdd_clicked();
	}
	function pbnAddAll_clicked() {
		return this.ctx.oficial_pbnAddAll_clicked();
	}
	function pbnDel_clicked() {
		return this.ctx.oficial_pbnDel_clicked();
	}
	function pbnDelAll_clicked() {
		return this.ctx.oficial_pbnDelAll_clicked();
	}
	function incluirFila(fila:Number) {
		return this.ctx.oficial_incluirFila(fila);
	}
	function incluirTodo() {
		return this.ctx.oficial_incluirTodo();
	}
	function excluirFila(fila:Number) {
		return this.ctx.oficial_excluirFila(fila);
	}
	function excluirTodo() {
		return this.ctx.oficial_excluirTodo();
	}
	function bufferChanged(fN:String) {
		return this.ctx.oficial_bufferChanged(fN);
	}
	function insertarLineaTabla(curArticulos:FLSqlCursor) {
		return this.ctx.oficial_insertarLineaTabla(curArticulos);
	}
	function actualizarCantidad() {
		return this.ctx.oficial_actualizarCantidad();
	}
	function bngOrdenacion_clicked(opcion:Number) {
		return this.ctx.oficial_bngOrdenacion_clicked(opcion);
	}
	function aceptarFormulario() {
		return this.ctx.oficial_aceptarFormulario();
	}
	function cancelarFormulario() {
		return this.ctx.oficial_cancelarFormulario();
	}
	function imprimirEtiquetas(datosReport) {
		return this.ctx.oficial_imprimirEtiquetas(datosReport);
	}
	function lanzarEtiArticulo(xmlKD:FLDomDocument, datosReport:Array) {
		return this.ctx.oficial_lanzarEtiArticulo(xmlKD, datosReport);
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration etiViveros */
/////////////////////////////////////////////////////////////////
//// ETIQUETAS_VIVEROS //////////////////////////////////////////
class etiViveros extends oficial /** %from: oficial */ {
    var COL_IDETIQUETA:Number;
    var tbnAceptarEti:Object;
    var tbnCancelarEti:Object;
    var isEti:Boolean;
    function etiViveros( context ) { oficial ( context ); }
	function init() { this.ctx.etiViveros_init(); }
	function imprimirEtiquetasEti(datosReport) {
		return this.ctx.etiViveros_imprimirEtiquetasEti(datosReport);
	}
	function aceptarFormularioEti() {
		return this.ctx.etiViveros_aceptarFormularioEti();
	}
		function generarTabla() {
		return this.ctx.etiViveros_generarTabla();
	}
	function insertarLineaTabla(curArticulos:FLSqlCursor) {
		return this.ctx.etiViveros_insertarLineaTabla(curArticulos);
	}

}
//// ETIQUETAS_VIVEROS //////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends etiViveros {
    function head( context ) { etiViveros ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////

function interna_init()
{
	this.iface.tbnAceptar = this.child("tbnAceptar");
	this.iface.tbnCancelar = this.child("tbnCancelar");
	this.child("pushButtonAccept").close();
	this.child("pushButtonCancel").close();

	this.iface.tdbArticulos = this.child("tdbArticulos");
	this.iface.tdbArticulos.setReadOnly(true);
	this.iface.tblArticulos = this.child("tblArticulos");

	connect(this.cursor(), "bufferChanged(QString)", this, "iface.bufferChanged");
	connect(this.iface.tblArticulos, "currentChanged(int, int)", this, "iface.tblArticulos_currentChanged");
	connect(this.child("pbnAdd"), "clicked()", this, "iface.pbnAdd_clicked");
	connect(this.child("pbnAddAll"), "clicked()", this, "iface.pbnAddAll_clicked");
	connect(this.child("pbnDel"), "clicked()", this, "iface.pbnDel_clicked");
	connect(this.child("pbnDelAll"), "clicked()", this, "iface.pbnDelAll_clicked");
	connect(this.child("bngOrdenacion"), "clicked(int)", this, "iface.bngOrdenacion_clicked()");
	connect(this.iface.tbnAceptar, "clicked()", this, "iface.aceptarFormulario");
	connect(this.iface.tbnCancelar, "clicked()", this, "iface.cancelarFormulario");

	this.cursor().setValueBuffer("cantidad", 1);

	this.iface.generarTabla();

	this.iface.tdbArticulos.setFocus();
}

//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////

function oficial_generarTabla()
{
	this.iface.COL_REFERENCIA = 0;
	this.iface.COL_DESCRIPCION = 1;
	this.iface.COL_CANTIDAD = 2;
	this.iface.COL_PVP = 3;
	this.iface.COL_CODBARRAS = 4;

	this.iface.tblArticulos.setNumCols(5);
	this.iface.tblArticulos.setColumnLabels("/", "Referencia/Descripcin/Cantidad/Precio/Cd.Barras");

	this.iface.tblArticulos.setColumnWidth(this.iface.COL_REFERENCIA, 100);
	this.iface.tblArticulos.setColumnWidth(this.iface.COL_DESCRIPCION, 223);
	this.iface.tblArticulos.setColumnWidth(this.iface.COL_CANTIDAD, 60);
	this.iface.tblArticulos.hideColumn(this.iface.COL_PVP);
	this.iface.tblArticulos.hideColumn(this.iface.COL_CODBARRAS);

	this.iface.tblArticulos.setColumnReadOnly(this.iface.COL_REFERENCIA, true);
	this.iface.tblArticulos.setColumnReadOnly(this.iface.COL_DESCRIPCION, true);
}

function oficial_tblArticulos_currentChanged(row:Number, col:Number)
{
	this.iface.currentRow = row;
	this.iface.currentCol = col;
}

function oficial_pbnAdd_clicked()
{
	this.iface.incluirFila();
}

function oficial_pbnAddAll_clicked()
{
	this.iface.incluirTodo();
}

function oficial_pbnDel_clicked()
{
	this.iface.excluirFila();
}

function oficial_pbnDelAll_clicked()
{
	this.iface.excluirTodo();
}

function oficial_incluirFila()
{
	if (!this.iface.tdbArticulos.cursor().isValid())
		return;

	// Inlcuir en la tabla el registro seleccionado
	var curArticulos:FLSqlCursor = new FLSqlCursor("articulos");
	if (!curArticulos.select("referencia = '"+this.iface.tdbArticulos.cursor().valueBuffer("referencia")+"'"))
		return;

	if (curArticulos.next()) {
		curArticulos.setModeAccess(curArticulos.Browse);
		curArticulos.refreshBuffer();
		this.iface.insertarLineaTabla(curArticulos);
	}
}

function oficial_incluirTodo()
{
	if (!this.iface.tdbArticulos.cursor().isValid())
		return;

	// Inlcuir en la tabla todos los registros
	var curArticulos:FLSqlCursor = new FLSqlCursor("articulos");
	if (!curArticulos.select(this.iface.tdbArticulos.filter()))
		return;

	var util:FLUtil = new FLUtil;
	var paso:Number = 0;
	util.createProgressDialog( "Incluyendo registros", curArticulos.size() );

	while (curArticulos.next()) {
		curArticulos.setModeAccess(curArticulos.Browse);
		curArticulos.refreshBuffer();
		this.iface.insertarLineaTabla(curArticulos);
		util.setProgress( ++paso );
	}

	util.destroyProgressDialog();
}

function oficial_excluirFila()
{
	// Sacar de la tabla el registro seleccionado
	if (this.iface.tblArticulos.numRows() == 0)
		return;

	this.iface.tblArticulos.removeRow(this.iface.currentRow);
}

function oficial_excluirTodo()
{
	// Sacar de la tabla todos los registros
	var numFilas:Number = this.iface.tblArticulos.numRows();
	if (numFilas == 0)
		return;

	var util:FLUtil = new FLUtil;
	var paso:Number = 0;
	util.createProgressDialog( "Excluyendo registros", numFilas );

	for (var fila:Number = 0; fila < numFilas; fila++) {
		this.iface.tblArticulos.removeRow(0);
		util.setProgress( ++paso );
	}

	util.destroyProgressDialog();
}

function oficial_bufferChanged(fN:String)
{
	switch (fN) {
		case "cantidad": {
			//this.iface.actualizarCantidad();
			break;
		}
	}
}

function oficial_insertarLineaTabla(curArticulos:FLSqlCursor)
{
	var numFilas:Number = this.iface.tblArticulos.numRows();
	for (var fila:Number = 0; fila < numFilas; fila++) {
		if (this.iface.tblArticulos.text(fila, this.iface.COL_REFERENCIA) == curArticulos.valueBuffer("referencia"))
			return;
	}

	var numLinea:Number = this.iface.tblArticulos.numRows();
	this.iface.tblArticulos.insertRows(numLinea);
	this.iface.tblArticulos.setText(numLinea, this.iface.COL_REFERENCIA, curArticulos.valueBuffer("referencia"));
	this.iface.tblArticulos.setText(numLinea, this.iface.COL_DESCRIPCION, curArticulos.valueBuffer("descripcion"));
	this.iface.tblArticulos.setText(numLinea, this.iface.COL_CANTIDAD, this.cursor().valueBuffer("cantidad"));
	this.iface.tblArticulos.setText(numLinea, this.iface.COL_PVP, curArticulos.valueBuffer("pvp"));
	this.iface.tblArticulos.setText(numLinea, this.iface.COL_CODBARRAS, curArticulos.valueBuffer("codbarras"));
}

function oficial_actualizarCantidad()
{
	var numFilas:Number = this.iface.tblArticulos.numRows();

	for (var fila:Number = 0; fila < numFilas; fila++) {
		this.iface.tblArticulos.setText(fila, this.iface.COL_CANTIDAD, this.cursor().valueBuffer("cantidad"));
	}
}

function oficial_bngOrdenacion_clicked(opcion:Number)
{
	switch (opcion) {
		case 0:
			this.iface.tblArticulos.sortColumn(this.iface.COL_REFERENCIA, true, true);
		break;
		case 1:
			this.iface.tblArticulos.sortColumn(this.iface.COL_DESCRIPCION, true, true);
		break;
	}
// 	this.iface.tblArticulos.selectRow(this.iface.currentRow);
}

function oficial_aceptarFormulario()
{
	var util:FLUtil = new FLUtil;
	var cursor = this.cursor();
	if (this.iface.tblArticulos.numRows() == 0)
		return;

	var datosReport:Array = [];
	datosReport["nombreinforme"] = "";
	datosReport["filas"] = 0;
	datosReport["cols"] = 0;
	var nombreInforme,filas,columnas;

	var codTipoEtiqueta = cursor.valueBuffer("codtipoetiqueta");

	if (codTipoEtiqueta && codTipoEtiqueta != "") {
		nombreInforme = util.sqlSelect("tiposetiquetas", "nombreinfome", "codtipoetiqueta = '" +  codTipoEtiqueta + "'");

		if (!nombreInforme || nombreInforme == false) {
			MessageBox.warning( util.translate( "scripts", "Hay un error en el nombre del Tipo de Etiqueta"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton );
			return;
		}

		datosReport["nombreinforme"] = nombreInforme;

		filas = util.sqlSelect("tiposetiquetas", "numfilas", "codtipoetiqueta = '" +  codTipoEtiqueta + "'");

		if (!filas || filas == false) {
			MessageBox.warning( util.translate( "scripts", "Hay un error en el n de filas del Tipo de Etiqueta"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton );
			return;
		}

		columnas = util.sqlSelect("tiposetiquetas", "numcolumnas", "codtipoetiqueta = '" +  codTipoEtiqueta + "'");

		if (!columnas || columnas == false) {
			MessageBox.warning( util.translate( "scripts", "Hay un error en el n de columnas del Tipo de Etiqueta"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton );
			return;
		}

		datosReport["filas"] = filas;
		datosReport["cols"] = columnas;
		this.iface.imprimirEtiquetas(datosReport);
	} else  {
		MessageBox.warning( util.translate( "scripts", "No has elegido un Tipo de Etiqueta"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton );
	}

// 	if ( this.child("tam3x7").checked )
// 		this.iface.imprimirEtiquetas("tam3x7");
//
// 	if ( this.child("tam4x11").checked )
// 		this.iface.imprimirEtiquetas("tam4x11");
//
// 	if ( this.child("tam4x17").checked )
// 		this.iface.imprimirEtiquetas("tam4x17");

//	this.child("pushButtonAccept").animateClick();
}

function oficial_imprimirEtiquetas(datosReport)
{
	var util:FLUtil = new FLUtil;

// 	var datosReport:Array = [];
// 	datosReport["nombreinforme"] = "";
// 	datosReport["cols"] = 0;
//
// 	switch (tam) {
// 		case "tam3x7": {
// 			datosReport["nombreinforme"] = "i_a4_3x7";
// 			datosReport["cols"] = 3;
// 			break;
// 		}
// 		case "tam4x11": {
// 			datosReport["nombreinforme"] = "i_a4_4x11";
// 			datosReport["cols"] = 4;
// 			break;
// 		}
// 		case "tam4x17": {
// 			datosReport["nombreinforme"] = "i_a4_4x17";
// 			datosReport["cols"] = 4;
// 			break;
// 		}
// 	}

	var cantidad:Number;
	var numFilas:Number = this.iface.tblArticulos.numRows();
	util.createProgressDialog( util.translate( "scripts", "Generando informe..." ), numFilas );

	var xmlKD:FLDomDocument = new FLDomDocument;
	xmlKD.setContent("<!DOCTYPE KUGAR_DATA><KugarData/>");
	var eRow:FLDomElement;
	for (var fila:Number = 0; fila < numFilas; fila++) {

		cantidad = parseInt(this.iface.tblArticulos.text(fila, this.iface.COL_CANTIDAD));
		if (!cantidad || isNaN(cantidad)) {
			util.setProgress( fila );
			continue;
		}

		for (var i:Number = 0; i < cantidad; i++) {
			eRow = xmlKD.createElement("Row");
			eRow.setAttribute("referencia", this.iface.tblArticulos.text(fila, this.iface.COL_REFERENCIA));
			eRow.setAttribute("descripcion", this.iface.tblArticulos.text(fila, this.iface.COL_DESCRIPCION));
			eRow.setAttribute("pvp", this.iface.tblArticulos.text(fila, this.iface.COL_PVP));
			eRow.setAttribute("codbarras", this.iface.tblArticulos.text(fila, this.iface.COL_CODBARRAS));
			eRow.setAttribute("level", 0);
			xmlKD.firstChild().appendChild(eRow);
		}

		util.setProgress( fila );
	}

	util.destroyProgressDialog();

	if (!this.iface.lanzarEtiArticulo(xmlKD, datosReport))
		return false;
}


function oficial_lanzarEtiArticulo(xmlKD:FLDomDocument, datosReport:Array)
{
	var util:FLUtil = new FLUtil;
	var rptViewer:FLReportViewer = new FLReportViewer();

	try { rptViewer.setReportData(xmlKD); }
	catch (e) { return; }

	var etiquetaInicial:Array;
	etiquetaInicial["fila"] = 0;
	etiquetaInicial["col"] = 0;
	if (datosReport["cols"] > 0) {
		etiquetaInicial["fila"] = this.child("eFila").value;
		if (etiquetaInicial.fila > datosReport.filas) {
			MessageBox.warning( util.translate( "scripts", "La posicin de fila %1 es mayor de la permitida\nPor favor introduzca un valor igual o inferior a %2").arg(etiquetaInicial.fila).arg(datosReport.filas), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton );
			return;
		}
		etiquetaInicial["col"] = this.child("eColumna").value;
		if (etiquetaInicial.col > datosReport.cols) {
			MessageBox.warning( util.translate( "scripts", "La posicin de columna %1 es mayor de la permitida\nPor favor introduzca un valor igual o inferior a %2").arg(etiquetaInicial.col).arg(datosReport.cols), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton );
			return;
		}
	}

	var rptViewer:FLReportViewer = new FLReportViewer();
	rptViewer.setReportTemplate(datosReport["nombreinforme"]);
	rptViewer.setReportData(xmlKD);
	if (datosReport["cols"] > 0)
		rptViewer.renderReport(etiquetaInicial.fila, etiquetaInicial.col);
	else
		rptViewer.renderReport();

	rptViewer.exec();
}

function oficial_cancelarFormulario()
{
	this.child("pushButtonCancel").animateClick();
}

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition etiViveros */
/////////////////////////////////////////////////////////////////
//// ETIQUETAS_VIVEROS //////////////////////////////////////////
function etiViveros_init()
{
	this.iface.tbnAceptarEti = this.child("tbnAceptarEti");
	this.iface.tbnCancelarEti = this.child("tbnCancelarEti");
	this.iface.tbnAceptar = this.child("tbnAceptar");
	this.iface.tbnCancelar = this.child("tbnCancelar");
	this.child("pushButtonAccept").close();
	this.child("pushButtonCancel").close();

	this.iface.tdbArticulos = this.child("tdbArticulos");
	this.iface.tdbArticulos.setReadOnly(true);
	this.iface.tblArticulos = this.child("tblArticulos");

	connect(this.cursor(), "bufferChanged(QString)", this, "iface.bufferChanged");
	connect(this.iface.tblArticulos, "currentChanged(int, int)", this, "iface.tblArticulos_currentChanged");
	connect(this.child("pbnAdd"), "clicked()", this, "iface.pbnAdd_clicked");
	connect(this.child("pbnAddAll"), "clicked()", this, "iface.pbnAddAll_clicked");
	connect(this.child("pbnDel"), "clicked()", this, "iface.pbnDel_clicked");
	connect(this.child("pbnDelAll"), "clicked()", this, "iface.pbnDelAll_clicked");
	//connect(this.child("bngOrdenacion"), "clicked(int)", this, "iface.bngOrdenacion_clicked()");
	connect(this.iface.tbnAceptarEti, "clicked()", this, "iface.aceptarFormularioEti");
	connect(this.iface.tbnCancelarEti, "clicked()", this, "iface.cancelarFormulario");
	connect(this.iface.tbnAceptar, "clicked()", this, "iface.aceptarFormulario");
	connect(this.iface.tbnCancelar, "clicked()", this, "iface.cancelarFormulario");

	this.cursor().setValueBuffer("cantidad", 1);

	this.iface.generarTabla();

	this.iface.tdbArticulos.setFocus();
}

function etiViveros_imprimirEtiquetasEti(datosReport)
{
	var util:FLUtil = new FLUtil;
	var cursor = this.cursor();
	//var cantidad:Number;
	var numFilas:Number = this.iface.tblArticulos.numRows();
	var aEtiquetas:Array = [];
	//var nombreInforme:String = ""
	for (var fila:Number = 0; fila < numFilas; fila++) {
		aEtiquetas[fila] = [];
		aEtiquetas[fila]["cantidad"] = parseInt(this.iface.tblArticulos.text(fila, this.iface.COL_CANTIDAD));
		aEtiquetas[fila]["referencia"] =  this.iface.tblArticulos.text(fila, this.iface.COL_REFERENCIA);
		aEtiquetas[fila]["pvp"] = this.iface.tblArticulos.text(fila, this.iface.COL_PVP);
		aEtiquetas[fila]["idetiqueta"] = this.iface.tblArticulos.text(fila, this.iface.COL_IDETIQUETA);
		aEtiquetas[fila]["barcode"] = util.sqlSelect("articulos","codbarras","referencia='" + aEtiquetas[fila]["referencia"] + "'");
		aEtiquetas[fila]["lote"] = "";
		if (aEtiquetas[fila]["idetiqueta"] == "")
			{
			MessageBox.warning( util.translate( "scripts", "La referencia " + aEtiquetas[fila]["referencia"] + " no tiene un idEtiqueta valido. Cancelando"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton );
			return;
			}
		}

	flfactinfo.iface.procesarEtiquetas(aEtiquetas,"");
	this.iface.isEti = false;
}

function etiViveros_aceptarFormularioEti()
{
	var util:FLUtil = new FLUtil;
	var cursor = this.cursor();
	if (this.iface.tblArticulos.numRows() == 0)
		return;

	this.iface.isEti = true;
	var datosReport:Array = [];
	datosReport["nombreinforme"] = "";
	datosReport["filas"] = 0;
	datosReport["cols"] = 0;
	var nombreInforme,filas,columnas;

	//var codTipoEtiqueta = cursor.valueBuffer("codtipoetiqueta");

	//if (codTipoEtiqueta && codTipoEtiqueta != "") {
	//	nombreInforme = util.sqlSelect("tiposetiquetas", "nombreinfome", "codtipoetiqueta = '" +  codTipoEtiqueta + "'");

	//	if (!nombreInforme || nombreInforme == false) {
	//		MessageBox.warning( util.translate( "scripts", "Hay un error en el nombre del Tipo de Etiqueta"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton );
	//		return;
	//	}

	//	datosReport["nombreinforme"] = nombreInforme;

	//	filas = util.sqlSelect("tiposetiquetas", "numfilas", "codtipoetiqueta = '" +  codTipoEtiqueta + "'");

	//	if (!filas || filas == false) {
	//		MessageBox.warning( util.translate( "scripts", "Hay un error en el n de filas del Tipo de Etiqueta"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton );
	//		return;
	//	}

	//	columnas = util.sqlSelect("tiposetiquetas", "numcolumnas", "codtipoetiqueta = '" +  codTipoEtiqueta + "'");

	//	if (!columnas || columnas == false) {
	//		MessageBox.warning( util.translate( "scripts", "Hay un error en el n de columnas del Tipo de Etiqueta"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton );
	//		return;
	//	}

	//	datosReport["filas"] = filas;
	//	datosReport["cols"] = columnas;
		this.iface.imprimirEtiquetasEti("");
	//} else  {
	//	MessageBox.warning( util.translate( "scripts", "No has elegido un Tipo de Etiqueta"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton );
	//}

// 	if ( this.child("tam3x7").checked )
// 		this.iface.imprimirEtiquetas("tam3x7");
//
// 	if ( this.child("tam4x11").checked )
// 		this.iface.imprimirEtiquetas("tam4x11");
//
// 	if ( this.child("tam4x17").checked )
// 		this.iface.imprimirEtiquetas("tam4x17");

//	this.child("pushButtonAccept").animateClick();
}

function etiViveros_generarTabla()
{
	this.iface.COL_REFERENCIA = 0;
	this.iface.COL_DESCRIPCION = 1;
	this.iface.COL_CANTIDAD = 2;
	this.iface.COL_PVP = 3;
	this.iface.COL_CODBARRAS = 4;
	this.iface.COL_IDETIQUETA = 5;

	this.iface.tblArticulos.setNumCols(6);
	this.iface.tblArticulos.setColumnLabels("/", "Referencia/Descripcin/Cantidad/Precio/Cd.Barras/Id Etiqueta");

	this.iface.tblArticulos.setColumnWidth(this.iface.COL_REFERENCIA, 100);
	this.iface.tblArticulos.setColumnWidth(this.iface.COL_DESCRIPCION, 223);
	this.iface.tblArticulos.setColumnWidth(this.iface.COL_CANTIDAD, 60);
	this.iface.tblArticulos.hideColumn(this.iface.COL_PVP);
	this.iface.tblArticulos.hideColumn(this.iface.COL_CODBARRAS);
	this.iface.tblArticulos.hideColumn(this.iface.COL_IDETIQUETA);

	this.iface.tblArticulos.setColumnReadOnly(this.iface.COL_REFERENCIA, true);
	this.iface.tblArticulos.setColumnReadOnly(this.iface.COL_DESCRIPCION, true);
	this.iface.tblArticulos.setColumnReadOnly(this.iface.COL_IDETIQUETA, true);
}
// Cuando isEti = True
function etiViveros_insertarLineaTabla(curArticulos:FLSqlCursor)
{
	var numFilas:Number = this.iface.tblArticulos.numRows();
	for (var fila:Number = 0; fila < numFilas; fila++) {
		if (this.iface.tblArticulos.text(fila, this.iface.COL_REFERENCIA) == curArticulos.valueBuffer("referencia"))
			return;
	}

	var numLinea:Number = this.iface.tblArticulos.numRows();
	this.iface.tblArticulos.insertRows(numLinea);
	this.iface.tblArticulos.setText(numLinea, this.iface.COL_REFERENCIA, curArticulos.valueBuffer("referencia"));
	this.iface.tblArticulos.setText(numLinea, this.iface.COL_DESCRIPCION, curArticulos.valueBuffer("descripcion"));
	this.iface.tblArticulos.setText(numLinea, this.iface.COL_CANTIDAD, this.cursor().valueBuffer("cantidad"));
	this.iface.tblArticulos.setText(numLinea, this.iface.COL_PVP, curArticulos.valueBuffer("pvp"));
	this.iface.tblArticulos.setText(numLinea, this.iface.COL_CODBARRAS, curArticulos.valueBuffer("codbarras"));
	if (this.cursor().valueBuffer("idetiqueta") && this.cursor().valueBuffer("idetiqueta") != "")
		{
		this.iface.tblArticulos.setText(numLinea, this.iface.COL_IDETIQUETA, this.cursor().valueBuffer("idetiqueta"));
		}
	else
		{
		this.iface.tblArticulos.setText(numLinea, this.iface.COL_IDETIQUETA, curArticulos.valueBuffer("idetiqueta"));
		}
}
//// ETIQUETAS_VIVEROS //////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

