/***************************************************************************
                 masterarticulos.qs  -  description
                             -------------------
    begin                : jue jun 21 2007
    copyright            : (C) 2007 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    var pbnTransferir:Object;
	function oficial( context ) { interna( context ); }
	function pbnActualizar_clicked() {
		return this.ctx.oficial_pbnActualizar_clicked();
	}
	function actualizarPreciosTarifa(codTarifa:String):Boolean {
		return this.ctx.oficial_actualizarPreciosTarifa(codTarifa);
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration tarifaViv */
//////////////////////////////////////////////////////////////////
//// TARIFAVIV ///////////////////////////////////////////////////
class tarifaViv extends oficial /** %from: oficial */ {
	var pbDispo:Object;
	function tarifaViv( context ) { oficial( context ); }
	function init() {
		this.ctx.tarifaViv_init();
	}
	function pbDispo_clicked() {
		return this.ctx.tarifaViv_pbDispo_clicked();
	}

}
//// TARIFAVIV ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration lascunasOnline */
//////////////////////////////////////////////////////////////////
//// LASCUNAS_ONLINE /////////////////////////////////////////////
class lascunasOnline extends tarifaViv /** %from: tarifaViv */  {
	var pbWeb:Object;
	function lascunasOnline( context ) { tarifaViv( context ); }
	function init() {
		this.ctx.lascunasOnline_init();
	}
	function pbWeb_clicked() {
		return this.ctx.lascunasOnline_pbWeb_clicked();
	}

}
//// LASCUNAS_ONLINE /////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration lasCunas */
/////////////////////////////////////////////////////////////////
//// LASCUNAS /////////////////////////////////////////////////
class lasCunas extends lascunasOnline /** %from: lascunasOnline */ {
	function lasCunas( context ) { lascunasOnline ( context ); }
	function actualizarPreciosTarifa(codTarifa:String):Boolean {
		return this.ctx.lasCunas_actualizarPreciosTarifa(codTarifa);
	}
	function init() {
		this.ctx.lasCunas_init();
	}
	function pbWeb_clicked() {
		return this.ctx.lasCunas_pbWeb_clicked();
	}
	function pbWeb_imagenes_clicked() {
		return this.ctx.lasCunas_pbWeb_imagenes_clicked();
	}
}
//// LASCUNAS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends lasCunas {
    function head( context ) { lasCunas ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C La tabla de regularizaciones de stocks se muestra en modo de slo lectura
\end */
function interna_init()
{
	connect(this.child("pbnActualizar"), "clicked()", this, "iface.pbnActualizar_clicked()");
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
function oficial_pbnActualizar_clicked()
{
	var util:FLUtil = new FLUtil;
	var cursor:FLSqlCursor = this.cursor();
	var curCommit:FLSqlCursor = new FLSqlCursor("tarifas");
	var codTarifa:String = cursor.valueBuffer("codtarifa");

	curCommit.transaction(false);
	try {
		if (this.iface.actualizarPreciosTarifa(codTarifa)) {
			curCommit.commit();
		} else {
			curCommit.rollback();
			return false;
		}
	} catch (e) {
		curCommit.rollback();
		MessageBox.critical(util.translate("scripts", "Hubo un error al actualizar los precios por tarifa: ") + e, MessageBox.Ok, MessageBox.NoButton);
		return false;
	}
	MessageBox.information(util.translate("scripts", "La tarifa %1 ha sido actualizada").arg(codTarifa), MessageBox.Ok, MessageBox.NoButton);
}

function oficial_actualizarPreciosTarifa(codTarifa:String):Boolean
{
	var util:FLUtil = new FLUtil;

	var res:Number = MessageBox.information(util.translate("scripts", "Se van a actualizar los precios de los articulos para la tarifa %1. \nEsto sobreescribir cualquier precio que haya sido modificado manualmente.\nDesea continuar?").arg(codTarifa), MessageBox.Yes, MessageBox.No);
	if (res != MessageBox.Yes)
		return false;

	var curArt:FLSqlCursor = new FLSqlCursor("articulostarifas");
	curArt.select("codtarifa = '" + codTarifa + "'");
	util.createProgressDialog(util.translate("scripts", "Actualizando tarifa..."), curArt.size());
	var progreso = 0;
	while (curArt.next()) {
		progreso++;
		util.setProgress(progreso);

		curArt.setModeAccess(curArt.Edit);
		curArt.refreshBuffer();

		var incLineal:Number = parseFloat(util.sqlSelect("tarifas","inclineal","codtarifa = '" + codTarifa + "'"));
		if (!incLineal || isNaN(incLineal))
			incLineal = 0;

		var incPorcentual:Number = util.sqlSelect("tarifas","incporcentual","codtarifa = '" + codTarifa + "'");
		if (!incPorcentual || isNaN(incPorcentual))
			incPorcentual = 0;

		var pvp:Number = util.sqlSelect("articulos","pvp","referencia = '" + curArt.valueBuffer("referencia") + "'");
		if (!pvp || isNaN(pvp))
			pvp = 0;

		var pvpTarifa:Number = ((pvp * (100 + incPorcentual)) / 100) + incLineal;

		curArt.setValueBuffer("pvp", pvpTarifa);
		if (!curArt.commitBuffer()) {
			util.destroyProgressDialog();
			return false;
		}
	}
	util.destroyProgressDialog();
	return true;
}


//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition tarifaViv */
//////////////////////////////////////////////////////////////////
//// TARIFAVIV ///////////////////////////////////////////////////

function tarifaViv_init()
{
	connect(this.child("pbDispo"), "clicked()", this, "iface.pbDispo_clicked()");
	this.iface.__init();
}

function tarifaViv_pbDispo_clicked()
{
	var util:FLUtil = new FLUtil;
	var cursor:FLSqlCursor = this.cursor();
	var curArTar:FLSqlCursor = new FLSqlCursor("articulostarifas");
	var codTarifa:String = cursor.valueBuffer("codtarifa");


	 // KLO Cdigo original.
    var dialog = new Dialog(util.translate ( "scripts", "Tarifa Origen" ), 0);
    dialog.caption = "Seleccionar una tarifa como origen";
    dialog.OKButtonText = util.translate ( "scripts", "Aceptar" );
    dialog.cancelButtonText = util.translate ( "scripts", "Cancelar" );

    var bgroup:GroupBox = new GroupBox;
    dialog.add( bgroup );
    var rB:Array = [];
    var tarifa:Array = [];
    var nModelos:Number = 0;
    var hayDefecto:Boolean = false;
    var hayOficial:Boolean = false;
    var iniReport:String;
    var cont:Number = 0;
    var textModelo:String;


    var curTar:FLSqlCursor = new FLSqlCursor("tarifas");
	curTar.select("1 = 1");
	while (curTar.next()) {

		curTar.setModeAccess(curTar.Edit);
		curTar.refreshBuffer();
		if (curTar.valueBuffer("codtarifa") != codTarifa)
			{
			tarifa[cont] = curTar.valueBuffer("codtarifa");
    			rB[cont] = new RadioButton;
    			rB[cont].text = curTar.valueBuffer("nombre");
                	rB[cont].checked = false;
                	bgroup.add( rB[cont] );
                	cont ++;
                	}
        }

     if (!dialog.exec())
        return;


      for (var i:Number = 0; i <= cont; i++)
      	{
        if (rB[i].checked == true)
        			{
     		     var res:Number = MessageBox.information(util.translate("scripts", "Se van a actualizar los articulos disponibles para la tarifa \"%1\", desde la tarifa \"%1\". \nEsto sobreescribir cualquier disponibilidad actual de la tarifa \"%1\".\n\t\tDesea continuar?")
     		     .arg("( "+codTarifa+" ) "+ util.sqlSelect("tarifas","nombre","codtarifa = '" + codTarifa + "'"))
     		     .arg("( "+tarifa[i]+" ) "+ util.sqlSelect("tarifas","nombre","codtarifa = '" + tarifa[i] + "'"))
     		     .arg("( "+codTarifa+" ) "+ util.sqlSelect("tarifas","nombre","codtarifa = '" + codTarifa + "'"))
     		     , MessageBox.Yes, MessageBox.No);
				if (res != MessageBox.Yes)
					return false;


			var curArt:FLSqlCursor = new FLSqlCursor("articulostarifas");
			curArt.select("codtarifa = '" + tarifa[i] + "'");
			util.createProgressDialog(util.translate("scripts", "Actualizando tarifa..."), curArt.size());
			var progreso = 0;
			while (curArt.next()) {
				progreso++;
				util.setProgress(progreso);
				curArt.setModeAccess(curArt.Edit);
				curArt.refreshBuffer();
				if (!util.sqlUpdate("articulostarifas", "excluir", curArt.valueBuffer("excluir"), "referencia = '" + curArt.valueBuffer("referencia") + "' AND codtarifa = '"+ codTarifa + "'"))
					{
					util.destroyProgressDialog();
					return false;
					}
     		     		}
     		util.destroyProgressDialog();
     		break;
    		}

	}
}
//// TARIFAVIV ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition lascunasOnline */
//////////////////////////////////////////////////////////////////
//// LASCUNAS_ONLINE /////////////////////////////////////////////
function lascunasOnline_init()
{
	connect(this.child("pbWeb"), "clicked()", this, "iface.pbWeb_clicked()");
	this.iface.__init();
}
function lascunasOnline_pbWeb_clicked()
{
var util:FLUtil = new FLUtil;
debug("Estoy en PBWEB");
var rutaTemporal:String = util.readSettingEntry("lascunasOnline/rutatemporal");
var comandoFtp:String = util.readSettingEntry("lascunasOnline/comandoexterno");
var ficheroExportado:String;

if (!rutaTemporal || rutaTemporal == "")
	{
	MessageBox.information(util.translate("scripts", "Este pc no est configurado todava."), MessageBox.Yes, MessageBox.NoButton);
	return false;

	}


// 1 .- Revisamos tarifas y generamos CVS
var ordenarPor:String;
var nombreInforme:String;
var orderBy:String;
var whereFijo:String;

	var curTar:FLSqlCursor = new FLSqlCursor("tarifas");
	curTar.select("1 = 1");
	util.createProgressDialog(util.translate("scripts", "Exportando Tarifas ..."), curTar.size());
	var progreso = 0;
	while (curTar.next()) {
		ficheroExportado = rutaTemporal + curTar.valueBuffer("codtarifa") + ".csv";
		ordenarPor = "";
		nombreInforme = "i_csv";
		orderBy = "articulos.referencia"
		whereFijo ="WHEREFIJO\narticulostarifas.codtarifa='" + curTar.valueBuffer("codtarifa") + "'\nFORMAT\ncsv\n";
		progreso++;
		util.setProgress(progreso);
		flfactinfo.iface.pub_lanzarInforme(curTar, nombreInforme, orderBy,false,false,false,whereFijo,"",0, ficheroExportado,true);
		for (var i=0; i < 5000000; i++)
			{
			//nada
			}

		}
	util.destroyProgressDialog();


// 2 .- Extraemos las imagenes a la carpeta especificada
var curArt:FLSqlCursor = new FLSqlCursor("articulos");
	curArt.select("not obsoleto AND sevende");
	util.createProgressDialog(util.translate("scripts", "Exportando Imgenes ..."), curArt.size());
	var progreso = 0;
	while (curArt.next()) {
		ficheroExportado = rutaTemporal + curArt.valueBuffer("referencia") +".jpg";
		if (File.exists(ficheroExportado)) {
			debug("El fichero " + ficheroExportado + " existe.");
			var fecha_fichero = new File(ficheroExportado).lastModified;
			debug("Fecha fichero " + fecha_fichero);
			debug("Fecha registro "+  curArt.valueBuffer("fecha_modificado"));
		}
		debug("Exportando imagen " + curArt.valueBuffer("referencia") + " en " + ficheroExportado );
		util.savePixmap(curArt.valueBuffer("imagen"),ficheroExportado,"JPEG");
		progreso++;
		util.setProgress(progreso);
			     }
	util.destroyProgressDialog();



if (comandoFtp != "" && comandoFtp)
	flfactppal.iface.pub_ejecutarComandoAsincrono(comandoFtp);

MessageBox.information(util.translate("scripts", "Proceso finalizado."), MessageBox.Yes, MessageBox.NoButton);


}
//// LASCUNAS_ONLINE /////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition lasCunas */
/////////////////////////////////////////////////////////////////
//// LASCUNAS /////////////////////////////////////////////////
function lasCunas_init()
{
	connect(this.child("pbWeb_imagenes"), "clicked()", this, "iface.pbWeb_imagenes_clicked()");
	this.iface.__init();
}

function lasCunas_pbWeb_clicked()
{
var util:FLUtil = new FLUtil;
debug("Estoy en PBWEB");
var rutaTemporal:String = util.readSettingEntry("lascunasOnline/rutatemporal");
var comandoFtp:String = util.readSettingEntry("lascunasOnline/comandoexterno");
var ficheroExportado:String;

if (!rutaTemporal || rutaTemporal == "")
	{
	MessageBox.information(util.translate("scripts", "Este pc no est configurado todava."), MessageBox.Yes, MessageBox.NoButton);
	return false;

	}


// 1 .- Revisamos tarifas y generamos CVS
var ordenarPor:String;
var nombreInforme:String;
var orderBy:String;
var whereFijo:String;

	var curTar:FLSqlCursor = new FLSqlCursor("tarifas");
	curTar.select("1 = 1");
	util.createProgressDialog(util.translate("scripts", "Exportando Tarifas ..."), curTar.size());
	var progreso = 0;
	while (curTar.next()) {
		ficheroExportado = rutaTemporal + curTar.valueBuffer("codtarifa") + ".csv";
		ordenarPor = "";
		nombreInforme = "i_csv";
		orderBy = "articulos.referencia"
		whereFijo ="WHEREFIJO\narticulostarifas.codtarifa='" + curTar.valueBuffer("codtarifa") + "'\nFORMAT\ncsv\n";
		progreso++;
		util.setProgress(progreso);
		flfactinfo.iface.pub_lanzarInforme(curTar, nombreInforme, orderBy,false,false,false,whereFijo,"",0, ficheroExportado,true);
		for (var i=0; i < 5000000; i++)
			{
			//nada
			}

		}
	util.destroyProgressDialog();



if (comandoFtp != "" && comandoFtp)
	flfactppal.iface.pub_ejecutarComandoAsincrono(comandoFtp);

MessageBox.information(util.translate("scripts", "Proceso finalizado."), MessageBox.Yes, MessageBox.NoButton);


}

function lasCunas_pbWeb_imagenes_clicked()
{
var util:FLUtil = new FLUtil;
debug("Estoy en PBWEB");
var rutaTemporal:String = util.readSettingEntry("lascunasOnline/rutatemporal");
var comandoFtp:String = util.readSettingEntry("lascunasOnline/comandoexterno");
var ficheroExportado:String;

if (!rutaTemporal || rutaTemporal == "")
	{
	MessageBox.information(util.translate("scripts", "Este pc no est configurado todava."), MessageBox.Yes, MessageBox.NoButton);
	return false;

	}


// 2 .- Extraemos las imagenes a la carpeta especificada
var curArt:FLSqlCursor = new FLSqlCursor("articulos");
	curArt.select("not obsoleto AND sevende");
	util.createProgressDialog(util.translate("scripts", "Exportando Imgenes ..."), curArt.size());
	var progreso = 0;
	while (curArt.next()) {
		ficheroExportado = rutaTemporal + curArt.valueBuffer("referencia") +".jpg";
		if (File.exists(ficheroExportado)) {
			debug("El fichero " + ficheroExportado + " existe.");
			var fecha_fichero = new File(ficheroExportado).lastModified;
			debug("Fecha fichero " + fecha_fichero);
			debug("Fecha registro "+  curArt.valueBuffer("fecha_modificado"));
		}
		debug("Exportando imagen " + curArt.valueBuffer("referencia") + " en " + ficheroExportado );
		util.savePixmap(curArt.valueBuffer("imagen"),ficheroExportado,"JPEG");
		progreso++;
		util.setProgress(progreso);
			     }
	util.destroyProgressDialog();



if (comandoFtp != "" && comandoFtp)
	flfactppal.iface.pub_ejecutarComandoAsincrono(comandoFtp);

MessageBox.information(util.translate("scripts", "Proceso finalizado."), MessageBox.Yes, MessageBox.NoButton);
}

function lasCunas_actualizarPreciosTarifa(codTarifa:String):Boolean
{
	var util:FLUtil = new FLUtil;

	var res:Number = MessageBox.information(util.translate("scripts", "Se van a actualizar los precios de los articulos para la tarifa %1. \nEsto sobreescribir cualquier precio que haya sido modificado manualmente.\nDesea continuar?").arg(codTarifa), MessageBox.Yes, MessageBox.No);
	if (res != MessageBox.Yes)
		return false;

	var curArt:FLSqlCursor = new FLSqlCursor("articulostarifas");
	curArt.select("codtarifa = '" + codTarifa + "'");
	util.createProgressDialog(util.translate("scripts", "Actualizando tarifa..."), curArt.size());
	var progreso = 0;
	while (curArt.next()) {
		progreso++;
		util.setProgress(progreso);

		curArt.setModeAccess(curArt.Edit);
		curArt.refreshBuffer();

		var incLineal:Number = parseFloat(util.sqlSelect("tarifas","inclineal","codtarifa = '" + codTarifa + "'"));
		if (!incLineal || isNaN(incLineal))
			incLineal = 0;

		var incPorcentual:Number = util.sqlSelect("tarifas","incporcentual","codtarifa = '" + codTarifa + "'");
		if (!incPorcentual || isNaN(incPorcentual))
			incPorcentual = 0;

		var pvp:Number = util.sqlSelect("articulos","pvp","referencia = '" + curArt.valueBuffer("referencia") + "'");
		if (!pvp || isNaN(pvp))
			pvp = 0;

		var formula:String = util.sqlSelect("tarifas","formula","codtarifa = '" + codTarifa + "'");
		var pvpTarifa:Number = 0;
		if (!formula || formula == "") {
			pvpTarifa = ((pvp * (100 + incPorcentual)) / 100) + incLineal;
		} else {
			var cursor_ = new FLSqlCursor("articulos");
			cursor_.select("referencia ='" + curArt.valueBuffer("referencia") + "'");
			cursor_.first();
			pvpTarifa = flfactalma.iface.generaPVPFormula(curArt.valueBuffer("referencia") , codTarifa, cursor_);
		}


		curArt.setValueBuffer("pvp", util.roundFieldValue(pvpTarifa, "articulostarifas", "pvp"));
		if (!curArt.commitBuffer()) {
			util.destroyProgressDialog();
			return false;
		}
	}
	util.destroyProgressDialog();
	return true;
}
//// LASCUNAS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

