/***************************************************************************
                 regstocks.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
        function calculateField(fN:String):String {
                return this.ctx.interna_calculateField(fN);
        }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); }
        function calcularCantidad() {
                return this.ctx.oficial_calcularCantidad();
        }
        function calcularValoresUltReg() {
                return this.ctx.oficial_calcularValoresUltReg();
        }
        function commonCalculateField(fN:String, cursor:FLSqlCursor):String {
                return this.ctx.oficial_commonCalculateField(fN, cursor);
        }
        function bufferChanged(fN:String) {
                return this.ctx.oficial_bufferChanged(fN);
        }
        //function cambiarCantidad(cantidadNueva:Number) { return this.ctx.oficial_cambiarCantidad(cantidadNueva); }
        //function deshabilitarCantidad() { return this.ctx.oficial_deshabilitarCantidad(); }
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration stockUnificado */
/////////////////////////////////////////////////////////////////
//// STOCK_UNIFICADO ////////////////////////////////////////////
class stockUnificado extends oficial /** %from: oficial */ {
	var filtroOriginal:String;
	function stockUnificado( context ) { oficial ( context ); }
	function init() { this.ctx.stockUnificado_init(); }
	function cambio_filtro() {
		this.ctx.stockUnificado_cambio_filtro();
	}
	function commonCalculateField(fN:String, cursor:FLSqlCursor):String {
                return this.ctx.stockUnificado_commonCalculateField(fN, cursor);
        }
}
//// STOCK_UNIFICADO ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration lasCunas */
/////////////////////////////////////////////////////////////////
//// LAS_CUNAS /////////////////////////////////////////////////
class lasCunas extends stockUnificado /** %from: stockUnificado */ {
  var tbnEtiquetas:Object;
    function lasCunas( context ) { stockUnificado ( context ); }
    function init() { this.ctx.lasCunas_init(); }
    function imprimirEtiquetas() {
	return this.ctx.lasCunas_imprimirEtiquetas();
	}
}
//// LAS_CUNAS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends lasCunas {
    function head( context ) { lasCunas ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
        function pub_cambiarCantidad(cantidad:Number) { return this.cambiarCantidad(cantidad); }
        function pub_commonCalculateField(fN:String, cursor:FLSqlCursor):String {
                return this.commonCalculateField(fN, cursor);
        }
}


//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

const iface = new ifaceCtx( this );

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C La cantidad est deshabilitada

El valor del stock de un artculo se modificar de forma automtica cuando haya modificacin de:

- Lineas de albarn de proveedor (incrementan el stock)

- Lineas de factura de proveedor no automticas (incrementan el stock)

- Lineas de pedido de cliente (decrementan el stock)

- Lineas de albarn de cliente no provenientes de un pedido (decrementan el stock)

- Lineas de factura de cliente no automticas (decrementan el stock)

El valor del stock de un artculo se puede modificar de forma manual desde la ventana de regularizaciones de stock

\end */
function interna_init()
{
        var cursor:FLSqlCursor = this.cursor();
        //this.iface.deshabilitarCantidad();
        //connect(this.child("tdbLineasRegStocks").cursor(), "newBuffer()", this, "iface.deshabilitarCantidad");
        connect(this.child("tdbLineasRegStocks").cursor(), "bufferCommited()", this, "iface.calcularCantidad");
        connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
        switch (cursor.modeAccess()) {
                case cursor.Edit: {
                        this.child("pushButtonAcceptContinue").close();
                        this.child("fdbReferencia").setDisabled(true);
                        this.child("fdbCodAlmacen").setDisabled(true);
                        break;
                }
        }
}

function interna_calculateField(fN:String):String
{
        var cursor:FLSqlCursor = this.cursor();
        return this.iface.commonCalculateField(fN, cursor);
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
/*
function oficial_cambiarCantidad(cantidadNueva:Number)
{
                this.child("fdbCantidad").setValue(cantidadNueva);
                this.iface.deshabilitarCantidad();
}

function oficial_deshabilitarCantidad()
{
                this.child("fdbCantidad").setDisabled(true);
}
*/
function oficial_bufferChanged(fN:String)
{
        var cursor:FLSqlCursor = this.cursor();
        switch (fN) {
                case "cantidad":
                case "reservada": {
                        cursor.setValueBuffer("disponible", this.iface.calculateField("disponible"));
                        break;
                }
        }
}

function oficial_commonCalculateField(fN:String, cursor:FLSqlCursor):String
{
        var util:FLUtil = new FLUtil;
        var valor:String;
        switch (fN) {
                case "disponible": {
                        var cantidad:Number = parseFloat(cursor.valueBuffer("cantidad"));
                        var reservada:Number = parseFloat(cursor.valueBuffer("reservada"));
                        valor = cantidad - reservada;
                        break;
                }
                case "cantidadultreg": {
                        valor = util.sqlSelect("lineasregstocks", "cantidadfin", "idstock = " + cursor.valueBuffer("idstock") + " ORDER BY fecha DESC, hora DESC");
                        if (isNaN(valor)) {
                                valor = 0;
                        }
                        break;
                }
                case "fechaultreg": {
                        valor = util.sqlSelect("lineasregstocks", "fecha", "idstock = " + cursor.valueBuffer("idstock") + " ORDER BY fecha DESC, hora DESC");
                        break;
                }
                case "horaultreg": {
                        valor = util.sqlSelect("lineasregstocks", "hora", "idstock = " + cursor.valueBuffer("idstock") + " ORDER BY fecha DESC, hora DESC");
                        break;
                }
        }
        return valor;
}

function oficial_calcularCantidad()
{
        var cursor:FLSqlCursor = this.cursor();

        this.iface.calcularValoresUltReg();

        this.child("fdbCantidad").setValue(cursor.valueBuffer("cantidadultreg"));
}

function oficial_calcularValoresUltReg()
{
        var cursor:FLSqlCursor = this.cursor();
        var fechaUltReg:String = this.iface.calculateField("fechaultreg");
        if (fechaUltReg) {
                this.child("fdbFechaUltReg").setValue(fechaUltReg);
                this.child("fdbHoraUltReg").setValue(this.iface.calculateField("horaultreg"));
                this.child("fdbCantidadUltReg").setValue(this.iface.calculateField("cantidadultreg"));
        } else {
                cursor.setNull("fechaultreg");
                cursor.setNull("horaultreg");
                this.child("fdbCantidadUltReg").setValue(0);
        }
}

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition stockUnificado */
/////////////////////////////////////////////////////////////////
//// STOCK_UNIFICADO ////////////////////////////////////////////
function stockUnificado_init()
{
this.iface.__init();

var cb_pendientes: Object = this.child("cb_pendientes");
this.iface.filtroOriginal = this.child("tdbLineasProducciones").cursor().mainFilter();
connect(cb_pendientes, "clicked()", this, "iface.cambio_filtro");
this.iface.cambio_filtro();

//var conn:String = flfactalma.iface.recogeConnUnificada();
//if (conn != "default")
//	{
//	this.child("tdbStocks").cursor().changeConnection(conn);
//	this.child("tdbStocks").setReadOnly(true);
//	this.child("tdbStocks").refresh();
//	this.child("gbxStocks1").hide();
	//this.child("tbwArticulo").setTabEnabled("stocks", false);
//	}
}

function stockUnificado_cambio_filtro()
{
	var util:FLUtil = new FLUtil();

	if (this.child("cb_pendientes").checked) {
		if (this.iface.filtroOriginal && this.iface.filtroOriginal != "")
			this.child("tdbLineasProducciones").cursor().setMainFilter(this.iface.filtroOriginal + " AND pendiente = true");
		else
			this.child("tdbLineasProducciones").cursor().setMainFilter("pendiente = true");
	} else {
		this.child("tdbLineasProducciones").cursor().setMainFilter(this.iface.filtroOriginal);
	}

	this.child("tdbLineasProducciones").refresh();
}

function stockUnificado_commonCalculateField(fN:String, cursor:FLSqlCursor):String
{
        var util:FLUtil = new FLUtil;
        var valor:String;
	var conn:String = flfactalma.iface.recogeConnUnificada();
        switch (fN) {
                case "disponible": {
                        var cantidad:Number = parseFloat(cursor.valueBuffer("cantidad"));
                        var reservada:Number = parseFloat(cursor.valueBuffer("reservada"));
                        valor = cantidad - reservada;
                        break;
                }
                case "cantidadultreg": {
                        valor = util.sqlSelect("lineasregstocks", "cantidadfin", "idstock = " + cursor.valueBuffer("idstock") + " ORDER BY fecha DESC, hora DESC", "lineasregstocks", conn);
                        if (isNaN(valor)) {
                                valor = 0;
                        }
                        break;
                }
                case "fechaultreg": {
                        valor = util.sqlSelect("lineasregstocks", "fecha", "idstock = " + cursor.valueBuffer("idstock") + " ORDER BY fecha DESC, hora DESC", "lineasregstocks", conn);
                        break;
                }
                case "horaultreg": {
                        valor = util.sqlSelect("lineasregstocks", "hora", "idstock = " + cursor.valueBuffer("idstock") + " ORDER BY fecha DESC, hora DESC", "lineasregstocks", conn);
                        break;
                }
        }
        return valor;
}
//// STOCK_UNIFICADO ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition lasCunas */
/////////////////////////////////////////////////////////////////
//// LAS_CUNAS /////////////////////////////////////////////////
function lasCunas_init() {
	this.iface.__init();
	this.iface.tbnEtiquetas = this.child("tbnEtiquetas");

	connect(this.iface.tbnEtiquetas, "clicked()", this, "iface.imprimirEtiquetas");
}


function lasCunas_imprimirEtiquetas() {
	debug("IMPRIME!");
	var cursor = this.child("tdbLineasProducciones").cursor();
	var util:FLUtil = new FLUtil;
	if (!cursor.isValid()) {
		return false;
	}

	var nombre_report = "i_produccion";
	var directa = true;
	var impresora = util.readSettingEntry("impresoras/produccion", "");
	if (!impresora)
		{
		directa = false;
		}
	flfactinfo.iface.pub_lanzarInforme(cursor, "i_etiquetas", "", "", false, directa, "ID_PRODUCCION\n" + cursor.valueBuffer("id") +"\nLOTE\n" + flfacturac.iface.trazabilidad_compose(cursor, cursor.valueBuffer("id")) + "\n", nombre_report, 1, impresora, false);

}
//// LAS_CUNAS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

