/***************************************************************************
                 factalma_general.qs  -  description
                             -------------------
    begin                : mie nov 23 2005
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
	var ctx:Object;
	function interna( context ) { this.ctx = context; }
	function main() {
		this.ctx.interna_main();
	}
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
	function oficial( context ) { interna( context ); }
	function updateTable(tabla:String):Boolean {
		return this.ctx.oficial_updateTable(tabla);
	}
	function sincroRow(referencia: String):Boolean {
		return this.ctx.oficial_sincroRow(referencia);
	}
	function obtenerListaCampos(tabla:String):Array {
		return this.ctx.oficial_obtenerListaCampos(tabla);
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends oficial {
	function head( context ) { oficial ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
	function ifaceCtx( context ) { head( context ); }
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/**
\C Los datos generales son nicos, por tanto formulario de no presenta los botones de navegacin por registros.
\end

\D La gestin del formulario se hace de forma manual mediante el objeto f (FLFormSearchDB)
\end
\end */
function interna_main()
{
var util = new FLUtil;
debug("Buscando cambios ...");
var conn_name:String = flfactalma.iface.recogeConnUnificada();
if ( conn_name != "default")
	{
	//Recogemos articulos locales
	//Si soy remoto: 
	//Familias
	util.createProgressDialog( util.translate( "scripts", "Actualizando tablas auxiliares" ), 5);
	util.setLabelText("Actualizando familias");
	util.setProgress(1);
	if (!this.iface.updateTable("familias"))
		{
		util.destroyProgressDialog();
		return;
		}
	//Formatos
	util.setLabelText("Actualizando formatos_planta");
	util.setProgress(2);
	if (!this.iface.updateTable("formato_planta"))
		{
		util.destroyProgressDialog();
		return;
		}
	//Contenedores
	util.setLabelText("Actualizando conteneodr_panta");
	util.setProgress(3);
	if (!this.iface.updateTable("contenedor_planta"))
		{
		util.destroyProgressDialog();
		return;
		}
	//Etiquetas
	util.setLabelText("Actualizando i_etiquetas");
	util.setProgress(4);
	if (!this.iface.updateTable("i_etiquetas"))
		{
		util.destroyProgressDialog();
		return;
		}
	//Tarifas
	util.setLabelText("Actualizando tarifas");
	util.setProgress(5);
	if (!this.iface.updateTable("tarifas"))
		{
		util.destroyProgressDialog();
		return;
		}
	//Articulos (Rellena tarifa y calcula gs1)
	util.destroyProgressDialog();
	


	var cur_art_local: FLSqlCursor = new FLSqlCursor("articulos");
	var list_locales = new Array();
	cur_art_local.select("1 = 1");
	
	while (cur_art_local.next())
		{
		list_locales[cur_art_local.valueBuffer("referencia")] = cur_art_local.valueBuffer("fecha_modificado").toString();
		}

	var qry_art_remotos: FLSqlQuery = new FLSqlQuery("", conn_name);
	qry_art_remotos.setTablesList("articulos");
	qry_art_remotos.setFrom("articulos");
	qry_art_remotos.setSelect("referencia,fecha_modificado");
	qry_art_remotos.setWhere("1=1");
	qry_art_remotos.setOrderBy("referencia");
	qry_art_remotos.exec()
	util.createProgressDialog( util.translate( "scripts", "Comprobando articulos" ), qry_art_remotos.size());
	var i = 0;
	var actualizados: Number = 0;
	while (qry_art_remotos.next())
		{
		util.setProgress(i);
		var referencia: String = qry_art_remotos.value("referencia");
		util.setLabelText("Comprobando " +  referencia);
		var sincro: Boolean = false;
		if (referencia in list_locales) //Existe en local
			{
			if (qry_art_remotos.value("fecha_modificado").toString() != list_locales[referencia])
				{
				sincro = true;
				}
				
			}
		else
			{
			sincro = true;
			}

		if (sincro)
			{
			actualizados += 1;
			if (!this.iface.sincroRow(referencia))
				{
				util.destroyProgressDialog();
				MessageBox.critical(util.translate("scripts","Error al actualizar la referencia " + referencia),
						MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
				return false;
				}
			}

		i += 1;
		}
	util.destroyProgressDialog();
	MessageBox.information(util.translate("scripts", "Proceso terminado. Se han actualizado " + actualizados + " registros"), MessageBox.Ok);
	}
}

function oficial_updateTable(tabla: String): Boolean
	{
	debug("Update Table " + tabla); 
	var util = new FLUtil;
	var conn_name:String = flfactalma.iface.recogeConnUnificada();
	var qry: FLSqlQuery = new FLSqlQuery("", conn_name);
	var cur_local : FLSqlCursor = new FLSqlCursor(tabla);
	qry.setTablesList(tabla);
	qry.setFrom(tabla);
	field_list = this.iface.obtenerListaCampos(tabla);
	qry.setSelect(field_list);
	qry.setWhere("1=1");
	qry.exec();
	//util.createProgressDialog( util.translate( "scripts", "" ), qry.size());
	
	var pk : String = cur_local.primaryKey();
	var p = 0;
	var cur_tmp = new FLSqlCursor(tabla);
	while (qry.next())
		{	
		//util.setProgress(p);
		//util.setLabelText("Comprobando " +  tabla + "." + qry.value(pk));
		var where: String = aqApp.db().manager().formatAssignValue(aqApp.db().manager().metadata(tabla).field(pk), qry.value(pk), true);
		var result = util.sqlSelect(tabla, pk, where);
		//debug("*" + where + " ** " + result);
		if (result)
			{
			
			cur_tmp.setModeAccess(cur_tmp.Edit);
			}
		else
			{
			cur_tmp.setModeAccess(cur_tmp.Insert);
			}
		cur_tmp.refreshBuffer();
		for (i = 0 ; i < field_list.length; i ++)
			{
			//debug(" Asigno " + field_list[i] + " = " + qry.value(field_list[i]));
			cur_tmp.setValueBuffer(field_list[i], qry.value(field_list[i]));
			}
		cur_tmp.commitBuffer();

		p += 1;
		}
	//util.destroyProgressDialog();
	return true;
	}

function oficial_sincroRow(referencia: String): Boolean
	{
	var util = new FLUtil;
	var tabla = "articulos";
	var conn_name:String = flfactalma.iface.recogeConnUnificada();
	var qry: FLSqlQuery = new FLSqlQuery("", conn_name);
	var cur_local : FLSqlCursor = new FLSqlCursor(tabla);
	qry.setTablesList(tabla);
	qry.setFrom(tabla);
	field_list = this.iface.obtenerListaCampos(tabla);
	qry.setSelect(field_list);
	
	qry.setWhere("referencia ='" + referencia + "'");
	qry.exec();
	//util.createProgressDialog( util.translate( "scripts", "" ), qry.size());
	var pk : String = cur_local.primaryKey();
	var p = 0;
	var cur_tmp = new FLSqlCursor(tabla);
	debug("Sincronizando REFERENCIA " + referencia);
	var cod_empresa: String = util.sqlSelect("empresa", "codgs1", "1 = 1");
	while (qry.next())
		{	
		//util.setProgress(p);
		//util.setLabelText("Sincronizando " +  tabla + "." + pk +" ( " +  qry.value(pk) + " ) ");
		//debug("Sincronizando " + qry.value(pk));
		var where: String = aqApp.db().manager().formatAssignValue(aqApp.db().manager().metadata(tabla).field(pk), qry.value(pk), true);
		if (util.sqlSelect(tabla, pk, where))
			{
			debug("Existe " + referencia);
			debug("Posicionando ");
			cur_tmp.select("referencia='" + referencia + "'");
			cur_tmp.first();
			cur_tmp.setModeAccess(cur_tmp.Edit);
			}
		else
			{
			debug("Nueva");
			cur_tmp.setModeAccess(cur_tmp.Insert);
			}
		cur_tmp.refreshBuffer();
		for (i = 0 ; i < field_list.length;i ++)
			{
			//debug("* " + field_list[i] + "-->" + qry.value(field_list[i]));
			if (field_list[i] == "idetiqueta" && qry.value(field_list[i]) == 0)
				{
				continue;
				}
			cur_tmp.setValueBuffer(field_list[i], qry.value(field_list[i]));
			}

	
		var barcode: String = formRecordarticulos.iface.calcularGS1(cod_empresa,referencia );
		debug("El GS1 de " + referencia + " es " + barcode);
		cur_tmp.setValueBuffer("codbarras",barcode);

		if (!cur_tmp.commitBuffer())
			{
			debug("No se han guardado cambios :(");
			return false;
			}
		//Generando GS1.
		
		
		


		//Generando tarifas.
		var qry_tarifas: FLSqlQuery = new FLSqlQuery("", conn_name);
		qry_tarifas.setTablesList("articulostarifas");
		qry_tarifas.setSelect("referencia,codtarifa,pvp,excluir");
		qry_tarifas.setFrom("articulostarifas");
		qry_tarifas.setWhere("referencia ='" + referencia + "'");
		if (qry_tarifas.exec())
			{
			if (!util.sqlDelete("articulostarifas","referencia ='" + referencia +"'"))
				{
				util.destroyProgressDialog();
				MessageBox.critical(util.translate("scripts","No se han borrado  los precios de tarifa viejos de la referencia " + referencia),
				MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
				return false;
				}	
			var cur_tarifas=  new FLSqlCursor("articulostarifas");
			while(qry_tarifas.next())
				{
				cur_tarifas.setModeAccess(cur_tarifas.Insert);
				cur_tarifas.refreshBuffer();
				cur_tarifas.setValueBuffer("referencia", referencia);
				cur_tarifas.setValueBuffer("codtarifa", qry_tarifas.value("codtarifa"));
				cur_tarifas.setValueBuffer("pvp", qry_tarifas.value("pvp"));
				cur_tarifas.setValueBuffer("excluir", qry_tarifas.value("excluir"));
				if (!cur_tarifas.commitBuffer())
					{
					util.destroyProgressDialog();
					MessageBox.critical(util.translate("scripts","Error al crear los precios de tarifa de la referencia " + referencia),
					MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
					return false;
					}
				}
			}
		p += 1;
		}
	//util.destroyProgressDialog();
	return true;
	}


function oficial_obtenerListaCampos(tabla:String):Array
{
	var util:FLUtil = new FLUtil();
	var contenido:String = util.sqlSelect("flfiles", "contenido", "nombre = '" + tabla + ".mtd'");
	
	var xmlContenido = new FLDomDocument();
	xmlContenido.setContent(contenido);
	
	var listaCampos:FLDomNodeList;
	listaCampos= xmlContenido.elementsByTagName("field");
	
	var arrayCampos:Array = [];
	var paso:Number = 0;
	for(var i = 0; i < listaCampos.length(); i++) {
		if (!listaCampos.item(i).namedItem("name")) 
			continue;
		arrayCampos[paso] = listaCampos.item(i).namedItem("name").toElement().text();
		paso++;
	}
	return arrayCampos;
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

