/***************************************************************************
                 albaranescli.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

/** @class_declaration interna */
//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
	function calculateField(fN:String):String { return this.ctx.interna_calculateField(fN); }
// 	function recordDelBeforelineasalbaranescli() { return this.ctx.interna_recordDelBeforelineasalbaranescli(); }
	function validateForm():Boolean { return this.ctx.interna_validateForm(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    var bloqueoProvincia:Boolean;
	var pbnAplicarComision:Object;
    function oficial( context ) { interna( context ); }
	function inicializarControles() {
		return this.ctx.oficial_inicializarControles();
	}
	function calcularTotales() {
		return this.ctx.oficial_calcularTotales();
	}
	function bufferChanged(fN:String) {
		return this.ctx.oficial_bufferChanged(fN);
	}
	function verificarHabilitaciones() {
		return this.ctx.oficial_verificarHabilitaciones();
	}
	function mostrarTraza() {
		return this.ctx.oficial_mostrarTraza();
	}
	function aplicarComision_clicked() {
		return this.ctx.oficial_aplicarComision_clicked();
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration dtoEspecial */
/////////////////////////////////////////////////////////////////
//// DTO ESPECIAL ///////////////////////////////////////////////
class dtoEspecial extends oficial /** %from: oficial */ {
    var bloqueoDto:Boolean;
    function dtoEspecial( context ) { oficial ( context ); }
	function init() {
		return this.ctx.dtoEspecial_init();
	}
	function bufferChanged(fN:String) {
		return this.ctx.dtoEspecial_bufferChanged(fN);
	}
	function calcularTotales() {
		return this.ctx.dtoEspecial_calcularTotales();
	}
}
//// DTO ESPECIAL ///////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration transportes */
//////////////////////////////////////////////////////////////////
//// TRANSPORTES//////////////////////////////////////////////////
class transportes extends dtoEspecial /** %from: oficial */ {
    function transportes( context ) { dtoEspecial( context ); }
	function bufferChanged(fN:String) {
		return this.ctx.transportes_bufferChanged(fN);
	}
}
//// TRANSPORTES//////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration clientesAlerta */
/////////////////////////////////////////////////////////////////
//// CLIENTES_ALERTA ////////////////////////////////////////////
class clientesAlerta extends transportes /** %from: oficial */ {
    function clientesAlerta( context ) { transportes ( context ); }
	function bufferChanged(fN:String) {
		return this.ctx.clientesAlerta_bufferChanged(fN);
	}
}
//// CLIENTES_ALERTA ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration controlNacional */
/////////////////////////////////////////////////////////////////
//// CONTROL_NACIONAL ///////////////////////////////////////////
class controlNacional extends clientesAlerta /** %from: oficial */ {
    function controlNacional( context ) { clientesAlerta ( context ); }
	function bufferChanged(fN:String) {
		return this.ctx.controlNacional_bufferChanged(fN);
	}
}
//// CONTROL_NACIONAL ///////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration scabLite */
/////////////////////////////////////////////////////////////////
//// CONTROL STOCK CABECERA /////////////////////////////////////
class scabLite extends controlNacional /** %from: oficial */ {
    var arrayStocks_:Array;
    function scabLite( context ) { controlNacional ( context ); }
    function init() {
        return this.ctx.scabLite_init();
    }
    function validateForm():Boolean {
        return this.ctx.scabLite_validateForm();
    }
    function cargarArrayStocks():Boolean {
        return this.ctx.scabLite_cargarArrayStocks();
    }
    function controlStockCabecera():Boolean {
        return this.ctx.scabLite_controlStockCabecera();
    }
}
//// CONTROL STOCK CABECERA /////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration albacliUser */
/////////////////////////////////////////////////////////////////
//// ALBACLI_USER ///////////////////////////////////////////////
class albacliUser extends scabLite /** %from: oficial */ {
    function albacliUser( context ) { scabLite ( context ); }
    function validateForm():Boolean {
    	return this.ctx.albacliUser_validateForm(); }
}
//// ALBACLI_USER ///////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration multiTarifaVenta */
/////////////////////////////////////////////////////////////////
//// MULTI_TARIFA_VENTA /////////////////////////////////////////
class multiTarifaVenta extends albacliUser /** %from: oficial */ {
    function multiTarifaVenta( context ) { albacliUser ( context ); }
    function bufferChanged(fN:String):String {
		 return this.ctx.multiTarifaVenta_bufferChanged(fN);
	}
}
//// MULTI_TARIFA_VENTA /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ivaIncluido */
//////////////////////////////////////////////////////////////////
//// IVAINCLUIDO /////////////////////////////////////////////////////
class ivaIncluido extends multiTarifaVenta /** %from: oficial */ {
    function ivaIncluido( context ) { multiTarifaVenta( context ); }
	function calcularTotales() {
		return this.ctx.ivaIncluido_calcularTotales();
	}
}
//// IVAINCLUIDO /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration lasCunas */
/////////////////////////////////////////////////////////////////
//// LAS_CUNAS /////////////////////////////////////////////////
class lasCunas extends ivaIncluido /** %from: ivaIncluido */ {
    function lasCunas( context ) { ivaIncluido ( context ); }
    function cargarArrayStocks():Boolean {
        return this.ctx.lasCunas_cargarArrayStocks();
    }
}
//// LAS_CUNAS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends lasCunas {
    function head( context ) { lasCunas ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
  function ifaceCtx( context ) { head( context ); }
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C
Este formulario realiza la gestion de los albaranes a clientes.

Los albaranes pueden ser generados de forma manual o a partir de uno o mas pedidos.
\end */
function interna_init()
{
	var util:FLUtil = new FLUtil();
	var cursor:FLSqlCursor = this.cursor();

	this.iface.bloqueoProvincia = false;
	this.iface.pbnAplicarComision = this.child("pbnAplicarComision");

    connect(this.iface.pbnAplicarComision, "clicked()", this, "iface.aplicarComision_clicked()");
	connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
	connect(this.child("tdbLineasAlbaranesCli").cursor(), "bufferCommited()", this, "iface.calcularTotales()");
	connect(this.child("tbnTraza"), "clicked()", this, "iface.mostrarTraza()");

	this.iface.pbnAplicarComision.setDisabled(true);

	if (cursor.modeAccess() == cursor.Insert) {
		this.child("fdbCodEjercicio").setValue(flfactppal.iface.pub_ejercicioActual());
		this.child("fdbCodDivisa").setValue(flfactppal.iface.pub_valorDefectoEmpresa("coddivisa"));
		this.child("fdbCodPago").setValue(flfactppal.iface.pub_valorDefectoEmpresa("codpago"));
		this.child("fdbCodAlmacen").setValue(flfactppal.iface.pub_valorDefectoEmpresa("codalmacen"));
		this.child("fdbCodSerie").setValue(flfactppal.iface.pub_valorDefectoEmpresa("codserie"));
		this.child("fdbTasaConv").setValue(util.sqlSelect("divisas", "tasaconv","coddivisa = '" + this.child("fdbCodDivisa").value() + "'"));
	}
	if (cursor.modeAccess() == cursor.Edit)
		this.child("fdbCodSerie").setDisabled(true);

	if (!cursor.valueBuffer("porcomision"))
		this.child("fdbPorComision").setDisabled(true);

	this.iface.inicializarControles();
}

function interna_calculateField(fN:String):String
{
		return formalbaranescli.iface.pub_commonCalculateField(fN, this.cursor());
}

function interna_validateForm()
{
	var cursor:FLSqlCursor = this.cursor();

	if (!flfactppal.iface.pub_validarProvincia(cursor, false)) {
		return false;
	}

	var idAlbaran = cursor.valueBuffer("idalbaran");
	var codCliente = this.child("fdbCodCliente").value();
	if (!flfacturac.iface.pub_validarIvaRecargoCliente(codCliente, idAlbaran, "lineasalbaranescli", "idalbaran")) {
		return false;
	}
	return true;
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
function oficial_inicializarControles()
{
	this.child("lblRecFinanciero").setText(this.iface.calculateField("lblRecFinanciero"));
	this.child("lblComision").setText(this.iface.calculateField("lblComision"));
	this.iface.verificarHabilitaciones();
}

function oficial_calcularTotales()
{
	var util:FLUtil = new FLUtil;

	this.child("fdbNeto").setValue(this.iface.calculateField("neto"));
	this.child("fdbTotalIva").setValue(this.iface.calculateField("totaliva"));
	this.child("fdbTotalRecargo").setValue(this.iface.calculateField("totalrecargo"));
	this.child("fdbTotaIrpf").setValue(this.iface.calculateField("totalirpf"));
	this.child("lblComision").setText(this.iface.calculateField("lblComision"));
	this.iface.verificarHabilitaciones();
}

function oficial_bufferChanged(fN:String)
{
	var cursor:FLSqlCursor = this.cursor();
	var util:FLUtil = new FLUtil();
	switch (fN) {
		case "recfinanciero":
		case "neto": {
			this.child("lblRecFinanciero").setText(this.iface.calculateField("lblRecFinanciero"));
			this.child("fdbTotaIrpf").setValue(this.iface.calculateField("totalirpf"));
		}
		/** \C
		El --total-- es el --neto-- menos el --totalirpf-- mas el --totaliva-- mas el --totalrecargo-- mas el --recfinanciero--
		\end */
		case "totalrecargo":
		case "totalirpf":
		case "totaliva": {
			this.child("fdbTotal").setValue(this.iface.calculateField("total"));
			break;
		}
		/** \C
		El --totaleuros-- es el producto del --total-- por la --tasaconv--
		\end */
		case "total": {
			this.child("fdbTotalEuros").setValue(this.iface.calculateField("totaleuros"));
			this.child("lblComision").setText(this.iface.calculateField("lblComision"));
			break;
		}
		case "tasaconv": {
			this.child("fdbTotalEuros").setValue(this.iface.calculateField("totaleuros"));
			break;
		}
		/** \C
		Al cambiar el --porcomision-- se mostrara el total de comision aplicada
		\end \end */
		case "porcomision": {
			this.child("lblComision").setText(this.iface.calculateField("lblComision"));
			break;
		}
		/** \C
		El valor de --coddir-- por defecto corresponde a la direccion del cliente marcada como direccion de facturacion
		\end */
		case "codcliente": {
			this.child("fdbCodDir").setValue("0");
			this.child("fdbCodDir").setValue(this.iface.calculateField("coddir"));
			break;
		}
		/** \C
		El --irpf-- es el asociado a la --codserie-- del albaran
		\end */
		case "codserie": {
			if (cursor.modeAccess() == cursor.Insert) {
			    this.cursor().setValueBuffer("irpf", this.iface.calculateField("irpf"));
			} else {
			    if (cursor.valueBuffer("codserie") != cursor.valueBufferCopy("codserie")) {
				cursor.setValueBuffer("codserie", cursor.valueBufferCopy("codserie"));
			    }
			}
			break;
		}
		/** \C
		El --totalirpf-- es el producto del --irpf-- por el --neto--
		\end */
		case "irpf": {
			this.child("fdbTotaIrpf").setValue(this.iface.calculateField("totalirpf"));
			break;
		}
		case "provincia": {
			if (!this.iface.bloqueoProvincia) {
				this.iface.bloqueoProvincia = true;
				flfactppal.iface.pub_obtenerProvincia(this, "","","");
				this.iface.bloqueoProvincia = false;
			}
			break;
		}
		case "idprovincia": {
			if (cursor.valueBuffer("idprovincia") == 0)
				cursor.setNull("idprovincia");
			break;
		}
		case "coddir": {
			this.child("fdbProvincia").setValue(this.iface.calculateField("provincia"));
			this.child("fdbCodPais").setValue(this.iface.calculateField("codpais"));
			break;
		}
		case "codagente": {
			this.iface.pbnAplicarComision.setDisabled(false);
			break;
		}
	}
}

function oficial_verificarHabilitaciones()
{
	var util:FLUtil = new FLUtil();
	if (!util.sqlSelect("lineasalbaranescli", "idalbaran", "idalbaran = " + this.cursor().valueBuffer("idalbaran"))) {
		this.child("fdbCodAlmacen").setDisabled(false);
		this.child("fdbCodDivisa").setDisabled(false);
		this.child("fdbTasaConv").setDisabled(false);
	} else {
		this.child("fdbCodAlmacen").setDisabled(true);
		this.child("fdbCodDivisa").setDisabled(true);
		this.child("fdbTasaConv").setDisabled(true);
	}
}

function oficial_mostrarTraza()
{
	flfacturac.iface.pub_mostrarTraza(this.cursor().valueBuffer("codigo"), "albaranescli");
}

function oficial_aplicarComision_clicked()
{
	var util:FLUtil;

	var idAlbaran:Number = this.cursor().valueBuffer("idalbaran");
	if(!idAlbaran)
		return;
	var codAgente:String = this.cursor().valueBuffer("codagente");
	if(!codAgente || codAgente == "")
		return;

	var res:Number = MessageBox.information(util.translate("scripts", "Seguro que desea actualizar la comisin en todas las lneas?"), MessageBox.Yes, MessageBox.No);
	if(res != MessageBox.Yes)
		return;

	var cursor:FLSqlCursor = new FLSqlCursor("empresa");
	cursor.transaction(false);

	try {
		if(!flfacturac.iface.pub_aplicarComisionLineas(codAgente,"lineasalbaranescli","idalbaran = " + idAlbaran)) {
			cursor.rollback();
			return;
		}
		else {
			cursor.commit();
		}
	} catch (e) {
		MessageBox.critical(util.translate("scripts", "Hubo un error al aplicarse la comisin en las lneas.\n%1").arg(e), MessageBox.Ok, MessageBox.NoButton);
		cursor.rollback();
		return false;
	}

	MessageBox.information(util.translate("scripts", "La comisin se actualiz correctamente."), MessageBox.Ok, MessageBox.NoButton);
	this.iface.pbnAplicarComision.setDisabled(true);
	this.child("tdbLineasAlbaranesCli").refresh();
}
//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition dtoEspecial */
//////////////////////////////////////////////////////////////////
//// DTO ESPECIAL ////////////////////////////////////////////////
function dtoEspecial_bufferChanged(fN:String)
{
	switch (fN) {
		case "neto": {
			this.child("fdbTotalIva").setValue(this.iface.calculateField("totaliva"));
			this.child("fdbTotalRecargo").setValue(this.iface.calculateField("totalrecargo"));
			this.iface.__bufferChanged(fN);
			break;
		}
		/** \C
		El --neto-- es el producto del --netosindtoesp-- por el --pordtoesp--
		\end */
		case "netosindtoesp": {
			if (!this.iface.bloqueoDto) {
				this.iface.bloqueoDto = true;
				this.child("fdbDtoEsp").setValue(this.iface.calculateField("dtoesp"));
				this.iface.bloqueoDto = false;
			}
			break;
		}
		case "pordtoesp": {
			if (!this.iface.bloqueoDto) {
				this.iface.bloqueoDto = true;
				this.child("fdbDtoEsp").setValue(this.iface.calculateField("dtoesp"));
				this.iface.bloqueoDto = false;
			}
			break;
		}
		case "dtoesp": {
			if (!this.iface.bloqueoDto) {
				this.iface.bloqueoDto = true;
				this.child("fdbPorDtoEsp").setValue(this.iface.calculateField("pordtoesp"));
				this.iface.bloqueoDto = false;
			}
			this.child("fdbNeto").setValue(this.iface.calculateField("neto"));
			break;
		}
		default: {
			this.iface.__bufferChanged(fN);
			break;
		}
	}
}

function dtoEspecial_calcularTotales()
{
	this.child("fdbNetoSinDtoEsp").setValue(this.iface.calculateField("netosindtoesp"));
	this.iface.__calcularTotales();
}

function dtoEspecial_init()
{
	this.iface.__init();

	this.iface.bloqueoDto = false;
}
//// DTO ESPECIAL ////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition transportes */
//////////////////////////////////////////////////////////////////
//// TRANSPORTES//////////////////////////////////////////////////
function transportes_bufferChanged(fN:String)
{
	var cursor:FLSqlCursor = this.cursor();
	var util:FLUtil = new FLUtil();
	switch (fN) {
//		case "matricula": {
//				var chofer:String;
//				chofer = util.sqlSelect("flota", "idchofer", "matricula = '" + cursor.valueBuffer("matricula") + "'");
//
//				if (chofer)
//					{
//					//debug("El chofer por defecto es " + chofer);
//					this.child("fdbChofer").setValue(chofer);
//					}
//				break;
//				 }
		default: {
			this.iface.__bufferChanged(fN);
			break;
			}
		}
}
//// TRANSPORTES//////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition clientesAlerta */
/////////////////////////////////////////////////////////////////
//// CLIENTES_ALERTA ////////////////////////////////////////////
function clientesAlerta_bufferChanged(fN:String)
{
	var cursor:FLSqlCursor = this.cursor();
	var util:FLUtil = new FLUtil();

	this.iface.__bufferChanged(fN);

	switch (fN) {
		case "codcliente": {
				var alerta:String = util.sqlSelect("clientes", "alerta", "codcliente = '" + this.child("fdbCodCliente").value() + "'");
		if (alerta && alerta != "")
			{
			var txt:String = "Este cliente tiene la siguiente alerta:\n" + alerta;
			MessageBox.information(util.translate("scripts", txt ), MessageBox.Ok, MessageBox.NoButton);
			}
				}
		}
	}
//// CLIENTES_ALERTA ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition controlNacional */
/////////////////////////////////////////////////////////////////
//// CONTROL_NACIONAL ///////////////////////////////////////////
function controlNacional_bufferChanged(fN:String)
{
	var cursor:FLSqlCursor = this.cursor();
	var util:FLUtil = new FLUtil();

	var nacional:Boolean = true;
	var errorRegimen:Boolean = false;
	var txt:String = "El regimen de I.V.A. , no concuerda con la direccin de facturacin";

	this.iface.__bufferChanged(fN);

	switch (fN) {
		case "codcliente": {
				//Comprobamos el pais.
				if (cursor.valueBuffer("codpais") != "ESP" && cursor.valueBuffer("codpais") != "ES")
					nacional = false;

				var regimenIva:String = util.sqlSelect("clientes", "regimeniva", "codcliente = '" + cursor.valueBuffer("codcliente") + "'");

				if (regimenIva != "false" && regimenIva != "0")
					{
					if (!nacional && regimenIva == "General")
						errorRegimen = true;

					if (nacional && regimenIva != "General")
						errorRegimen = true;

					if (errorRegimen)
						MessageBox.information(util.translate("scripts", txt ), MessageBox.Ok, MessageBox.NoButton);
					}
				}

		}
}
//// CONTROL_NACIONAL ///////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition scabLite */
/////////////////////////////////////////////////////////////////
//// CONTROL STOCK CABECERA /////////////////////////////////////
function scabLite_init()
{
    this.iface.__init();

    var util:FLUtil = new FLUtil;

    this.iface.arrayStocks_ = this.iface.cargarArrayStocks();
    if (!this.iface.arrayStocks_) {
        MessageBox.warning(util.translate("scripts", "Error al cargar los datos de stock"), MessageBox.Ok, MessageBox.NoButton);
        return false;
    }
}

function scabLite_cargarArrayStocks():Array
{
    var util:FLUtil = new FLUtil;
    var cursor:FLSqlCursor = this.cursor();
    var arrayStocks:Array = [];

    var qryStocks:FLSqlQuery = new FLSqlQuery;
    qryStocks.setTablesList("albaranescli,lineasalbaranescli");
    qryStocks.setSelect("la.referencia, la.idlineapedido, SUM(la.cantidad)");
    qryStocks.setFrom("albaranescli a INNER JOIN lineasalbaranescli la ON a.idalbaran = la.idalbaran");
    qryStocks.setWhere("a.idalbaran = " + cursor.valueBuffer("idalbaran") + " AND la.referencia IS NOT NULL GROUP BY a.codalmacen, la.referencia, la.idlineapedido");
    qryStocks.setForwardOnly(true);
    if (!qryStocks.exec()) {
        return false;
    }
    var i:Number = 0;
    while (qryStocks.next()) {
        arrayStocks[i] = [];
        arrayStocks[i]["idarticulo"] = qryStocks.value("la.referencia");
        arrayStocks[i]["codalmacen"] = cursor.valueBuffer("codalmacen");
        arrayStocks[i]["cantidad"] = qryStocks.value("SUM(la.cantidad)");
        arrayStocks[i]["idlineapedido"] = qryStocks.value("la.idlineapedido");
        i++;
    }
    return arrayStocks;
}

function scabLite_validateForm():Boolean
{
    if (!this.iface.__validateForm()) {
        return false;
    }

    if (!this.iface.controlStockCabecera()) {
        return false;
    }

    return true;
}

function scabLite_controlStockCabecera():Boolean
{
    var util:FLUtil = new FLUtil;
    var cursor:FLSqlCursor = this.cursor();

    var arrayActual:Array = this.iface.cargarArrayStocks();
    if (!arrayActual) {
        MessageBox.warning(util.translate("scripts", "Error al cargar los datos de stock"), MessageBox.Ok, MessageBox.NoButton);
        return false;
    }

    var arrayAfectados:Array = flfactalma.iface.pub_arraySocksAfectados(this.iface.arrayStocks_, arrayActual);
    if (!arrayAfectados) {
        return false;
    }
    var automatico:Boolean;
    for (var i:Number = 0; i < arrayAfectados.length; i++)
    {
        	    try {
      var x:Number = arrayAfectados[i]["idlineapedido"];
      automatico = true;
      }
      catch (e) {
      automatico = false;
    	}
    	    if (!flfactppal.iface.pub_valorDefectoEmpresa("stockpedidos") || !automatico )
    	    	{
    	    	debug("Este albarn cuenta");
        	if (!flfactalma.iface.pub_cambiarStock(arrayAfectados[i]["codalmacen"], arrayAfectados[i]["idarticulo"], arrayAfectados[i]["cantidad"] * -1, "cantidad"))
        		{
            		return false;
        		}
    		}
   }
    return true;
}

//// CONTROL STOCK CABECERA /////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition albacliUser */
/////////////////////////////////////////////////////////////////
//// ALBACLI_USER ///////////////////////////////////////////////
function albacliUser_validateForm()
{
debug("guardando usuario");
var cursor:FLSqlCursor = this.cursor();

if (cursor.valueBuffer("usuario") == "")
  {
  cursor.setValueBuffer("usuario", aqApp.db().user());
  debug("Guardando ... " +  aqApp.db().user());
  }

return this.iface.__validateForm();

}
//// ALBACLI_USER ///////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition multiTarifaVenta */
/////////////////////////////////////////////////////////////////
//// MULTI_TARIFA_VENTA /////////////////////////////////////////
function multiTarifaVenta_bufferChanged(fN:String):String
{
	if (fN == "codcliente")
		flfacturac.iface.bufferChangedTarifas(this.cursor());

	this.iface.__bufferChanged(fN);
}
//// MULTI_TARIFA_VENTA /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition ivaIncluido */
//////////////////////////////////////////////////////////////////
//// IVAINCLUIDO /////////////////////////////////////////////////////

function ivaIncluido_calcularTotales()
{
	this.iface.__calcularTotales();

	formRecordfacturascli.iface.comprobarRedondeoIVA(this.cursor(), "idalbaran")
}

//// IVAINCLUIDO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition lasCunas */
/////////////////////////////////////////////////////////////////
//// LAS_CUNAS /////////////////////////////////////////////////
function lasCunas_cargarArrayStocks()
{
    var util:FLUtil = new FLUtil;
    var cursor:FLSqlCursor = this.cursor();
    var arrayStocks:Array = [];

    var qryStocks:FLSqlQuery = new FLSqlQuery;
    qryStocks.setTablesList("albaranescli,lineasalbaranescli");
    qryStocks.setSelect("la.referencia, la.idlineapedido, SUM(la.cantidad), la.codalmacen");
    qryStocks.setFrom("albaranescli a INNER JOIN lineasalbaranescli la ON a.idalbaran = la.idalbaran");
    qryStocks.setWhere("a.idalbaran = " + cursor.valueBuffer("idalbaran") + " AND la.referencia IS NOT NULL GROUP BY a.codalmacen, la.codalmacen, la.referencia, la.idlineapedido");
    qryStocks.setForwardOnly(true);
    if (!qryStocks.exec()) {
        return false;
    }
    var i:Number = 0;
    while (qryStocks.next()) {
        arrayStocks[i] = [];
        arrayStocks[i]["idarticulo"] = qryStocks.value("la.referencia");
	if (qryStocks.value("la.codalmacen") && qryStocks.value("la.codalmacen") != "")
		{
		arrayStocks[i]["codalmacen"] = qryStocks.value("la.codalmacen");
		}
	else
		{
		arrayStocks[i]["codalmacen"] = cursor.valueBuffer("codalmacen");
		}

        arrayStocks[i]["cantidad"] = qryStocks.value("SUM(la.cantidad)");
        arrayStocks[i]["idlineapedido"] = qryStocks.value("la.idlineapedido");
        i++;
    }
    return arrayStocks;
}
//// LAS_CUNAS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

