/***************************************************************************
                 lineaspedidoscli.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
	function calculateField(fN:String):String { return this.ctx.interna_calculateField(fN); }
	function validateForm():Boolean { return this.ctx.interna_validateForm(); }
	function acceptedForm() { return this.ctx.interna_acceptedForm(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); }
	function desconectar() {
		return this.ctx.oficial_desconectar();
	}
	function bufferChanged(fN:String) {
		return this.ctx.oficial_bufferChanged(fN);
	}
	function commonBufferChanged(fN:String, miForm:Object) {
		return this.ctx.oficial_commonBufferChanged(fN, miForm);
	}
	function commonCalculateField(fN:String, cursor:FLSqlCursor):String {
		return this.ctx.oficial_commonCalculateField(fN, cursor);
	}
	function obtenerTarifa(codCliente:String, cursor:FLSqlCursor):String {
		return this.ctx.oficial_obtenerTarifa(codCliente, cursor);
	}
	function datosTablaPadre(cursor:FLSqlCursor):Array {
		return this.ctx.oficial_datosTablaPadre(cursor);
	}
	function dameFiltroReferencia():String {
		return this.ctx.oficial_dameFiltroReferencia();
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration irpfExcluidosIva */
//////////////////////////////////////////////////////////////////
//// IRPF_EXCLUIDOS_IVA //////////////////////////////////////////
class irpfExcluidosIva extends oficial /** %from: oficial */ {
    function irpfExcluidosIva( context ) { oficial( context ); }
    function init() {
		this.ctx.irpfExcluidosIva_init();
	}
}

//// IRPF_EXCLUIDOS_IVA //////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration baseInalterable */
/////////////////////////////////////////////////////////////////
//// BASE_INALTERABLE ///////////////////////////////////////////
class baseInalterable extends irpfExcluidosIva /** %from: oficial */ {
    function baseInalterable( context ) { irpfExcluidosIva ( context ); }
	function commonBufferChanged( fN:String, miForm:Object ) {
		return this.ctx.baseInalterable_commonBufferChanged(fN, miForm);
	}
}
//// BASE_INALTERABLE ///////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration cantSize */
/////////////////////////////////////////////////////////////////
//// CANT_SIZE //////////////////////////////////////////////////
class cantSize extends baseInalterable /** %from: oficial */ {
    var boolSize:Boolean;
    function cantSize( context ) { baseInalterable ( context ); }
    function commonBufferChanged(fN:String, miForm:Object) {
	return this.ctx.cantSize_commonBufferChanged(fN, miForm);
}
    function commonCalculateField(fN:String, cursor:FLSqlCursor):String {
	return this.ctx.cantSize_commonCalculateField(fN, cursor);
}
    function init() {
    	this.ctx.cantSize_init();
}
    function validateForm():Boolean {
    	return this.ctx.cantSize_validateForm();
}
    function analizaCadena(cadena:String,cantidad:Number):String {
    	return this.ctx.cantSize_analizaCadena(cadena,cantidad);
}
}
//// CANT_SIZE //////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration tarifaAlternativa */
/////////////////////////////////////////////////////////////////
//// TARIFA_ALTERNATIVA /////////////////////////////////////////
class tarifaAlternativa extends cantSize /** %from: oficial */ {
    function tarifaAlternativa( context ) { cantSize ( context ); }
    function obtenerTarifa(codCliente:String, cursor:FLSqlCursor):String {
		return this.ctx.tarifaAlternativa_obtenerTarifa(codCliente, cursor);
	}
}
//// TARIFA_ALTERNATIVA /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration rapelClientes */
/////////////////////////////////////////////////////////////////
//// RAPEL_CLIENTES /////////////////////////////////////////////
class rapelClientes extends tarifaAlternativa /** %from: oficial */ {
    function rapelClientes( context ) { tarifaAlternativa ( context ); }
	function commonCalculateField(fN:String, cursor:FLSqlCursor):String {
		return this.ctx.rapelClientes_commonCalculateField(fN, cursor);
	}
}
//// RAPEL_CLIENTES /////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ivaIncluido */
//////////////////////////////////////////////////////////////////
//// IVAINCLUIDO /////////////////////////////////////////////////////
class ivaIncluido extends rapelClientes /** %from: oficial */ {
	var bloqueoPrecio:Boolean;
    function ivaIncluido( context ) { rapelClientes( context ); }
	function init() {
		return this.ctx.ivaIncluido_init();
	}
	function habilitarPorIvaIncluido(miForm:Object) {
		return this.ctx.ivaIncluido_habilitarPorIvaIncluido(miForm);
	}
	function commonCalculateField(fN:String, cursor:FLSqlCursor):String {
		return this.ctx.ivaIncluido_commonCalculateField(fN, cursor);
	}
	function commonBufferChanged(fN:String, miForm:Object) {
		return this.ctx.ivaIncluido_commonBufferChanged(fN, miForm);
	}
}
//// IVAINCLUIDO /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration stockUnificado */
/////////////////////////////////////////////////////////////////
//// STOCK_UNIFICADO ////////////////////////////////////////////
class stockUnificado extends ivaIncluido /** %from: oficial */ {
	var linea_actual: Number;
	var table: Object;
	var mi_fecha_marcada: Boolean;
	function stockUnificado( context ) { ivaIncluido ( context ); }
	function init() {
		return this.ctx.stockUnificado_init();
	}
	function commonBufferChanged(fN:String, miForm:Object) {
		return this.ctx.stockUnificado_commonBufferChanged(fN, miForm);
	}
	function muestra_stock(miForm:Object) {
		this.ctx.stockUnificado_muestra_stock(miForm);
	}
	function genera_tabla(obj: Object) {
		this.ctx.stockUnificado_genera_tabla(obj);
	}
	function rellena_linea_almacen(qry:FLSqlQuery,referencia: String, miForm: Object)  {
		this.ctx.stockUnificado_rellena_linea_almacen(qry, referencia, miForm);
	}

	function rellena_lineas_pedidos_hasta(qry_entradas: FLSqlQuery, referencia: String,cod_almacen: String,cantidad_actual: Number, fecha_minima:String, miForm: Object ): Number {
		return this.ctx.stockUnificado_rellena_lineas_pedidos_hasta(qry_entradas, referencia, cod_almacen , cantidad_actual, fecha_minima, miForm);
	}
	function rellena_lineas_pedidos_hasta_hoy(fecha: String, referencia: String,cod_almacen: String,cantidad_actual: Number, miForm: Object) {
		this.ctx.stockUnificado_rellena_lineas_pedidos_hasta_hoy(fecha,referencia,cod_almacen,cantidad_actual, miForm);
	}
	function validateForm():Boolean {
		return this.ctx.stockUnificado_validateForm();
	}
	function comprobar_mi_reserva(cod_almacen:String, fecha_previa:String, miForm:Object ): Number {
		return this.ctx.stockUnificado_comprobar_mi_reserva(cod_almacen, fecha_previa, miForm);
	}

}
//// STOCK_UNIFICADO ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration lasCunas */
/////////////////////////////////////////////////////////////////
//// LAS CUNAS  /////////////////////////////////////////////////
class lasCunas extends stockUnificado /** %from: stockUnificado */ {
    function lasCunas( context ) { stockUnificado ( context ); }
    function commonBufferChanged(fN:String, miForm:Object) {
	return this.ctx.lasCunas_commonBufferChanged(fN, miForm);
    }
    	function muestra_stock(miForm:Object) {
		this.ctx.lasCunas_muestra_stock(miForm);
	}
	function genera_tabla(obj: Object) {
		this.ctx.lasCunas_genera_tabla(obj);
	}
	function comprobar_mi_reserva(cod_almacen:String, fecha_previa:String, miForm:Object ): Number {
		return this.ctx.lasCunas_comprobar_mi_reserva(cod_almacen, fecha_previa, miForm);
	}
	function rellena_lineas_pedidos_hasta_hoy(fecha: String, referencia: String,cod_almacen: String,cantidad_actual: Number, miForm:Object) {
		this.ctx.lasCunas_rellena_lineas_pedidos_hasta_hoy(fecha,referencia,cod_almacen,cantidad_actual, miForm);
	}

	function rellena_lineas_pedidos_hasta(qry_entradas: FLSqlQuery, referencia: String,cod_almacen: String,cantidad_actual: Number, fecha_minima:String, miForm:Object ): Number {
		return this.ctx.lasCunas_rellena_lineas_pedidos_hasta(qry_entradas, referencia, cod_almacen , cantidad_actual, fecha_minima, miForm);
	}
}
//// LAS CUNAS  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends lasCunas {
    function head( context ) { lasCunas ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
		function pub_commonBufferChanged(fN:String, miForm:Object) {
				return this.commonBufferChanged(fN, miForm);
		}
		function pub_commonCalculateField(fN:String, cursor:FLSqlCursor):String {
				return this.commonCalculateField(fN, cursor);
		}
}

const iface = new pubIvaIncluido( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration pubIvaIncluido */
/////////////////////////////////////////////////////////////////
//// PUB_IVA_INCLUIDO ///////////////////////////////////////////
class pubIvaIncluido extends ifaceCtx /** %from: ifaceCtx */ {
    function pubIvaIncluido( context ) { ifaceCtx( context ); }
	function pub_habilitarPorIvaIncluido(miForm:Object) {
		return this.habilitarPorIvaIncluido(miForm);
	}
}

//// PUB_IVA_INCLUIDO ///////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C
Este formulario realiza la gestin de las lneas de pedidos a clientes.
\end */
function interna_init()
{
	var util:FLUtil = new FLUtil();
	var cursor:FLSqlCursor = this.cursor();
	connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
	connect(form, "closed()", this, "iface.desconectar");

	var codSerie:String = "";
	var porComision:Number = 0;
	var codAgente:String = "";
	var codCliente:String = "";

	if(cursor.cursorRelation()) {debug("con cursorRelation");
		codSerie = cursor.cursorRelation().valueBuffer("codserie");
		porComision = cursor.cursorRelation().valueBuffer("porcomision");
		codAgente = cursor.cursorRelation().valueBuffer("codagente");
		codCliente = cursor.cursorRelation().valueBuffer("codcliente");
	}
	else {debug("sin cursorRelation");
		var idPedido:Number = cursor.valueBuffer("idpedido");
		debug("idPedido " + idPedido);
		if(idPedido) {
			codSerie = util.sqlSelect("pedidoscli", "codserie", "idpedido = " + idPedido);
			porComision = util.sqlSelect("pedidoscli", "porcomision", "idpedido = " + idPedido);
			codAgente = util.sqlSelect("pedidoscli", "codagente", "idpedido = " + idPedido);
			codCliente = util.sqlSelect("pedidoscli", "codcliente", "idpedido = " + idPedido);
		}
	}

	var irpf:Number = 0;
	if (codSerie && codSerie != "") {
		irpf = util.sqlSelect("series", "irpf", "codserie = '" + codSerie + "'");
	}
	if (!irpf) {
		irpf = 0;
	}

	if (cursor.modeAccess() == cursor.Insert) {
		var opcionIvaRec:Number = flfacturac.iface.pub_tieneIvaDocCliente(cursor.cursorRelation().valueBuffer("codserie"), cursor.cursorRelation().valueBuffer("codcliente"), "");
		switch (opcionIvaRec) {
			case 0: {
				this.child("fdbCodImpuesto").setValue("");
				this.child("fdbIva").setValue(0);
				this.child("fdbRecargo").setValue(0);
				break;
			}
			case 1: {
				this.child("fdbRecargo").setValue(0);
//Rellenamos el codimpuesto del almacen por defecto
				var impuestoAlmacen:String = util.sqlSelect("factalma_general", "codimpuesto", "1 = 1");
				if (impuestoAlmacen)
					this.child("fdbCodImpuesto").setValue(impuestoAlmacen);
//Fin
				break;
			}
		}
		this.child("fdbIRPF").setValue(irpf);
		this.child("fdbDtoPor").setValue(this.iface.calculateField("dtopor"));
		if (porComision) {
			this.child("fdbPorComision").setDisabled(true);
		} else {
			if (!codAgente || codAgente == "") {
				this.child("fdbPorComision").setDisabled(true);
			} else {
				this.child("fdbPorComision").setValue(this.iface.calculateField("porcomision"));
			}
		}
	}

	if (porComision) {
		this.child("fdbPorComision").setDisabled(true);
	}

	this.child("lblComision").setText(this.iface.calculateField("lblComision"));
	this.child("lblDtoPor").setText(this.iface.calculateField("lbldtopor"));

	var filtroReferencia:String = this.iface.dameFiltroReferencia();
	this.child("fdbReferencia").setFilter(filtroReferencia);
}

function interna_calculateField(fN:String):String
{
		return this.iface.commonCalculateField(fN, this.cursor());
		/** \C
		El --pvpunitario-- ser el correspondiente al artculo segn la tarifa asociada al cliente. Si no se ha especificado este dato, se tomar el pvp asociado al artculo.
		\end */
		/** \C
		El --pvpsindto-- ser el producto del campo --cantidad-- por el campo --pvpunitario--
		\end */
		/** \C
		El --iva-- ser el correspondiente al --codimpuesto-- en la tabla de impuestos
		\end */
		/** \C
		El --pvptotal-- ser el --pvpsindto-- menos el --dtopor-- y menos el --dtolineal--
		\end */
		/** \Cvar util:FLUtil = new FLUtil();
		El --dtopor-- ser el descuento asociado al cliente
		\end */
		/** \C
		El --recargo-- ser el correspondiente al --codimpuesto-- en la tabla de impuestos en el caso de que el cliente tenga activado el campo Aplicar recargo de equivalencia en su correspondiente formulario.
		\end */
}

function interna_validateForm():Boolean
{
		var cursor:FLSqlCursor = this.cursor();

		/** \C
		La cantidad de artculos especificada ser mayor o igual que la del --totalenalbaran--
		\end */
		if (parseFloat(cursor.valueBuffer("cantidad")) < parseFloat(cursor.valueBuffer("totalenalbaran"))) {
				var util:FLUtil = new FLUtil();
				MessageBox.critical(util.translate("scripts","La cantidad especificada no puede ser menor que la servida."),
						MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
				return false;
		}
		return true;
}

function interna_acceptedForm()
{
		disconnect(this.cursor(), "bufferChanged(QString)", this, "iface.bufferChanged");
}

//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
function oficial_desconectar()
{
		disconnect(this.cursor(), "bufferChanged(QString)", this, "iface.bufferChanged");
}

function oficial_bufferChanged(fN:String)
{
		this.iface.commonBufferChanged(fN, form);
		/** \C
		Al cambiar la --referencia-- se mostrarn los valores asociados de --pvpvunitario-- y --codimpuesto--
		\end */
		/** \C
		Al cambiar el --codimpuesto-- se mostrarn los valores asociados de --iva-- y --recargo--
		\end */
		/** \C
		Al cambiar la --cantidad-- o el --pvpunitario-- se mostrar el valor asociado de --pvpsindto--
		\end */
		/** \C
		Al cambiar el --pvpsindto--, el --dtopor-- o el --dtolineal-- se mostrar el valor asociado de --pvptotal--
		\end */
}

function oficial_commonBufferChanged(fN:String, miForm:Object)
{
	var cursor:FLSqlCursor = miForm.cursor();
	switch (fN) {
		case "referencia":{
			miForm.child("fdbPvpUnitario").setValue(this.iface.commonCalculateField("pvpunitario", miForm.cursor()));
			miForm.child("fdbCodImpuesto").setValue(this.iface.commonCalculateField("codimpuesto", miForm.cursor()));
			break;
		}
		case "codimpuesto":{
			miForm.child("fdbIva").setValue(this.iface.commonCalculateField("iva", miForm.cursor()));
			miForm.child("fdbRecargo").setValue(this.iface.commonCalculateField("recargo", miForm.cursor()));
			break;
		}
		case "cantidad":
		case "pvpunitario":{
            cursor.setValueBuffer("pvpsindto", this.iface.commonCalculateField("pvpsindto", miForm.cursor()));
            // KLO. Algunas veces da error con los decimales. miForm.child("fdbPvpSinDto").setValue(this.iface.commonCalculateField("pvpsindto", miForm.cursor()));
			break;
		}
		case "pvpsindto":
		case "dtopor":{
			miForm.child("lblDtoPor").setText(this.iface.commonCalculateField("lbldtopor", miForm.cursor()));
		}
		case "dtolineal":{
			miForm.child("fdbPvpTotal").setValue(this.iface.commonCalculateField("pvptotal", miForm.cursor()));
			break;
		}
		case "pvptotal":
		case "porcomision": {
			var tabla:String = cursor.table();
			switch (tabla) {
				case "lineaspresupuestoscli":
				case "lineaspedidoscli":
				case "lineasalbaranescli":
				case "lineasfacturascli": {
					miForm.child("lblComision").setText(this.iface.commonCalculateField("lblComision", cursor));
					break;
				}
			}
			break;
		}
	}
}

/** \D Obtiene la tarifa asociada a un cliente
@param codCliente: cdigo del cliente
@param cursor: Cursor del documento que busca la tarifa. Para sobreescribir
@return Cdigo de la tarifa asociada o false si no tiene ninguna tarifa asociada
\end */
function oficial_obtenerTarifa(codCliente:String, cursor:FLSqlCursor):String
{
	var util:FLUtil = new FLUtil;
	return util.sqlSelect("clientes c INNER JOIN gruposclientes gc ON c.codgrupo = gc.codgrupo", "gc.codtarifa", "codcliente = '" + codCliente + "'", "clientes,gruposclientes");
}

function oficial_commonCalculateField(fN:String, cursor:FLSqlCursor):String
{
	var util:FLUtil = new FLUtil();
	var datosTP:Array = this.iface.datosTablaPadre(cursor);
	if (!datosTP)
		return false;
	var wherePadre:String = datosTP.where;
	var tablaPadre:String = datosTP.tabla;

	var valor:String;
	switch (fN) {
		case "pvpunitario":{
			var codCliente:String = datosTP["codcliente"];
			var referencia:String = cursor.valueBuffer("referencia");
			var codTarifa:String = this.iface.obtenerTarifa(codCliente, cursor);
			if (codTarifa) {
				valor = util.sqlSelect("articulostarifas", "pvp", "referencia = '" + referencia + "' AND codtarifa = '" + codTarifa + "'");
			}
			if (!valor) {
				valor = util.sqlSelect("articulos", "pvp", "referencia = '" + referencia + "'");
			}
			var tasaConv:Number = datosTP["tasaconv"];
			valor = parseFloat(valor) / tasaConv;
			break;
		}
		case "pvpsindto":{
			valor = parseFloat(cursor.valueBuffer("pvpunitario")) * parseFloat(cursor.valueBuffer("cantidad"));
			valor = util.roundFieldValue(valor, "lineaspedidoscli", "pvpsindto");
			break;
		}
		case "iva": {
			valor = flfacturac.iface.pub_campoImpuesto("iva", cursor.valueBuffer("codimpuesto"), datosTP["fecha"]);
			if (isNaN(valor)) {
				valor = "";
			}
			break;
		}
		case "lbldtopor":{
			valor = (cursor.valueBuffer("pvpsindto") * cursor.valueBuffer("dtopor")) / 100;
			valor = util.roundFieldValue(valor, "lineaspedidoscli", "pvpsindto");
			break;
		}
		case "pvptotal":{
			var dtoPor:Number = (cursor.valueBuffer("pvpsindto") * cursor.valueBuffer("dtopor")) / 100;
			dtoPor = util.roundFieldValue(dtoPor, "lineaspedidoscli", "pvpsindto");
			valor = cursor.valueBuffer("pvpsindto") - parseFloat(dtoPor) - cursor.valueBuffer("dtolineal");
			valor = util.roundFieldValue(valor, cursor.table(), "pvptotal");
			break;
		}
		case "dtopor":{
			var codCliente:String = datosTP["codcliente"];
			valor = flfactppal.iface.pub_valorQuery("descuentosclientes,descuentos", "SUM(d.dto)", "descuentosclientes dc INNER JOIN descuentos d ON dc.coddescuento = d.coddescuento", "dc.codcliente = '" + codCliente + "';");
			break;
		}
		case "recargo":{
			var codCliente:String = datosTP["codcliente"];;
			var aplicarRecEq:Boolean = util.sqlSelect("clientes", "recargo", "codcliente = '" + codCliente + "'");
			if (aplicarRecEq == true) {
				valor = flfacturac.iface.pub_campoImpuesto("recargo", cursor.valueBuffer("codimpuesto"), datosTP["fecha"]);
			} else {
				valor = "";
			}
			if (isNaN(valor)) {
				valor = "";
			}
			break;
		}
		case "codimpuesto": {
			var codCliente:String = datosTP["codcliente"];;
			var codSerie:String = datosTP["codserie"];;
			if (flfacturac.iface.pub_tieneIvaDocCliente(codSerie, codCliente, "")) {
				valor = util.sqlSelect("articulos", "codimpuesto", "referencia = '" + cursor.valueBuffer("referencia") + "'");
			} else {
				valor = "";
			}
			break;
		}
		case "porcomision": {
			var porComisionPadre:String = datosTP["porcomision"];
			if (porComisionPadre) {
				valor = "";
				break;
			}
			var codAgente:String = datosTP["codagente"];
			if (!codAgente || codAgente == "") {
				valor = "";
				break;
			}
			var comisionAgente:Number = flfacturac.iface.pub_calcularComisionLinea(codAgente,cursor.valueBuffer("referencia"));
			comisionAgente = util.roundFieldValue(comisionAgente, cursor.table(), "porcomision");
			valor = comisionAgente.toString();
			break;
		}
		case "lblComision": {
			var porComision:Number = parseFloat(cursor.valueBuffer("porcomision"));
			if (!porComision) {
				break;
			}
			var pvpTotal:Number = parseFloat(cursor.valueBuffer("pvptotal"));
			var comision:Number = (porComision * pvpTotal) / 100;
			comision = util.roundFieldValue(comision, cursor.table(), "pvptotal");
			valor = comision.toString();
			break;
		}
	}
	return valor;
}

/** \D Devuelve la tabla padre de la tabla parmetro, as como la clusula where necesaria para localizar el registro padre
@param	cursor: Cursor cuyo padre se busca
@return	Array formado por:
	* where: Clusula where
	* tabla: Nombre de la tabla padre
o false si hay error
\end */
function oficial_datosTablaPadre(cursor:FLSqlCursor):Array
{
	var datos:Array;
	switch (cursor.table()) {
		case "lineaspresupuestoscli": {
			datos.where = "idpresupuesto = "+ cursor.valueBuffer("idpresupuesto");
			datos.tabla = "presupuestoscli";
			break;
		}
		case "lineaspedidoscli": {
			datos.where = "idpedido = "+ cursor.valueBuffer("idpedido");
			datos.tabla = "pedidoscli";
			break;
		}
		case "lineasalbaranescli": {
			datos.where = "idalbaran = "+ cursor.valueBuffer("idalbaran");
			datos.tabla = "albaranescli";
			break;
		}
		case "lineasfacturascli": {
			datos.where = "idfactura = "+ cursor.valueBuffer("idfactura");
			datos.tabla = "facturascli";
			break;
		}
		case "tpv_lineascomanda": {
			datos.where = "idtpv_comanda = "+ cursor.valueBuffer("idtpv_comanda");
			datos.tabla = "tpv_comandas";
			break;
		}
	}
	var curRel:FLSqlCursor = cursor.cursorRelation();
	if (curRel && curRel.table() == datos.tabla) {
		switch (cursor.table()) {
			case "tpv_lineascomanda": {
				datos["tasaconv"] = 1;
				datos["codserie"] = false;
				datos["porcomision"] = 0;
				datos["codagente"] = false;
				break;
			}
			default: {
				datos["tasaconv"] = curRel.valueBuffer("tasaconv");
				datos["codserie"] = curRel.valueBuffer("codserie");
				datos["porcomision"] = curRel.valueBuffer("porcomision");
				datos["codagente"] = curRel.valueBuffer("codagente");
			}
		}
		datos["codcliente"] = curRel.valueBuffer("codcliente");
		datos["fecha"] = curRel.valueBuffer("fecha");
	} else {
		var qryDatos:FLSqlQuery = new FLSqlQuery;
		qryDatos.setTablesList(datos.tabla);
		switch (cursor.table()) {
			case "tpv_lineascomanda": {
				qryDatos.setSelect("codcliente, fecha");
				break;
			}
			default: {
				qryDatos.setSelect("tasaconv, codcliente, fecha, codserie, porcomision, codagente");
			}
		}

		qryDatos.setFrom(datos.tabla);
		qryDatos.setWhere(datos.where);
		qryDatos.setForwardOnly(true);
		if (!qryDatos.exec()) {
			return false;
		}
		if (!qryDatos.first()) {
			return false;
		}
		switch (cursor.table()) {
			case "tpv_lineascomanda": {
				datos["tasaconv"] = 1;
				datos["codserie"] = false;
				datos["porcomision"] = 0;
				datos["codagente"] = false;
				break;
			}
			default: {
				datos["tasaconv"] = qryDatos.value("tasaconv");
				datos["codserie"] = qryDatos.value("codserie");
				datos["porcomision"] = qryDatos.value("porcomision");
				datos["codagente"] = qryDatos.value("codagente");
			}
		}
		datos["codcliente"] = qryDatos.value("codcliente");
		datos["fecha"] = qryDatos.value("fecha");
	}
	return datos;
}

function oficial_dameFiltroReferencia():String
{
	return "sevende";
}
//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition irpfExcluidosIva */
/////////////////////////////////////////////////////////////////
//// IRPF_EXCLUIDOS_IVA /////////////////////////////////////////

function irpfExcluidosIva_init()
{
	this.iface.__init();
	var util:FLUtil = new FLUtil();
	var cursor:FLSqlCursor = this.cursor();
	var datosTP:Array = this.iface.datosTablaPadre(cursor);
	var irpf:Number = 0;
        if (util.sqlSelect("clientes", "regimeniva", "codcliente = '" + datosTP["codcliente"] + "'") == "Exento")
        	{

       	if (cursor.modeAccess() == cursor.Insert)
       			{
			this.child("fdbIRPF").setValue(irpf);
			}
		}
}

//// IRPF_EXCLUIDOS_IVA /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition baseInalterable */
/////////////////////////////////////////////////////////////////
//// BASE_INALTERABLE ///////////////////////////////////////////
function baseInalterable_commonBufferChanged(fN:String, miForm:object ) {

var util:FLUtil = new FLUtil();

this.iface.__commonBufferChanged(fN,miForm);

if (fN == "referencia")
	{
	if (util.sqlSelect("articulos","inalterable", "referencia ='" + miForm.cursor().valueBuffer("referencia") + "'"))
		 {
		miForm.child("fdbDtoLineal").setValue(0);
		miForm.child("fdbDtoLineal").setDisabled(true);
		miForm.child("fdbDtoPor").setValue(0);
		miForm.child("fdbDtoPor").setDisabled(true);
		 }
		 else
		 {
		 miForm.child("fdbDtoPor").setDisabled(false);
		 miForm.child("fdbDtoLineal").setDisabled(false);
		 }


	}
}
//// BASE_INALTERABLE ///////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition cantSize */
/////////////////////////////////////////////////////////////////
//// CANT_SIZE //////////////////////////////////////////////////

function cantSize_commonBufferChanged(fN:String, miForm:Object)
{
	var cursor:FLSqlCursor = miForm.cursor();
	var util:FLUtil = new FLUtil();
	switch (fN) {
		case "cantsize":{
			//debug("noto algo...");
			miForm.child("fdbPvpSinDto").setValue(this.iface.commonCalculateField("pvpsindto", miForm.cursor()));
			miForm.child("fdbCodImpuesto").setValue(this.iface.commonCalculateField("codimpuesto", miForm.cursor()));
			miForm.child("fdbDescripcion").setValue(this.iface.analizaCadena(cursor.valueBuffer("descripcion"),cursor.valueBuffer("cantsize")));
			break;
			}
		case "referencia":{
			var referencia:String = cursor.valueBuffer("referencia");
			var boolSize:Boolean = util.sqlSelect("articulos", "usasize", "referencia = '" + referencia + "'");
			//debug("Limpiando");
			if (!boolSize)
				miForm.child("fdbCantidadSize").setDisabled(true);
			else
				{
				miForm.child("fdbCantidadSize").setDisabled(false);
				}
			miForm.child("fdbCantidadSize").setValue("1");
			}
		default:{
			this.iface.__commonBufferChanged(fN, miForm);
			}
		   }

}

function cantSize_commonCalculateField(fN:String, cursor:FLSqlCursor):String
{
	var util:FLUtil = new FLUtil();
	var datosTP:Array = this.iface.datosTablaPadre(cursor);
	if (!datosTP)
		return false;
	var wherePadre:String = datosTP.where;
	var tablaPadre:String = datosTP.tabla;

	var valor:String;
	switch (fN) {
			case "pvpsindto":{
						var referencia:String = cursor.valueBuffer("referencia");
						var boolSize:Boolean = util.sqlSelect("articulos", "usasize", "referencia = '" + referencia + "'");
						if (!boolSize)
							{
							valor = parseFloat(cursor.valueBuffer("pvpunitario")) * parseFloat(cursor.valueBuffer("cantidad"));
							}
							else
							{
							//debug("Este articulo se paga por tamao de tronco");
							valor = parseFloat(cursor.valueBuffer("pvpunitario")) * parseFloat(cursor.valueBuffer("cantsize"));
							}
						valor = util.roundFieldValue(valor, "lineaspedidoscli", "pvpsindto");
						//debug("Devolviendo valor ..." + valor);
						break;
					}

			default:{
				//debug("buscando " + fN + "en atras");
				valor = this.iface.__commonCalculateField(fN, cursor);
				}
		}

 return valor;
}

function cantSize_init()
{
this.iface.__init();

var util:FLUtil = new FLUtil();
var cursor:FLSqlCursor = this.cursor();
this.iface.boolSize = false;
if (cursor.modeAccess() == cursor.Insert || cursor.modeAccess() == cursor.Browse )
	{
	this.child("fdbCantidadSize").setDisabled(true);
	}
	else
	{
	var referencia:String = cursor.valueBuffer("referencia");
	this.iface.boolSize = util.sqlSelect("articulos", "usasize", "referencia = '" + referencia + "'");

	if (!this.iface.boolSize)
		this.child("fdbCantidadSize").setDisabled(true);
	else
		this.child("fdbCantidadSize").setDisabled(false);
	}


}

function cantSize_validateForm():Boolean
{
var util:FLUtil = new FLUtil();
var cursor:FLSqlCursor = this.cursor();

	if (!this.iface.__validateForm())
		return false;


	if (cursor.valueBuffer("cantsize") < 10 && util.sqlSelect("articulos", "usasize", "referencia = '" + cursor.valueBuffer("referencia") + "'") )
		{
		var txt:String = "Este articulo se vende por tamao de tronco y solo se ha especificado " + cursor.valueBuffer("cantsize") + ".\nDesea continuar?";
		if (MessageBox.Yes != MessageBox.warning(txt, MessageBox.No, MessageBox.Yes))
			return false;
		}
return true;
}

function cantSize_analizaCadena(cadena:String,cantidad:Number):String
{
//debug("Analizando ...");

cadena = cadena.left(cadena.lastIndexOf(". Suma longitud tronco")) + ". Suma longitud tronco : " + cantidad + " cms.  ";


return cadena;
}
//// CANT_SIZE //////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition tarifaAlternativa */
/////////////////////////////////////////////////////////////////
//// TARIFA_ALTERNATIVA /////////////////////////////////////////
function tarifaAlternativa_obtenerTarifa(codCliente:String, cursor:FLSqlCursor):String
{
	var util:FLUtil = new FLUtil;
	var codTarifa:String;

	if(cursor.cursorRelation())
		codTarifa = cursor.cursorRelation().valueBuffer("codtarifa");

	if (!codTarifa)
		codTarifa = this.iface.__obtenerTarifa(codCliente, cursor);

	return codTarifa;

}
//// TARIFA_ALTERNATIVA /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition rapelClientes */
/////////////////////////////////////////////////////////////////
//// RAPEL_CLIENTES /////////////////////////////////////////////
function rapelClientes_commonCalculateField(fN:String, cursor:FLSqlCursor):String
{
	var util:FLUtil = new FLUtil();
	var datosTP:Array = this.iface.datosTablaPadre(cursor);
	if (!datosTP)
		return false;
	var wherePadre:String = datosTP.where;
	var tablaPadre:String = datosTP.tabla;

	var valor:String;
	switch (fN) {
		case "dtopor":{
			var codCliente:String = datosTP["codcliente"];
			var codEjercicio:String = flfactppal.iface.ejercicioActual();
			var suma:Number = util.sqlSelect("facturascli", "sum(totaleuros)", "codcliente = '" + codCliente + "' AND codejercicio = '" + codEjercicio + "'" );

			if(!suma)
				suma=0;

			if (isNaN(suma)) {
			MessageBox.critical(util.translate("scripts","Se ha producido un problema al obtener las ventas para el rpel"),
						MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);

			}
 			else
				{
			valor = this.iface.__commonCalculateField(fN, cursor);
				}
			valor = flfactppal.iface.pub_valorQuery("descuentosclientes,descuentos", "SUM(d.dto)", "descuentosclientes dc INNER JOIN descuentos d ON dc.coddescuento = d.coddescuento", "dc.codcliente = '" + codCliente + "' AND dc.minimo <= " + suma );
			break;
		}
		     default:{
			valor = this.iface.__commonCalculateField(fN, cursor);
		}
	}
	return valor;
}
//// RAPEL_CLIENTES /////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition ivaIncluido */
//////////////////////////////////////////////////////////////////
//// IVAINCLUIDO /////////////////////////////////////////////////////
function ivaIncluido_init()
{
	this.iface.__init();
	this.iface.habilitarPorIvaIncluido(form);
}

function ivaIncluido_habilitarPorIvaIncluido(miForm:Object)
{
	if (miForm.cursor().valueBuffer("ivaincluido")) {
		miForm.child("fdbPvpUnitarioIva").setDisabled(false);
		miForm.child("fdbPvpUnitario").setDisabled(true);
	} else {
		miForm.child("fdbPvpUnitarioIva").setDisabled(true);
		miForm.child("fdbPvpUnitario").setDisabled(false);
        miForm.child("fdbPvpTotalIvaInc").setValue("0");
	}
}

function ivaIncluido_commonBufferChanged(fN:String, miForm:Object)
{
	var util:FLUtil = new FLUtil();

	switch (fN) {
		case "referencia":
			this.iface.bloqueoPrecio = true;
			var ivaIncluido_:Boolean = this.iface.commonCalculateField("ivaincluido", miForm.cursor());
			miForm.child("fdbIvaIncluido").setValue(ivaIncluido_);
			miForm.child("fdbCodImpuesto").setValue(this.iface.commonCalculateField("codimpuesto", miForm.cursor()));

			if (ivaIncluido_) {
				miForm.child("fdbPvpUnitarioIva").setValue(this.iface.commonCalculateField("pvpunitarioiva", miForm.cursor()));
				miForm.cursor().setValueBuffer("pvpunitario", this.iface.commonCalculateField("pvpunitario2", miForm.cursor()));
			} else {
				miForm.cursor().setValueBuffer("pvpunitario", this.iface.commonCalculateField("pvpunitario", miForm.cursor()));
				miForm.child("fdbPvpUnitarioIva").setValue(this.iface.commonCalculateField("pvpunitarioiva2", miForm.cursor()));
			}
			this.iface.bloqueoPrecio = false;
			this.iface.habilitarPorIvaIncluido(miForm);
			break;
		case "codimpuesto":
			miForm.child("fdbIva").setValue(this.iface.commonCalculateField("iva", miForm.cursor()));
			miForm.child("fdbRecargo").setValue(this.iface.commonCalculateField("recargo", miForm.cursor()));
/*			if (!this.iface.bloqueoPrecio && miForm.cursor().valueBuffer("ivaincluido")) {
				this.iface.bloqueoPrecio = true;
				miForm.cursor().setValueBuffer("pvpunitario", this.iface.commonCalculateField("pvpunitario", miForm.cursor()));
				this.iface.bloqueoPrecio = false;
			}*/
			break;

		case "ivaincluido":
			this.iface.habilitarPorIvaIncluido(miForm);
		case "iva": {
			if (!this.iface.bloqueoPrecio) {
				this.iface.bloqueoPrecio = true;
				if (miForm.cursor().valueBuffer("ivaincluido")) {
					miForm.cursor().setValueBuffer("pvpunitario", this.iface.commonCalculateField("pvpunitario2", miForm.cursor()));
				} else {
					miForm.child("fdbPvpUnitarioIva").setValue(this.iface.commonCalculateField("pvpunitarioiva2", miForm.cursor()));
				}
				this.iface.bloqueoPrecio = false;
			}
			break;
		}
		case "recargo": {
			if (!this.iface.bloqueoPrecio) {
				this.iface.bloqueoPrecio = true;
				if (miForm.cursor().valueBuffer("ivaincluido")) {
					miForm.cursor().setValueBuffer("pvpunitario", this.iface.commonCalculateField("pvpunitario2", miForm.cursor()));
				} else {
					miForm.child("fdbPvpUnitarioIva").setValue(this.iface.commonCalculateField("pvpunitarioiva2", miForm.cursor()));
				}
				this.iface.bloqueoPrecio = false;
			}
			break;
		}
		case "pvpunitarioiva": {
			if (!this.iface.bloqueoPrecio) {
				this.iface.bloqueoPrecio = true;
				miForm.cursor().setValueBuffer("pvpunitario", this.iface.commonCalculateField("pvpunitario2", miForm.cursor()));
				this.iface.bloqueoPrecio = false;
			}
			break;
		}
		case "pvpunitario": {
			if (!this.iface.bloqueoPrecio) {
				this.iface.bloqueoPrecio = true;
				miForm.child("fdbPvpUnitarioIva").setValue(this.iface.commonCalculateField("pvpunitarioiva2", miForm.cursor()));
				this.iface.bloqueoPrecio = false;
			}
		}
		case "cantidad": {
			if (miForm.cursor().valueBuffer("ivaincluido")) {
				miForm.cursor().setValueBuffer("pvpsindto", this.iface.commonCalculateField("pvpsindto", miForm.cursor()));
			} else {
				return this.iface.__commonBufferChanged(fN, miForm);
			}
			break;
		}
		case "pvpsindto":
		case "dtopor": {
			miForm.child("lblDtoPor").setText(this.iface.commonCalculateField("lbldtopor", miForm.cursor()));
		}
		case "dtolineal": {
			if (miForm.cursor().valueBuffer("ivaincluido")) {
				miForm.cursor().setValueBuffer("pvptotal", this.iface.commonCalculateField("pvptotal", miForm.cursor()));
                miForm.cursor().setValueBuffer("pvptotalivainc", this.iface.commonCalculateField("pvptotalivainc", miForm.cursor()));
			} else {
				return this.iface.__commonBufferChanged(fN, miForm);
			}
			break;
		}
		default:
			return this.iface.__commonBufferChanged(fN, miForm);
	}
}

function ivaIncluido_commonCalculateField(fN, cursor):String
{
	var util:FLUtil = new FLUtil();
	var valor:String;
	var referencia:String = cursor.valueBuffer("referencia");

	switch (fN) {
		case "pvpunitarioiva":
			valor = this.iface.__commonCalculateField("pvpunitario", cursor);
			break;
		case "pvpunitarioiva2": {
			var iva:Number = parseFloat(cursor.valueBuffer("iva"));
			if (isNaN(iva)) {
				iva = 0;
			}
			/// Realmente el recargo no debe incluirse
			// var recargo:Number = parseFloat(cursor.valueBuffer("recargo"));
			// if (isNaN(recargo)) {
			// 	iva = recargo;
			// }
			// iva += parseFloat(recargo);
			valor = cursor.valueBuffer("pvpunitario") * ((100 + iva) / 100);
			break;
		}
		case "pvpunitario2": {
			var iva:Number = parseFloat(cursor.valueBuffer("iva"));
			if (isNaN(iva)) {
				iva = 0;
			}
			/// Realmente el recargo no debe incluirse
			// var recargo:Number = parseFloat(cursor.valueBuffer("recargo"));
			// if (isNaN(recargo)) {
			// 	iva = recargo;
			// }
			// iva += parseFloat(recargo);
			valor = parseFloat(cursor.valueBuffer("pvpunitarioiva")) / ((100 + iva) / 100);
			break;
		}
		case "pvpsindto":
			valor = parseFloat(cursor.valueBuffer("pvpunitario")) * parseFloat(cursor.valueBuffer("cantidad"));
			break;

		case "ivaincluido":
			valor = util.sqlSelect("articulos", "ivaincluido", "referencia = '" + referencia + "'");
			break;

		case "pvptotal":{
			var dtoPor:Number = (cursor.valueBuffer("pvpsindto") * cursor.valueBuffer("dtopor")) / 100;
			dtoPor = util.roundFieldValue(dtoPor, "lineaspedidoscli", "pvpsindto");
			valor = cursor.valueBuffer("pvpsindto") - parseFloat(dtoPor) - cursor.valueBuffer("dtolineal");
			break;
		}
        case "pvptotalivainc":{
            var iva:Number = parseFloat(cursor.valueBuffer("iva"));
            if (isNaN(iva)) {
                iva = 0;
            }
            var dtoPor:Number = (cursor.valueBuffer("pvpsindto") * cursor.valueBuffer("dtopor")) / 100;
            dtoPor = util.roundFieldValue(dtoPor, "lineaspedidoscli", "pvpsindto");
            pvpTotal = cursor.valueBuffer("pvpsindto") - parseFloat(dtoPor) - cursor.valueBuffer("dtolineal");
            valor = pvpTotal * ((100 + iva) / 100);
            break;
        }
		default:
			valor = this.iface.__commonCalculateField(fN, cursor);
	}
	return valor;
}
//// IVAINCLUIDO /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition stockUnificado */
/////////////////////////////////////////////////////////////////
//// STOCK_UNIFICADO ////////////////////////////////////////////
function stockUnificado_commonBufferChanged(fN:String, miForm:Object)
{
if (fN == "referencia" || fN == "fecha_reserva" || fN == "cantidad" || fN == "codalmacen")
	{
	if (fN == "referencia")
		{
		flfactalma.iface.revisar_entradas(miForm.cursor().valueBuffer("referencia"));
		}

	if (fN == "codalmacen" && (miForm.cursor().table() == "lineaspedidoscli" || miForm.cursor().table() == "lineaspresupuestoscli"))
		{

		var util:FLUtil = new FLUtil();
		var cod_finca = util.sqlSelect("almacenes","codfinca","codalmacen='" + miForm.cursor().valueBuffer("codalmacen") +"'");
		if (!cod_finca)
			{
			cod_finca = "";
			}
		miForm.cursor().setValueBuffer("codfinca", cod_finca);

		}

	this.iface.muestra_stock(miForm);
	}
return this.iface.__commonBufferChanged(fN, miForm);
}

function stockUnificado_muestra_stock(miForm:Object)
{
if (miForm.cursor().table() != "lineaspedidoscli")
	{
	return;
	}

this.iface.genera_tabla(miForm);
}

function stockUnificado_genera_tabla(miForm: Object)
{
var util:FLUtil = new FLUtil();
var referencia: String = miForm.cursor().valueBuffer("referencia");
var conn:String = flfactalma.iface.recogeConnUnificada();

var desc_servidor: String = util.sqlSelect("articulos","descripcion","referencia ='" + referencia +"'","articulos", conn);
this.child("le_articulo").setText(desc_servidor);


this.iface.table = miForm.child("fl_stock");
this.iface.table.clear();
this.iface.mi_fecha_marcada = false;
//debug("buscando referencia " + referencia);
this.child("label_albaranado").hide();
if (!util.sqlSelect("articulos","referencia","referencia ='" + referencia + "'"))
	{
	debug("Malamente!!");
	return;
	}
debug("REPINTANDO!");


this.iface.table.setNumCols(6);
this.iface.table.setColumnWidth(0, 250);

this.iface.table.setColumnWidth(1, 120);
this.iface.table.setColumnWidth(2, 120);
this.iface.table.setColumnWidth(3, 120);
this.iface.table.setColumnWidth(4, 120);
this.iface.table.setColumnWidth(5, 400);
this.iface.table.setColumnReadOnly(0, true);
this.iface.table.setColumnReadOnly(1, true);
this.iface.table.setColumnReadOnly(2, true);
this.iface.table.setColumnReadOnly(3, true);
this.iface.table.setColumnReadOnly(4, true);
this.iface.table.setColumnReadOnly(5, true);

this.iface.table.setColumnLabels("/", "Finca/Fecha/Stock/Reservado/Entrada/Observaciones");
this.iface.linea_actual = 0;
var conn:String = flfactalma.iface.recogeConnUnificada();

var qry_almacen:FLSqlQuery = new FLSqlQuery("",conn);
qry_almacen.setTablesList("almacenes");
qry_almacen.setSelect("codalmacen,nombre");
qry_almacen.setFrom("almacenes");
qry_almacen.setWhere("1=1");
qry_almacen.setOrderBy( "nombre asc" );
qry_almacen.setForwardOnly( true );
if (!qry_almacen.exec())
	return;

while(qry_almacen.next())
	{
	this.iface.rellena_linea_almacen(qry_almacen, referencia, miForm);
	}

}

function stockUnificado_rellena_linea_almacen(qry:FLSqlQuery, referencia: String, miForm:Object)
{
var util:FLUtil = new FLUtil();
var conn:String = flfactalma.iface.recogeConnUnificada();
//this.iface.table.insertRows(this.iface.linea_actual);
//this.iface.tblDocs.setText(this.iface.linea_actual, 0, qry.value(1));
//this.iface.linea_actual += 1;
//debug("Rellena linea almacen (" + referencia +") " + qry.value("nombre"));
var id_stock: Number = util.sqlSelect("stocks","idstock","codalmacen='" + qry.value("codalmacen") +"' AND referencia='" + referencia + "'","stocks",conn);
var cantidad_actual:Number = 0;
if (!id_stock)
	{
	cantidad_actual = 0;
	}
else
	{
	cantidad_actual  = util.sqlSelect("stocks","cantidad","idstock=" + id_stock,"stocks", conn); //Recojo la cantidad disponible del almacen y referencia.
	}
if (!cantidad_actual)
	{
	cantidad_actual = 0;
	}
//Meto almacen.
//debug("Insertando almacen " + qry.value("nombre") +" en linea " + this.iface.linea_actual);
var color_no_incl = new Color(255, 255, 255);
this.iface.table.insertRows(this.iface.linea_actual);
this.iface.table.setText(this.iface.linea_actual, 0, qry.value("nombre"));
this.iface.table.setText(this.iface.linea_actual, 2, cantidad_actual);
this.iface.table.setCellBackgroundColor(this.iface.linea_actual,0,color_no_incl);
this.iface.table.setCellBackgroundColor(this.iface.linea_actual,1,color_no_incl);
if (cantidad_actual > 0)
			{
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_no_incl);
			}
		else
			{
			var color_neg = new Color(255, 200, 200);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_neg);
			}
this.iface.table.setCellBackgroundColor(this.iface.linea_actual,3,color_no_incl);
this.iface.table.setCellBackgroundColor(this.iface.linea_actual,4,color_no_incl);
this.iface.linea_actual += 1;


if (!id_stock)
	{
	id_stock = 0;
	}



var qry_entradas: FLSqlQuery = new FLSqlQuery("",conn);
qry_entradas.setTablesList("vlc_produccion");
qry_entradas.setSelect("fecha_disponible,cantidad");
qry_entradas.setFrom("vlc_produccion");
qry_entradas.setWhere("pendiente = true AND idstock =" + id_stock);
qry_entradas.setOrderBy( "fecha_disponible asc" );

if (!qry_entradas.exec())
	{
	debug("No hay entradas para " + qry.value("codalmacen") );
	return;
	}

var ultima_fecha: Date = new Date();
var cantidad_con_pedidos_previos:Number = 0;

if (id_stock > 0)
	{
	while(qry_entradas.next())
		{

		cantidad_actual = this.iface.rellena_lineas_pedidos_hasta(qry_entradas, referencia, qry.value("codalmacen"), cantidad_actual, ultima_fecha, miForm); //Rellenamos lineas reservas hasta fecha entrada
		cantidad_actual = this.iface.comprobar_mi_reserva(qry.value("codalmacen"), qry_entradas.value("fecha_disponible"), miForm);
		cantidad_con_pedidos_previos = cantidad_actual + qry_entradas.value("cantidad");
		ultima_fecha = qry_entradas.value("fecha_disponible");
		this.iface.table.insertRows(this.iface.linea_actual);

		//debug("Insertando entrada ...");

		this.iface.table.setText(this.iface.linea_actual, 1, ultima_fecha.toString().left(10));
		this.iface.table.setText(this.iface.linea_actual, 2, cantidad_con_pedidos_previos); //Sumatorio
		this.iface.table.setText(this.iface.linea_actual, 4, qry_entradas.value("cantidad"));
		this.iface.table.setText(this.iface.linea_actual, 5, qry_entradas.value("id"));
		this.iface.table.setCellBackgroundColor(this.iface.linea_actual,0,color_no_incl);
		this.iface.table.setCellBackgroundColor(this.iface.linea_actual,1,color_no_incl);
		if (cantidad_con_pedidos_previos > 0)
			{
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_no_incl);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,4,color_no_incl);
			}
		else
			{
			var color_neg = new Color(255, 200, 200);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_neg);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,4,color_neg);
			}
		this.iface.table.setCellBackgroundColor(this.iface.linea_actual,3,color_no_incl);
		this.iface.linea_actual += 1;
		}
	}
//debug("mirando hasta hoy " + ultima_fecha);
this.iface.rellena_lineas_pedidos_hasta_hoy(ultima_fecha, referencia, qry.value("codalmacen"), cantidad_actual, miForm) //Rellenamos lineas reservas hasta final.
this.iface.comprobar_mi_reserva(qry.value("codalmacen"), "", miForm);
//debug("Terminando almacen " + qry.value("nombre") +" en linea " + this.iface.linea_actual);
}


function stockUnificado_rellena_lineas_pedidos_hasta_hoy(fecha: String, referencia: String, cod_almacen: String, cantidad_actual: Number, miForm: Object)
{
//debug("Comprobando hasta hoy " + fecha + " para referencia " + referencia +" y almacen "+ cod_almacen);
var nueva_cantidad: Number = cantidad_actual;
var util:FLUtil = new FLUtil();
var conn:String = flfactalma.iface.recogeConnUnificada();
var fecha_previa: String = "";
var color_no_incl = new Color(255, 255, 255);
if (fecha != "")
	{
	var qry_pedidos: FLSqlQuery = new FLSqlQuery("",conn);
	qry_pedidos.setTablesList("vlc_reservas");
	qry_pedidos.setSelect("id,fecha,cantidad,idlinea,database,pedido,cod_almacen");
	qry_pedidos.setFrom("vlc_reservas");
	qry_pedidos.setWhere("fecha >= '" + fecha +"' AND NOT (idlinea =" + miForm.cursor().valueBuffer("idlinea") +" AND database = '" + aqApp.db().database() +"') AND referencia='" + referencia + "' AND cod_almacen ='" + cod_almacen +"'");
	qry_pedidos.setOrderBy( "fecha asc" );
	//debug("Consulta hasta hoy " + qry_pedidos.sql());
	if (!qry_pedidos.exec())
		return;

	while(qry_pedidos.next())
		{
		this.iface.table.insertRows(this.iface.linea_actual);
		nueva_cantidad = this.iface.comprobar_mi_reserva(cod_almacen, qry_pedidos.value("fecha"), miForm);
		var cantidad: Number = qry_pedidos.value("cantidad") * -1;
		nueva_cantidad += cantidad;

		this.iface.table.setText(this.iface.linea_actual, 1, qry_pedidos.value("fecha").toString().left(10));
		this.iface.table.setText(this.iface.linea_actual, 2, nueva_cantidad); //Sumatorio
		this.iface.table.setText(this.iface.linea_actual, 3, cantidad);
		this.iface.table.setText(this.iface.linea_actual, 5, "( " + qry_pedidos.value("database") + ") Pedido " + qry_pedidos.value("pedido"));
		this.iface.table.setCellBackgroundColor(this.iface.linea_actual,0,color_no_incl);
		this.iface.table.setCellBackgroundColor(this.iface.linea_actual,1,color_no_incl);
		if (nueva_cantidad > 0)
			{
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_no_incl);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,3,color_no_incl);
			}
		else
			{
			var color_neg = new Color(255, 200, 200);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_neg);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,3,color_neg);
			}
		this.iface.table.setCellBackgroundColor(this.iface.linea_actual,4,color_no_incl);
		this.iface.linea_actual += 1;
		fecha_previa = qry_pedidos.value("fecha").toString();
		//debug("hasta_hoy ++ " + nueva_cantidad);
		}
	}
//debug("Comprobando mi reserva en futuro " + cod_almacen + " > " + fecha_previa);
this.iface.comprobar_mi_reserva(cod_almacen, fecha_previa, miForm);

}



function stockUnificado_rellena_lineas_pedidos_hasta(qry_entradas: FLSqlQuery, referencia: String, cod_almacen: String, cantidad_actual: Number, fecha_minima: String, miForm: Object): Number
{
var nueva_cantidad: Number = cantidad_actual;
var util:FLUtil = new FLUtil();
var conn:String = flfactalma.iface.recogeConnUnificada();
var fecha_previa: String = "";
var color_no_incl = new Color(255, 255, 255);
var qry_pedidos: FLSqlQuery = new FLSqlQuery("",conn);
qry_pedidos.setTablesList("vlc_reservas");
qry_pedidos.setSelect("id,fecha,cantidad,database,pedido,referencia,cod_almacen");
qry_pedidos.setFrom("vlc_reservas");
if (fecha_minima == "")
	{
	qry_pedidos.setWhere("fecha <= '" + qry_entradas.value("fecha_disponible") +"' AND NOT (idlinea =" + miForm.cursor().valueBuffer("idlinea") +" AND database = '" + aqApp.db().database() +"') AND referencia='" + referencia + "' AND cod_almacen ='" + cod_almacen +"'");
	}
else
	{
	qry_pedidos.setWhere("fecha > '" + fecha_minima + "' AND fecha <= '" + qry_entradas.value("fecha_disponible") +"' AND NOT (idlinea =" + miForm.cursor().valueBuffer("idlinea") +" AND database = '" + aqApp.db().database() +"') AND referencia='" + referencia + "' AND cod_almacen ='" + cod_almacen +"'");
	}
qry_pedidos.setOrderBy( "fecha asc" );
if (!qry_pedidos.exec())
	return nueva_cantidad;

while(qry_pedidos.next())
	{

	//nueva_cantidad = this.iface.comprobar_mi_reserva(nueva_cantidad, cod_almacen, fecha_previa, qry_pedidos.value("fecha"));
	nueva_cantidad = this.iface.comprobar_mi_reserva(cod_almacen, qry_pedidos.value("fecha"), miForm);
	this.iface.table.insertRows(this.iface.linea_actual);
	var cantidad: Number = qry_pedidos.value("cantidad") * -1;
	nueva_cantidad += cantidad;

	this.iface.table.setText(this.iface.linea_actual, 1, qry_pedidos.value("fecha").toString().left(10));
	this.iface.table.setText(this.iface.linea_actual, 2, nueva_cantidad); //Sumatorio
	this.iface.table.setText(this.iface.linea_actual, 3, cantidad);
	this.iface.table.setText(this.iface.linea_actual, 5, "( " + qry_pedidos.value("database") + ") Pedido " + qry_pedidos.value("pedido"));
	this.iface.table.setCellBackgroundColor(this.iface.linea_actual,0,color_no_incl);
	this.iface.table.setCellBackgroundColor(this.iface.linea_actual,1,color_no_incl);
	if (nueva_cantidad > 0)
			{
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_no_incl);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,3,color_no_incl);
			}
		else
			{
			var color_neg = new Color(255, 200, 200);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_neg);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,3,color_neg);
			}
	this.iface.table.setCellBackgroundColor(this.iface.linea_actual,4,color_no_incl);
	this.iface.linea_actual += 1;
	fecha_previa = qry_pedidos.value("fecha").toString();
	}

if (fecha_previa != "")
	{
	//debug(1);
	nueva_cantidad = this.iface.comprobar_mi_reserva(cod_almacen, fecha_previa, miForm);
	}
//else
//	{
	//Asegura que aparezca mi reserva.
//	if (this.cursor().valueBuffer("fecha_reserva") <= qry_entradas.value("fecha_disponible"))
//		{
//		debug("Forzando mi reserva desde hoy");
//		this.iface.comprobar_mi_reserva(nueva_cantidad, cod_almacen, qry_entradas.value("fecha_disponible"), this.cursor().valueBuffer("fecha_reserva"));
//		}
//	}
return nueva_cantidad;
}


function stockUnificado_init()
{
	this.iface.__init();
	flfactalma.iface.revisar_entradas(form.cursor().valueBuffer("referencia"));
	this.iface.muestra_stock(form);
	//this.iface.habilitarPorIvaIncluido(form);
}
//Rellenar grid

//Conectar boton reserva

//setear almacen con mas stock.

function stockUnificado_validateForm():Boolean
{
var ret:Boolean = this.iface.__validateForm();
if (!ret)
	{
	return false;
	}
var conn:String = flfactalma.iface.recogeConnUnificada();
 //Compruebo si la reserva esta en reservas.
var cursor:FLSqlCursor = this.cursor();

if (cursor.valueBuffer("fecha_reserva") == "0000-00-00")
	{
	cursor.setNull("fecha_reserva");
	}

var util:FLUtil = new FLUtil();
if (!cursor.isNull("fecha_reserva"))
	{
	//debug("Hay reserva");
	var cur_reservas:FLSqlCursor = new FLSqlCursor("vlc_reservas", conn);
	cur_reservas.select("idlinea = " + cursor.valueBuffer("idlinea") + " and database = '" + aqApp.db().database() +"'");
	if (cur_reservas.first())
		{
		//debug("Edit!");
		cur_reservas.setModeAccess(cur_reservas.Edit);
		}
	else
		{
		//debug("Insert!");
		cur_reservas.setModeAccess(cur_reservas.Insert);
		}
	cur_reservas.refreshBuffer();
	cur_reservas.setValueBuffer("fecha", cursor.valueBuffer("fecha_reserva"));
	cur_reservas.setValueBuffer("idlinea", cursor.valueBuffer("idlinea"));
	cur_reservas.setValueBuffer("cantidad", cursor.valueBuffer("cantidad"));
	cur_reservas.setValueBuffer("database", aqApp.db().database());
	cur_reservas.setValueBuffer("pedido", cursor.cursorRelation().valueBuffer("codigo"));
	debug("-->" + cursor.valueBuffer("referencia") + " , " + cursor.valueBuffer("codalmacen"));
	cur_reservas.setValueBuffer("referencia", cursor.valueBuffer("referencia"));
	cur_reservas.setValueBuffer("cod_almacen", cursor.valueBuffer("codalmacen"));
	if (!cur_reservas.commitBuffer())
		{
		MessageBox.critical(util.translate("scripts","Problema al actualizar la reserva."),
						MessageBox.Ok, MessageBox.NoButton,MessageBox.NoButton);
		return false;
		}
	return ret;
	}
else
	{
	//Eliminar reserva previa si hay en buffer.
	if (!cursor.isCopyNull("fecha_reserva"))
		{
		//debug("Eliminado reserva obsoleta.");
		util.sqlDelete("vlc_reservas","idlinea = " + cursor.valueBuffer("idlinea") + " and database = '" + aqApp.db().database() +"'", conn);
		}
	}
return ret;
}

function stockUnificado_comprobar_mi_reserva(cod_almacen: String, fecha_previa: String, miForm: Object)
{
//debug(" ** Comprobando mi reserva almacen " + cod_almacen + " fecha " + fecha_previa +" --> " + this.iface.linea_actual +"*"+ this.iface.table.text(this.iface.linea_actual -1, 2));
var cantidad_previa: Number = parseInt(this.iface.table.text(this.iface.linea_actual -1, 2));
var fecha_reserva: Date = new Date();

if (miForm.cursor().valueBuffer("totalenalbaran") == miForm.cursor().valueBuffer("cantidad") && miForm.cursor().valueBuffer("cantidad") != 0)
	{
	debug("Ya estoy albaranada.Cancelado");
	this.child("label_albaranado").show();
	return cantidad_previa;
	}



if (!miForm.cursor().isNull("fecha_reserva"))
	{
	fecha_reserva = miForm.cursor().valueBuffer("fecha_reserva");
	 }

//debug("Compruebo con " + fecha_reserva + " < " + fecha_previa);
if (this.iface.mi_fecha_marcada)
	{
	debug("Ya estoy marcada.Cancelado");
	return cantidad_previa;
	}

if (miForm.cursor().valueBuffer("codalmacen") != cod_almacen)
		{
		debug("No es el mismo almacen.Cancelado");
		return cantidad_previa;
		}




if ( fecha_reserva <= fecha_previa || fecha_previa == "")
	{
	//Continuamos.
	}
else
	{
	debug("Fecha reserva es menor que fecha previa (" + fecha_reserva + "<" + fecha_previa + " .Cancelado");
	return cantidad_previa;
	}

//debug("Comprobando mi reserva!!");
var util:FLUtil = new FLUtil();
var cursor: FLSqlCursor = miForm.cursor();
var nueva_cantidad: Number = cantidad_previa;

//print("Previa!! " + cantidad_previa);
//if (!cursor.isNull("fecha_reserva"))
//	{
	//if (cursor.valueBuffer("fecha_reserva") <= fecha_limite && cursor.valueBuffer("fecha_reserva") > fecha_previa)
	//	{
		debug("Meto mi linea!!");
		//var color_no_incl = new Color(255, 255, 255);
		var color_incl = new Color(200, 255, 200);
		var color_pendiente = new Color(200, 200, 255);
		if (miForm.cursor().isNull("fecha_reserva"))
			{
			color_incl = color_pendiente;
			}
		this.iface.table.insertRows(this.iface.linea_actual);
		nueva_cantidad = cantidad_previa - (cursor.valueBuffer("cantidad") - miForm.cursor().valueBuffer("totalenalbaran")) ;
		this.iface.table.setText(this.iface.linea_actual, 0, "---->" );
		this.iface.table.setText(this.iface.linea_actual, 1, fecha_reserva.toString().left(10) );
		this.iface.table.setText(this.iface.linea_actual, 2, nueva_cantidad); //Sumatorio
		this.iface.table.setText(this.iface.linea_actual, 3,( cursor.valueBuffer("cantidad")  - miForm.cursor().valueBuffer("totalenalbaran") )* -1);
		if (miForm.cursor().valueBuffer("totalenalbaran")  > 0 && (miForm.cursor().valueBuffer("totalenalbaran") != cursor.valueBuffer("cantidad")))
			{
			this.iface.table.setText(this.iface.linea_actual, 5, "ALBARANADO PREVIAMENTE : "+ miForm.cursor().valueBuffer("totalenalbaran"));
			if (nueva_cantidad > 0)
				{
				this.iface.table.setCellBackgroundColor(this.iface.linea_actual,4,color_incl);
				this.iface.table.setCellBackgroundColor(this.iface.linea_actual,5,color_incl);
				}
			}
		else
			{
			this.iface.table.setText(this.iface.linea_actual, 5, "");
			}
		this.iface.table.setCellBackgroundColor(this.iface.linea_actual,0,color_incl);
		this.iface.table.setCellBackgroundColor(this.iface.linea_actual,1,color_incl);
		if (nueva_cantidad > 0)
			{
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_incl);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,3,color_incl);
			}
		else
			{
			var color_neg = new Color(255, 200, 200);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_neg);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,3,color_neg);
			}
		this.iface.table.setCellBackgroundColor(this.iface.linea_actual,4,color_incl);
		this.iface.linea_actual += 1;
		this.iface.mi_fecha_marcada = true;
	//	}
	//}

return nueva_cantidad;
}

//// STOCK_UNIFICADO ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition lasCunas */
/////////////////////////////////////////////////////////////////
//// LAS CUNAS  /////////////////////////////////////////////////
function lasCunas_commonBufferChanged(fN, miForm)
{
var result = this.iface.__commonBufferChanged(fN, miForm);
if (miForm.cursor().table() == "lineasfacturascli" || miForm.cursor().table() == "lineasalbaranescli" || miForm.cursor().table() == "lineaspedidoscli" || miForm.cursor().table() == "lineaspresupuestoscli") {
	if (fN == "referencia" || fN == "codalmacen" || fN == "cantidad") {
		if ( miForm.cursor().valueBuffer("referencia") && miForm.cursor().valueBuffer("codalmacen") && miForm.cursor().valueBuffer("cantidad"))
			{
			flfacturac.iface.trazabilidad_compose(miForm.cursor());
			}
	}
}

return result;
}

function lasCunas_muestra_stock(miForm:Object)
{
debug("PRE MUESTRA SOTCK!");
if (miForm.cursor().table() != "lineaspedidoscli" && miForm.cursor().table() != "lineaspresupuestoscli")
	{
	return;
	}
debug("Muestra stock!!!!");
this.iface.genera_tabla(miForm);
}

function lasCunas_genera_tabla(miForm: Object)
{
debug("generando tabla!");
var util:FLUtil = new FLUtil();
var referencia: String = miForm.cursor().valueBuffer("referencia");
var conn:String = flfactalma.iface.recogeConnUnificada();

if (miForm.cursor().table() == "lineaspedidoscli") {
	var desc_servidor: String = util.sqlSelect("articulos","descripcion","referencia ='" + referencia +"'","articulos", conn);
	this.child("le_articulo").setText(desc_servidor);
	this.child("label_albaranado").hide();
}
this.iface.table = miForm.child("fl_stock");
this.iface.table.clear();
this.iface.mi_fecha_marcada = false;
debug("buscando referencia " + referencia);

if (!util.sqlSelect("articulos","referencia","referencia ='" + referencia + "'"))
	{
	debug("Malamente!!");
	return;
	}
debug("REPINTANDO!");


this.iface.table.setNumCols(6);
this.iface.table.setColumnWidth(0, 250);

this.iface.table.setColumnWidth(1, 120);
this.iface.table.setColumnWidth(2, 120);
this.iface.table.setColumnWidth(3, 120);
this.iface.table.setColumnWidth(4, 120);
this.iface.table.setColumnWidth(5, 400);
this.iface.table.setColumnReadOnly(0, true);
this.iface.table.setColumnReadOnly(1, true);
this.iface.table.setColumnReadOnly(2, true);
this.iface.table.setColumnReadOnly(3, true);
this.iface.table.setColumnReadOnly(4, true);
this.iface.table.setColumnReadOnly(5, true);

this.iface.table.setColumnLabels("/", "Finca/Fecha/Stock/Reservado/Entrada/Observaciones");
this.iface.linea_actual = 0;
var conn:String = flfactalma.iface.recogeConnUnificada();

var qry_almacen:FLSqlQuery = new FLSqlQuery("",conn);
qry_almacen.setTablesList("almacenes");
qry_almacen.setSelect("codalmacen,nombre");
qry_almacen.setFrom("almacenes");
qry_almacen.setWhere("1=1");
qry_almacen.setOrderBy( "nombre asc" );
qry_almacen.setForwardOnly( true );
if (!qry_almacen.exec())
	return;

while(qry_almacen.next())
	{
	this.iface.rellena_linea_almacen(qry_almacen, referencia, miForm);
	}

}

function lasCunas_comprobar_mi_reserva(cod_almacen: String, fecha_previa: String, miForm:Object)
{
debug(" ** Comprobando mi reserva almacen " + cod_almacen + " fecha " + fecha_previa +" --> " + this.iface.linea_actual +"*"+ this.iface.table.text(this.iface.linea_actual -1, 2));
var cantidad_previa: Number = parseInt(this.iface.table.text(this.iface.linea_actual -1, 2));

if (miForm.cursor().table() != "lineaspedidoscli") {
	debug("Saltando!!");
	return cantidad_previa;
}

return this.iface.__comprobar_mi_reserva(cod_almacen, fecha_previa, miForm);

}

function lasCunas_rellena_lineas_pedidos_hasta(qry_entradas: FLSqlQuery, referencia: String, cod_almacen: String, cantidad_actual: Number, fecha_minima: String, miForm: Object): Number
{
var nueva_cantidad: Number = cantidad_actual;
var util:FLUtil = new FLUtil();
var conn:String = flfactalma.iface.recogeConnUnificada();
var fecha_previa: String = "";
var color_no_incl = new Color(255, 255, 255);
var qry_pedidos: FLSqlQuery = new FLSqlQuery("",conn);
qry_pedidos.setTablesList("vlc_reservas");
qry_pedidos.setSelect("id,fecha,cantidad,database,pedido,referencia,cod_almacen");
qry_pedidos.setFrom("vlc_reservas");
debug("lasCunas_rellena_lineas_pedisdos_hasta__" + miForm.cursor().table());


if (fecha_minima == "")
	{
	if (miForm.cursor().table() == "lineaspedidoscli") {
		qry_pedidos.setWhere("fecha <= '" + qry_entradas.value("fecha_disponible") +"' AND NOT (idlinea =" + miForm.cursor().valueBuffer("idlinea") +" AND database = '" + aqApp.db().database() +"') AND referencia='" + referencia + "' AND cod_almacen ='" + cod_almacen +"'");

	} else {
		//debug("alternativo");
		qry_pedidos.setWhere("fecha <= '" + qry_entradas.value("fecha_disponible")  +"' AND referencia='" + referencia + "' AND cod_almacen ='" + cod_almacen +"'");
	}

	}
else
	{
	if (miForm.cursor().table() == "lineaspedidoscli") {
		qry_pedidos.setWhere("fecha > '" + fecha_minima + "' AND fecha <= '" + qry_entradas.value("fecha_disponible") +"' AND NOT (idlinea =" + miForm.cursor().valueBuffer("idlinea") +" AND database = '" + aqApp.db().database() +"') AND referencia='" + referencia + "' AND cod_almacen ='" + cod_almacen +"'");
	} else {
		//debug("alternativo");
		qry_pedidos.setWhere("fecha > '" + fecha_minima + "' AND fecha <= '" + qry_entradas.value("fecha_disponible") +"' AND referencia='" + referencia + "' AND cod_almacen ='" + cod_almacen +"'");
	}

	}
qry_pedidos.setOrderBy( "fecha asc" );
if (!qry_pedidos.exec())
	return nueva_cantidad;

while(qry_pedidos.next())
	{

	//nueva_cantidad = this.iface.comprobar_mi_reserva(nueva_cantidad, cod_almacen, fecha_previa, qry_pedidos.value("fecha"));
	nueva_cantidad = this.iface.comprobar_mi_reserva(cod_almacen, qry_pedidos.value("fecha"), miForm);
	this.iface.table.insertRows(this.iface.linea_actual);
	var cantidad: Number = qry_pedidos.value("cantidad") * -1;
	nueva_cantidad += cantidad;

	this.iface.table.setText(this.iface.linea_actual, 1, qry_pedidos.value("fecha").toString().left(10));
	this.iface.table.setText(this.iface.linea_actual, 2, nueva_cantidad); //Sumatorio
	this.iface.table.setText(this.iface.linea_actual, 3, cantidad);
	this.iface.table.setText(this.iface.linea_actual, 5, "( " + qry_pedidos.value("database") + ") Pedido " + qry_pedidos.value("pedido"));
	this.iface.table.setCellBackgroundColor(this.iface.linea_actual,0,color_no_incl);
	this.iface.table.setCellBackgroundColor(this.iface.linea_actual,1,color_no_incl);
	if (nueva_cantidad > 0)
			{
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_no_incl);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,3,color_no_incl);
			}
		else
			{
			var color_neg = new Color(255, 200, 200);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_neg);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,3,color_neg);
			}
	this.iface.table.setCellBackgroundColor(this.iface.linea_actual,4,color_no_incl);
	this.iface.linea_actual += 1;
	fecha_previa = qry_pedidos.value("fecha").toString();
	}

if (fecha_previa != "")
	{
	//debug(1);
	nueva_cantidad = this.iface.comprobar_mi_reserva(cod_almacen, fecha_previa, miForm);
	}
//else
//	{
	//Asegura que aparezca mi reserva.
//	if (this.cursor().valueBuffer("fecha_reserva") <= qry_entradas.value("fecha_disponible"))
//		{
//		debug("Forzando mi reserva desde hoy");
//		this.iface.comprobar_mi_reserva(nueva_cantidad, cod_almacen, qry_entradas.value("fecha_disponible"), this.cursor().valueBuffer("fecha_reserva"));
//		}
//	}
return nueva_cantidad;
}

function lasCunas_rellena_lineas_pedidos_hasta_hoy(fecha: String, referencia: String, cod_almacen: String, cantidad_actual: Number, miForm:Object)
{
debug("Comprobando hasta hoy " + fecha + " para referencia " + referencia +" y almacen "+ cod_almacen);
var nueva_cantidad: Number = cantidad_actual;
var util:FLUtil = new FLUtil();
var conn:String = flfactalma.iface.recogeConnUnificada();
var fecha_previa: String = "";
var color_no_incl = new Color(255, 255, 255);
if (fecha != "")
	{
	var qry_pedidos: FLSqlQuery = new FLSqlQuery("",conn);
	qry_pedidos.setTablesList("vlc_reservas");
	qry_pedidos.setSelect("id,fecha,cantidad,idlinea,database,pedido,cod_almacen");
	qry_pedidos.setFrom("vlc_reservas");
	if (miForm.cursor().table() == "lineaspedidoscli") {
		qry_pedidos.setWhere("fecha >= '" + fecha +"' AND NOT (idlinea =" + miForm.cursor().valueBuffer("idlinea") +" AND database = '" + aqApp.db().database() +"') AND referencia='" + referencia + "' AND cod_almacen ='" + cod_almacen +"'");
	} else {
		//debug("alternativo");
		qry_pedidos.setWhere("fecha >= '" + fecha +"' AND referencia='" + referencia + "' AND cod_almacen ='" + cod_almacen +"'");
	}
	qry_pedidos.setOrderBy( "fecha asc" );
	//debug("Consulta hasta hoy " + qry_pedidos.sql());
	if (!qry_pedidos.exec())
		return;

	while(qry_pedidos.next())
		{
		this.iface.table.insertRows(this.iface.linea_actual);
		nueva_cantidad = this.iface.comprobar_mi_reserva(cod_almacen, qry_pedidos.value("fecha"), miForm);
		var cantidad: Number = qry_pedidos.value("cantidad") * -1;
		nueva_cantidad += cantidad;

		this.iface.table.setText(this.iface.linea_actual, 1, qry_pedidos.value("fecha").toString().left(10));
		this.iface.table.setText(this.iface.linea_actual, 2, nueva_cantidad); //Sumatorio
		this.iface.table.setText(this.iface.linea_actual, 3, cantidad);
		this.iface.table.setText(this.iface.linea_actual, 5, "( " + qry_pedidos.value("database") + ") Pedido " + qry_pedidos.value("pedido"));
		this.iface.table.setCellBackgroundColor(this.iface.linea_actual,0,color_no_incl);
		this.iface.table.setCellBackgroundColor(this.iface.linea_actual,1,color_no_incl);
		if (nueva_cantidad > 0)
			{
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_no_incl);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,3,color_no_incl);
			}
		else
			{
			var color_neg = new Color(255, 200, 200);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,2,color_neg);
			this.iface.table.setCellBackgroundColor(this.iface.linea_actual,3,color_neg);
			}
		this.iface.table.setCellBackgroundColor(this.iface.linea_actual,4,color_no_incl);
		this.iface.linea_actual += 1;
		fecha_previa = qry_pedidos.value("fecha").toString();
		//debug("hasta_hoy ++ " + nueva_cantidad);
		}
	}
//debug("Comprobando mi reserva en futuro " + cod_almacen + " > " + fecha_previa);
this.iface.comprobar_mi_reserva(cod_almacen, fecha_previa, miForm);

}

//// LAS CUNAS  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

