/***************************************************************************
                 lineaspresupuestoscli.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
	function calculateField(fN:String):String { return this.ctx.interna_calculateField(fN); }
	function validateForm():Boolean { return this.ctx.interna_validateForm(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); }
	function desconectar() {
		return this.ctx.oficial_desconectar();
	}
	function bufferChanged(fN:String) {
		return this.ctx.oficial_bufferChanged(fN);
	}
	function dameFiltroReferencia():String {
		return this.ctx.oficial_dameFiltroReferencia();
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration irpfExcluidosIva */
//////////////////////////////////////////////////////////////////
//// IRPF_EXCLUIDOS_IVA //////////////////////////////////////////
class irpfExcluidosIva extends oficial /** %from: oficial */ {
    function irpfExcluidosIva( context ) { oficial( context ); }
    function init() {
		this.ctx.irpfExcluidosIva_init();
	}
}

//// IRPF_EXCLUIDOS_IVA //////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration cantSize */
/////////////////////////////////////////////////////////////////
//// CANT_SIZE //////////////////////////////////////////////////
class cantSize extends irpfExcluidosIva /** %from: oficial */ {
    var boolSize:Boolean;
    function cantSize( context ) { irpfExcluidosIva ( context ); }
    function init() {
    	this.ctx.cantSize_init();
}
    function validateForm():Boolean {
    	return this.ctx.cantSize_validateForm();
}

    function analizaCadena(cadena:String,cantidad:Number):String {
    	return formRecordlineaspedidoscli.iface.analizaCadena(cadena,cantidad);
}
}
//// CANT_SIZE //////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ivaIncluido */
/////////////////////////////////////////////////////////////////
//// IVA_INCLUIDO ///////////////////////////////////////////////
class ivaIncluido extends cantSize /** %from: oficial */ {
    function ivaIncluido( context ) { cantSize ( context ); }
	function init() {
		return this.ctx.ivaIncluido_init();
	}
}
//// IVA_INCLUIDO ///////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration lasCunas */
/////////////////////////////////////////////////////////////////
//// LAS CUNAS  /////////////////////////////////////////////////
class lasCunas extends ivaIncluido /** %from: ivaIncluido */  {
    function lasCunas( context ) { ivaIncluido ( context ); }
    function init() {
	return this.ctx.lasCunas_init();
	}
}
//// LAS CUNAS  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends lasCunas {
    function head( context ) { lasCunas ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C
Este formulario realiza la gestin de las lneas de presupuestos a clientes.
\end */
function interna_init()
{
	var util:FLUtil = new FLUtil();
	var cursor:FLSqlCursor = this.cursor();
	connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
	connect(form, "closed()", this, "iface.desconectar");

	var irpf:Number = util.sqlSelect("series", "irpf", "codserie = '" + cursor.cursorRelation().valueBuffer("codserie") + "'");
	if (!irpf) {
		irpf = 0;
	}

	if (cursor.modeAccess() == cursor.Insert) {
		var opcionIvaRec:Number = flfacturac.iface.pub_tieneIvaDocCliente(cursor.cursorRelation().valueBuffer("codserie"), cursor.cursorRelation().valueBuffer("codcliente"), "");
		switch (opcionIvaRec) {
			case 0: {
				this.child("fdbCodImpuesto").setValue("");
				this.child("fdbIva").setValue(0);
				this.child("fdbRecargo").setValue(0);
				break;
			}
			case 1: {
				this.child("fdbRecargo").setValue(0);
//Rellenamos el codimpuesto del almacen por defecto
				var impuestoAlmacen:String = util.sqlSelect("factalma_general", "codimpuesto", "1 = 1");
				if (impuestoAlmacen)
					this.child("fdbCodImpuesto").setValue(impuestoAlmacen);
//Fin
				break;
			}
		}
		this.child("fdbIRPF").setValue(irpf);
		this.child("fdbDtoPor").setValue(this.iface.calculateField("dtopor"));
		if (cursor.cursorRelation().valueBuffer("porcomision")) {
			this.child("fdbPorComision").setDisabled(true);
		} else {
			if (!cursor.cursorRelation().valueBuffer("codagente") || cursor.cursorRelation().valueBuffer("codagente") == "") {
				this.child("fdbPorComision").setDisabled(true);
			} else {
				this.child("fdbPorComision").setValue(this.iface.calculateField("porcomision"));
			}
		}
	}

	if (cursor.cursorRelation().valueBuffer("porcomision")) {
		this.child("fdbPorComision").setDisabled(true);
	}

	this.child("lblComision").setText(this.iface.calculateField("lblComision"));
	this.child("lblDtoPor").setText(this.iface.calculateField("lbldtopor"));

	var filtroReferencia:String = this.iface.dameFiltroReferencia();
	this.child("fdbReferencia").setFilter(filtroReferencia);
}

/** \C
Los campos calculados de este formulario son los mismos que los del formulario de lneas de pedido a cliente
\end */
function interna_calculateField(fN:String):String
{
		return formRecordlineaspedidoscli.iface.pub_commonCalculateField(fN, this.cursor());
}

/** \D Funcin a sobrecargar
\end */
function interna_validateForm():Boolean
{
	return true;
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
function oficial_desconectar()
{
		disconnect(this.cursor(), "bufferChanged(QString)", this, "iface.bufferChanged");
}

/** \C
Las dependencias entre controles de este formulario son las mismas que las del formulario de lneas de pedido a cliente
\end */
function oficial_bufferChanged(fN:String)
{
		formRecordlineaspedidoscli.iface.pub_commonBufferChanged(fN, form);
}

function oficial_dameFiltroReferencia():String
{
	return "sevende";
}
//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition irpfExcluidosIva */
/////////////////////////////////////////////////////////////////
//// IRPF_EXCLUIDOS_IVA /////////////////////////////////////////

function irpfExcluidosIva_init()
{
	this.iface.__init();
	var util:FLUtil = new FLUtil();
	var cursor:FLSqlCursor = this.cursor();
	var irpf:Number = 0;
        if (util.sqlSelect("clientes", "regimeniva", "codcliente = '" + cursor.cursorRelation().valueBuffer("codcliente") + "'") == "Exento")
        	{

       	if (cursor.modeAccess() == cursor.Insert)
       			{
			this.child("fdbIRPF").setValue(irpf);
			}
		}
}

//// IRPF_EXCLUIDOS_IVA /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition cantSize */
/////////////////////////////////////////////////////////////////
//// CANT_SIZE //////////////////////////////////////////////////
function cantSize_init()
{
this.iface.__init();

var util:FLUtil = new FLUtil();
var cursor:FLSqlCursor = this.cursor();
this.iface.boolSize = false;
if (cursor.modeAccess() == cursor.Insert || cursor.modeAccess() == cursor.Browse )
	{
	this.child("fdbCantidadSize").setDisabled(true);
	}
	else
	{
	var referencia:String = cursor.valueBuffer("referencia");
	this.iface.boolSize = util.sqlSelect("articulos", "usasize", "referencia = '" + referencia + "'");

	if (!this.iface.boolSize)
		this.child("fdbCantidadSize").setDisabled(true);
	else
		this.child("fdbCantidadSize").setDisabled(false);
	}


}

function cantSize_validateForm():Boolean
{
var util:FLUtil = new FLUtil();
var cursor:FLSqlCursor = this.cursor();

	if (!this.iface.__validateForm())
		return false;


	if (!this.iface.boolSize)
		return true;
	else
	if (cursor.valueBuffer("cantsize") < 10 && util.sqlSelect("articulos", "usasize", "referencia = '" + cursor.valueBuffer("referencia") + "'") )
		{
		var txt:String = "Este articulo se vende por tamao de tronco y solo se ha especificado " + cursor.valueBuffer("cantsize") + ".\nDesea continuar?";
		if (MessageBox.Yes != MessageBox.warning(txt, MessageBox.No, MessageBox.Yes))
			return false;
		}
return true;
}

//// CANT_SIZE //////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition ivaIncluido */
/////////////////////////////////////////////////////////////////
//// IVA_INCLUIDO //////////////////////////////////////////////
function ivaIncluido_init()
{
	this.iface.__init();
	formRecordlineaspedidoscli.iface.pub_habilitarPorIvaIncluido(form);
}

//// IVA_INCLUIDO //////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition lasCunas */
/////////////////////////////////////////////////////////////////
//// LAS CUNAS  /////////////////////////////////////////////////
function lasCunas_init()
{
	this.iface.__init();
	formRecordlineaspedidoscli.iface.muestra_stock(form);
}
//// LAS CUNAS  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

