/***************************************************************************
                 masterpedidoscli.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
	var ctx:Object;
	function interna( context ) { this.ctx = context; }
	function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
	var pbnGAlbaran:Object;
	var pbnGFactura:Object;
	var tdbRecords:FLTableDB;
	var tbnImprimir:Object;
	var tbnAbrirCerrar:Object;
	var curAlbaran:FLSqlCursor;
	var curLineaAlbaran:FLSqlCursor;
	var ignorarAvisoStock_:Boolean;

    function oficial( context ) { interna( context ); }
	function imprimir(codPedido:String) {
		return this.ctx.oficial_imprimir(codPedido);
	}
	function procesarEstado() {
		return this.ctx.oficial_procesarEstado();
	}
	function pbnGenerarAlbaran_clicked() {
		return this.ctx.oficial_pbnGenerarAlbaran_clicked();
	}
	function pbnGenerarFactura_clicked() {
		return this.ctx.oficial_pbnGenerarFactura_clicked();
	}
	function generarAlbaran(where:String, cursor:FLSqlCursor, datosAgrupacion:Array):Number {
		return this.ctx.oficial_generarAlbaran(where, cursor, datosAgrupacion);
	}
	function commonCalculateField(fN:String, cursor:FLSqlCursor):String {
		return this.ctx.oficial_commonCalculateField(fN, cursor);
	}
	function copiaLineas(idPedido:Number, idAlbaran:Number):Boolean {
		return this.ctx.oficial_copiaLineas(idPedido, idAlbaran);
	}
	function copiaLineaPedido(curLineaPedido:FLSqlCursor, idAlbaran:Number):Number {
		return this.ctx.oficial_copiaLineaPedido(curLineaPedido, idAlbaran);
	}
	function actualizarDatosPedido(where:String, idAlbaran:String):Boolean {
		return this.ctx.oficial_actualizarDatosPedido(where, idAlbaran);
	}
	function totalesAlbaran():Boolean {
		return this.ctx.oficial_totalesAlbaran();
	}
	function datosAlbaran(curPedido:FLSqlCursor, where:String, datosAgrupacion:Array):Boolean {
		return this.ctx.oficial_datosAlbaran(curPedido, where, datosAgrupacion);
	}
	function datosLineaAlbaran(curLineaPedido:FLSqlCursor):Boolean {
		return this.ctx.oficial_datosLineaAlbaran(curLineaPedido);
	}
	function comprobarStockEnAlbaranado(curLineaPedido:FLSqlCursor, cantidad:Number):Array {
		return this.ctx.oficial_comprobarStockEnAlbaranado(curLineaPedido, cantidad);
	}
	function abrirCerrarPedido() {
		return this.ctx.oficial_abrirCerrarPedido();
	}
	function filtrarTabla():Boolean {
		return this.ctx.oficial_filtrarTabla();
	}
	function filtroTabla():String {
		return this.ctx.oficial_filtroTabla();
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration dtoEspecial */
/////////////////////////////////////////////////////////////////
//// DTO ESPECIAL ///////////////////////////////////////////////
class dtoEspecial extends oficial /** %from: oficial */ {
    function dtoEspecial( context ) { oficial ( context ); }
	function commonCalculateField(fN:String, cursor:FLSqlCursor):String {
		return this.ctx.dtoEspecial_commonCalculateField(fN, cursor);
	}
	function totalesAlbaran():Boolean {
		return this.ctx.dtoEspecial_totalesAlbaran();
	}
	function datosAlbaran(curPedido:FLSqlCursor,where:String,datosAgrupacion:Array):Boolean {
		return this.ctx.dtoEspecial_datosAlbaran(curPedido,where,datosAgrupacion);
	}
	function buscarPorDtoEsp(where:String):Number {
		return this.ctx.dtoEspecial_buscarPorDtoEsp(where);
	}
}
//// DTO ESPECIAL ///////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration envioMail */
/////////////////////////////////////////////////////////////////
//// ENVIO_MAIL ////////////////////////////////////////////////
class envioMail extends dtoEspecial /** %from: oficial */ {
    function envioMail( context ) { dtoEspecial ( context ); }
	function init() {
		return this.ctx.envioMail_init();
	}
	function enviarDocumento(codPedido:String, codCliente:String) {
		return this.ctx.envioMail_enviarDocumento(codPedido, codCliente);
	}
	function imprimir(codPedido:String) {
		return this.ctx.envioMail_imprimir(codPedido);
	}
}

//// ENVIO_MAIL ////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration documentoEnvioMail */
/////////////////////////////////////////////////////////////////
//// DOCUMENTO ENVIO MAIL ///////////////////////////////////////
class documentoEnvioMail extends envioMail /** %from: envioMail */ {
    function documentoEnvioMail( context ) { envioMail ( context ); }
    function enviarDocumento(codPresupuesto:String, codCliente:String) {
		return this.ctx.documentoEnvioMail_enviarDocumento(codPresupuesto, codCliente);
	}
}
//// DOCUMENTO ENVIO MAIL ///////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration switchOrderDocu */
/////////////////////////////////////////////////////////////////
//// SWITCHORDERDOCU ////////////////////////////////////////////
class switchOrderDocu extends documentoEnvioMail /** %from: oficial */ {
    function switchOrderDocu( context ) { documentoEnvioMail ( context ); }
    function init() {
    	this.ctx.switchOrderDocu_init();
    }
}
//// SWITCHORDERDOCU ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration etiViveros */
/////////////////////////////////////////////////////////////////
//// ETIQUETAS_VIVEROS //////////////////////////////////////////
class etiViveros extends switchOrderDocu /** %from: oficial */ {
    function etiViveros( context ) { switchOrderDocu ( context ); }
	function init() { this.ctx.etiViveros_init(); }
	function imprimirEtiquetas() {
		return this.ctx.etiViveros_imprimirEtiquetas();
	}
}
//// ETIQUETAS_VIVEROS //////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration cantSize */
/////////////////////////////////////////////////////////////////
//// CANT_SIZE //////////////////////////////////////////////////
class cantSize extends etiViveros /** %from: oficial */ {
    function cantSize( context ) { etiViveros ( context ); }
    function datosLineaAlbaran(curLineaPedido:FLSqlCursor):Boolean {
		return this.ctx.cantSize_datosLineaAlbaran(curLineaPedido);
	}
}
//// CANT_SIZE //////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration carrysAlbaranes */
/////////////////////////////////////////////////////////////////
//// CARRYS_ALBARANES ///////////////////////////////////////////
class carrysAlbaranes extends cantSize /** %from: oficial */ {
    function carrysAlbaranes( context ) { cantSize ( context ); }
    function datosAlbaran(curPedido:FLSqlCursor, where:String, datosAgrupacion:Array):Boolean {
		return this.ctx.carrysAlbaranes_datosAlbaran(curPedido, where, datosAgrupacion);
	}
}
//// CARRYS_ALBARANES ///////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration tarifaAlternativa */
/////////////////////////////////////////////////////////////////
//// TARIFA_ALTERNATIVA /////////////////////////////////////////
class tarifaAlternativa extends carrysAlbaranes /** %from: oficial */ {
    function tarifaAlternativa( context ) { carrysAlbaranes ( context ); }
	function datosAlbaran(curPedido:FLSqlCursor, where:String, datosAgrupacion:Array):Boolean {
		return this.ctx.tarifaAlternativa_datosAlbaran(curPedido, where, datosAgrupacion);
	}
}
//// TARIFA_ALTERNATIVA /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration pedidosFincas */
/////////////////////////////////////////////////////////////////
//// PEDIDOS_FINCAS /////////////////////////////////////////////
class pedidosFincas extends tarifaAlternativa /** %from: oficial */ {
	function pedidosFincas( context ) { tarifaAlternativa ( context ); }
	function init() {
		this.ctx.pedidosFincas_init();
	}

	function pedirAFincas_clicked() {
		this.ctx.pedidosFincas_pedirAFincas_clicked();
	}

	function actualizaRegistroCarga(pedido:Number):Boolean {
		return pedidosFincas_actualizaRegistroCarga(pedido);
	}

	function seleccionarFincasPedido(id_pedido: Number):String {
		return pedidosFincas_seleccionarFincasPedido(id_pedido);
	}

}
//// PEDIDOS_FINCAS /////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration lasCunas */
/////////////////////////////////////////////////////////////////
//// LAS_CUNAS //////////////////////////////////////////////////
class lasCunas extends pedidosFincas /** %from: pedidosFincas */ {
    var filtroOriginal: String;
    function lasCunas( context ) { pedidosFincas ( context ); }
	function datosAlbaran(curPedido:FLSqlCursor, where:String, datosAgrupacion:Array):Boolean {
		return this.ctx.lasCunas_datosAlbaran(curPedido, where, datosAgrupacion);
	}
	function init() {
		this.ctx.lasCunas_init();
	}
	function mostrar_reservas_albaranables() {
		this.ctx.lasCunas_mostrar_reservas_albaranables();
	}
	function datosLineaAlbaran(curLineaPedido:FLSqlCursor):Boolean {
		return this.ctx.lasCunas_datosLineaAlbaran(curLineaPedido);
	}
	function pedirAFincas_clicked() {
		this.ctx.lasCunas_pedirAFincas_clicked();
	}
}
//// LAS_CUNAS //////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ivaIncluido */
//////////////////////////////////////////////////////////////////
//// IVAINCLUIDO /////////////////////////////////////////////////////
class ivaIncluido extends lasCunas /** %from: oficial */ {
    function ivaIncluido( context ) { lasCunas( context ); }
	function datosLineaAlbaran(curLineaPedido:FLSqlCursor):Boolean {
		return this.ctx.ivaIncluido_datosLineaAlbaran(curLineaPedido);
	}
	function totalesAlbaran():Boolean {
		return this.ctx.ivaIncluido_totalesAlbaran();
	}
}
//// IVAINCLUIDO /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration almacenLinea */
/////////////////////////////////////////////////////////////////
//// ALMACEN_LINEA //////////////////////////////////////////////
class almacenLinea extends ivaIncluido /** %from: ivaIncluido */ {
	function almacenLinea( context ) { ivaIncluido ( context ); }
	function datosLineaAlbaran(curLineaPedido:FLSqlCursor):Boolean {
		return this.ctx.almacenLinea_datosLineaAlbaran(curLineaPedido);
	}
	function comprobarStockEnAlbaranado(curLineaPedido:FLSqlCursor, cantidad:Number):Array {
		return this.ctx.almacenLinea_comprobarStockEnAlbaranado(curLineaPedido, cantidad);
	}
}
//// ALMACEN_LINEA //////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration stockUnificado */
/////////////////////////////////////////////////////////////////
//// STOCK_UNIFICADO ////////////////////////////////////////////
class stockUnificado extends almacenLinea /** %from: almacenLinea */ {
	function stockUnificado( context ) { almacenLinea ( context ); }
	function copiaLineas(idPedido:Number, idAlbaran:Number):Boolean {
		return this.ctx.stockUnificado_copiaLineas(idPedido, idAlbaran);
	}

}
//// STOCK_UNIFICADO ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends stockUnificado {
    function head( context ) { stockUnificado ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
	function pub_commonCalculateField(fN:String, cursor:FLSqlCursor):String {
		return this.commonCalculateField(fN, cursor);
	}
	function pub_generarAlbaran(where:String, cursor:FLSqlCursor, datosAgrupacion:Array):Number {
		return this.generarAlbaran(where, cursor, datosAgrupacion);
	}
	function pub_imprimir(codPedido:String) {
		return this.imprimir(codPedido);
	}
}

const iface = new pubEnvioMail( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration pubEnvioMail */
/////////////////////////////////////////////////////////////////
//// PUB_ENVIO_MAIL /////////////////////////////////////////////
class pubEnvioMail extends ifaceCtx /** %from: ifaceCtx */ {
    function pubEnvioMail( context ) { ifaceCtx( context ); }
	function pub_enviarDocumento(codPedido:String, codCliente:String) {
		return this.enviarDocumento(codPedido, codCliente);
	}
}

//// PUB_ENVIO_MAIL /////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C
Este es el formulario maestro de pedidos a cliente.
\end */
function interna_init()
{
	this.iface.pbnGAlbaran = this.child("pbnGenerarAlbaran");
	this.iface.pbnGFactura = this.child("pbnGenerarFactura");
	this.iface.tdbRecords = this.child("tableDBRecords");
	this.iface.tbnImprimir = this.child("toolButtonPrint");
	this.iface.tbnAbrirCerrar = this.child("tbnAbrirCerrar");

	connect(this.iface.pbnGAlbaran, "clicked()", this, "iface.pbnGenerarAlbaran_clicked()");
	connect(this.iface.pbnGFactura, "clicked()", this, "iface.pbnGenerarFactura_clicked()");
	connect(this.iface.tdbRecords, "currentChanged()", this, "iface.procesarEstado");
	connect(this.iface.tbnImprimir, "clicked()", this, "iface.imprimir");
	connect(this.iface.tbnAbrirCerrar, "clicked()", this, "iface.abrirCerrarPedido()");

	this.iface.filtrarTabla();
	this.iface.procesarEstado();
}

//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
/** \C
Al pulsar el botn imprimir se lanzar el informe correspondiente al pedido seleccionado (en caso de que el mdulo de informes est cargado)
\end */
function oficial_imprimir(codPedido:String)
{
	if (sys.isLoadedModule("flfactinfo")) {
		var codigo:String;
		if (codPedido) {
			codigo = codPedido;
		} else {
			if (!this.cursor().isValid())
				return;
			codigo = this.cursor().valueBuffer("codigo");
		}
		var curImprimir:FLSqlCursor = new FLSqlCursor("i_pedidoscli");
		curImprimir.setModeAccess(curImprimir.Insert);
		curImprimir.refreshBuffer();
		curImprimir.setValueBuffer("descripcion", "temp");
		curImprimir.setValueBuffer("d_pedidoscli_codigo", codigo);
		curImprimir.setValueBuffer("h_pedidoscli_codigo", codigo);
		flfactinfo.iface.pub_lanzarInforme(curImprimir, "i_pedidoscli");
	} else
			flfactppal.iface.pub_msgNoDisponible("Informes");
}

function oficial_procesarEstado()
{
		if (this.cursor().valueBuffer("editable") == true) {
				this.iface.pbnGAlbaran.enabled = true;
				this.iface.pbnGFactura.enabled = true;
		} else {
				this.iface.pbnGAlbaran.enabled = false;
				this.iface.pbnGFactura.enabled = false;
		}
}

/** \C
Al pulsar el botn de generar albarn se crear el albarn correspondiente al pedido seleccionado.
\end */
function oficial_pbnGenerarAlbaran_clicked()
{
	var cursor:FLSqlCursor = this.cursor();
	var where:String = "idpedido = " + cursor.valueBuffer("idpedido");
	var util:FLUtil = new FLUtil;

	if (cursor.valueBuffer("editable") == false) {
		MessageBox.warning(util.translate("scripts", "El pedido ya est servido"), MessageBox.Ok, MessageBox.NoButton);
		this.iface.procesarEstado();
		return;
	}
	this.iface.pbnGAlbaran.setEnabled(false);
	this.iface.pbnGFactura.setEnabled(false);

	var ok:Boolean;
	cursor.transaction(false);

	try {
		if (this.iface.generarAlbaran(where, cursor))
			cursor.commit();
		else
			cursor.rollback();
	}
	catch (e) {
		cursor.rollback();
		MessageBox.critical(util.translate("scripts", "Hubo un error en la generacin del albarn:") + "\n" + e, MessageBox.Ok, MessageBox.NoButton);
	}

	this.iface.tdbRecords.refresh();
	this.iface.procesarEstado();
}

/** \C
Al pulsar el botn de generar factura se crearn tanto el albarn como la factura correspondientes al pedido seleccionado.
\end */
function oficial_pbnGenerarFactura_clicked()
{
	var idAlbaran:Number;
	var util:FLUtil = new FLUtil;
	var curAlbaran:FLSqlCursor = new FLSqlCursor("albaranescli");
	var cursor:FLSqlCursor = this.cursor();
	var where:String = "idpedido = " + cursor.valueBuffer("idpedido");

	if (cursor.valueBuffer("editable") == false) {
		MessageBox.warning(util.translate("scripts", "El pedido ya est servido. Genere la factura desde la ventana de albaranes"), MessageBox.Ok, MessageBox.NoButton);
		this.iface.procesarEstado();
		return;
	}
	this.iface.pbnGAlbaran.setEnabled(false);
	this.iface.pbnGFactura.setEnabled(false);

	cursor.transaction(false);
	try {
		idAlbaran = this.iface.generarAlbaran(where, cursor);
		if (idAlbaran) {
			cursor.commit();
			cursor.transaction(false);
			where = "idalbaran = " + idAlbaran;
			curAlbaran.select(where);
			if (curAlbaran.first()) {
				if (formalbaranescli.iface.pub_generarFactura(where, curAlbaran))
					cursor.commit();
				else
					cursor.rollback();
			} else
				cursor.rollback();
		} else
			cursor.rollback();
	}
	catch (e) {
		cursor.rollback();
		MessageBox.critical(util.translate("scripts", "Hubo un error en la generacin de la factura:") + "\n" + e, MessageBox.Ok, MessageBox.NoButton);
	}

	this.iface.tdbRecords.refresh();
	this.iface.procesarEstado();
}

/** \D
Genera el albarn asociado a uno o ms pedidos
@param where: Sentencia where para la consulta de bsqueda de los pedidos a agrupar
@param cursor: Cursor con los datos principales que se copiarn del pedido al albarn
@param datosAgrupacion: Array con los datos indicados en el formulario de agrupacin de pedidos
@return Identificador del albarn generado. FALSE si hay error
\end */
function oficial_generarAlbaran(where:String, curPedido:FLSqlCursor, datosAgrupacion:Array):Number
{
	var util:FLUtil = new FLUtil;

	if (!this.iface.curAlbaran) {
		this.iface.curAlbaran = new FLSqlCursor("albaranescli");
	}
	this.iface.curAlbaran.setModeAccess(this.iface.curAlbaran.Insert);
	this.iface.curAlbaran.refreshBuffer();

	if (!this.iface.datosAlbaran(curPedido, where, datosAgrupacion)) {
		return false;
	}
	if (!this.iface.curAlbaran.commitBuffer()) {
		return false;
	}

	var idAlbaran:Number = this.iface.curAlbaran.valueBuffer("idalbaran");

	var qryPedidos:FLSqlQuery = new FLSqlQuery();
	qryPedidos.setTablesList("pedidoscli");
	qryPedidos.setSelect("idpedido");
	qryPedidos.setFrom("pedidoscli");
	qryPedidos.setWhere(where);

	if (!qryPedidos.exec()) {
		return false;
	}
	var idPedido:String;
	while (qryPedidos.next()) {
		idPedido = qryPedidos.value(0);
		if (!this.iface.copiaLineas(idPedido, idAlbaran))
			return false;
	}

	this.iface.curAlbaran.select("idalbaran = " + idAlbaran);
	if (this.iface.curAlbaran.first()) {
		if (util.sqlSelect("lineasalbaranescli", "idlinea", "idalbaran = " + idAlbaran)) {
			this.iface.curAlbaran.setModeAccess(this.iface.curAlbaran.Edit);
			this.iface.curAlbaran.refreshBuffer();
			if (!this.iface.totalesAlbaran()) {
				return false;
			}
			if (this.iface.curAlbaran.commitBuffer() == false) {
				return false;
			}
		} else {
			res = MessageBox.warning(util.translate("scripts", "El albarn generado no tiene ninguna lnea.\nDesea generarlo de todas formas?"), MessageBox.Yes, MessageBox.No);
			if (res == MessageBox.No) {
				this.iface.curAlbaran.setModeAccess(this.iface.curAlbaran.Del);
				this.iface.curAlbaran.refreshBuffer();
				if (this.iface.curAlbaran.commitBuffer() == false) {
					return false;
				}
			}
		}
	}
	return idAlbaran;
}

/** \D Informa los datos de un albarn a partir de los de uno o varios pedidos
@param	curPedido: Cursor que contiene los datos a incluir en el albarn
@param where: Sentencia where para la consulta de bsqueda de los pedidos a agrupar
@param datosAgrupacion: Array con los datos indicados en el formulario de agrupacin de pedidos
@return	True si el clculo se realiza correctamente, false en caso contrario
\end */
function oficial_datosAlbaran(curPedido:FLSqlCursor, where:String, datosAgrupacion:Array):Boolean
{
	var util:FLUtil = new FLUtil();
	var fecha:String;
	var hora:String;
	if (datosAgrupacion) {
		fecha = datosAgrupacion["fecha"];
		hora = datosAgrupacion["hora"];
	} else {
		var hoy:Date = new Date();
		fecha = hoy.toString();
		hora = hoy.toString().right(8);
	}

	var codEjercicio:String = curPedido.valueBuffer("codejercicio");
	var datosDoc:Array = flfacturac.iface.pub_datosDocFacturacion(fecha, codEjercicio, "albaranescli");
	if (!datosDoc.ok)
		return false;
	if (datosDoc.modificaciones == true) {
		codEjercicio = datosDoc.codEjercicio;
		fecha = datosDoc.fecha;
	}

	var codDir:Number = util.sqlSelect("dirclientes", "id", "codcliente = '" + curPedido.valueBuffer("codcliente") + "' AND domenvio = 'true'");

	with (this.iface.curAlbaran) {
		setValueBuffer("codserie", curPedido.valueBuffer("codserie"));
		setValueBuffer("codejercicio", codEjercicio);
		setValueBuffer("irpf", curPedido.valueBuffer("irpf"));
		setValueBuffer("fecha", fecha);
		setValueBuffer("hora", hora);
		setValueBuffer("codagente", curPedido.valueBuffer("codagente"));
		setValueBuffer("porcomision", curPedido.valueBuffer("porcomision"));
		setValueBuffer("codalmacen", curPedido.valueBuffer("codalmacen"));
		setValueBuffer("codpago", curPedido.valueBuffer("codpago"));
		setValueBuffer("coddivisa", curPedido.valueBuffer("coddivisa"));
		setValueBuffer("tasaconv", curPedido.valueBuffer("tasaconv"));
		setValueBuffer("codcliente", curPedido.valueBuffer("codcliente"));
		setValueBuffer("cifnif", curPedido.valueBuffer("cifnif"));
		setValueBuffer("nombrecliente", curPedido.valueBuffer("nombrecliente"));
		if (!codDir) {
			codDir = curPedido.valueBuffer("coddir")
			if (codDir == 0)
				setNull("coddir");
			else
				setValueBuffer("coddir", curPedido.valueBuffer("coddir"));
			setValueBuffer("direccion", curPedido.valueBuffer("direccion"));
			setValueBuffer("codpostal", curPedido.valueBuffer("codpostal"));
			setValueBuffer("ciudad", curPedido.valueBuffer("ciudad"));
			setValueBuffer("provincia", curPedido.valueBuffer("provincia"));
			setValueBuffer("apartado", curPedido.valueBuffer("apartado"));
			setValueBuffer("codpais", curPedido.valueBuffer("codpais"));
		} else {
			setValueBuffer("coddir", codDir);
			setValueBuffer("direccion", util.sqlSelect("dirclientes","direccion","id = " + codDir));
			setValueBuffer("codpostal", util.sqlSelect("dirclientes","codpostal","id = " + codDir));
			setValueBuffer("ciudad", util.sqlSelect("dirclientes","ciudad","id = " + codDir));
			setValueBuffer("provincia", util.sqlSelect("dirclientes","provincia","id = " + codDir));
			setValueBuffer("apartado", util.sqlSelect("dirclientes","apartado","id = " + codDir));
			setValueBuffer("codpais", util.sqlSelect("dirclientes","codpais","id = " + codDir));
		}
		setValueBuffer("recfinanciero", curPedido.valueBuffer("recfinanciero"));
		setValueBuffer("observaciones", curPedido.valueBuffer("observaciones"));
	}

	return true;
}

/** \D Informa los datos de un albarn referentes a totales (I.V.A., neto, etc.)
@return	True si el clculo se realiza correctamente, false en caso contrario
\end */
function oficial_totalesAlbaran():Boolean
{
	with (this.iface.curAlbaran) {
		setValueBuffer("neto", formalbaranescli.iface.pub_commonCalculateField("neto", this));
		setValueBuffer("totaliva", formalbaranescli.iface.pub_commonCalculateField("totaliva", this));
		setValueBuffer("totalirpf", formalbaranescli.iface.pub_commonCalculateField("totalirpf", this));
		setValueBuffer("totalrecargo", formalbaranescli.iface.pub_commonCalculateField("totalrecargo", this));
		setValueBuffer("total", formalbaranescli.iface.pub_commonCalculateField("total", this));
		setValueBuffer("totaleuros", formalbaranescli.iface.pub_commonCalculateField("totaleuros", this));
	}
	return true;
}

function oficial_actualizarDatosPedido(where:String, idAlbaran:String):Boolean
{
	var curPedidos:FLSqlCursor = new FLSqlCursor("pedidoscli");
	curPedidos.select(where);
	while (curPedidos.next()) {
		curPedidos.setModeAccess(curPedidos.Edit);
		curPedidos.refreshBuffer();
		curPedidos.setValueBuffer("servido", "S");
		curPedidos.setValueBuffer("editable", false);
		if(!curPedidos.commitBuffer())
			return false;
	}
	return true;
}

function oficial_commonCalculateField(fN:String, cursor:FLSqlCursor):String
{
		var util = new FLUtil();
		var valor;
		/** \C
		El --cdigo-- se construye como la concatenacin de --codserie--, --codejercicio-- y --numero--
		\end */
		if (fN == "codigo")
				valor = flfacturac.iface.pub_construirCodigo(cursor.valueBuffer("codserie"), cursor.valueBuffer("codejercicio"), cursor.valueBuffer("numero"));

		switch (fN) {
			/** \C
			El --total-- es el --neto-- menos el --totalirpf-- ms el --totaliva-- ms el --totalrecargo-- ms el --recfinanciero--
			\end */
			case "total": {
				var neto = parseFloat(cursor.valueBuffer("neto"));
				var totalIrpf = parseFloat(cursor.valueBuffer("totalirpf"));
				var totalIva = parseFloat(cursor.valueBuffer("totaliva"));
				var totalRecargo = parseFloat(cursor.valueBuffer("totalrecargo"));
				var recFinanciero = (parseFloat(cursor.valueBuffer("recfinanciero")) * neto) / 100;
				recFinanciero = parseFloat(util.roundFieldValue(recFinanciero, "pedidoscli", "total"));
				valor = neto - totalIrpf + totalIva + totalRecargo + recFinanciero;
				valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "total"));
				break;
			}
			case "lblComision": {
				valor = (parseFloat(cursor.valueBuffer("porcomision")) * (parseFloat(cursor.valueBuffer("neto")))) / 100;
				valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "total"));
				break;
			}
			case "lblRecFinanciero": {
				valor = (parseFloat(cursor.valueBuffer("recfinanciero")) * (parseFloat(cursor.valueBuffer("neto")))) / 100;
				valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "total"));
				break;
			}
			/** \C
			El --totaleuros-- es el producto del --total-- por la --tasaconv--
			\end */
			case "totaleuros": {
				var total = parseFloat(cursor.valueBuffer("total"));
				var tasaConv = parseFloat(cursor.valueBuffer("tasaconv"));
				valor = total * tasaConv;
				valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "totaleuros"));
				break;
			}
			/** \C
			El --neto-- es la suma del pvp total de las lneas de factura
			\end */
			case "neto": {
				valor = util.sqlSelect("lineaspedidoscli", "SUM(pvptotal)", "idpedido = " + cursor.valueBuffer("idpedido"));
				valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "neto"));
				break;
			}
			/** \C
			El --totaliva-- es la suma del iva correspondiente a las lneas de factura
			\end */
			case "totaliva": {
				var codCli:String = cursor.valueBuffer("codcliente");
				var regIva:String = flfacturac.iface.pub_regimenIVACliente(cursor);
				if(regIva == "U.E." || regIva == "Exento" || regIva == "Exportaciones") {
					valor = 0;
					break;
				}
				valor = util.sqlSelect("lineaspedidoscli", "SUM((pvptotal * iva) / 100)", "idpedido = " + cursor.valueBuffer("idpedido"));
				valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "totaliva"));
				break;
			}
			/** \C
			El --totarecargo-- es la suma del recargo correspondiente a las lneas de factura
			\end */
			case "totalrecargo": {
				var codCli:String = cursor.valueBuffer("codcliente");
				var regIva:String = flfacturac.iface.pub_regimenIVACliente(cursor);
				if(regIva == "U.E." || regIva == "Exento" || regIva == "Exportaciones") {
					valor = 0;
					break;
				}
				valor = util.sqlSelect("lineaspedidoscli", "SUM((pvptotal * recargo) / 100)", "idpedido = " + cursor.valueBuffer("idpedido"));
				valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "totalrecargo"));
				break;
			}
			/** \C
			El --coddir-- corresponde a la direccin del cliente marcada como direccin de facturacin
			\end */
			case "coddir": {
				valor = util.sqlSelect("dirclientes", "id", "codcliente = '" + cursor.valueBuffer("codcliente") + "' AND domfacturacion = 'true'");
				if (!valor) {
					valor = "";
				}
				break;
			}
			/** \C
			El --irpf-- es el asociado al --codserie-- del albarn
			\end */
			case "irpf": {
				valor = util.sqlSelect("series", "irpf", "codserie = '" + cursor.valueBuffer("codserie") + "'");
				break;
			}
			/** \C
			El --totalirpf-- es el producto del --irpf-- por el --neto--
			\end */
			case "totalirpf": {
				valor = util.sqlSelect("lineaspedidoscli", "SUM((pvptotal * irpf) / 100)", "idpedido = " + cursor.valueBuffer("idpedido"));
// 				valor = (parseFloat(cursor.valueBuffer("irpf")) * (parseFloat(cursor.valueBuffer("neto")))) / 100;
				valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "totalirpf"));
				break;
			}
			case "provincia": {
				valor = util.sqlSelect("dirclientes", "provincia", "id = " + cursor.valueBuffer("coddir"));
				if (!valor)
					valor = cursor.valueBuffer("provincia");
				break;
			}
			case "codpais": {
				valor = util.sqlSelect("dirclientes", "codpais", "id = " + cursor.valueBuffer("coddir"));
				if (!valor)
					valor = cursor.valueBuffer("codpais");
				break;
			}
		}
		return valor;
}

/** \D
Copia las lneas de un pedido como lneas de su albarn asociado
@param idPedido: Identificador del pedido
@param idAlbaran: Identificador del albarn
@return VERDADERO si no hay error. FALSE en otro caso.
\end */
function oficial_copiaLineas(idPedido:Number, idAlbaran:Number):Boolean
{
	var util:FLUtil = new FLUtil;
	var cantidad:Number;
	var totalEnAlbaran:Number;
	this.iface.ignorarAvisoStock_ = false;
	var curLineaPedido:FLSqlCursor = new FLSqlCursor("lineaspedidoscli");
	curLineaPedido.select("idpedido = " + idPedido + " AND (cerrada = false or cerrada IS NULL)");
	while (curLineaPedido.next()) {
		curLineaPedido.setModeAccess(curLineaPedido.Browse);
		curLineaPedido.refreshBuffer();
		cantidad = parseFloat(curLineaPedido.valueBuffer("cantidad"));
		totalEnAlbaran = parseFloat(curLineaPedido.valueBuffer("totalenalbaran"));
		if (cantidad != totalEnAlbaran) { /// > cambiado por != para poder albaranar lneas con cantidad negativa
			if (!this.iface.copiaLineaPedido(curLineaPedido, idAlbaran)) {
				return false;
			}
		}
	}
	return true;
}

/** \D
Copia una lneas de un pedido en su albarn asociado
@param curdPedido: Cursor posicionado en la lnea de pedido a copiar
@param idAlbaran: Identificador del albarn
@return identificador de la lnea de albarn creada si no hay error. FALSE en otro caso.
\end */
function oficial_copiaLineaPedido(curLineaPedido:FLSqlCursor, idAlbaran:Number):Number
{
	if (!this.iface.curLineaAlbaran) {
		this.iface.curLineaAlbaran = new FLSqlCursor("lineasalbaranescli");
	}
	with (this.iface.curLineaAlbaran) {
		setModeAccess(Insert);
		refreshBuffer();
		setValueBuffer("idalbaran", idAlbaran);
	}

	if (!this.iface.datosLineaAlbaran(curLineaPedido)) {
		return false;
	}

 	/// Este If est puesto para no crear lneas de albararn con cantidad 0 cuando el pedido tiene una cantidad superior pero no hay stock
 	if (!(this.iface.curLineaAlbaran.valueBuffer("cantidad") == 0 && curLineaPedido.valueBuffer("cantidad") != 0)) {
		if (!this.iface.curLineaAlbaran.commitBuffer()) {
			return false;
		}
 	}

	return this.iface.curLineaAlbaran.valueBuffer("idlinea");
}

/** \D Copia los datos de una lnea de pedido en una lnea de albarn
@param	curLineaPedido: Cursor que contiene los datos a incluir en la lnea de albarn
@return	True si la copia se realiza correctamente, false en caso contrario
\end */
function oficial_datosLineaAlbaran(curLineaPedido:FLSqlCursor):Boolean
{
	var util:FLUtil = new FLUtil;

	var cantidad:Number = parseFloat(curLineaPedido.valueBuffer("cantidad")) - parseFloat(curLineaPedido.valueBuffer("totalenalbaran"));
	var comprobarStock:Array = this.iface.comprobarStockEnAlbaranado(curLineaPedido, cantidad);
	if (!comprobarStock["ok"])
		return false;

	if (!comprobarStock["haystock"]) {
		cantidad = comprobarStock["cantidad"];
	}
	var pvpSinDto:Number = parseFloat(curLineaPedido.valueBuffer("pvpsindto")) * cantidad / parseFloat(curLineaPedido.valueBuffer("cantidad"));
	pvpSinDto = util.roundFieldValue(pvpSinDto, "lineasalbaranescli", "pvpsindto");

	var iva:Number, recargo:Number;
	var codImpuesto:String = curLineaPedido.valueBuffer("codimpuesto");
	with (this.iface.curLineaAlbaran) {
		setValueBuffer("idlineapedido", curLineaPedido.valueBuffer("idlinea"));
		setValueBuffer("idpedido", curLineaPedido.valueBuffer("idpedido"));
		setValueBuffer("referencia", curLineaPedido.valueBuffer("referencia"));
		setValueBuffer("descripcion", curLineaPedido.valueBuffer("descripcion"));
		setValueBuffer("pvpunitario", curLineaPedido.valueBuffer("pvpunitario"));
		setValueBuffer("cantidad", cantidad);
		setValueBuffer("codimpuesto", codImpuesto);
		if (curLineaPedido.isNull("iva")) {
			setNull("iva");
		} else {
			iva = curLineaPedido.valueBuffer("iva");
			if (iva != 0 && codImpuesto && codImpuesto != "") {
				iva = formRecordlineaspedidoscli.iface.pub_commonCalculateField("iva", this); /// Para cambio de IVA segn fechas
			}
			setValueBuffer("iva", iva);
		}
		if (curLineaPedido.isNull("recargo")) {
			setNull("recargo");
		} else {
			recargo = curLineaPedido.valueBuffer("recargo");
			if (recargo != 0 && codImpuesto && codImpuesto != "") {
				recargo = formRecordlineaspedidoscli.iface.pub_commonCalculateField("recargo", this); /// Para cambio de IVA segn fechas
			}
			setValueBuffer("recargo", recargo);
		}
		setValueBuffer("irpf", curLineaPedido.valueBuffer("irpf"));
		setValueBuffer("dtolineal", curLineaPedido.valueBuffer("dtolineal"));
		setValueBuffer("dtopor", curLineaPedido.valueBuffer("dtopor"));
		setValueBuffer("porcomision", curLineaPedido.valueBuffer("porcomision"));
		setValueBuffer("pvpsindto", pvpSinDto);
		setValueBuffer("pvptotal", formRecordlineaspedidoscli.iface.pub_commonCalculateField("pvptotal", this));
	}
	return true;
}

function oficial_comprobarStockEnAlbaranado(curLineaPedido:FLSqlCursor, cantidad:Number):Array
{
	var util:FLUtil = new FLUtil;
	var res:Array = [];

	res["haystock"] = true;
	res["cantidad"] = 0;
	res["ok"] = true;
	var referencia:String = curLineaPedido.valueBuffer("referencia");
	if (referencia && referencia != "") {
		var controlStock:Boolean = util.sqlSelect("articulos", "controlstock", "referencia = '" + referencia + "'");
		if (!controlStock) {
			var codAlmacen:String;
			if (curLineaPedido.cursorRelation())
				codAlmacen = curLineaPedido.cursorRelation().valueBuffer("codalmacen");
			else
				codAlmacen = util.sqlSelect("pedidoscli", "codalmacen", "idpedido = " + curLineaPedido.valueBuffer("idpedido"));

			var cantidadStock:Number = parseFloat(util.sqlSelect("stocks", "cantidad", "referencia = '" + referencia + "' AND codalmacen = '" + codAlmacen + "'"));
			if (!cantidadStock || isNaN(cantidadStock))
				cantidadStock = 0;

			if (cantidadStock < cantidad) {
				res["haystock"] = false;
				if (!this.iface.ignorarAvisoStock_) {
					var resCuestion:Number = MessageBox.warning(util.translate("scripts", "El artculo %1 no permite ventas sin stocks.\nEst albaranando ms cantidad (%2) que la disponible (%3) ahora mismo en el almacn %4.\nDesea continuar dejando el pedido parcialmente albaranado?\n(pulse Ignorar para evitar esta pregunta en el resto de las lneas)").arg(referencia).arg(cantidad).arg(cantidadStock).arg(codAlmacen), MessageBox.No, MessageBox.Yes, MessageBox.Ignore);
					switch (resCuestion) {
						case MessageBox.Yes: {
							cantidadStock = 0;
							break;
						}
						case MessageBox.Ignore: {
							this.iface.ignorarAvisoStock_ = true;
							cantidadStock = 0;
							break;
						}
						default: {
							res["ok"] = false;
							return res;
						}
					}
				} else {
					cantidadStock = 0;
				}

				if (cantidadStock < 0) {
					cantidadStock = 0;
				}
				res["cantidad"] = cantidadStock;
			}
		}
	}
	return res;
}

function oficial_abrirCerrarPedido()
{
	var util:FLUtil;
	var cursor:FLSqlCursor = this.cursor();

	var idPedido:Number = cursor.valueBuffer("idpedido");
	if(!idPedido) {
		MessageBox.warning(util.translate("scripts", "No hay ningn registro seleccionado"), MessageBox.Ok, MessageBox.NoButton);
	}

	var cerrar:Boolean = true;
	var res:Number;
	if(util.sqlSelect("lineaspedidoscli","cerrada","idpedido = " + idPedido + " AND cerrada")) {
		cerrar = false;
		res = MessageBox.information(util.translate("scripts", "El pedido seleccionado tiene lneas cerradas.\nSeguro que desea abrirlas?"), MessageBox.Yes, MessageBox.No);
	}
	else {
		if(!cursor.valueBuffer("editable")) {
			MessageBox.warning(util.translate("scripts", "El pedido ya ha sido servido completamente."), MessageBox.Ok, MessageBox.NoButton);
			return;
		}
		res = MessageBox.information(util.translate("scripts", "Se va a cerrar el pedido y no podr terminar de servirse.\nDesea continuar?"), MessageBox.Yes, MessageBox.No);
	}
	if(res != MessageBox.Yes)
		return;

	if(!util.sqlUpdate("lineaspedidoscli","cerrada",cerrar,"idpedido = " + idPedido))
		return;

	if (!flfacturac.iface.pub_actualizarEstadoPedidoCli(idPedido))
		return;

	this.iface.tdbRecords.refresh();
}

function oficial_filtrarTabla():Boolean
{
	var filtro:String = this.iface.filtroTabla();
	this.cursor().setMainFilter(filtro);
	return true;
}

function oficial_filtroTabla():String
{
	var filtro:String = "";
	var codEjercicio:String = flfactppal.iface.pub_ejercicioActual();
	if (codEjercicio) {
		filtro = "codejercicio='" + codEjercicio + "'";
	}
	return filtro;
}
//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition dtoEspecial */
/////////////////////////////////////////////////////////////////
//// DTO ESPECIAL ///////////////////////////////////////////////
function dtoEspecial_commonCalculateField(fN:String, cursor:FLSqlCursor):String
{
	var util = new FLUtil();
	var valor;

	switch (fN) {
	/** \C
	El --totaliva-- es la suma del iva correspondiente a las lneas de factura
	\end */
		case "totaliva":{
			var porDto:Number = cursor.valueBuffer("pordtoesp");
			if (!porDto || porDto == 0) {
				valor = this.iface.__commonCalculateField(fN, cursor);
				break;
			}
			valor = util.sqlSelect("lineaspedidoscli", "SUM((pvptotal * iva * (100 - " + porDto + ")) / 100 / 100)", "idpedido = " + cursor.valueBuffer("idpedido"));
			valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "totaliva"));
			break;
		}
	/** \C
	El --totarecargo-- es la suma del recargo correspondiente a las lneas de factura
	\end */
		case "totalrecargo":{
			var porDto:Number = cursor.valueBuffer("pordtoesp");
			if (!porDto || porDto == 0) {
				valor = this.iface.__commonCalculateField(fN, cursor);
				break;
			}
			valor = util.sqlSelect("lineaspedidoscli", "SUM((pvptotal * recargo * (100 - " + porDto + ")) / 100 / 100)", "idpedido = " + cursor.valueBuffer("idpedido"));
			valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "totalrecargo"));
			break;
		}
	/** \C
	El --netosindtoesp-- es la suma del pvp total de las lneas de factura
	\end */
		case "netosindtoesp":{
			valor = this.iface.__commonCalculateField("neto", cursor);
			break;
		}
	/** \C
	El --neto-- es el --netosindtoesp-- menos el --dtoesp--
	\end */
		case "neto": {
			valor = parseFloat(cursor.valueBuffer("netosindtoesp")) - parseFloat(cursor.valueBuffer("dtoesp"));
			valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "neto"));
			break;
		}
	/** \C
	El --dtoesp-- es el --netosindtoesp-- menos el porcentaje que marca el --pordtoesp--
	\end */
		case "dtoesp": {
			valor = (parseFloat(cursor.valueBuffer("netosindtoesp")) * parseFloat(cursor.valueBuffer("pordtoesp"))) / 100;
			valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "dtoesp"));
			break;
		}
	/** \C
	El --pordtoesp-- es el --dtoesp-- entre el --netosindtoesp-- por 100
	\end */
		case "pordtoesp": {
			if (parseFloat(cursor.valueBuffer("netosindtoesp")) != 0) {
				valor = (parseFloat(cursor.valueBuffer("dtoesp")) / parseFloat(cursor.valueBuffer("netosindtoesp"))) * 100;
			} else {
				valor = cursor.valueBuffer("pordtoesp");
			}
			valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "pordtoesp"));
			break;
		}
		/** \C
		El --totalirpf-- es el producto del --irpf-- por el --neto--
		\end */
		case "totalirpf": {
			valor = (util.sqlSelect("lineaspedidoscli", "SUM((pvptotal * irpf) / 100)", "idpedido = " + cursor.valueBuffer("idpedido")));
			if (parseFloat(cursor.valueBuffer("pordtoesp")) != 0)
			{
			valor = valor - ( valor * parseFloat(cursor.valueBuffer("pordtoesp")) / 100);
			}
			valor = parseFloat(util.roundFieldValue(valor, "pedidoscli", "totalirpf"));
			break;
		}
		default: {
			valor = this.iface.__commonCalculateField(fN, cursor);
			break;
		}
	}
	return valor;
}

/** \D Informa los datos de un albarn a partir de los de uno o varios pedidos
@param	curPedido: Cursor que contiene los datos a incluir en el albarn
@return	True si el clculo se realiza correctamente, false en caso contrario
\end */
function dtoEspecial_datosAlbaran(curPedido:FLSqlCursor,where:String,datosAgrupacion:Array):Boolean
{
	var util:FLUtil = new FLUtil();
	var porDtoEsp:Number = this.iface.buscarPorDtoEsp(where);
	if (porDtoEsp == -1) {
		MessageBox.critical(util.translate("scripts", "No es posible generar un nico albarn para pedidos con distinto porcentaje de descuento especial"), MessageBox.Ok, MessageBox.NoButton);
		return false;
	}

	var fecha:String;
	if (curPedido.action() == "pedidoscli") {
		var hoy:Date = new Date();
		fecha = hoy.toString();
	} else
		fecha = curPedido.valueBuffer("fecha");

	with (this.iface.curAlbaran) {
		setValueBuffer("pordtoesp", porDtoEsp);
	}

	if(!this.iface.__datosAlbaran(curPedido, where, datosAgrupacion))
		return false;

	return true;
}

/** \D Informa los datos de un albarn referentes a totales (I.V.A., neto, etc.)
@return	True si el clculo se realiza correctamente, false en caso contrario
\end */
function dtoEspecial_totalesAlbaran():Boolean
{
	with (this.iface.curAlbaran) {
		setValueBuffer("netosindtoesp", formalbaranescli.iface.pub_commonCalculateField("netosindtoesp", this));
		setValueBuffer("dtoesp", formalbaranescli.iface.pub_commonCalculateField("dtoesp", this));
		setValueBuffer("neto", formalbaranescli.iface.pub_commonCalculateField("neto", this));
		setValueBuffer("totaliva", formalbaranescli.iface.pub_commonCalculateField("totaliva", this));
		setValueBuffer("totalirpf", formalbaranescli.iface.pub_commonCalculateField("totalirpf", this));
		setValueBuffer("totalrecargo", formalbaranescli.iface.pub_commonCalculateField("totalrecargo", this));
		setValueBuffer("total", formalbaranescli.iface.pub_commonCalculateField("total", this));
		setValueBuffer("totaleuros", formalbaranescli.iface.pub_commonCalculateField("totaleuros", this));
	}
	return true;
}

/** \D
Busca el porcentaje de descuento especial realizado a los pedidos que se agruparn en un albarn. Si existen dos pedidos con distinto porcentaje devuelve un cdigo de error.
@param where: Clusula where para buscar los pedidos
@return porcenteje de descuento (-1 si hay error);
\end */
function dtoEspecial_buscarPorDtoEsp(where:String):Number
{
	var util:FLUtil = new FLUtil;
	var porDtoEsp:Number = util.sqlSelect("pedidoscli", "pordtoesp", where);
	var porDtoEsp2:Number = util.sqlSelect("pedidoscli", "pordtoesp", where + " AND pordtoesp <> " + porDtoEsp);
	if (!porDtoEsp2 && isNaN(parseFloat(porDtoEsp2)))
		return porDtoEsp;
	else
		return -1;
}
//// DTO ESPECIAL ///////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition envioMail */
/////////////////////////////////////////////////////////////////
//// ENVIO_MAIL /////////////////////////////////////////////////
function envioMail_init()
{
	this.iface.__init();
	//this.child("tbnEnviarMail").close();
	connect(this.child("tbnEnviarMail"), "clicked()", this, "iface.enviarDocumento()");
}

function envioMail_enviarDocumento(codPedido:String, codCliente:String)
{
	var cursor:FLSqlCursor = this.cursor();
	var util:FLUtil = new FLUtil();

	if (!codPedido) {
		codPedido = cursor.valueBuffer("codigo");
	}

	if (!codCliente) {
		codCliente = cursor.valueBuffer("codcliente");
	}
	var tabla:String = "clientes";
	var emailCliente:String = flfactppal.iface.pub_componerListaDestinatarios(codCliente, tabla);
	if (!emailCliente || emailCliente == "")
		if (!util.sqlSelect("empresa","nodestinatario","1 = 1"))
			return;

	var rutaIntermedia:String = util.readSettingEntry("scripts/flfactinfo/dirCorreo");
	if (!rutaIntermedia.endsWith("/")) {
		rutaIntermedia += "/";
	}

	var cuerpo:String = "";
	var asunto:String = util.translate("scripts", "Pedido %1").arg(codPedido);
	var rutaDocumento:String = rutaIntermedia + "P_" + codPedido + ".pdf";

	var codigo:String;
	if (codPedido) {
		codigo = codPedido;
	} else {
		if (!cursor.isValid()) {
			return;
		}
		codigo = cursor.valueBuffer("codigo");
	}

	var numCopias:Number = util.sqlSelect("pedidoscli p INNER JOIN clientes c ON c.codcliente = p.codcliente", "c.copiasfactura", "p.codigo = '" + codigo + "'", "pedidoscli,clientes");
	if (!numCopias) {
		numCopias = 1;
	}

	var curImprimir:FLSqlCursor = new FLSqlCursor("i_pedidoscli");
	curImprimir.setModeAccess(curImprimir.Insert);
	curImprimir.refreshBuffer();
	curImprimir.setValueBuffer("descripcion", "temp");
	curImprimir.setValueBuffer("d_pedidoscli_codigo", codigo);
	curImprimir.setValueBuffer("h_pedidoscli_codigo", codigo);
	flfactinfo.iface.pub_lanzarInforme(curImprimir, "i_pedidoscli", "", "", false, false, "", "i_pedidoscli", numCopias, rutaDocumento, true);

	var arrayDest:Array = [];
	arrayDest[0] = [];
	arrayDest[0]["tipo"] = "to";
	arrayDest[0]["direccion"] = emailCliente;

	var arrayAttach:Array = [];
	arrayAttach[0] = rutaDocumento;

	flfactppal.iface.pub_enviarCorreo(cuerpo, asunto, arrayDest, arrayAttach);
}

function envioMail_imprimir(codPedido:String)
{
	var util:FLUtil = new FLUtil;

	var datosEMail:Array = [];
	datosEMail["tipoInforme"] = "pedidoscli";
	var codCliente:String;
	if (codPedido && codPedido != "") {
		datosEMail["codDestino"] = util.sqlSelect("pedidoscli", "codcliente", "codigo = '" + codPedido + "'");
		datosEMail["codDocumento"] = codPedido;
	} else {
		var cursor:FLSqlCursor = this.cursor();
		datosEMail["codDestino"] = cursor.valueBuffer("codcliente");
		datosEMail["codDocumento"] = cursor.valueBuffer("codigo");
	}
	flfactinfo.iface.datosEMail = datosEMail;
	this.iface.__imprimir(codPedido);
}

//// ENVIO_MAIL /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition documentoEnvioMail */
/////////////////////////////////////////////////////////////////
//// DOCUMENTO ENVIO MAIL ///////////////////////////////////////
function documentoEnvioMail_enviarDocumento(codPedido:String, codCliente:String)
{
	var cursor:FLSqlCursor = this.cursor();
	var util:FLUtil = new FLUtil();

	if (!codPedido) {
		codPedido = cursor.valueBuffer("codigo");
	}

	if (!codCliente) {
		codCliente = cursor.valueBuffer("codcliente");
	}
	var tabla:String = "clientes";
	var emailCliente:String = flfactppal.iface.pub_componerListaDestinatarios(codCliente, tabla);
	if (!emailCliente || emailCliente == "")
		if (!util.sqlSelect("empresa","nodestinatario","1 = 1"))
			return;

	var rutaIntermedia:String = util.readSettingEntry("scripts/flfactinfo/dirCorreo");
	if (!rutaIntermedia.endsWith("/")) {
		rutaIntermedia += "/";
	}

	var cuerpo:String = "";
	var asunto:String = util.translate("scripts", "Pedido %1").arg(codPedido);
	var rutaDocumento:String = rutaIntermedia + "P_" + codPedido + ".pdf";

	var codigo:String;
	if (codPedido) {
		codigo = codPedido;
	} else {
		if (!cursor.isValid()) {
			return;
		}
		codigo = cursor.valueBuffer("codigo");
	}

	var numCopias:Number = util.sqlSelect("pedidoscli p INNER JOIN clientes c ON c.codcliente = p.codcliente", "c.copiasfactura", "p.codigo = '" + codigo + "'", "pedidoscli,clientes");
	if (!numCopias) {
		numCopias = 1;
	}

	var nombre_report = flfactinfo.iface.resuelveTipoReport("i_pedidoscli", cursor);
	var curImprimir:FLSqlCursor = new FLSqlCursor("i_pedidoscli");
	curImprimir.setModeAccess(curImprimir.Insert);
	curImprimir.refreshBuffer();
	curImprimir.setValueBuffer("descripcion", "temp");
	curImprimir.setValueBuffer("d_pedidoscli_codigo", codigo);
	curImprimir.setValueBuffer("h_pedidoscli_codigo", codigo);
	flfactinfo.iface.pub_lanzarInforme(curImprimir, "i_pedidoscli", "", "", false, false, "", nombre_report, numCopias, rutaDocumento, true);

	var arrayDest:Array = [];
	arrayDest[0] = [];
	arrayDest[0]["tipo"] = "to";
	arrayDest[0]["direccion"] = emailCliente;

	var arrayAttach:Array = [];
	arrayAttach[0] = rutaDocumento;

	flfactppal.iface.pub_enviarCorreo(cuerpo, asunto, arrayDest, arrayAttach);
}
//// DOCUMENTO ENVIO MAIL ///////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition switchOrderDocu */
/////////////////////////////////////////////////////////////////
//// SWITCHORDERDOCU ////////////////////////////////////////////
function switchOrderDocu_init()
{
this.iface.__init();
if (this.child("tableDBRecords").isSortOrderAscending())
	this.child("tableDBRecords").setSortOrder(0);
}
//// SWITCHORDERDOCU ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition etiViveros */
/////////////////////////////////////////////////////////////////
//// ETIQUETAS_VIVEROS //////////////////////////////////////////
function etiViveros_init()
{
this.iface.__init();
connect(this.child("pbEtiquetas"), "clicked()", this, "iface.imprimirEtiquetas");
}
function etiViveros_imprimirEtiquetas()
{
var cursor = this.cursor();
var util:FLUtil = new FLUtil;
//Cogemos pedido
var curLineas:FLSqlCursor = new FLSqlCursor("lineaspedidoscli");
curLineas.select("idpedido = " + cursor.valueBuffer("idpedido"));
var codCliente:String = cursor.valueBuffer("codcliente");
var aEtiquetas:Array = [];
var i:Number = 0;
if (curLineas.first())
	{
	do {
	   if (curLineas.valueBuffer("referencia") && curLineas.valueBuffer("referencia") != "")
		{
	   	aEtiquetas[i] = [];
	   	aEtiquetas[i]["referencia"] = curLineas.valueBuffer("referencia");
	   	aEtiquetas[i]["cantidad"] = curLineas.valueBuffer("cantidad");
		aEtiquetas[i]["idetiqueta"] = 0; //Prevalece la etiqueta asiganada al articulo
		aEtiquetas[i]["barcode"] = util.sqlSelect("articulos","codbarras","referencia='" + curLineas.valueBuffer("referencia") + "'");
		if (curLineas.valueBuffer("lote"))
			{
			aEtiquetas[i]["lote"] = curLineas.valueBuffer("lote");
			}
		else
			{
			aEtiquetas[i]["lote"] = aEtiquetas[i]["barcode"] ;
			}
	   	var pvpIvaIncluido:Number = parseFloat(curLineas.valueBuffer("pvptotal") / curLineas.valueBuffer("cantidad"));
	   	if (curLineas.valueBuffer("iva"))
			{
			pvpIvaIncluido = parseFloat(((curLineas.valueBuffer("iva") * pvpIvaIncluido) / 100 ) + pvpIvaIncluido);
			}
	   	aEtiquetas[i]["pvp"] = util.roundFieldValue(pvpIvaIncluido,"lineasalbaranescli","pvptotal");
	   	i = i + 1;
		}
	} while (curLineas.next());

	if (i > 0)
		{
		flfactinfo.iface.procesarEtiquetas(aEtiquetas,codCliente);
		}
	}
}
//// ETIQUETAS_VIVEROS //////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition cantSize */
/////////////////////////////////////////////////////////////////
//// CANT_SIZE //////////////////////////////////////////////////

function cantSize_datosLineaAlbaran(curLineaPedido:FLSqlCursor):Boolean
{
	if (!this.iface.__datosLineaAlbaran(curLineaPedido))
  		return false;

	this.iface.curLineaAlbaran.setValueBuffer("cantsize", curLineaPedido.valueBuffer("cantsize"));
return true;
}

//// CANT_SIZE //////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition carrysAlbaranes */
/////////////////////////////////////////////////////////////////
//// CARRYS_ALBARANES ///////////////////////////////////////////
function carrysAlbaranes_datosAlbaran(curPedido:FLSqlCursor, where:String, datosAgrupacion:Array):Boolean
{
	var util:FLUtil;
	var numeroCarros:String = "";
	var numeroBandejas:String = "";
	var retorno:Boolean = this.iface.__datosAlbaran(curPedido, where, datosAgrupacion);


	if (!retorno)
		return false;
//	do {
//	numeroCarros = Input.getText( util.translate("scripts", "Nmero de carros usados") );
//	  } while (numeroCarros == "" || numeroCarros == " ");
//	do {
//	numeroBandejas = Input.getText( util.translate("scripts", "Nmero de bandejas usadas") );
//	 } while (numeroBandejas == "" || numeroBandejas == " ");
//
//	this.iface.curAlbaran.setValueBuffer("numcarros", numeroCarros);
//	this.iface.curAlbaran.setValueBuffer("numbandejas", numeroBandejas);

	return true;
}
//// CARRYS_ALBARANES ///////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition tarifaAlternativa */
/////////////////////////////////////////////////////////////////
//// TARIFA_ALTERNATIVA /////////////////////////////////////////




function tarifaAlternativa_datosAlbaran(curPedido:FLSqlCursor, where:String, datosAgrupacion:Array):Boolean
{
	if (!this.iface.__datosAlbaran(curPedido, where, datosAgrupacion))
		return false;

	this.iface.curAlbaran.setValueBuffer("codtarifa", curPedido.valueBuffer("codtarifa"));
	return true;
}
//// TARIFA_ALTERNATIVA /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition pedidosFincas */
/////////////////////////////////////////////////////////////////
//// PEDIDOS_FINCAS /////////////////////////////////////////////
function pedidosFincas_init()
{

	var _i = this.iface;

	_i.__init();
	connect(this.child("pbpedirafincas"), "clicked()", this, "iface.pedirAFincas_clicked()");

}

function pedidosFincas_seleccionarFincasPedido(id_pedido:Number): String
{
	var result : String = "";
	var util = new FLUtil();
	var qryCarga:FLSqlQuery = new FLSqlQuery();
	qryCarga.setTablesList("lineaspedidoscli");
	qryCarga.setSelect("DISTINCT codfinca");
	qryCarga.setFrom("lineaspedidoscli");
	qryCarga.setWhere("idpedido = " + id_pedido + " AND NOT codfinca is NULL");

	var dialog = new QDialog(util.translate ( "scripts", "Seleccin fincas" ));
	//dialog.caption = "Listado";
	dialog.OKButtonText = util.translate ( "scripts", "Aceptar" );
	dialog.cancelButtonText = util.translate ( "scripts", "Cancelar" );
	dialog.modal = true;
	dialog.resize(300, 500);


	var lay_botones = new QHBoxLayout();





	var gbx_maestro = new QGroupBox(dialog);
	var lay_maestro = new QVBoxLayout(gbx_maestro);
	var lista = new Array();
	var lista_codigos = new Array();
	if (qryCarga.exec()) {

		var scroll = new QScrollView(dialog);
		var i = 0;
		while(qryCarga.next()) {
			var cod_finca = qryCarga.value(0);
			if (!cod_finca) {
				continue;
			}
			lista_codigos[i] = cod_finca;
			var nombre_finca = cod_finca + " - " + util.sqlSelect("fincas","descripcion","codfinca='" + cod_finca + "'");
			var lay = new QHBoxLayout();
			var check_box = new QCheckBox(nombre_finca, dialog);
			check_box.checked = false;
			lista[i] = check_box;

			lay.addWidget(check_box);
			lay_maestro.addLayout(lay);
			i++;
  			}

  		pb_aceptar = new QPushButton(sys.translate("Aceptar"), dialog);
	    	connect(pb_aceptar, "clicked()", dialog, "accept()");
	    	lay_botones.addWidget(pb_aceptar);
		pb_cancelar = new QPushButton(sys.translate("Cancelar"), dialog);
	    	connect(pb_cancelar, "clicked()", dialog, "reject()");
	    	lay_botones.addWidget(pb_cancelar);
		lay_maestro.addLayout(lay_botones);
  	}

  	if (!dialog.exec())
	{
		//debug("Cancelado");
		return result;

	}

	var array_respuestas = new Array();
	for (i = 0;i < lista.length; i++) {
		if (lista[i].checked) {
			array_respuestas.push(lista_codigos[i]);
		}
	}

	if (array_respuestas.length > 0) {
		result = " AND codfinca IN ('" + array_respuestas.join("','") + "')";
	}

	debug("resultado devuelto: " + result);
	return result;
}

function pedidosFincas_pedirAFincas_clicked()
{
	//debug("YEAHHH");
	var util:FLUtil;
	var cursor:FLSqlCursor = this.cursor();
	if (!cursor)
		return false;


	var yapedido:Boolean = cursor.valueBuffer("pedidoafinca");
	var msg:String;
	var whereFijo:String="";
	var res:String;
	var pedir:Boolean = true;
	var hoy:Date = new Date();
	fecha = hoy.toString().left(10);
	hora = hoy.toString().right(8);
	idUsuario = sys.nameUser();
	var where_adicional:String = "";

	if (!yapedido)
		{
		msg = "Desea enviar el pedido a las fincas";
		}
	else
		{
		msg = "ESTE PEDIDO YA SE HA ENVIADO ANTERIORMENTE\n  desea volver a enviar el pedido a las fincas ?";
		}

	res = MessageBox.warning(util.translate("scripts", msg), MessageBox.Yes, MessageBox.No);
	if (res == MessageBox.No) {
		debug("Creando dialogo de seleccin de fincas");
		where_adicional = this.iface.seleccionarFincasPedido(cursor.valueBuffer("idpedido"));
		if(where_adicional == "") {
			pedir = false;
		}
        } else {
        	debug("Se pide a todas las fincas");
        }



	if (pedir)
		{
		if (util.sqlSelect("lineaspedidoscli", "idpedido", "idpedido = " + cursor.valueBuffer("idpedido") + " AND codfinca is NULL LIMIT 1"))
			{
			res = MessageBox.warning(util.translate("scripts", "Hay lineas sin especificar finca.\nDesea continuar?"), MessageBox.Yes, MessageBox.No);
			if (res == MessageBox.No)
				return false;
			}

		var qryCarga:FLSqlQuery = new FLSqlQuery();
		qryCarga.setTablesList("lineaspedidoscli");
		qryCarga.setSelect("DISTINCT codfinca");
		qryCarga.setFrom("lineaspedidoscli");
		qryCarga.setWhere("idpedido = " + cursor.valueBuffer("idpedido") + " AND NOT codfinca is NULL" + where_adicional);

		if (!qryCarga.exec()) {
			MessageBox.warning(util.translate("scripts", "No se ha especificado ninguna finca en ninguna linea"), MessageBox.Yes, MessageBox.No);
			return false;
		}

		util.createProgressDialog(util.translate("scripts", "Enviando ..."), qryCarga.size());
		var progreso = 0;
		var tiempo = 8000000; //primero mas lento para que arranque jasper.

		while (qryCarga.next()) {
			util.setLabelText("Pedido a " + qryCarga.value(0));
			util.setProgress(progreso);
			whereFijo = "WHERE\npedidoscli.idpedido=" + cursor.valueBuffer("idpedido") + " AND lineaspedidoscli.codfinca= '" + qryCarga.value(0) + "'\nUSER\n"+ idUsuario + "\nFECHA\n" + fecha + "\nHORA\n" + hora + "\n";
			impresora = util.sqlSelect("fincas", "impresora", "codfinca = '" + qryCarga.value(0) + "'");
			if (impresora != "")
		 		flfactinfo.iface.pub_lanzarInforme(cursor, "i_carga","","",false,true,whereFijo,"i_carga",0,impresora,false);
			else
				{
				var msgImpresora:String = "No hay impresora especificada para la Finca " + qryCarga.value(0) + "\nSe omite la impresin";
				res = MessageBox.warning(util.translate("scripts", msgImpresora), MessageBox.Yes, MessageBox.No);
				}


			for (var i=0; i < tiempo; i++)
				{
				var a = 1;

				}
			progreso++;
			tiempo = 500000;
			}

		util.destroyProgressDialog()


		if (!util.sqlUpdate("pedidoscli","pedidoafinca",true,"idpedido = " + cursor.valueBuffer("idpedido")))
			MessageBox.warning(util.translate("scripts", "No se puede marcar como \"ya pedido a finca\". Pedido no editable"), MessageBox.Yes, MessageBox.No);
		}

	res = MessageBox.warning(util.translate("scripts", "Desea imprimir la orden de recogida?"), MessageBox.Yes, MessageBox.No);
		if (res == MessageBox.Yes)
			{
			whereFijo = "WHERE\npedidoscli.idpedido=" + cursor.valueBuffer("idpedido") + "\nUSER\n"+ idUsuario + "\nFECHA\n" + fecha + "\nHORA\n" + hora + "\n";
			flfactinfo.iface.pub_lanzarInforme(cursor, "i_carga_recogida","","",false,false,whereFijo);
			}

	if (pedir)
		if(!this.iface.actualizaRegistroCarga(cursor.valueBuffer("idpedido")))
			MessageBox.warning(util.translate("scripts", "Se ha producido un error al actualizar el registro de cargas"), MessageBox.Yes, MessageBox.No);

this.child("tableDBRecords").refresh()
}

function pedidosFincas_actualizaRegistroCarga(pedido:Number):Boolean
{

	var util:FLUtil;
	//debug("Actualizando registro " + pedido);
	var qryCarga:FLSqlQuery = new FLSqlQuery();
	qryCarga.setTablesList("lineaspedidoscli");
	qryCarga.setSelect("codfinca,referencia,descripcion,cantidad");
	qryCarga.setFrom("lineaspedidoscli");
	qryCarga.setWhere("idpedido = " + pedido);

	if (!qryCarga.exec()) {
		MessageBox.warning(util.translate("scripts", "El pedido no contiene lineas"), MessageBox.Yes, MessageBox.No);
		return false;
		}
	var cursorReg:FLSqlCursor = new FLSqlCursor("reg_pedidos_fincas");
	var hoy:Date = new Date();
	fecha = hoy.toString();
	hora = hoy.toString().right(8);
	idUsuario = sys.nameUser();

	while (qryCarga.next()) {
	cursorReg.setModeAccess(cursorReg.Insert);
	//debug("Insertando linea en " + qryCarga.value(0));
	cursorReg.refreshBuffer();
	cursorReg.setValueBuffer("idpedido",pedido);
	cursorReg.setValueBuffer("codfinca",qryCarga.value(0));
	cursorReg.setValueBuffer("referencia",qryCarga.value(1));
	cursorReg.setValueBuffer("descripcion",qryCarga.value(2));
	cursorReg.setValueBuffer("cantidad",qryCarga.value(3));
	cursorReg.setValueBuffer("fecha",fecha);
	cursorReg.setValueBuffer("hora",hora);
	cursorReg.setValueBuffer("idusuario",idUsuario);
	if (!cursorReg.commitBuffer()) {
		return false;
		}
	}
return true;

}
//// PEDIDOS_FINCAS /////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition lasCunas */
/////////////////////////////////////////////////////////////////
//// LAS_CUNAS //////////////////////////////////////////////////

function lasCunas_init()
{

	var _i = this.iface;

	_i.__init();
	this.iface.filtroOriginal = this.iface.tdbRecords.cursor().mainFilter();
	connect(this.child("cb_reservas"), "clicked()", this, "iface.mostrar_reservas_albaranables");
	this.iface.mostrar_reservas_albaranables();
}

function lasCunas_datosAlbaran(curPedido:FLSqlCursor, where:String, datosAgrupacion:Array):Boolean
{
	if (!this.iface.__datosAlbaran(curPedido, where, datosAgrupacion))
		return false;

	this.iface.curAlbaran.setValueBuffer("idusuario", curPedido.valueBuffer("idusuario"));
	return true;
}

function lasCunas_mostrar_reservas_albaranables()
{
	var util:FLUtil = new FLUtil();
	var hoy:Date = new Date();
	var filtro:String = "idpedido IN (SELECT p.idpedido FROM pedidoscli p INNER JOIN lineaspedidoscli lp ON lp.idpedido = p.idpedido WHERE (lp.fecha_reserva <='" + hoy +"' AND NOT lp.totalenalbaran = lp.cantidad) OR (lp.fecha_reserva IS NULL AND NOT lp.totalenalbaran = lp.cantidad)) ";
	if (this.child("cb_reservas").checked) {
		debug("filtro reservas");
		if (this.iface.filtroOriginal && this.iface.filtroOriginal != "")
			this.iface.tdbRecords.cursor().setMainFilter(this.iface.filtroOriginal + " AND " + filtro);
		else
			this.iface.tdbRecords.cursor().setMainFilter(filtro);
	} else {
		debug("filtro normal");
		this.iface.tdbRecords.cursor().setMainFilter(this.iface.filtroOriginal);
	}

	this.iface.tdbRecords.refresh();
}

function lasCunas_datosLineaAlbaran(curLineaPedido:FLSqlCursor):Boolean
{
	if (!this.iface.__datosLineaAlbaran(curLineaPedido)) {
		return false;
	}
	with (this.iface.curLineaAlbaran) {
		setValueBuffer("lote", curLineaPedido.valueBuffer("lote"));
	}
	return true;
}

function lasCunas_pedirAFincas_clicked()
{
	//debug("YEAHHH");
	var util:FLUtil;
	var cursor:FLSqlCursor = this.cursor();
	if (!cursor)
		return false;


	var yapedido:Boolean = cursor.valueBuffer("pedidoafinca");
	var msg:String;
	var whereFijo:String="";
	var res:String;
	var pedir:Boolean = true;
	var hoy:Date = new Date();
	fecha = cursor.valueBuffer("fecha_carga").toString().left(10);
	idUsuario = sys.nameUser();
	var where_adicional:String = "";

	if (!yapedido)
		{
		msg = "Desea enviar el pedido a las fincas";
		}
	else
		{
		msg = "ESTE PEDIDO YA SE HA ENVIADO ANTERIORMENTE\n  desea volver a enviar el pedido a las fincas ?";
		}

	res = MessageBox.warning(util.translate("scripts", msg), MessageBox.Yes, MessageBox.No);
	if (res == MessageBox.No) {
		debug("Creando dialogo de seleccin de fincas");
		where_adicional = this.iface.seleccionarFincasPedido(cursor.valueBuffer("idpedido"));
		if(where_adicional == "") {
			pedir = false;
		}
        } else {
        	debug("Se pide a todas las fincas");
        }


	if (pedir)
		{
		if (util.sqlSelect("lineaspedidoscli", "idpedido", "idpedido = " + cursor.valueBuffer("idpedido") + " AND codfinca is NULL LIMIT 1"))
			{
			res = MessageBox.warning(util.translate("scripts", "Hay lineas sin especificar finca.\nDesea continuar?"), MessageBox.Yes, MessageBox.No);
			if (res == MessageBox.No)
				return false;
			}

		var qryCarga:FLSqlQuery = new FLSqlQuery();
		qryCarga.setTablesList("lineaspedidoscli");
		qryCarga.setSelect("DISTINCT codfinca");
		qryCarga.setFrom("lineaspedidoscli");
		qryCarga.setWhere("idpedido = " + cursor.valueBuffer("idpedido") + " AND NOT codfinca is NULL" + where_adicional);

		if (!qryCarga.exec()) {
			MessageBox.warning(util.translate("scripts", "No se ha especificado ninguna finca en ninguna linea"), MessageBox.Yes, MessageBox.No);
			return false;
		}

		util.createProgressDialog(util.translate("scripts", "Enviando ..."), qryCarga.size());
		var progreso = 0;
		var tiempo = 8000000; //primero mas lento para que arranque jasper.

		while (qryCarga.next()) {
			util.setLabelText("Pedido a " + qryCarga.value(0));
			util.setProgress(progreso);
			whereFijo = "WHERE\npedidoscli.idpedido=" + cursor.valueBuffer("idpedido") + " AND lineaspedidoscli.codfinca= '" + qryCarga.value(0) + "'\nUSER\n"+ idUsuario + "\nFECHA\n" + fecha + "\n";
			impresora = util.sqlSelect("fincas", "impresora", "codfinca = '" + qryCarga.value(0) + "'");
			if (impresora != "")
		 		flfactinfo.iface.pub_lanzarInforme(cursor, "i_carga","","",false,true,whereFijo,"i_carga",0,impresora,false);
			else
				{
				var msgImpresora:String = "No hay impresora especificada para la Finca " + qryCarga.value(0) + "\nSe omite la impresin";
				res = MessageBox.warning(util.translate("scripts", msgImpresora), MessageBox.Yes, MessageBox.No);
				}


			for (var i=0; i < tiempo; i++)
				{
				var a = 1;

				}
			progreso++;
			tiempo = 500000;
			}

		util.destroyProgressDialog()


		if (!util.sqlUpdate("pedidoscli","pedidoafinca",true,"idpedido = " + cursor.valueBuffer("idpedido")))
			MessageBox.warning(util.translate("scripts", "No se puede marcar como \"ya pedido a finca\". Pedido no editable"), MessageBox.Yes, MessageBox.No);
		}

	res = MessageBox.warning(util.translate("scripts", "Desea imprimir la orden de recogida?"), MessageBox.Yes, MessageBox.No);
		if (res == MessageBox.Yes)
			{
			whereFijo = "WHERE\npedidoscli.idpedido=" + cursor.valueBuffer("idpedido") + "\nUSER\n"+ idUsuario + "\nFECHA\n" + fecha + "\n";
			flfactinfo.iface.pub_lanzarInforme(cursor, "i_carga_recogida","","",false,false,whereFijo);
			}

	if (pedir)
		if(!this.iface.actualizaRegistroCarga(cursor.valueBuffer("idpedido")))
			MessageBox.warning(util.translate("scripts", "Se ha producido un error al actualizar el registro de cargas"), MessageBox.Yes, MessageBox.No);

this.child("tableDBRecords").refresh()
}
//// LAS_CUNAS //////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition ivaIncluido */
//////////////////////////////////////////////////////////////////
//// IVAINCLUIDO /////////////////////////////////////////////////////
/** \D Copia los datos de una lnea de pedido en una lnea de albarn
@param	curLineaPedido: Cursor que contiene los datos a incluir en la lnea de albarn
@return	True si la copia se realiza correctamente, false en caso contrario
\end */
function ivaIncluido_datosLineaAlbaran(curLineaPedido:FLSqlCursor):Boolean
{
	if (!this.iface.__datosLineaAlbaran(curLineaPedido)) {
		return false;
	}
	with (this.iface.curLineaAlbaran) {
		setValueBuffer("ivaincluido", curLineaPedido.valueBuffer("ivaincluido"));
		setValueBuffer("pvpunitarioiva", curLineaPedido.valueBuffer("pvpunitarioiva"));
	}
	/// El cambio puede deberse a que la fecha del nuevo documento est asociada a un tipo de IVA distinto del documento origens
	if (curLineaPedido.valueBuffer("iva") != this.iface.curLineaAlbaran.valueBuffer("iva")) {
		if (this.iface.curLineaAlbaran.valueBuffer("ivaincluido")) {
			this.iface.curLineaAlbaran.setValueBuffer("pvpunitario", formRecordlineaspedidoscli.iface.pub_commonCalculateField("pvpunitario2", this.iface.curLineaAlbaran));
			this.iface.curLineaAlbaran.setValueBuffer("pvpsindto", formRecordlineaspedidoscli.iface.pub_commonCalculateField("pvpsindto", this.iface.curLineaAlbaran));
			this.iface.curLineaAlbaran.setValueBuffer("pvptotal", formRecordlineaspedidoscli.iface.pub_commonCalculateField("pvptotal", this.iface.curLineaAlbaran));
		} else {
			this.iface.curLineaAlbaran.setValueBuffer("pvpunitarioiva", formRecordlineaspedidoscli.iface.pub_commonCalculateField("pvpunitarioiva2", this.iface.curLineaAlbaran));
		}
	}

	return true;
}

function ivaIncluido_totalesAlbaran():Boolean
{
	this.iface.__totalesAlbaran();

	// Comprobar redondeo y recalcular totales
	formRecordfacturascli.iface.comprobarRedondeoIVA(this.iface.curAlbaran, "idalbaran")
	with (this.iface.curAlbaran) {
		setValueBuffer("total", formpedidoscli.iface.pub_commonCalculateField("total", this));
		setValueBuffer("totaleuros", formpedidoscli.iface.pub_commonCalculateField("totaleuros", this));
	}
	return true;
}

//// IVAINCLUIDO /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition almacenLinea */
/////////////////////////////////////////////////////////////////
//// ALMACEN_LINEA //////////////////////////////////////////////
function almacenLinea_datosLineaAlbaran(curLineaPedido:FLSqlCursor):Boolean
{
	if (!this.iface.__datosLineaAlbaran(curLineaPedido)) {
		return false;
	}
	with (this.iface.curLineaAlbaran) {
		setValueBuffer("codalmacen", curLineaPedido.valueBuffer("codalmacen"));
	}
	return true;
}

function almacenLinea_comprobarStockEnAlbaranado(curLineaPedido:FLSqlCursor, cantidad:Number):Array
{
	var util:FLUtil = new FLUtil;
	var res:Array = [];

	res["haystock"] = true;
	res["cantidad"] = 0;
	res["ok"] = true;
	var referencia:String = curLineaPedido.valueBuffer("referencia");
	if (referencia && referencia != "") {
		var controlStock:Boolean = util.sqlSelect("articulos", "controlstock", "referencia = '" + referencia + "'");
		if (!controlStock) {
			var codAlmacen:String = curLineaPedido.valueBuffer("codalmacen");
			if (!codAlmacen || codAlmacen == "") {
				if (curLineaPedido.cursorRelation())
					codAlmacen = curLineaPedido.cursorRelation().valueBuffer("codalmacen");
				else
					codAlmacen = util.sqlSelect("pedidoscli", "codalmacen", "idpedido = " + curLineaPedido.valueBuffer("idpedido"));
			}
			//debug("codalmacen = " + codAlmacen);

			var cantidadStock:Number = parseFloat(util.sqlSelect("stocks", "cantidad", "referencia = '" + referencia + "' AND codalmacen = '" + codAlmacen + "'"));
			if (!cantidadStock || isNaN(cantidadStock))
				cantidadStock = 0;

			if (cantidadStock < cantidad) {
				res["haystock"] = false;
				if (!this.iface.ignorarAvisoStock_) {
					var resCuestion:Number = MessageBox.warning(util.translate("scripts", "El artículo %1 no permite ventas sin stocks.\nEstá albaranando más cantidad (%2) que la disponible (%3) ahora mismo en el almacén %4.\n¿Desea continuar dejando el pedido parcialmente albaranado?\n(pulse Ignorar para evitar esta pregunta en el resto de las líneas)").arg(referencia).arg(cantidad).arg(cantidadStock).arg(codAlmacen), MessageBox.No, MessageBox.Yes, MessageBox.Ignore);
					switch (resCuestion) {
						case MessageBox.Yes: {
							break;
						}
						case MessageBox.Ignore: {
							this.iface.ignorarAvisoStock_ = true;
							break;
						}
						default: {
							res["ok"] = false;
							return res;
						}
					}
				}
				if (cantidadStock < 0) {
					cantidadStock = 0;
				}
				res["cantidad"] = cantidadStock;
			}
		}
	}
	return res;
}
//// ALMACEN_LINEA //////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition stockUnificado */
/////////////////////////////////////////////////////////////////
//// STOCK_UNIFICADO ////////////////////////////////////////////
function stockUnificado_copiaLineas(idPedido:Number, idAlbaran:Number):Boolean
{
	var util:FLUtil = new FLUtil;
	var cantidad:Number;
	var totalEnAlbaran:Number;
	var hoy:Date = new Date();
	var conn:String = flfactalma.iface.recogeConnUnificada();
	this.iface.ignorarAvisoStock_ = false;
	var curLineaPedido:FLSqlCursor = new FLSqlCursor("lineaspedidoscli");
	curLineaPedido.select("idpedido = " + idPedido + " AND (cerrada = false or cerrada IS NULL) AND (fecha_reserva <= '" + hoy + "' OR fecha_reserva IS NULL)");
	while (curLineaPedido.next()) {
		curLineaPedido.setModeAccess(curLineaPedido.Browse);
		curLineaPedido.refreshBuffer();
		cantidad = parseFloat(curLineaPedido.valueBuffer("cantidad"));
		totalEnAlbaran = parseFloat(curLineaPedido.valueBuffer("totalenalbaran"));
		if (cantidad != totalEnAlbaran) { /// > cambiado por != para poder albaranar lÃÂ­neas con cantidad negativa
			if (!this.iface.copiaLineaPedido(curLineaPedido, idAlbaran)) {
				return false;
			}
		if ( curLineaPedido.valueBuffer("fecha_reserva") <= hoy)
			{
			debug("Borrando reserva DB: " +  aqApp.db().database() + " LINEA: " +  curLineaPedido.valueBuffer("idlinea") + " FECHA: " + curLineaPedido.valueBuffer("fecha_reserva"));
			util.sqlDelete("vlc_reservas","idlinea = " + curLineaPedido.valueBuffer("idlinea") +" AND database='" + aqApp.db().database() +"'", conn);
			}
		}
	}
	return true;
}

//// STOCK_UNIFICADO ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

