/***************************************************************************
                 factalma_general.qs  -  description
                             -------------------
    begin                : mie nov 23 2005
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
	var ctx:Object;
	function interna( context ) { this.ctx = context; }
	function main() {
		this.ctx.interna_main();
	}
	function init() {
		this.ctx.interna_init();
	}
	function calculateField(fN:String):String {
		return this.ctx.interna_calculateField(fN);
	}
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
	function oficial( context ) { interna( context ); }
	function bufferChanged(fN:String) {
		return this.ctx.oficial_bufferChanged(fN);
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration jasperPlugin */
//////////////////////////////////////////////////////////////////
//// JASPER_PLUGIN ///////////////////////////////////////////////
class jasperPlugin extends oficial /** %from: oficial */ {
    function jasperPlugin( context ) { oficial( context ); }
    function init() {
        return this.ctx.jasperPlugin_init();
    }
    function seteaPath() {
            return this.ctx.jasperPlugin_seteaPath();
     }
    function seteaPlugin() {
            return this.ctx.jasperPlugin_seteaPlugin();
     }
    function testJava() {
            return this.ctx.jasperPlugin_testJava();
     }
    function testPlugin() {
            return this.ctx.jasperPlugin_testPlugin();
     }
     function checkRT() {
            return this.ctx.jasperPlugin_checkRT();
     }
     function checkCompilar() {
            return this.ctx.jasperPlugin_checkCompilar();
     }
     function checkGuardaTemporal() {
            return this.ctx.jasperPlugin_checkGuardaTemporal();
     }
     function fixPath(ruta:String):String {
            return this.ctx.jasperPlugin_fixPath(ruta);
    }
    function guardaCodificacion() {
            return this.ctx.jasperPlugin_guardaCodificacion();
     }
    function guardaMaxJVM() {
            return this.ctx.jasperPlugin_guardaMaxJVM();
     }
    }

//// JASPER_PLUGIN ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration cmrMini */
/////////////////////////////////////////////////////////////////
//// CMR_MINI ///////////////////////////////////////////////////
class cmrMini extends jasperPlugin /** %from: oficial */ {
    function cmrMini( context ) { jasperPlugin ( context ); }
    function init() {
    		this.ctx.cmrMini_init();
    	}
    function guardarImpresora():Boolean {
    		this.ctx.cmrMini_guardarImpresora();
    	}
}
//// CMR_MINI ///////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration impresoras */
/////////////////////////////////////////////////////////////////
//// IMPRESORAS /////////////////////////////////////////////////
class impresoras extends cmrMini /** %from: jasperPlugin */ {
	function impresoras( context ) { cmrMini ( context ); }
	function init() {
        return this.ctx.impresoras_init();
    }
	function guardaImpresora() {
            this.ctx.impresoras_guardaImpresora();
     }
	function muestraMiImpresora() {
            this.ctx.impresoras_muestraMiImpresora();
     }
}
//// IMPRESORAS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration documentoEnvioMail */
/////////////////////////////////////////////////////////////////
//// DOCUMENTO ENVIO MAIL ///////////////////////////////////////
class documentoEnvioMail extends impresoras /** %from: jasperPlugin */ {
    function documentoEnvioMail( context ) { impresoras ( context ); }

        function init() {
        return this.ctx.documentoEnvioMail_init();
    }

    	function seteaPresupuestosCli() {
    		this.ctx.documentoEnvioMail_seteaPresupuestosCli();
    }

        function seteaPedidosCli() {
    		this.ctx.documentoEnvioMail_seteaPedidosCli();
    }

        function seteaAlbaranesCli() {
    		this.ctx.documentoEnvioMail_seteaAlbaranesCli();
    }

        function seteaFacturasCli() {
    		this.ctx.documentoEnvioMail_seteaFacturasCli();
    }
}
//// DOCUMENTO ENVIO MAIL ///////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends documentoEnvioMail {
	function head( context ) { documentoEnvioMail ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
	function ifaceCtx( context ) { head( context ); }
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/**
\C Los datos generales son nicos, por tanto formulario de no presenta los botones de navegacin por registros.
\end

\D La gestin del formulario se hace de forma manual mediante el objeto f (FLFormSearchDB)
\end
\end */
function interna_main()
{
	var f:Object = new FLFormSearchDB("factinfo_general");
	var cursor:FLSqlCursor = f.cursor();

	cursor.select();
	if (!cursor.first())
		cursor.setModeAccess(cursor.Insert);
	else
		cursor.setModeAccess(cursor.Edit);

	f.setMainWidget();
	if (cursor.modeAccess() == cursor.Insert)
		f.child("pushButtonCancel").setDisabled(true);
	cursor.refreshBuffer();
	var commitOk:Boolean = false;
	var acpt:Boolean;
	cursor.transaction(false);
	while (!commitOk) {
		acpt = false;
		f.exec("id");
		acpt = f.accepted();
		if (!acpt) {
			if (cursor.rollback())
				commitOk = true;
		} else {
			if (cursor.commitBuffer()) {
				cursor.commit();
				commitOk = true;
			}
		}
		f.close();
	}
}

function interna_init()
{
	var util:FLUtil = new FLUtil;
	var cursor:FLSqlCursor = this.cursor();

	connect (cursor, "bufferChanged(QString)", this, "iface.bufferChanged");

}

function interna_calculateField(fN:String):String
{
	var util:FLUtil = new FLUtil;
	var cursor:FLSqlCursor = this.cursor();
	var valor:String;

	switch (fN) {
		case "x": {
			break;
		}
		default: {
			valor = this.iface.__calculateField(fN);
			break;
		}
	}

	return valor;
}

//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
function oficial_bufferChanged(fN:String)
{
	var util:FLUtil = new FLUtil;
	var cursor:FLSqlCursor = this.cursor();
	switch (fN) {
		case "X": {
			break;
		}
	}
}
//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition jasperPlugin */
//////////////////////////////////////////////////////////////////
//// JASPER_PLUGIN ///////////////////////////////////////////////
function jasperPlugin_init()
{
    var util:FLUtil = new FLUtil;
    connect(this.child("pbPath"), "clicked()", this, "iface.seteaPath");
    connect(this.child("pbJPlugin"), "clicked()", this, "iface.seteaPlugin");
    connect(this.child("pbJava"), "clicked()", this, "iface.testJava");
    connect(this.child("pbPlugin"), "clicked()", this, "iface.testPlugin");
    connect(this.child("chbRT"), "clicked()", this, "iface.checkRT");
    connect(this.child("chbCompilar"), "clicked()", this, "iface.checkCompilar");
    connect(this.child("chbGuardaTemporal"), "clicked()", this, "iface.checkGuardaTemporal");
    connect(this.child("cBCodificacion"), "activated(int)", this, "iface.guardaCodificacion");
    connect(this.child("leMaxJVM"), "textChanged(QString)", this, "iface.guardaMaxJVM");;
    this.child("lnJPlugin").text = util.readSettingEntry("jasperplugin/pluginpath");
    this.child("lnJPlugin").setEnabled(false);
    this.child("lnPath").text = util.readSettingEntry("jasperplugin/reportspath");
    this.child("lnPath").setEnabled(false);
    this.child("leMaxJVM").text = util.readSettingEntry("jasperplugin/MaxJVM");
    this.child("chbRT").checked = util.readSettingEntry("jasperplugin/detecRT");
    this.child("chbGuardaTemporal").checked = util.readSettingEntry("jasperplugin/guardatemporal");
    this.child("chbCompilar").checked = util.readSettingEntry("jasperplugin/compilarSiempre");
    this.child("cBCodificacion").currentItem = util.readSettingEntry("jasperplugin/codificacion");
    this.iface.__init();
}
function jasperPlugin_seteaPath()
{
    var util:FLUtil = new FLUtil;
    var dirBasePath = this.iface.fixPath(FileDialog.getExistingDirectory(Dir.home));

    if (!dirBasePath)
    return;
    this.child("lnPath").text = dirBasePath;
    util.writeSettingEntry("jasperplugin/reportspath",dirBasePath);
}
function jasperPlugin_seteaPlugin()
{
    var util:FLUtil = new FLUtil;
    var dirBasePath = this.iface.fixPath(FileDialog.getExistingDirectory(Dir.home));

    if (!dirBasePath)
    return;
    this.child("lnJPlugin").text = dirBasePath;
    util.writeSettingEntry("jasperplugin/pluginpath",dirBasePath);
}
function jasperPlugin_testJava()
{
    var util:FLUtil = new FLUtil;
    var resultado:Array = flfactppal.iface.pub_ejecutarComandoAsincrono("java -version");
        MessageBox.information(util.translate("scripts", resultado["salida"]), MessageBox.Ok);
}
function jasperPlugin_testPlugin()
{
    var util:FLUtil = new FLUtil;
    var ruta:String = this.child("lnJPlugin").text + "enebooreports.jar";
    if (File.exists(ruta))
    	{
    	if (flfactinfo.iface.procesoInicializado)
    		{
    		flfactinfo.iface.procesoJP.kill();
    		flfactinfo.iface.procesoInicializado = false;
    		}
    	flfactinfo.iface.pub_lanzarInforme(this.cursor(), "version","", "", false, false,"","","","",false);
        }
     else MessageBox.information(util.translate("scripts", " Ruta incorrecta !! \n " + ruta), MessageBox.Ok);
}
function jasperPlugin_checkRT()
{
   var util:FLUtil = new FLUtil;
   var pulsado:Boolean = false;
   if (this.child("chbRT").checked) pulsado = true;
  //debug ("JASPER_PLUGIN :: Guardando checkRT = " + pulsado);
   util.writeSettingEntry("jasperplugin/detecRT",pulsado);
}
function jasperPlugin_checkCompilar()
{
   var util:FLUtil = new FLUtil;
   var pulsado:Boolean = false;
   if (this.child("chbCompilar").checked) pulsado = true;
  //debug ("JASPER_PLUGIN :: Guardando checkCompilar = " + pulsado);
   util.writeSettingEntry("jasperplugin/compilarSiempre",pulsado);
}
function jasperPlugin_checkGuardaTemporal()
{
   var util:FLUtil = new FLUtil;
   var pulsado:Boolean = false;
   if (this.child("chbGuardaTemporal").checked) pulsado = true;
   util.writeSettingEntry("jasperplugin/guardatemporal",pulsado);
}
function jasperPlugin_fixPath(ruta:String):String
{
var rutaFixed:String;
    if (sys.osName() == "WIN32")
            {
           var barra = "\\";
        while (ruta != rutaFixed)
                    {
                    rutaFixed = ruta;
                    ruta = ruta.replace("/",barra);
                    }
        if (!rutaFixed.endsWith(barra)) rutaFixed +="\\";
            } else
                rutaFixed= ruta;
return rutaFixed;
}
function jasperPlugin_guardaCodificacion()
{
   var util:FLUtil = new FLUtil;
   util.writeSettingEntry("jasperplugin/codificacion",this.child("cBCodificacion").currentItem);
}

function jasperPlugin_guardaMaxJVM()
{
   var util:FLUtil = new FLUtil;
   util.writeSettingEntry("jasperplugin/MaxJVM",this.child("leMaxJVM").text);
}
//// JASPER_PLUGIN ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition cmrMini */
/////////////////////////////////////////////////////////////////
//// CMR_MINI ///////////////////////////////////////////////////
function cmrMini_init()
{
	var util:FLUtil = new FLUtil;
	this.iface.__init();
	this.child("lnImpresora").text = util.readSettingEntry("cmr/rutaImpresora","");
	this.child("lnImpresora").setEnabled(false);
	connect(this.child("pbnCMR"), "clicked()", this, "iface.guardarImpresora");
}

function cmrMini_guardarImpresora():Boolean
{
	var util:FLUtil = new FLUtil;
	var Impresora:String = Input.getText( util.translate("scripts", "Escribe la impresroa a usar") );
	util.writeSettingEntry("cmr/rutaImpresora",Impresora);
	this.child("lnImpresora").text = Impresora;
}
//// CMR_MINI ///////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition impresoras */
/////////////////////////////////////////////////////////////////
//// IMPRESORAS /////////////////////////////////////////////////
function impresoras_init()
{
this.iface.__init();
var tdbImpresoras = this.child("tdbImpresoras");
connect(this.child("pbGuardar"), "clicked()", this, "iface.guardaImpresora");
connect (tdbImpresoras, "currentChanged()", this, "iface.muestraMiImpresora");
}

function impresoras_guardaImpresora()
{
var util:FLUtil = new FLUtil;
var cursor:FLSqlCursor = this.child("tdbImpresoras").cursor();
util.writeSettingEntry("impresoras/" + cursor.valueBuffer("codigo"),this.child("leImpresora").text);
MessageBox.information(util.translate("scripts", " Impresora guardada !\n " + cursor.valueBuffer("codigo") + " --> " + this.child("leImpresora").text), MessageBox.Ok);
}

function impresoras_muestraMiImpresora()
{
var cursor:FLSqlCursor = this.child("tdbImpresoras").cursor();
var util:FLUtil = new FLUtil();
this.child("leImpresora").text = util.readSettingEntry("impresoras/" + cursor.valueBuffer("codigo"));
}
//// IMPRESORAS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition documentoEnvioMail */
/////////////////////////////////////////////////////////////////
//// DOCUMENTO ENVIO MAIL ///////////////////////////////////////
function documentoEnvioMail_init() {
	this.iface.__init();

	connect(this.child("pbPresupuestosCli"), "clicked()", this, "iface.seteaPresupuestosCli");
	connect(this.child("pbPedidosCli"), "clicked()", this, "iface.seteaPedidosCli");
	connect(this.child("pbAlbaranesCli"), "clicked()", this, "iface.seteaAlbaranesCli");
	connect(this.child("pbFacturasCli"), "clicked()", this, "iface.seteaFacturasCli");

}

function documentoEnvioMail_seteaPresupuestosCli() {
	var cursor = this.cursor();

	cursor.setValueBuffer("envio_mail_presupuestoscli", flfactinfo.iface.selectorReport("i_presupuestoscli"));
}

function documentoEnvioMail_seteaPedidosCli() {
	var cursor = this.cursor();

	cursor.setValueBuffer("envio_mail_pedidoscli", flfactinfo.iface.selectorReport("i_pedidoscli"));
}
function documentoEnvioMail_seteaAlbaranesCli() {
	var cursor = this.cursor();

	cursor.setValueBuffer("envio_mail_albaranescli", flfactinfo.iface.selectorReport("i_albaranescli"));
}
function documentoEnvioMail_seteaFacturasCli() {
	var cursor = this.cursor();

	cursor.setValueBuffer("envio_mail_facturascli", flfactinfo.iface.selectorReport("i_facturascli"));
}

//// DOCUMENTO ENVIO MAIL ///////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

