/***************************************************************************
                 i_masterclientes.qs  -  description
                             -------------------
    begin                : mar jun 27 2006
    copyright            : (C) 2006 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); }
	function lanzar() {
		return this.ctx.oficial_lanzar();
	}
	function obtenerParamInforme():Array {
		return this.ctx.oficial_obtenerParamInforme();
	}
	function obtenerOrden(nivel:Number, cursor:FLSqlCursor):String {
		return this.ctx.oficial_obtenerOrden(nivel, cursor);
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration listadoCliPro */
/////////////////////////////////////////////////////////////////
//// ENVIO MAIL /////////////////////////////////////////////////
class listadoCliPro extends oficial /** %from: oficial */ {
    function listadoCliPro( context ) { oficial ( context ); }
	function init() {
		return this.ctx.listadoCliPro_init();
	}
	function enviarDocumento(codCliente:String) {
		return this.ctx.listadoCliPro_enviarDocumento(codCliente);
	}
}
//// ENVIO MAIL /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends listadoCliPro {
    function head( context ) { listadoCliPro ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
function interna_init()
{
	connect (this.child("toolButtonPrint"), "clicked()", this, "iface.lanzar()");
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
function oficial_lanzar()
{
	var cursor:FLSqlCursor = this.cursor();

	var pI = this.iface.obtenerParamInforme();
	if (!pI)
		return;

	flfactinfo.iface.pub_establecerId(cursor.valueBuffer("id"));
	flfactinfo.iface.pub_lanzarInforme(cursor, pI.nombreInforme, pI.orderBy, pI.groupBy, pI.etiquetas, pI.impDirecta, pI.whereFijo, pI.nombreReport);
}

/** \D Obtiene un array con los parmetros necesarios para establecer el informe
@return	array de parmetros o false si hay error
\end */
function oficial_obtenerParamInforme():Array
{
	var paramInforme:Array = [];
	paramInforme["nombreInforme"] = false;
	paramInforme["orderBy"] = "";
	paramInforme["groupBy"] = false;
	paramInforme["etiquetas"] = false;
	paramInforme["impDirecta"] = false;
	paramInforme["whereFijo"] = false;
	paramInforme["nombreReport"] = false;
	paramInforme["numCopias"] = false;

	var cursor:FLSqlCursor = this.cursor();
	var seleccion:String = cursor.valueBuffer("id");
	if (!seleccion)
		return;

	paramInforme.nombreInforme = cursor.action();

	if (cursor.valueBuffer("agruparxgrupo")) {
		paramInforme.nombreInforme = "i_clientesxgrupo";
		paramInforme.orderBy = "clientes.codgrupo";
	}
	if (cursor.valueBuffer("agruparxagente")) {
		paramInforme.nombreInforme = "i_clientesxagente";
		paramInforme.orderBy = "clientes.codagente";
	}

	paramInforme.whereFijo = "dirclientes.domfacturacion = true";

	var orderBy:String = "";
	var o:String = "";
	for (var i:Number = 1; i <= 3; i++) {
		o = this.iface.obtenerOrden(i, cursor);
		if (o) {
			if (orderBy == "")
				orderBy = o;
			else
				orderBy += ", " + o;
		}
	}

	if (paramInforme.orderBy && orderBy)
		paramInforme.orderBy += ", ";

	paramInforme.orderBy += orderBy;
	return paramInforme;
}

function oficial_obtenerOrden(nivel:Number, cursor:FLSqlCursor):String
{
	var util:FLUtil = new FLUtil;
	var ret:String = "";
	var orden:String = cursor.valueBuffer("orden" + nivel.toString());

	switch (orden) {
		case util.translate("scripts","Cod. cliente"):
				ret += "clientes.codcliente";
				break;
		case util.translate("scripts","Cliente"):
				ret += "clientes.nombre";
				break;
		case util.translate("scripts","Poblacin"):
				ret += "dirclientes.ciudad";
				break;
		case util.translate("scripts","Provincia"):
				ret += "dirclientes.provincia";
				break;
		case util.translate("scripts","Pas"):
				ret += "dirclientes.codpais";
				break;
		case util.translate("scripts","Cod.Postal"):
				ret += "dirclientes.codpostal";
				break;
	}

	if (ret != "") {
			var tipoOrden:String = cursor.valueBuffer("tipoorden" + nivel.toString());
			if (tipoOrden == util.translate("scripts","Descendente"))
					ret += " DESC";
	}
	return ret;
}

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition listadoCliPro */
/////////////////////////////////////////////////////////////////
//// ENVIO MAIL /////////////////////////////////////////////////
function listadoCliPro_init()
{
	this.iface.__init();
	//this.child("tbnEnviarMail").close();
	connect(this.child("tbnEnviarMail"), "clicked()", this, "iface.enviarDocumento()");
}

function listadoCliPro_enviarDocumento(codCliente:String)
{
	var cursor:FLSqlCursor = this.cursor();
	var util:FLUtil = new FLUtil();
	var descripcion:String = cursor.valueBuffer("descripcion");
	var informe:String="Los siguietes clientes no se han procesado :";
	var numDest:Number = 0;
	var incidencias:Boolean = false;
	var arrayDest:Array = [];



	var rutaIntermedia:String = util.readSettingEntry("scripts/flfactinfo/dirCorreo");
	if (!rutaIntermedia.endsWith("/")) {
		rutaIntermedia += "/";
	}

	var cuerpo:String = "";
	var asunto:String = util.translate("scripts", "COMUNICADO %1").arg(descripcion);


		if (!cursor.isValid()) {
			return;
		}

// Establecer consulta ...
	var consulta:FLSqlQuery;
	consulta = flfactinfo.iface.pub_establecerConsulta(cursor,"i_clientes","","","dirclientes.domfacturacion AND NOT clientes.debaja");

	if (consulta.exec() == false) {
	return;
	}
		//Repaso la query recogiendo correos_electrnicos

	if (consulta.first())
		do {
//			debug("Procesando a ... " + consulta.value("clientes.nombre"));

			if (consulta.value("clientes.email") == "" || consulta.value("clientes.email").find("@") == -1 )
				{
				informe += "\n" + consulta.value("clientes.codcliente") + " - " + consulta.value("clientes.nombre") + ".";
				incidencias = true;
				}
			else
		    		{
//		    		debug(consulta.value("clientes.email"));
		   		 arrayDest[numDest] = [];
		   		 arrayDest[numDest]["tipo"] = "bcc";
		   		 arrayDest[numDest]["direccion"] = consulta.value("clientes.email");
		    		 numDest ++;
		    		}

		} while (consulta.next());


	if (numDest < 0)
		return;
	if (incidencias)
		MessageBox.warning(util.translate("scripts", informe), MessageBox.Ok, MessageBox.NoButton);

	var arrayAttach:Array = [];
	arrayAttach[0] = "";

	flfactppal.iface.pub_enviarCorreo(cuerpo, asunto, arrayDest, arrayAttach);
}

//// ENVIO MAIL /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

