/***************************************************************************
                 i_masterfacturascli.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); }
	function lanzar() {
		return this.ctx.oficial_lanzar();
	}
	function obtenerParamInforme():Array {
		return this.ctx.oficial_obtenerParamInforme();
	}
	function facturaRectificada(nodo:FLDomNode, campo:String):String {
		return this.ctx.oficial_facturaRectificada(nodo,campo);
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration infoPendientes */
/////////////////////////////////////////////////////////////////
//// INFO_PENDIENTES ////////////////////////////////////////////
class infoPendientes extends oficial /** %from: oficial */ {
    function infoPendientes( context ) { oficial ( context ); }
    function obtenerParamInforme():Array {
		return this.ctx.infoPendientes_obtenerParamInforme();
	}
}
//// INFO_PENDIENTES ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration filtroDomiciliado */
/////////////////////////////////////////////////////////////////
//// FILTRO_DOMICILIADO /////////////////////////////////////////
class filtroDomiciliado extends infoPendientes /** %from: oficial */ {
    function filtroDomiciliado( context ) { infoPendientes ( context ); }
    function obtenerParamInforme():Array {
		return this.ctx.filtroDomiciliado_obtenerParamInforme();
	}

}
//// FILTRO_DOMICILIADO /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration envioMail */
/////////////////////////////////////////////////////////////////
//// ENVIO MAIL /////////////////////////////////////////////////
class envioMail extends filtroDomiciliado /** %from: oficial */ {
    function envioMail( context ) { filtroDomiciliado ( context ); }
	function init() {
		return this.ctx.envioMail_init();
	}
	function enviarDocumento() {
		return this.ctx.envioMail_enviarDocumento();
	}
}
//// ENVIO MAIL /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration creycau */
/////////////////////////////////////////////////////////////////
//// CREDITO Y CAUCION //////////////////////////////////////////
class creycau extends envioMail /** %from: oficial */ {
    function creycau( context ) { envioMail ( context ); }
    function obtenerParamInforme():Array {
	return this.ctx.creycau_obtenerParamInforme();
	}
}
//// CREDITO Y CAUCION //////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends creycau {
    function head( context ) { creycau ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
	function pub_facturaRectificada(nodo:FLDomNode, campo:String):String {
		return this.facturaRectificada(nodo, campo);
	}
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
function interna_init()
{
	connect (this.child("toolButtonPrint"), "clicked()", this, "iface.lanzar()");
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
function oficial_lanzar()
{
	var cursor:FLSqlCursor = this.cursor();
	var pI = this.iface.obtenerParamInforme();
	if (!pI) {
		return;
	}

	flfactinfo.iface.pub_lanzarInforme(cursor, pI.nombreInforme, pI.orderBy, "", false, false, pI.whereFijo,"",0,"",false);
}

/** \D Obtiene un array con los parmetros necesarios para establecer el informe
@return	array de parmetros o false si hay error
\end */
function oficial_obtenerParamInforme():Array
{
	var paramInforme:Array = [];
	paramInforme["nombreInforme"] = false;
	paramInforme["orderBy"] = false;
	paramInforme["groupBy"] = false;
	paramInforme["etiquetas"] = false;
	paramInforme["impDirecta"] = false;
	paramInforme["whereFijo"] = false;
	paramInforme["nombreReport"] = false;
	paramInforme["numCopias"] = false;

	var cursor:FLSqlCursor = this.cursor();
	var seleccion:String = cursor.valueBuffer("id");
	if (!seleccion)
		return false;
	paramInforme.nombreInforme = cursor.action();
	paramInforme.orderBy = "";
	var o:String = "";
	for (var i:Number = 1; i < 3; i++) {
		o = formi_albaranescli.iface.pub_obtenerOrden(i, cursor, "facturascli");
		if (o) {
			if (paramInforme.orderBy == "")
				paramInforme.orderBy = o;
			else
				paramInforme.orderBy += ", " + o;
		}
	}

	if(paramInforme.nombreInforme != "i_resfacturascli") {
		if (paramInforme.orderBy)
			paramInforme.orderBy += ",";
		paramInforme.orderBy += " lineasfacturascli.idalbaran, lineasfacturascli.referencia, lineasfacturascli.idlinea";
	}

	if (cursor.valueBuffer("codintervalo")) {
		var intervalo:Array = [];
		intervalo = flfactppal.iface.pub_calcularIntervalo(cursor.valueBuffer("codintervalo"));
		cursor.setValueBuffer("d_facturascli_fecha", intervalo.desde);
		cursor.setValueBuffer("h_facturascli_fecha", intervalo.hasta);
	}

	var where:String = "";
	if (cursor.valueBuffer("deabono")) {
		where = "facturascli.deabono";
	}
	if (cursor.valueBuffer("filtrarimportes")) {
		if (!cursor.isNull("desdeimporte")) {
			if (where != "") {
				where += " AND ";
			}
			where += "facturascli.total >= " + cursor.valueBuffer("desdeimporte");
		}
		if (!cursor.isNull("hastaimporte")) {
			if (where != "") {
				where += " AND ";
			}
			where += "facturascli.total <= " + cursor.valueBuffer("hastaimporte");
		}
	}
	paramInforme.whereFijo = where;

	return paramInforme;
}

function oficial_facturaRectificada(nodo:FLDomNode, campo:String):String
{
	var util:FLUtil = new FLUtil;
	var idFacturaRect:String = nodo.attributeValue("facturascli.idfacturarect");
	var coFacturaRect:String = util.sqlSelect("facturascli", "codigo", "idfactura = " + idFacturaRect);
	if (coFacturaRect)
		return util.translate("scripts", "**** Rectifica a la factura %1 ****").arg(coFacturaRect);
	else
		return "";
}
//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition infoPendientes */
/////////////////////////////////////////////////////////////////
//// INFO_PENDIENTES ////////////////////////////////////////////
function infoPendientes_obtenerParamInforme():Array
{
	var paramInforme:Array = [];
	paramInforme["nombreInforme"] = false;
	paramInforme["orderBy"] = false;
	paramInforme["groupBy"] = false;
	paramInforme["etiquetas"] = false;
	paramInforme["impDirecta"] = false;
	paramInforme["whereFijo"] = false;
	paramInforme["nombreReport"] = false;
	paramInforme["numCopias"] = false;

	var cursor:FLSqlCursor = this.cursor();
	var seleccion:String = cursor.valueBuffer("id");
	if (!seleccion)
		return false;
	paramInforme.nombreInforme = cursor.action();
	paramInforme.orderBy = "";
	var o:String = "";
	for (var i:Number = 1; i < 3; i++) {
		o = formi_albaranescli.iface.pub_obtenerOrden(i, cursor, "facturascli");
		if (o) {
			if (paramInforme.orderBy == "")
				paramInforme.orderBy = o;
			else
				paramInforme.orderBy += ", " + o;
		}
	}

	if(paramInforme.nombreInforme != "i_resfacturascli") {
		if (paramInforme.orderBy)
			paramInforme.orderBy += ",";
		paramInforme.orderBy += " lineasfacturascli.idalbaran, lineasfacturascli.referencia, lineasfacturascli.idlinea";
	}

	if (cursor.valueBuffer("codintervalo")) {
		var intervalo:Array = [];
		intervalo = flfactppal.iface.pub_calcularIntervalo(cursor.valueBuffer("codintervalo"));
		cursor.setValueBuffer("d_facturascli_fecha", intervalo.desde);
		cursor.setValueBuffer("h_facturascli_fecha", intervalo.hasta);
	}

	var where:String = "";
	if (cursor.valueBuffer("deabono")) {
		where = "facturascli.deabono";
	}
	if (cursor.valueBuffer("filtrarimportes")) {
		if (!cursor.isNull("desdeimporte")) {
			if (where != "") {
				where += " AND ";
			}
			where += "facturascli.total >= " + cursor.valueBuffer("desdeimporte");
		}
		if (!cursor.isNull("hastaimporte")) {
			if (where != "") {
				where += " AND ";
			}
			where += "facturascli.total <= " + cursor.valueBuffer("hastaimporte");
		}
	}

	var pendiente:String;
	if (cursor.valueBuffer("pendiente") == "S")
		pendiente = "facturascli.idfactura IN ( SELECT idfactura FROM reciboscli WHERE NOT estado = 'Pagado')";

	if (cursor.valueBuffer("pendiente") == "No")
		pendiente = "facturascli.idfactura NOT IN ( SELECT idfactura FROM reciboscli WHERE NOT estado = 'Pagado')";

	if (where != "") {
				where += " AND ";
			}
			where += pendiente;


	paramInforme.whereFijo = where;

	return paramInforme;
}
//// INFO_PENDIENTES ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition filtroDomiciliado */
/////////////////////////////////////////////////////////////////
//// FILTRO_DOMICILIADO /////////////////////////////////////////

function filtroDomiciliado_obtenerParamInforme():Array
{
 var cursor:FLSqlCursor = this.cursor();
 var paramInforme:Array = this.iface.__obtenerParamInforme();
 var coletilla:String;

 	if (cursor.valueBuffer("domiciliados") == "S")
 		 coletilla = "formaspago.codpago IN (select formaspago.codpago FROM formaspago WHERE formaspago.domiciliado = 'true')";
 	else if (cursor.valueBuffer("domiciliados") == "No")
 		 coletilla = "formaspago.codpago NOT IN (select formaspago.codpago FROM formaspago WHERE formaspago.domiciliado = 'true')";

 if (paramInforme["whereFijo"] =="" && coletilla != "")
 	paramInforme["whereFijo"] = coletilla;
 else if (paramInforme["whereFijo"] !="" && coletilla !="")
 	paramInforme["whereFijo"] = paramInforme["whereFijo"] + " AND " + coletilla;

//debug("Retornando wherefijo = " + paramInforme["whereFijo"]);
 return paramInforme;

}

//// FILTRO_DOMICILIADO /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

//// FILTRO_DOMICILIADO /////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition envioMail */
/////////////////////////////////////////////////////////////////
//// ENVIO MAIL /////////////////////////////////////////////////
function envioMail_init()
{
	this.iface.__init();
	connect(this.child("tbnEnviarMail"), "clicked()", this, "iface.enviarDocumento()");
}

function envioMail_enviarDocumento()
{

	var cursor:FLSqlCursor = this.cursor();
	var util:FLUtil = new FLUtil();

	if (!cursor.isValid()) {
			return;
		}

	var pI = this.iface.obtenerParamInforme();
	if (!pI) {
		return;
	}

	var codCliente:String = cursor.valueBuffer("i_facturascli_codcliente");

	var tabla:String = "clientes";
	var emailCliente:String = flfactppal.iface.pub_componerListaDestinatarios(codCliente, tabla);
	if (!emailCliente && !util.sqlSelect("empresa","nodestinatario","1 = 1") ) {
		return;
	}

	var rutaIntermedia:String = util.readSettingEntry("scripts/flfactinfo/dirCorreo");
	if (!rutaIntermedia.endsWith("/")) {
		rutaIntermedia += "/";
	}

	var cuerpo:String = "";
	var asunto:String = util.translate("scripts", "Listado de Facturas");
	var rutaDocumento:String = rutaIntermedia + "F_" + codCliente + ".pdf";

	var numCopias:Number = 1;


	var arrayDest:Array = [];
	arrayDest[0] = [];
	arrayDest[0]["tipo"] = "to";
	arrayDest[0]["direccion"] = emailCliente;

	var arrayAttach:Array = [];
	arrayAttach[0] = rutaDocumento;

	debug("****" + arrayDest + " " + arrayAttach);
	flfactppal.iface.pub_enviarCorreo(cuerpo, asunto, arrayDest, arrayAttach);

//	flfactinfo.iface.pub_lanzarInforme(cursor, cursor.action(), "", "", false, false, whereFijo, cursor.action(), 1, rutaDocumento, true);

	flfactinfo.iface.pub_lanzarInforme(cursor, pI.nombreInforme, pI.orderBy, "", false, false, pI.whereFijo,pI.nombreInforme,1,rutaDocumento, true );

}
//// ENVIO MAIL /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition creycau */
/////////////////////////////////////////////////////////////////
//// CREDITO Y CAUCION //////////////////////////////////////////
function creycau_obtenerParamInforme():Array
{
var cursor:FLSqlCursor = this.cursor();
var paramInforme:Array = this.iface.__obtenerParamInforme();
var whereFijo:String = "";

       if (cursor.valueBuffer("creycau") == "S")
           whereFijo= "clientes.creycau";

    if (cursor.valueBuffer("creycau") == "No")
           whereFijo= "NOT clientes.creycau";

    if (paramInforme.whereFijo != "" && whereFijo != "" ) {
                whereFijo = " AND " + whereFijo;
            }

    paramInforme.whereFijo += whereFijo;

    return paramInforme;
}
//// CREDITO Y CAUCION //////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

