/***************************************************************************
                 dirclientes.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() {
                this.ctx.interna_init();
        }
        function calculateField(fN:String):String {
                return this.ctx.interna_calculateField(fN);
        }
        function validateForm():Boolean {
                return this.ctx.interna_validateForm();
        }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
        var bloqueoProvincia:Boolean = false;
    function oficial( context ) { interna( context ); }
        function bufferChanged(fN:String) {
                return this.ctx.oficial_bufferChanged(fN);
        }
        function comprobarCPProvincia():Boolean {
                return this.ctx.oficial_comprobarCPProvincia();
        }
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration noCheckCp */
//////////////////////////////////////////////////////////////////
//// NOCHECKCP ///////////////////////////////////////////////////
class noCheckCp extends oficial /** %from: oficial */ {
    function noCheckCp( context ) { oficial( context ); }
        function validateForm():Boolean {
                return this.ctx.noCheckCp_validateForm();
        }
}
//// NOCHECKCP ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration controlPoblacion */
//////////////////////////////////////////////////////////////////
//// CONTROL_POBLACION ///////////////////////////////////////////
class controlPoblacion extends noCheckCp /** %from: oficial */ {
    function controlPoblacion( context ) { noCheckCp( context ); }
    function bufferChanged(fN:String) {
                return this.ctx.controlPoblacion_bufferChanged(fN);
        }
    function calculateField(fN:String):String {
                return this.ctx.controlPoblacion_calculateField(fN);
        }
}

//// CONTROL_POBLACION ///////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends controlPoblacion {
    function head( context ) { controlPoblacion ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
}


//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

const iface = new ifaceCtx( this );

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C Si en la tabla de direcciones de clientes no hay todava ninguna direccin asociada al cliente, la primera direccin introducida se tomar como direccin de facturacin y direccin de envo
\end */
function interna_init()
{
        var cursor:FLSqlCursor = this.cursor();
        if (cursor.modeAccess() == cursor.Insert) {
                var cursorCli:FLSqlCursor = new FLSqlCursor("dirclientes");
                cursorCli.select("codcliente = '" + cursor.valueBuffer("codcliente") + "'");
                if (!cursorCli.first()){
                        cursor.setValueBuffer("domenvio", "true");
                        cursor.setValueBuffer("domfacturacion", "true");
                }
        }
        connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
}

function interna_calculateField(fN:String):String
{
        var util:FLUtil = new FLUtil;
        var cursor:FLSqlCursor = this.cursor();
        var valor:String;

        return valor;
}

function interna_validateForm():Boolean
{
        var util:FLUtil = new FLUtil;
        var cursor:FLSqlCursor = this.cursor();

        if (!this.iface.comprobarCPProvincia()) {
                return false;
        }

        if (!flfactppal.iface.pub_validarProvincia(cursor)) {
                return false;
        }

        return true;
}

//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
function oficial_bufferChanged(fN:String)
{
        var util:FLUtil = new FLUtil();
        var cursor:FLSqlCursor = this.cursor();

        switch (fN) {
                case "provincia": {
                        if (!this.iface.bloqueoProvincia) {
                                this.iface.bloqueoProvincia = true;
                                flfactppal.iface.pub_obtenerProvincia(this);
                                this.iface.bloqueoProvincia = false;
                        }
                        break;
                }
                case "idprovincia": {
                        if (cursor.valueBuffer("idprovincia") == 0) {
                                cursor.setNull("idprovincia");
                        }
                        break;
                }
        }
}

/** \D Comprueba si el pas es Espaa que el cdigo postal sea el equivalente a la provincia
\end */
function oficial_comprobarCPProvincia():Boolean
{
	var util:FLUtil = new FLUtil();
    var cursor:FLSqlCursor = this.cursor();

	var codPais:String = cursor.valueBuffer("codpais");
	var codIso:String = util.sqlSelect("paises", "codiso", "codpais = '" + codPais + "'");
	if (codIso == "ES") {
		var codPostal2:String = cursor.valueBuffer("codpostal").left(2);
		var idProvincia:String = cursor.valueBuffer("idprovincia");
		var codProvincia:String = util.sqlSelect("provincias", "codigo" , "idprovincia = " + idProvincia);
		if (codPostal2 != codProvincia) {
			MessageBox.warning(util.translate("scripts", "El cdigo postal no corresponde a la provincia"), MessageBox.Ok, MessageBox.NoButton);
			return false;
		}
	}
	return true;
}

/** @class_definition noCheckCp */
//////////////////////////////////////////////////////////////////
//// NOCHECKCP ///////////////////////////////////////////////////
function noCheckCp_validateForm():Boolean
{
        var util:FLUtil = new FLUtil;
        var cursor:FLSqlCursor = this.cursor();

        if (!flfactppal.iface.pub_validarProvincia(cursor)) {
                return false;
        }

        return true;
}
//// NOCHECKCP ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition controlPoblacion */
//////////////////////////////////////////////////////////////////
//// CONTROL_POBLACION ///////////////////////////////////////////
function controlPoblacion_bufferChanged(fN:String)
{
        var util:FLUtil = new FLUtil();
        var cursor:FLSqlCursor = this.cursor();
        switch (fN) {
                case "codpostal": {
                       		var codigoPostal = cursor.valueBuffer("codpostal");
                       		if (codigoPostal)
                       		if (codigoPostal.length == 5)
                       			{
                       			cursor.setValueBuffer("ciudad",this.iface.calculateField("ciudad"));
                       			}
                        	break;
                		}
                default : {
                        this.iface.__bufferChanged(fN);
                        break;
                        }

                }

}

function controlPoblacion_calculateField(fN:String):String
{
        var util:FLUtil = new FLUtil;
        var cursor:FLSqlCursor = this.cursor();
        var valor:String;
        switch (fN) {
                case "ciudad": {
                	//Cargamos un valor existente ...
                	var qryDir:FLSqlQuery = new FLSqlQuery();
			qryDir.setTablesList("dirclientes");
			qryDir.setSelect("ciudad ,codcliente");
			qryDir.setFrom("dirclientes")
			qryDir.setWhere("codpostal = '" + cursor.valueBuffer("codpostal") + "'");
			if ( qryDir.exec() )
				{
				var i:Number= 0;
				if ( qryDir.first() )
					{
					var dialog = new Dialog(util.translate ( "scripts", "Poblaciones" ), 0);
    					dialog.caption = "Seleccionar una poblacin";
    					dialog.OKButtonText = util.translate ( "scripts", "Aceptar" );
    					dialog.cancelButtonText = util.translate ( "scripts", "Cancelar" );
					var bgroup:GroupBox = new GroupBox;
					dialog.add( bgroup );
					var rB:Array = [];
					var ciudad:Array = [];
					do 	{

						var repe:Boolean = false;
						var v:Number;
						for ( v = 1; v <= i; v++)
							if (qryDir.value(0) == ciudad[v])
								repe = true;

						if (!repe)
						{
						i++;
						rB[i] = new RadioButton;
        					rB[i].text = "("+qryDir.value(1)+") " + qryDir.value(0);
        					ciudad[i] = qryDir.value(0);

        					if (i == 1)
        						rB[i].checked = true;
        					else
        						rB[i].checked = false;

						bgroup.add( rB[i] );
						}

						} while ( qryDir.next() );


					if (i > 1)
						{
						if (!dialog.exec())
        							return;

        					var x:Number;
        					for (x = 1; x <= i ; x++)
        						{
        						if (rB[x].checked)
        						valor = ciudad[x];
        						}

    						}
    						else
    						{
    						valor = ciudad[i];

    						}
					} else
						{
						valor = cursor.valueBuffer("ciudad");
						}
				}
				else
                		valor = cursor.valueBuffer("ciudad");
                	break;
                	}
		default : {
                        valor = this.iface.__calculateField(fN);
                        break;
                        }
          }
        return valor;
}

//// CONTROL_POBLACION ///////////////////////////////////////////
//////////////////////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

