/***************************************************************************
                 empresa.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
	var ctx:Object;
	function interna( context ) { this.ctx = context; }
	function main() { this.ctx.interna_main(); }
	function init() { this.ctx.interna_init(); }
	function validateForm():Boolean { return this.ctx.interna_validateForm(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
	var pbnCambiarEjercicioActual:Object;
	var bloqueoProvincia:Boolean;
	function oficial( context ) { interna( context ); }
	function pbnCambiarEjercicioActual_clicked() {
		return this.ctx.oficial_pbnCambiarEjercicioActual_clicked();
	}
	function mostrarEjercicioActual() {
		return this.ctx.oficial_mostrarEjercicioActual();
	}
	function cambiarEjercicioActual():Boolean {
		return this.ctx.oficial_cambiarEjercicioActual();
	}
	function bufferChanged(fN:String) {
		return this.ctx.oficial_bufferChanged(fN);
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration navegador */
/////////////////////////////////////////////////////////////////
//// CONF NAVEGADOR /////////////////////////////////////////////
class navegador extends oficial /** %from: oficial */ {
	function navegador( context ) { oficial ( context ); }
	function init() {
		return this.ctx.navegador_init();
	}
	function cambiarNavegador() {
		return this.ctx.navegador_cambiarNavegador();
	}
}
//// CONF NAVEGADOR /////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration pdf */
/////////////////////////////////////////////////////////////////
//// PDF ////////////////////////////////////////////////////////
class pdf extends navegador /** %from: oficial */ {
	function pdf( context ) { navegador ( context ); }
	function init() {
		this.ctx.pdf_init();
	}
	function pdfclicked() {
		this.ctx.pdf_pdfclicked();
	}
	function fixPath(ruta:String):String {
		return this.ctx.pdf_fixPath(ruta);
	}
}
//// PDF ////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration fixVarios */
/////////////////////////////////////////////////////////////////
//// FIX_VARIOS /////////////////////////////////////////////////
class fixVarios extends pdf /** %from: oficial */ {
	function fixVarios( context ) { pdf ( context ); }
	function init() {
		this.ctx.fixVarios_init();
		}
	function pbnIdProvincia_clicked() {
		return this.ctx.fixVarios_pbnIdProvincia_clicked();
	}
	function pbnGS1_clicked() {
		return this.ctx.fixVarios_pbnGS1_clicked();
	}
	function pbnPNeto_clicked() {
		return this.ctx.fixVarios_pbnPNeto_clicked();
	}

	function saveInforme(informe:String) {
		this.ctx.fixVarios_saveInforme(informe);
	}

}
//// FIX_VARIOS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration lascunasOnline */
/////////////////////////////////////////////////////////////////
//// LASCUNAS_ONLINE ////////////////////////////////////////////
class lascunasOnline extends fixVarios /** %from: oficial */ {
	function lascunasOnline( context ) { fixVarios ( context ); }
	function init() {
		this.ctx.lascunasOnline_init();
	}
	function pbrutato_clicked() {
		this.ctx.lascunasOnline_pbrutato_clicked();
	}
     	function fixPath(ruta:String):String {
	        return this.ctx.lascunasOnline_fixPath(ruta);
    	}
	function validateForm():Boolean {
		return this.ctx.lascunasOnline_validateForm();
	}
}
//// LASCUNAS_ONLINE ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration envioMail */
/////////////////////////////////////////////////////////////////
//// ENVIO MAIL /////////////////////////////////////////////////
class envioMail extends lascunasOnline /** %from: navegador */ {
	function envioMail( context ) { lascunasOnline ( context ); }
	function init() {
		return this.ctx.envioMail_init();
	}
	function cambiarClienteCorreo() {
		return this.ctx.envioMail_cambiarClienteCorreo();
	}
	function cambiarNombreCorreo() {
		return this.ctx.envioMail_cambiarNombreCorreo();
	}
	function cambiarDirIntermedia() {
		return this.ctx.envioMail_cambiarDirIntermedia();
	}
}
//// ENVIO MAIL /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends envioMail {
	function head( context ) { envioMail ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
	function ifaceCtx( context ) { head( context ); }
	function pub_cambiarEjercicioActual():Boolean {
		return this.cambiarEjercicioActual();
	}
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C Cuando cambia el ejercicio actual se establece el ttulo de las ventanas principales con
el nombre del ejercicio seleccionado
\end */
function interna_init()
{
	var cursor:FLSqlCursor = this.cursor();
	this.iface.pbnCambiarEjercicioActual = this.child("pbnCambiarEjercicioActual");
	this.iface.bloqueoProvincia = false;
	connect(this.iface.pbnCambiarEjercicioActual, "clicked()", this, "iface.pbnCambiarEjercicioActual_clicked");
	connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");

	if (!flfactppal.iface.pub_ejercicioActual())
		flfactppal.iface.pub_cambiarEjercicioActual(this.cursor().valueBuffer("codejercicio"));

	this.child("fdbCodEjercicio").close();
	this.child("fdbNombreEjercicio").close();

	this.iface.mostrarEjercicioActual();
}

/**
\C Los datos de la empresa son nicos, por tanto formulario de no presenta los botones de navegacin por registros.
\end

\D La gestin del formulario se hace de forma manual mediante el objeto f (FLFormSearchDB)
\end
\end */
function interna_main()
{
	var f:Object = new FLFormSearchDB("empresa");
	var cursor:FLSqlCursor = f.cursor();

	cursor.select();
	if (!cursor.first())
			cursor.setModeAccess(cursor.Insert);
	else
			cursor.setModeAccess(cursor.Edit);

	f.setMainWidget();
	if (cursor.modeAccess() == cursor.Insert)
			f.child("pushButtonCancel").setDisabled(true);
	cursor.refreshBuffer();
	var commitOk:Boolean = false;
	var acpt:Boolean;
	cursor.transaction(false);
	while (!commitOk) {
		acpt = false;
		f.exec("nombre");
		acpt = f.accepted();
		if (!acpt) {
			if (cursor.rollback())
				commitOk = true;
		} else {
			if (cursor.commitBuffer()) {
				cursor.commit();
				commitOk = true;
			}
		}
	}
}

function interna_validateForm():Boolean
{
	var util:FLUtil = new FLUtil();
/** \C No puede activarse la contabilidad integrada si no est cargado el mdulo principal de Contabilidad
\end */
	if (!sys.isLoadedModule("flcontppal") && this.cursor().valueBuffer("contintegrada") == true) {
		MessageBox.warning(util.translate("scripts", "No puede activarse la contabilidad integrada si no est cargado el mdulo principal de Contabilidad"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
		return false;
	}
	return true;
}

//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
/** \D Cambia el ejercicio actual para el usuario conectado
*/
function oficial_pbnCambiarEjercicioActual_clicked()
{
	if (!this.iface.cambiarEjercicioActual())
		return;
	this.iface.mostrarEjercicioActual();
}

/** \D Permite seleccionar el ejercicio actual del usuario conectado

@return	true si el cambio se realiza correctamente, false en caso contrario
\end */
function oficial_cambiarEjercicioActual():Boolean
{
	var f:Object = new FLFormSearchDB("ejercicios");
	f.setMainWidget();
	var codEjercicio:String = f.exec("codejercicio");
	if (!codEjercicio)
		return false;
	var ok:Boolean = flfactppal.iface.pub_cambiarEjercicioActual(codEjercicio);
	return ok;
}

/** \D Muestra el ejercicio actual en el formulario y en el Main Widget
*/
function oficial_mostrarEjercicioActual()
{
	var util:FLUtil = new FLUtil();
	var codEjercicio:String = flfactppal.iface.pub_ejercicioActual();
	var nombreEjercicio:String = util.sqlSelect( "ejercicios", "nombre", "codejercicio='" + codEjercicio + "'" );
	try {
		sys.setCaptionMainWidget( nombreEjercicio );
		this.child("lblValEjercicioActual").text = codEjercicio + " - " + nombreEjercicio;
		this.child("lblEjercicioActual").text = util.translate("scripts", "Ejercicio actual para ") + sys.nameUser() + ":";
	}
	catch (e) {}
}

function oficial_bufferChanged(fN:String)
{
	var util:FLUtil = new FLUtil;
	var cursor:FLSqlCursor = this.cursor();

	switch (fN) {
		case "provincia": {
			if (!this.iface.bloqueoProvincia) {
				this.iface.bloqueoProvincia = true;
				flfactppal.iface.pub_obtenerProvincia(this);
				this.iface.bloqueoProvincia = false;
			}
			break;
		}
	}
}
//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition navegador */
/////////////////////////////////////////////////////////////////
//// CONF NAVEGADOR /////////////////////////////////////////////
function navegador_init()
{
	this.iface.__init();

	var util:FLUtil = new FLUtil();
	this.child("lblNombreNavegador").text = util.readSettingEntry("scripts/flfactinfo/nombrenavegador");
	connect(this.child("pbnCambiarNavegador"), "clicked()", this, "iface.cambiarNavegador");
}

function navegador_cambiarNavegador()
{
	var util:FLUtil = new FLUtil();
	var nombreNavegador:String = Input.getText( util.translate( "scripts", "Nombre del navegador o ruta de acceso:" ) );
	if (!nombreNavegador) {
		return;
	}

	this.child("lblNombreNavegador").text = nombreNavegador;
	util.writeSettingEntry("scripts/flfactinfo/nombrenavegador", nombreNavegador);
}

//// CONF NAVEGADOR /////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition pdf */
/////////////////////////////////////////////////////////////////
//// PDF ////////////////////////////////////////////////////////
function pdf_init()
{
var util:FLUtil = new FLUtil;
this.iface.__init();
connect(this.child("pbpdf"), "clicked()", this, "iface.pdfclicked");
this.child("lepdf").text = util.readSettingEntry("pdffolder", "");
this.child("lepdf").setEnabled(false);

}

function pdf_pdfclicked()
{
var dirBasePath = this.iface.fixPath(FileDialog.getExistingDirectory(Dir.home));
    if (!dirBasePath)
    	return;
    this.child("lepdf").text = dirBasePath;
var settings = new AQSettings;
settings.writeEntry("pdffolder", dirBasePath);

}

function pdf_fixPath(ruta:String):String
{
var rutaFixed:String;
    if (sys.osName() == "WIN32")
            {
           var barra = "\\";
        while (ruta != rutaFixed)
                    {
                    rutaFixed = ruta;
                    ruta = ruta.replace("/",barra);
                    }
        if (!rutaFixed.endsWith(barra)) rutaFixed +="\\";
            } else
                rutaFixed= ruta;
return rutaFixed;
}
//// PDF ////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition fixVarios */
/////////////////////////////////////////////////////////////////
//// FIX_VARIOS /////////////////////////////////////////////////
function fixVarios_init()
{
this.iface.__init();


this.child("tbwEmpresa").setTabEnabled("tabFix", false);

if (sys.isDebuggerMode())
	{
	var pbnIdProvincia = this.child("pbnIdProvincia");
	var pbnGS1 = this.child("pbnGS1");
	var pbnPNeto = this.child("pbnProyectosNeto");
	this.child("tbwEmpresa").setTabEnabled("tabFix", true);
	connect(pbnIdProvincia, "clicked()", this, "iface.pbnIdProvincia_clicked");
	connect(pbnGS1, "clicked()", this, "iface.pbnGS1_clicked");
	connect(pbnPNeto, "clicked()", this, "iface.pbnPNeto_clicked");
	}

}

function fixVarios_pbnIdProvincia_clicked()
{
var util:FLUtil = new FLUtil;
var idProvinciaTemp: Number = 0;
var registrosProcesados:Number = 0;
var registrosAlterados :Number = 0;
var registrosErroneos : Number = 0;
var informe:String = "Resultados de la BD " + sys.nameBD() + ".\nProceso: Actualizar idProvincia.";
var codCliente:String;
//Creamos cursor a dirclientes
var cursorDirClientes:FLSqlCursor = new FLSqlCursor("dirclientes");

	        cursorDirClientes.select("1 = 1");
                if (cursorDirClientes.first())
                	do {
                		registrosProcesados++;
                		codCliente = cursorDirClientes.valueBuffer("codcliente");
                		if (!cursorDirClientes.valueBuffer("idprovincia"))
                			{
                			// Miramos si tiene pais
                			if (cursorDirClientes.valueBuffer("codpais") != "" && cursorDirClientes.valueBuffer("codpais") != " " )
                				{
                				//Sacamos la idprovincia de provincias.
                				idProvinciaTemp = util.sqlSelect("provincias", "idprovincia", "codpais = '" + cursorDirClientes.valueBuffer("codpais") + "' AND provincia = '" + cursorDirClientes.valueBuffer("provincia") + "'");
                				if (!idProvinciaTemp)
                					{
                					informe += "\nERROR :: Una direccion del cliente " + codCliente + " no tiene ninguna provincia asignada.";
                					registrosErroneos++;
                					}
                				else
                					{
                					cursorDirClientes.setModeAccess(cursorDirClientes.Edit);
                					cursorDirClientes.refreshBuffer();
                					cursorDirClientes.setValueBuffer("idprovincia", idProvinciaTemp);
                					if (cursorDirClientes.commitBuffer())
                						{
                						informe += "\nINFO :: Una direccion del cliente '" + codCliente + "' se modifica con la idprovincia " + idProvinciaTemp +" ( " + util.sqlSelect("provincias", "provincia", "idprovincia = " + idProvinciaTemp) + " - " + util.sqlSelect("provincias", "codpais ", "idprovincia = " + idProvinciaTemp)+ " ).";
                						idProvinciaTemp = 0;
                						codCliente = "";
                						registrosAlterados++;

                						}
                					else
                						{
                						informe += "\nERROR :: No se ha podido cambiar la idprovincia en una direccion del cliente " + codCliente + ".";
                						registrosErroneos++;
                						idProvinciaTemp = 0;
                						codCliente = "";
                						}
                					}
                				}
                				else
                				{
                				informe += "\nERROR :: No se ha especificado el pais en una direccion del cliente " + codCliente+ ".";
                				registrosErroneos++;
                				}
                			}
                	    } while (cursorDirClientes.next())
informe += "\n--------------------------------------------------------";
informe += "\nRegistros procesados : " + registrosProcesados + ".";
informe += "\nRegistros modificados : " + registrosAlterados + ".";
informe += "\nRegistros erroneos : " + registrosErroneos + ".";
informe += "\n--------------------------------------------------------";
this.iface.saveInforme(informe);
MessageBox.information("Proceso finalizado", MessageBox.Ok, MessageBox.NoButton,
                           MessageBox.NoButton, "Eneboo");
}

function fixVarios_saveInforme(informe:String)
{
var nombreFichero:String = FileDialog.getSaveFileName("*.txt");
nombreFichero = nombreFichero + ".txt";
var file = new File(nombreFichero);
	file.open(File.WriteOnly);
	file.writeLine(informe);
	file.close();

}

function fixVarios_facturascliIdProvincia_clicked()
{

var esEditable:Boolean;
        var curPago:FLSqlCursor = new FLSqlCursor("facturascli");
     //   curPago.setActivatedCommitActions(false);
        curPago.select("1 = 1");
     if (curPago.first())
	do {
                esEditable = curPago.valueBuffer("editable");
                if (!esEditable)
                	{
                	debug("desbloqueando");
                        curPago.setUnLock("editable", true);
                	}

            // Si no existe idprovincia , le asigno una

                if (!esEditable)
                	{
                	debug("bloqueando");
                        curPago.setUnLock("editable", false);
                	}

	  } while ( curPago.next());

}

function fixVarios_pbnGS1_clicked()
{
var util:FLUtil = new FLUtil;
var cursorArticulos:FLSqlCursor = new FLSqlCursor("articulos");
var codEmpresa:String = util.sqlSelect("empresa", "codgs1", "1 = 1");
var referencia:String;
var barcode:String;
var informe:String = "Resultados de la BD " + sys.nameBD() + ".\nProceso: Actualizar GS1.";
var registrosProcesados:Number = 0;
var registrosAlterados:Number = 0;
var registrosErroneos : Number = 0;

	        cursorArticulos.select("1 = 1");
                if (cursorArticulos.first())
                	do {
                	    referencia = cursorArticulos.valueBuffer("referencia");
                	    barcode = formRecordarticulos.iface.calcularGS1(codEmpresa,referencia );
                	    cursorArticulos.setModeAccess(cursorArticulos.Edit);
                	    cursorArticulos.refreshBuffer();
                	    cursorArticulos.setValueBuffer("codbarras", barcode);
                	    cursorArticulos.setValueBuffer("tipocodbarras","Code128");
                	if (!cursorArticulos.commitBuffer())
                		{
                		informe +="\nError al procesar la referencia " + referencia + ".";
                		registrosErroneos++;
                		}
                	else
                		{
                		registrosAlterados++;
                		}
                	registrosProcesados++;
                	barcode = "";
                	referencia = "";
                	    } while (cursorArticulos.next())

informe += "\n--------------------------------------------------------";
informe += "\nRegistros procesados : " + registrosProcesados + ".";
informe += "\nRegistros modificados : " + registrosAlterados + ".";
informe += "\nRegistros erroneos : " + registrosErroneos + ".";
informe += "\n--------------------------------------------------------";
this.iface.saveInforme(informe);
MessageBox.information("Proceso finalizado", MessageBox.Ok, MessageBox.NoButton,
                           MessageBox.NoButton, "Eneboo");
}

function fixVarios_pbnPNeto_clicked()
{
var util:FLUtil = new FLUtil;
var informe:String = "Resultados de la BD " + sys.nameBD() + ".\nProceso: Actualizar Neto de proyectos.";
var registrosProcesados:Number = 0;
var registrosAlterados:Number = 0;
var registrosProcesadosSP:Number = 0;
var registrosAlteradosSP:Number = 0;
var codCentro:String;
var codSubcentro:String;

		var cursorProyectos:FLSqlCursor = new FLSqlCursor("cl_proyectos");
	        cursorProyectos.select("1 = 1");

                if (cursorProyectos.first())
                	do {
                		codCentro = cursorProyectos.valueBuffer("codcentro")
//                		debug("Actualizando Centro ... " + codCentro);
//                		debug("Actualizando proyectos ... SERVICIOSCLI");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineasservicioscli");
                		flfacturac.iface.guardarSubtotal(cursorTemp, codCentro);
//                		debug("Actualizando proyectos ... GASTOS");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("gastos");
                		flfacturac.iface.guardarSubtotal(cursorTemp, codCentro);
//                		debug("Actualizando proyectos ... PRESUPUESTOSCLI");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineaspresupuestoscli");
                		flfacturac.iface.guardarSubtotal(cursorTemp, codCentro);
//                		debug("Actualizando proyectos ... PEDIDOSCLI");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineaspedidoscli");
                		flfacturac.iface.guardarSubtotal(cursorTemp, codCentro);
//                	 	debug("Actualizando proyectos ... ALBARANESCLI");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineasalbaranescli");
                		flfacturac.iface.guardarSubtotal(cursorTemp, codCentro);
//                		debug("Actualizando proyectos ... FACTURASCLI");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineasfacturascli");
                		flfacturac.iface.guardarSubtotal(cursorTemp, codCentro);
//                		debug("Actualizando proyectos ... PEDIDOSPROV");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineaspedidosprov");
                		flfacturac.iface.guardarSubtotal(cursorTemp, codCentro);
//                		debug("Actualizando proyectos ... ALBARANESPROV");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineasalbaranesprov");
                		flfacturac.iface.guardarSubtotal(cursorTemp, codCentro);
//                		debug("Actualizando proyectos ... FACTURASPROV");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineasfacturasprov");
                		flfacturac.iface.guardarSubtotal(cursorTemp, codCentro);
                		registrosProcesados++;
                		registrosAlterados++;
                	    } while (cursorProyectos.next())

               	 var cursorSubProyectos:FLSqlCursor = new FLSqlCursor("cl_subproyectos");
	        cursorSubProyectos.select("1 = 1");

                if (cursorSubProyectos.first())
                	do {
                		codSubCentro =  cursorSubProyectos.valueBuffer("codsubcentro");
//                		debug("Actualizando Subproyecto ... " + codSubCentro);
//	               		debug("Actualizando proyectos ... SERVICIOSCLI");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineasservicioscli");
                		flfacturac.iface.guardarSubtotalSubProyecto(cursorTemp, codSubCentro);
//                		debug("Actualizando proyectos ... GASTOS");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("gastos");
                		flfacturac.iface.guardarSubtotalSubProyecto(cursorTemp, codSubCentro);
//                		debug("Actualizando proyectos ... PRESUPUESTOSCLI");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineaspresupuestoscli");
                		flfacturac.iface.guardarSubtotalSubProyecto(cursorTemp, codSubCentro);
//                		debug("Actualizando proyectos ... PEDIDOSCLI");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineaspedidoscli");
                		flfacturac.iface.guardarSubtotalSubProyecto(cursorTemp, codSubCentro);
//                	 	debug("Actualizando proyectos ... ALBARANESCLI");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineasalbaranescli");
                		flfacturac.iface.guardarSubtotalSubProyecto(cursorTemp, codSubCentro);
//                		debug("Actualizando proyectos ... FACTURASCLI");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineasfacturascli");
                		flfacturac.iface.guardarSubtotalSubProyecto(cursorTemp, codSubCentro);
//                		debug("Actualizando proyectos ... PEDIDOSPROV");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineaspedidosprov");
                		flfacturac.iface.guardarSubtotalSubProyecto(cursorTemp, codSubCentro);
//                		debug("Actualizando proyectos ... ALBARANESPROV");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineasalbaranesprov");
                		flfacturac.iface.guardarSubtotalSubProyecto(cursorTemp, codSubCentro);
//                		debug("Actualizando proyectos ... FACTURASPROV");
                		var cursorTemp:FLSqlCursor = new FLSqlCursor("lineasfacturasprov");
                		flfacturac.iface.guardarSubtotalSubProyecto(cursorTemp, codSubCentro);
                		registrosProcesadosSP++;
                		registrosAlteradosSP++;
                	    } while (cursorSubProyectos.next())

informe += "\n--------------------------------------------------------";
informe += "\nRegistros de proyectos procesados : " + registrosProcesados + ".";
informe += "\nRegistros de proyectos modificados : " + registrosAlterados + ".";
informe += "\nRegistros de subproyectos procesados : " + registrosProcesadosSP + ".";
informe += "\nRegistros de subproyectos modificados : " + registrosAlteradosSP + ".";
informe += "\n--------------------------------------------------------";
this.iface.saveInforme(informe);
MessageBox.information("Proceso finalizado", MessageBox.Ok, MessageBox.NoButton,
                           MessageBox.NoButton, "Eneboo");
}
//// FIX_VARIOS /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition lascunasOnline */
/////////////////////////////////////////////////////////////////
//// LASCUNAS_ONLINE ////////////////////////////////////////////
function lascunasOnline_init() {
    var util:FLUtil = new FLUtil;
	this.iface.__init();
	 connect(this.child("pbtemporalto"), "clicked()", this, "iface.pbrutato_clicked");
	 this.child("lERutaTO").text = util.readSettingEntry("lascunasOnline/rutatemporal");
         this.child("lEComandoTO").text = util.readSettingEntry("lascunasOnline/comandoexterno");

}

function lascunasOnline_pbrutato_clicked() {
    var util:FLUtil = new FLUtil;
    var dirBasePath = this.iface.fixPath(FileDialog.getExistingDirectory(Dir.home));

    if (!dirBasePath)
    return;
    this.child("lERutaTO").text = dirBasePath;
    util.writeSettingEntry("lascunasOnline/rutatemporal",dirBasePath);
}

function lascunasOnline_fixPath(ruta:String):String
{
var rutaFixed:String;
    if (sys.osName() == "WIN32")
            {
           var barra = "\\";
        while (ruta != rutaFixed)
                    {
                    rutaFixed = ruta;
                    ruta = ruta.replace("/",barra);
                    }
        if (!rutaFixed.endsWith(barra)) rutaFixed +="\\";
            } else
                rutaFixed= ruta;
return rutaFixed;
}

function lascunasOnline_validateForm():Boolean
{
var util:FLUtil = new FLUtil();
	util.writeSettingEntry("lascunasOnline/comandoexterno",this.child("lEComandoTO").text);
	return this.iface.__validateForm();
}
//// LASCUNAS_ONLINE ////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition envioMail */
/////////////////////////////////////////////////////////////////
//// ENVIO MAIL /////////////////////////////////////////////////
function envioMail_init()
{
	this.iface.__init();

	var util:FLUtil = new FLUtil();
	this.child("lblClienteCorreo").text = util.readSettingEntry("scripts/flfactinfo/clientecorreo");
	this.child("lblNombreCorreo").text = util.readSettingEntry("scripts/flfactinfo/nombrecorreo");
	this.child("lblDirIntermedia").text = util.readSettingEntry("scripts/flfactinfo/dirCorreo");
	connect(this.child("pbnCambiarClienteCorreo"), "clicked()", this, "iface.cambiarClienteCorreo");
	connect(this.child("pbnCambiarNombreCorreo"), "clicked()", this, "iface.cambiarNombreCorreo");
	connect(this.child("pbnCambiarDirIntermedia"), "clicked()", this, "iface.cambiarDirIntermedia");
}

function envioMail_cambiarClienteCorreo()
{
	var util:FLUtil = new FLUtil();
	var opciones:Array = ["KMail", "Thunderbird","Thunderbird 3+", "Outlook"];
	var codClienteCorreo:String = Input.getItem( util.translate( "scripts", "Cliente de correo:"), opciones, "KMail", false);

	if (!codClienteCorreo) {
		return;
	}

	this.child("lblClienteCorreo").text = codClienteCorreo;
	util.writeSettingEntry("scripts/flfactinfo/clientecorreo", codClienteCorreo);

	var nombreCorreo = "";
	switch (codClienteCorreo) {
		case "KMail": { nombreCorreo = "kmail"; break; }
		case "Thunderbird": { nombreCorreo = "thunderbird"; break; }
		case "Thunderbird 3+": { nombreCorreo = "thunderbird"; break; }
		case "Outlook": { nombreCorreo = "outlook.exe"; break; }
		case "AqExtension": { nombreCorreo = "aqextension"; break; }
	}
	if (nombreCorreo != "") {
		this.child("lblNombreCorreo").text = nombreCorreo;
		util.writeSettingEntry("scripts/flfactinfo/nombrecorreo", nombreCorreo);
	}
}

function envioMail_cambiarNombreCorreo()
{
	var util:FLUtil = new FLUtil();
	var texto:String = "Debe escribir la ruta al programa de correo. A continuacin se detallan algunos ejemplos: \n\n - MAC:  /Applications/Thunderbird.app/Contents/MacOS/Thunedrbird.app/Contents/MacOS/thunderbird \n\n - WINDOWS:  C:'\\Program Files (x86)\\Mozilla Thunderbird\\thunderbird.exe \n\n - LINUX:  thunderbird \n\n\n Escriba su ruta para el programa de correo:";
	var nombreCorreo:String = Input.getText( util.translate( "scripts", texto ) );

	if (!nombreCorreo) {
		return;
	}

	this.child("lblNombreCorreo").text = nombreCorreo;
	util.writeSettingEntry("scripts/flfactinfo/nombrecorreo", nombreCorreo);
}

function envioMail_cambiarDirIntermedia()
{
	var util:FLUtil = new FLUtil();
	var ruta:String = FileDialog.getExistingDirectory(util.translate("scripts", ""), util.translate("scripts", "RUTA INTERMEDIA"));

	if (!File.isDir(ruta)) {
		MessageBox.information(util.translate("scripts", "Ruta errnea"),MessageBox.Ok, MessageBox.NoButton);
		return;
	}
	this.child("lblDirIntermedia").text = ruta;
	util.writeSettingEntry("scripts/flfactinfo/dirCorreo", ruta);
}
//// ENVIO MAIL /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

