/***************************************************************************
                 masterreciboscli.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); }
	function imprimir(codRecibo:String) {
		return this.ctx.oficial_imprimir(codRecibo)
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration envioMail */
/////////////////////////////////////////////////////////////////
//// ENVIO_MAIL ////////////////////////////////////////////////
class envioMail extends oficial /** %from: oficial */ {
    function envioMail( context ) { oficial ( context ); }
	function init() {
		return this.ctx.envioMail_init();
	}
	function enviarDocumento(codRecibo:String, codCliente:String) {
		return this.ctx.envioMail_enviarDocumento(codRecibo, codCliente);
	}
	function imprimir(codRecibo:String) {
		return this.ctx.envioMail_imprimir(codRecibo)
	}
}

//// ENVIO_MAIL ////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration recibosCodejercicio */
//////////////////////////////////////////////////////////////////
//// RECIBOS_CODEJERCICIO ////////////////////////////////////////
class recibosCodejercicio extends envioMail /** %from: oficial */ {
    function recibosCodejercicio ( context ) { envioMail ( context ); }
    function init() { this.ctx.recibosCodejercicio_init(); }
}
//// RECIBOS_CODEJERCICIO ////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration ocultarDomiciliados */
//////////////////////////////////////////////////////////////////
//// OCULTAR_DOMICILIADOS ////////////////////////////////////////
class ocultarDomiciliados extends recibosCodejercicio /** %from: oficial */ {
    var filtroViejo:String;
    function ocultarDomiciliados ( context ) { recibosCodejercicio( context ); }
	function init() {
		this.ctx.ocultarDomiciliados_init();
	}
	function ocultar() {
		this.ctx.ocultarDomiciliados_ocultar();
	}
}
//// OCULTAR_DOMICILIADOS ////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration flagRecibosImpresos */
//////////////////////////////////////////////////////////////////
//// FLAG_RECIBOS_IMPRESOS ///////////////////////////////////////
class flagRecibosImpresos extends ocultarDomiciliados /** %from: oficial */ {
    function flagRecibosImpresos( context ) { ocultarDomiciliados( context ); }
	function imprimir(codRecibo:String) {
		return this.ctx.flagRecibosImpresos_imprimir(codRecibo)
	}
	function marcarImpreso(filtro:String):Boolean {
		return this.ctx.flagRecibosImpresos_marcarImpreso(filtro);
	}
}
//// FLAG_RECIBOS_IMPRESOS ///////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends flagRecibosImpresos {
    function head( context ) { flagRecibosImpresos ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
	function pub_imprimir(codRecibo:String) {
		return this.imprimir(codRecibo);
	}
}

const iface = new pubEnvioMail( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration pubEnvioMail */
/////////////////////////////////////////////////////////////////
//// PUB_ENVIO_MAIL /////////////////////////////////////////////
class pubEnvioMail extends ifaceCtx /** %from: ifaceCtx */ {
    function pubEnvioMail( context ) { ifaceCtx( context ); }
	function pub_enviarDocumento(codRecibo:String, codCliente:String) {
		return this.enviarDocumento(codRecibo, codCliente);
	}
}

//// PUB_ENVIO_MAIL /////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
function interna_init()
{
		this.child("tableDBRecords").setEditOnly(true);
		connect(this.child("toolButtonPrint"), "clicked()", this, "iface.imprimir");
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
/** \D
Crea un informe con el listado de registros de la remesa. Funciona cuando est cargado el mdulo de informes
\end */
function oficial_imprimir(codRecibo:String)
{
	if (sys.isLoadedModule("flfactinfo")) {
		var codigo:String;
		if (codRecibo) {
			codigo = codRecibo;
		} else {
			if (!this.cursor().isValid())
				return;
			codigo = this.cursor().valueBuffer("codigo");
		}
		var curImprimir:FLSqlCursor = new FLSqlCursor("i_reciboscli");
		curImprimir.setModeAccess(curImprimir.Insert);
		curImprimir.refreshBuffer();
		curImprimir.setValueBuffer("descripcion", "temp");
		curImprimir.setValueBuffer("d_reciboscli_codigo", codigo);
		curImprimir.setValueBuffer("h_reciboscli_codigo", codigo);
		flfactinfo.iface.pub_lanzarInforme(curImprimir, "i_reciboscli");
	} else
			flfactppal.iface.pub_msgNoDisponible("Informes");
}

//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition envioMail */
/////////////////////////////////////////////////////////////////
//// ENVIO_MAIL /////////////////////////////////////////////////
function envioMail_init()
{
	this.iface.__init();
	connect(this.child("tbnEnviarMail"), "clicked()", this, "iface.enviarDocumento()");
	this.child("tbnEnviarMail").close();
}

function envioMail_enviarDocumento(codRecibo:String, codCliente:String)
{
	var cursor:FLSqlCursor = this.cursor();
	var util:FLUtil = new FLUtil();

	if (!codRecibo) {
		codRecibo = cursor.valueBuffer("codigo");
	}

	if (!codCliente) {
		codCliente = cursor.valueBuffer("codcliente");
	}

	var tabla:String = "clientes";
	var emailCliente:String = flfactppal.iface.pub_componerListaDestinatarios(codCliente, tabla);

	if (!emailCliente || emailCliente == "")
		if (!util.sqlSelect("empresa","nodestinatario","1 = 1"))
			return;

	var rutaIntermedia:String = util.readSettingEntry("scripts/flfactinfo/dirCorreo");
	if (!rutaIntermedia.endsWith("/")) {
		rutaIntermedia += "/";
	}

	var cuerpo:String = "";
	var asunto:String = util.translate("scripts", "Recibo %1").arg(codRecibo);
	var rutaDocumento:String = rutaIntermedia + "R_" + codRecibo + ".pdf";


	var util:FLUtil = new FLUtil;
	var codigo:String;
	if (codRecibo) {
		codigo = codRecibo;
	} else {
		if (!cursor.isValid()) {
			return;
		}
		codigo = cursor.valueBuffer("codigo");
	}

	var numCopias:Number = util.sqlSelect("reciboscli r INNER JOIN clientes c ON c.codcliente = r.codcliente", "c.copiasfactura", "r.codigo = '" + codigo + "'", "reciboscli,clientes");
	if (!numCopias) {
		numCopias = 1;
	}

	var curImprimir:FLSqlCursor = new FLSqlCursor("i_reciboscli");
	curImprimir.setModeAccess(curImprimir.Insert);
	curImprimir.refreshBuffer();
	curImprimir.setValueBuffer("descripcion", "temp");
	curImprimir.setValueBuffer("d_reciboscli_codigo", codigo);
	curImprimir.setValueBuffer("h_reciboscli_codigo", codigo);
	flfactinfo.iface.pub_lanzarInforme(curImprimir, "i_reciboscli", "", "", false, false, "", "i_reciboscli", 1, rutaDocumento, true);

	var arrayDest:Array = [];
	arrayDest[0] = [];
	arrayDest[0]["tipo"] = "to";
	arrayDest[0]["direccion"] = emailCliente;

	var arrayAttach:Array = [];
	arrayAttach[0] = rutaDocumento;

	flfactppal.iface.pub_enviarCorreo(cuerpo, asunto, arrayDest, arrayAttach);
}

function envioMail_imprimir(codRecibo:String)
{
	var util:FLUtil = new FLUtil;

	var datosEMail:Array = [];
	datosEMail["tipoInforme"] = "reciboscli";
	var codCliente:String;
	if (codRecibo && codRecibo != "") {
		datosEMail["codDestino"] = util.sqlSelect("reciboscli", "codcliente", "codigo = '" + codRecibo + "'");
		datosEMail["codDocumento"] = codRecibo;
	} else {
		var cursor:FLSqlCursor = this.cursor();
		datosEMail["codDestino"] = cursor.valueBuffer("codcliente");
		datosEMail["codDocumento"] = cursor.valueBuffer("codigo");
	}
	flfactinfo.iface.datosEMail = datosEMail;
	this.iface.__imprimir(codRecibo);
}

//// ENVIO_MAIL /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition recibosCodejercicio */
//////////////////////////////////////////////////////////////////
//// RECIBOS_CODEJERCICIO ////////////////////////////////////////
function recibosCodejercicio_init()
{
 var cursor = this.cursor();
 var valor:String = "idfactura IN (SELECT idfactura FROM facturascli WHERE codejercicio = '" + flfactppal.iface.pub_ejercicioActual() + "')";
 cursor.setMainFilter(valor);
this.child("tableDBRecords").refresh();
 this.iface.__init();

}
//// RECIBOS_CODEJERCICIO ////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition ocultarDomiciliados */
//////////////////////////////////////////////////////////////////
//// OCULTAR_DOMICILIADOS ////////////////////////////////////////
function ocultarDomiciliados_init()
{
var cursor = this.cursor();
connect(this.child("cbOcultarDomiciliados"), "clicked()", this, "iface.ocultar");
this.iface.__init();
this.iface.filtroViejo = cursor.mainFilter();
this.iface.ocultar();
}

function ocultarDomiciliados_ocultar()
{

var cursor = this.cursor();
var valor:String;
if (this.child("cbOcultarDomiciliados").checked)
	{
	if (this.iface.filtroViejo != "")
		{
//		debug("Filtro Viejo ocupado");
		valor = this.iface.filtroViejo + " AND ";
		}
 	valor = valor +"idfactura IN (SELECT idfactura FROM facturascli WHERE codpago IN (SELECT codpago FROM formaspago WHERE domiciliado ))";
	}
else
valor = this.iface.filtroViejo;

cursor.setMainFilter(valor);
this.child("tableDBRecords").refresh();

}
//// OCULTAR_DOMICILIADOS ////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition flagRecibosImpresos */
//////////////////////////////////////////////////////////////////
//// FLAG_RECIBOS_IMPRESOS ///////////////////////////////////////
function flagRecibosImpresos_imprimir(codRecibo:String)
{
var numero:String = this.cursor().valueBuffer("idrecibo");

	this.iface.__imprimir(codRecibo);
	this.iface.marcarImpreso("idrecibo = " + numero );
}

function flagRecibosImpresos_marcarImpreso(filtro:String):Boolean
{
	var util:FLUtil = new FLUtil;

	var res:Number = MessageBox.information(util.translate("scripts", "Desea marcar el recibo como Impreso?"), MessageBox.Yes, MessageBox.No);
	if (res != MessageBox.Yes) {
		return true;
	}
	var curRecibo:FLSqlCursor = new FLSqlCursor("reciboscli");
	curRecibo.setActivatedCommitActions(false);
	curRecibo.select(filtro);
	while (curRecibo.next()) {
		curRecibo.setModeAccess(curRecibo.Edit);
		curRecibo.refreshBuffer();
		curRecibo.setValueBuffer("impreso", true);
		if (!curRecibo.commitBuffer()) {
			return false;
		}
	}
	return true;
}
//// FLAG_RECIBOS_IMPRESOS ///////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

