/***************************************************************************
                 masterrecibosprov.qs  -  description
                             -------------------
    begin                : lun abr 26 2004
    copyright            : (C) 2004 by InfoSiAL S.L.
    email                : mail@infosial.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
    function oficial( context ) { interna( context ); }
    function imprimir(codRecibo:String) {
		return this.ctx.oficial_imprimir(codRecibo);
	}
}
//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration recibosCodejercicio */
//////////////////////////////////////////////////////////////////
//// RECIBOS_CODEJERCICIO ////////////////////////////////////////
class recibosCodejercicio extends oficial /** %from: oficial */ {
    function recibosCodejercicio ( context ) { oficial ( context ); }
    function init() { this.ctx.recibosCodejercicio_init(); }
}
//// RECIBOS_CODEJERCICIO ////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration lasCunas */
//////////////////////////////////////////////////////////////////
//// LASCUNAS ////////////////////////////////////////////////////
class lasCunas extends recibosCodejercicio /** %from: oficial */ {
    var tdbRecords:FLTableDB;
    function lasCunas( context ) { recibosCodejercicio( context ); }
    function init() { this.ctx.lasCunas_init(); }
}
//// LASCUNAS ////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends lasCunas {
    function head( context ) { lasCunas( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
	function pub_imprimir(codRecibo:String) {
		return this.imprimir(codRecibo);
	}
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////

function init() {
    this.iface.init();
}

function interna_init()
{
		form.child("tableDBRecords").setEditOnly(true);
		connect(form.child("toolButtonPrint"), "clicked()", this, "iface.imprimir");
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
/** \D
Crea un informe con el listado de registros de la remesa. Funciona cuando est cargado el mdulo de informes
\end */
function oficial_imprimir(codRecibo:String)
{
	if (sys.isLoadedModule("flfactinfo")) {
		var codigo:String;
		if (codRecibo) {
			codigo = codRecibo;
		} else {
			if (!this.cursor().isValid())
				return;
			codigo = this.cursor().valueBuffer("codigo");
		}
		var curImprimir:FLSqlCursor = new FLSqlCursor("i_recibosprov");
		curImprimir.setModeAccess(curImprimir.Insert);
		curImprimir.refreshBuffer();
		curImprimir.setValueBuffer("descripcion", "temp");
		curImprimir.setValueBuffer("d_recibosprov_codigo", codigo);
		curImprimir.setValueBuffer("h_recibosprov_codigo", codigo);
		flfactinfo.iface.pub_lanzarInforme(curImprimir, "i_recibosprov");
	} else
			flfactppal.iface.pub_msgNoDisponible("Informes");
}
//// OFICIAL ////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition recibosCodejercicio */
//////////////////////////////////////////////////////////////////
//// RECIBOS_CODEJERCICIO ////////////////////////////////////////
function recibosCodejercicio_init()
{
 var cursor = this.cursor();
 var valor:String = "idfactura IN (SELECT idfactura FROM facturasprov WHERE codejercicio = '" + flfactppal.iface.pub_ejercicioActual() + "')";
 cursor.setMainFilter(valor);
 this.iface.__init();
this.child("tableDBRecords").refresh();

}
//// RECIBOS_CODEJERCICIO ////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition lasCunas */
//////////////////////////////////////////////////////////////////
//// LASCUNAS ////////////////////////////////////////////////////
function lasCunas_init()
{
	this.iface.tdbRecords = this.child("tableDBRecords");
        var arrayCampos:Array = ["fecha", "numproveedor","codproveedor","nombreproveedor"];
	this.iface.tdbRecords.setOrderCols(arrayCampos);
	this.iface.tdbRecords.refresh();
        this.iface.__init();
}
//// LASCUNAS ////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////

//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

