/***************************************************************************
                 mastercarga.qs  -  description
                             -------------------
    begin                : dom ene 25 2015
    copyright            : Jos Antonio Fernndez Fernndez
    email                : aullasistemas@gmail.com
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** @file */

/** @class_declaration interna */
////////////////////////////////////////////////////////////////////////////
//// DECLARACION ///////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
class interna {
    var ctx:Object;
    function interna( context ) { this.ctx = context; }
    function init() { this.ctx.interna_init(); }
}
//// INTERNA /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
class oficial extends interna {
	var tbnImprimir:Object;
    function oficial( context ) { interna( context ); }
	function imprimir(codPresupuesto:String) {
		return this.ctx.oficial_imprimir(codPresupuesto);
	}
	function filtrarTabla():Boolean {
		return this.ctx.oficial_filtrarTabla();
	}
	function filtroTabla():String {
		return this.ctx.oficial_filtroTabla();
	}
}

//// OFICIAL /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_declaration cmrMini */
/////////////////////////////////////////////////////////////////
//// CMR_MINI ///////////////////////////////////////////////////
class cmrMini extends oficial /** %from: oficial */ {
    var tbnImprimir: Object;
    function cmrMini( context ) { oficial ( context ); }
    function imprimirCMR(codAlbaran:String) {
		return this.ctx.cmrMini_imprimirCMR(codAlbaran);
	}
    function init() {
    		this.ctx.cmrMini_init();
    	}
}
//// CMR_MINI ///////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////
class head extends cmrMini {
    function head( context ) { cmrMini ( context ); }
}
//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_declaration ifaceCtx */
/////////////////////////////////////////////////////////////////
//// INTERFACE  /////////////////////////////////////////////////
class ifaceCtx extends head {
    function ifaceCtx( context ) { head( context ); }
	function pub_imprimir(codPresupuesto:String) {
		return this.imprimir(codPresupuesto);
	}
}

const iface = new ifaceCtx( this );
//// INTERFACE  /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition interna */
////////////////////////////////////////////////////////////////////////////
//// DEFINICION ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//// INTERNA /////////////////////////////////////////////////////
/** \C
Este es el formulario maestro de presupuestos a cliente.
\end */
function interna_init()
{
	this.iface.tbnImprimir = this.child("toolButtonPrint");
//	connect(this.iface.tbnImprimir, "clicked()", this, "iface.imprimir");

	this.iface.filtrarTabla();
//	this.iface.procesarEstado();
}
//// INTERNA /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition oficial */
//////////////////////////////////////////////////////////////////
//// OFICIAL /////////////////////////////////////////////////////
/** \C
Al pulsar el botn imprimir se lanzar el informe correspondiente al presupuesto seleccionado (en caso de que el mdulo de informes est cargado)
\end */
function oficial_imprimir(codPresupuesto:String)
{
	if (sys.isLoadedModule("flfactinfo")) {

		var codigo:String;
		if (codPresupuesto) {
			codigo = codPresupuesto;
		} else {
			if (!this.cursor().isValid())
				return;
			codigo = this.cursor().valueBuffer("codigo");
		}
		var curImprimir:FLSqlCursor = new FLSqlCursor("i_presupuestoscli");
		curImprimir.setModeAccess(curImprimir.Insert);
		curImprimir.refreshBuffer();
		curImprimir.setValueBuffer("descripcion", "temp");
		curImprimir.setValueBuffer("d_presupuestoscli_codigo", codigo);
		curImprimir.setValueBuffer("h_presupuestoscli_codigo", codigo);
		flfactinfo.iface.pub_lanzarInforme(curImprimir, "i_presupuestoscli");
		return;
	}

	var tipoDoc:String = "presupuestoscli";
	var f:Object = new FLFormSearchDB("facturas_imp");
	var cursor:FLSqlCursor = f.cursor();

	cursor.setActivatedCheckIntegrity(false);
	cursor.select();
	if (!cursor.first())
		cursor.setModeAccess(cursor.Insert);
	else
		cursor.setModeAccess(cursor.Edit);

	f.setMainWidget();
	cursor.refreshBuffer();
	var acpt:String = f.exec("desde");
	if (acpt) {
		cursor.commitBuffer();
		var q:FLSqlQuery = new FLSqlQuery(tipoDoc);
		q.setValueParam("from", cursor.valueBuffer("desde"));
		q.setValueParam("to", cursor.valueBuffer("hasta"));
		var rptViewer = new FLReportViewer();
		rptViewer.setReportTemplate(tipoDoc);
		rptViewer.setReportData(q);
		rptViewer.renderReport();
		rptViewer.exec();
		f.close();
	}
}

function oficial_filtrarTabla():Boolean
{
	var filtro:String = this.iface.filtroTabla();
	//this.child("tableDBCargaAlbaranes").cursor().setMainFilter(filtro);
	return true;
}

function oficial_filtroTabla():String
{
	var util:FLUtil = new FLUtil();
	var filtro:String = "";
	var diasAlbaran:Number = util.sqlSelect("vivppal_general","diasprevioscarga","1=1");


	if (!diasAlbaran)
		{
		diasAlbaran = 5;
		}

	 var d = new Date();

    	    var fechaAlbaran:Date = new Date(util.addDays(d.toString().left(10), diasAlbaran * -1) );
//    	debug("fechaAlbaran vale " + fechaAlbaran);
	util.sqlUpdate("vivppal_general","filtrofechacarga",fechaAlbaran.toString().left(10),"1=1");

//	debug("Filtrofechacarga vale " + util.sqlSelect("vivppal_general","filtrofechacarga","1=1"));
	return filtro;
}
//// OFICIAL /////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition cmrMini */
/////////////////////////////////////////////////////////////////
//// CMR_MINI ///////////////////////////////////////////////////
function cmrMini_init()
{
	this.iface.__init();
	this.iface.tbnImprimir = this.child("toolButtonPrint");

	connect(this.iface.tbnImprimir, "clicked()", this, "iface.imprimirCMR");

}

function cmrMini_imprimirCMR(codAlbaran:String)
{
var util:FLUtil;
			if ( !this.cursor().valueBuffer("fechacarga") || this.cursor().valueBuffer("fechacarga") == "0000-00-00") {
			        MessageBox.information(util.translate("scripts", "No está especificada la fecha de carga\nProceso cancelado"), MessageBox.Ok);
			return;
		}

formalbaranescli.iface.imprimirCMR(this.cursor().valueBuffer("codigo"));

}
//// CMR_MINI ///////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition head */
/////////////////////////////////////////////////////////////////
//// DESARROLLO /////////////////////////////////////////////////

//// DESARROLLO /////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

